/*->c.xmain  */

#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <stdarg.h>
#include <ctype.h>
#include <time.h>
#include <locale.h>
#include <setjmp.h>



#include "os.h"
#include "bbc.h"
#include "flex.h"
#include "werr.h"
#include "wimp.h"
#include "akbd.h"

#include "alloc.h"
#include "fsx.h"
#include "filetype.h"
#include "bits.h"
#include "trans.h"
#include "etc.h"
#include "wos.h"
#include "poll.h"
#include "timex.h"
#include "xmath.h"
#include "err.h"
#include "conf.h"
#include "osreg.h"
#include "deb.h"
#include "scanplus.h"
#include "key.h"
#include "osthread.h"
#include "scrap.h"


#include "xext.h"
#include "xint.h"





/*****************************************************************************/

char * errmessages[MAXERRNO]=
{
 "{XNEEDED}",
 "{XMATCH}",
 "{XTOKEN}",
 "{XTYPE}",
 "{XLVALUE}",
 "{XBTYPE}",
 "{XBADARG}",
 "{XWRARG}",
 "{XIDENT}",
 "{XMULT}",
 "{XCONST}",
 "{XSTATE}",
 "{XBREAK}",
 "{XCONT}",
 "{XPRES}",
 "{XSWITCH}",
 "{XDEFLT}",
 "{XRETURN}",
 "{XARGS}",
 "{XDIVZ}",
 "{XMEM}"
};


static jmp_buf xraisejmp;

int        xerrflags;
os_error * xerrpointer;



void xraise(int errno,...)
{
 va_list args;
 char    v[256];
 char    format[256];
 int     len;


 xzstrncpy(format,errmessages[errno],sizeof(format));
 trans(format,sizeof(format));

 va_start(args, errno);
 VSNPRINTF(v,sizeof(v),format,args,len);

 va_end(args);

/*
 if(!throwbackstart())
 {
  throwbacksend(Throwback_ReasonProcessing,lexfile);
  throwbacksend(Throwback_ReasonErrorDetails,lexfile,lexline,2,v);

  throwbackend();
 }
 else
*/
	if(xerrflags & XERRNOREPORT)
	{
		xerrpointer=generror(0,transtoken("XERR"),v,lexline,lexfile);
	}
	else
	{
  werr(0,"{XERR}",v,lexline,lexfile);
	}


//	cprintf("xerr");
 longjmp(xraisejmp,1);
}


/*****************************************************************************/
/* Library functions */


void printi(int fp)
{
 printf("%d",stack[fp]);
}


void prints(int fp)
{
 printf("%s",stringptr(stack[fp]));
}



void debprints(int fp)
{
 xcprintf("%s",stringptr(stack[fp]));
}


void debprinti(int fp)
{
 xcprintf("%d",stack[fp]);
}



/* string to int */

int stoi(int fp)
{
 return(atoi(stringptr(stack[fp])));
}


/* int to dec string */

int itos(int fp)
{
 char temp[16];
 xsprintf(sizeof(temp),NULL,temp,"%d",stack[fp]);
 return(createstring(temp));
}


/* to hex string */

int itoxs(int fp)
{
 char temp[16];
 xsprintf(sizeof(temp),NULL,temp,"%x",stack[fp]);
 return(createstring(temp));
}


/* return char n of string */

int schar(int fp)
{
 return(*(stringptr(stack[fp])+stack[fp+1]));
}


/* make string of char */

int chars(int fp)
{
 char temp[16];
 temp[0]=stack[fp];
 temp[1]=0;
 return(createstring(temp));
}

/* string len */

int slen(int fp)
{
 return(stringlen(stack[fp]));
/* return(strlen(stringptr(stack[fp]))); */
}


/* string mids(string s,int start,int len) */

int mids(int fp)
{
 int    s;
 char * p;
 char * q;
 int    len;
 int    slen;
 int    start;

 start=stack[fp+1];
 len=stack[fp+2];
 slen=stringlen(stack[fp]); /* C style doesn't count last 0 */

 if(start<0) start=0;
 if(start>slen) start=slen;

 if(len<0) len=0;
 if((len+start)>slen) len=slen-start;

 s=mkstring(len);

 p=stringptr(stack[fp])+start;
 q=stringptr(s);

 memcpy(q,p,len);
 *(q+len)=0;

 return(s);
}


int sins(int fp)
{
 char * p;
 char * q;
 int    from;

 from=stack[fp+2];
 if(from<stringlen(stack[fp]))
 {
  p=stringptr(stack[fp]);
  q=stringptr(stack[fp+1]);

  q=strstr(p+from,q);
  if(q) return(q-p);
 }
 return(-1);
}



int identifier(int fp)
{
	int      internal;
 symstr * sx;
	int      argc;
	int						type;
	int      mode;
	int      sym;

 sym=xfindi(stringptr(stack[fp]),&internal);
 if(sym==XSNOTFOUND) return(-1);

 if(internal)    /* internal function */
 {
  argc=((fndefn*)sym)->argc;
		type=((fndefn*)sym)->type;
		mode=PXFN;
 }
 else
 {
  sx=xptr(sym);
  argc=sx->argc;
		type=sx->type;
		mode=sx->mode;
 }

	return(type|(mode<<8)|(argc<<16));
}




void bbcvdu(int fp)
{
 bbc_vdu(stack[fp]);
}


void bbcplot(int fp)
{
	bbc_plot(stack[fp],stack[fp+1],stack[fp+2]);
}

int bbcinkey(int fp)
{
 return(bbc_inkey(stack[fp]));
 return(0);
}


int cs_isshift(int fp)
{
 return(isshift);
}

int cs_isctrl(int fp)
{
 return(isctrl);
}

int cs_isalt(int fp)
{
 return(isalt);
}



int bbcadval(int fp)
{
// return(bbc_adval(stack[fp]));
 return(0);
}


int bbcget(int fp)
{
 return(0);
 //return(bbc_get());
 fp=0;
}


void bbcgcol(int fp)
{
	bbc_gcol(stack[fp],stack[fp+1]);
}


int getenvs(int fp)
{
 char * p=getenv(stringptr(stack[fp]));

 if(p) 
 {
  assignstring(stack[fp],p);
  return(1);
 }
 else
  return(0);
}



int getregs(int fp)
{
 os_error * err;
 char       string[MAX_PATH];
 int        size;

 size=sizeof(string);

 err=regreadstr(stringptr(stack[fp]),string,&size);
 if(err || size==0) return(0);

 assignstring(stack[fp],string);

 return(1);
}



#ifdef NEVER

int osclis(int fp)
{
 os_error * ep;

// ep=os_cli(stringptr(stack[fp]));

 ep=NULL;

 if(ep)
 {
  assignstring(stack[fp],ep->errmess);
  return(1);
 }
 else
  return(0);

}

#endif



int xoscommand(int fp)
{
 os_error * err;

 err=oscommand(stack[fp],stringptr(stack[fp+1]),stringptr(stack[fp+2]),
               stringptr(stack[fp+3]),stringptr(stack[fp+4]),stack[fp+5]);

 if(err)
 {
  assignstring(stack[fp+6],err->errmess);
  return(1);
 }
 else
 {
  assignstring(stack[fp+6],"");
  return(0);
 }
}



int systems(int fp)
{
 char string[MAX_PATH];
 xzstrncpy(string,stringptr(stack[fp]),sizeof(string));
 return(system(string));
}



int xrunexe(int fp)
{
	os_error * err;
 int        exitcode;

	err=runexe(stringptr(stack[fp]),&exitcode);

	zreport(err);

	return(exitcode);
}




void xtranslate(int fp)
{
 char string[1024];
 xzstrncpy(string,stringptr(stack[fp]),sizeof(string));
 trans(string,sizeof(string));
 assignstring(stack[fp],string);
}




void ourfx(int fp)
{
	zreport(fx(stack[fp],stack[fp+1],stack[fp+2]));

}






static filetypelink  xfiletypelink;
static filetypetag * xfiletypetable;
static filetypetag   xendtag={FTLAST,NULL,NULL};
static int           xnfiletypes;

#define XFCHUNK (8*sizeof(filetypetag))


// void addfiletype(char * extension,char * description,int type)

void xaddfiletype(int fp)
{
 os_error * err;
 char     * adata;
 int        elen;
 int        dlen;

 err=schunk((flex_ptr)&xfiletypetable,(xnfiletypes+1)*sizeof(filetypetag),XFCHUNK);
 if(!err)
 {
  elen=stringlen(stack[fp+0])+1;
  dlen=stringlen(stack[fp+1])+1;

  err=salloc((flex_ptr)&adata,elen+dlen);
  if(!err)
  {
   strcpy(adata,stringptr(stack[fp]));
   strcpy(adata+elen,stringptr(stack[fp]));

   xfiletypelink.tags=xfiletypetable;

   xfiletypetable[xnfiletypes].filetype=stack[fp+2];
   xfiletypetable[xnfiletypes].extension=adata;
   xfiletypetable[xnfiletypes].description=adata+elen;
   xnfiletypes++;
   xfiletypetable[xnfiletypes]=xendtag;
  }
 }

 zreport(err);
}


static os_error * xfiletypesinit(void)
{
 os_error * err;

 err=salloc((flex_ptr)&xfiletypetable,sizeof(filetypetag));
 if(!err)
 {
  *xfiletypetable=xendtag;
  xnfiletypes=0;
  addfiletypetable(xfiletypetable,&xfiletypelink);
 }

 return(err);
}



#ifdef NEVER

/* return r1, use r0,r1,r2 */

int ourswi13(int fp)
{
/*
 os_regset rx;

 memcpy(rx.r,stack+fp+1,3*sizeof(int));
 os_swix(stack[fp],&rx);

 return(rx.r[1]);
*/
 return(0);
}


int ourswin4(int fp)
{
/*
 os_regset rx;
 int       n;

 n=stack[fp];
 memcpy(rx.r,stack+fp+2,4*sizeof(int));
 os_swix(stack[fp+1],&rx);
 return(rx.r[n]);
*/
 return(0);
}




int ourswin8(int fp)
{

/* os_regset rx;
 int       n;

 n=stack[fp];
 memcpy(rx.r,stack+fp+2,8*sizeof(int));
 os_swix(stack[fp+1],&rx);
 return(rx.r[n]);
*/

 return(0);
}


#endif



int xscale(int fp)
{
 return(scale(stack[fp],stack[fp+1],stack[fp+2]));
}




#define MAXFILE 16

static FILE * fpn[MAXFILE];



/* int    fileopen(string & name,string & mode)  // open file  */
/* returns file handle >0
   or 0 if file can't be opened. */


int fileopen(int fp)
{
 int i;

 for(i=0;i<MAXFILE;i++) if(!fpn[i]) break;

 if(i==MAXFILE) zraise(ZFILEMAX);

 fpn[i]=fopen(stringptr(stack[fp]),stringptr(stack[fp+1]));

 if(fpn[i]) return(i+1);
 else       return(0);
}



/* int    fileclose(int handle);                  // close file */
/* return 0 if sucessfuly closed
   or non zero on error. */


int fileclose(int fp)
{
 int i=stack[fp]-1;
 int code; 

 code=1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  code=fclose(fpn[i]);
  fpn[i]=0;
 }

 return(code);
}



/* int    filewrites(string & s,int handle);      // write string to file */
/* return non zero on error
   or         0 if OK

   Trailing zero not written.
 */

int filewrites(int fp)
{
 int i=stack[fp+1]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(fputs(stringptr(stack[fp]),fpn[i]));
 }
 return(1);
}




/* int    filewritei(int i,int handle);           // write int    to file */
/* return non zero on error
           0 if OK */


int filewritei(int fp)
{
 int i=stack[fp+1]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(!fwrite(&(stack[fp]),4,1,fpn[i]));
 }
 return(1);
}




/* int    fileerror(int handle);                  // check for error */
/* return non zero if an error has occured
   or  0 if OK */

int fileerror(int fp)
{
 int i=stack[fp]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(ferror(fpn[i]));
 }
 return(1);
}



/* int    fileeof(int handle);                    // check for eof   */
/* return non zero on EOF
   or 0 if not eof */

int fileeof(int fp)
{
 int i=stack[fp]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(feof(fpn[i]));
 }
 return(1);
}



/* int    filereadi(int handle);                  // read int        */
/* return integer read */

int filereadi(int fp)
{
 int i=stack[fp]-1;
 int temp;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  fread(&temp,4,1,fpn[i]);

  return(temp);
 }
 return(0);
}





/* int    filereads(string & s,int handle);       // read string     */
/* return non zero on error
   or         0 if OK */

#define SBFLEN 1024


static int filereads2(int fp,int strip)
{
 int    i=stack[fp+1]-1;
 char   temp[SBFLEN];
 int    s=stack[fp];
 int    first;
 char * p;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  first=1;

  while(1)
  {
   if(fgets(temp,SBFLEN,fpn[i]))
   {
    if(strip)
    {
     p=temp+strlen(temp)-1;
     while(p>=temp)
     {
      if(*p=='\r' || *p=='\n') *p--=0;
      else                     break;
     }
    }

    if(first)
    {
     assignstring(s,temp);
     first=0;
    }
    else
    {
     appendstring(s,temp);
    }
   }

   if(ferror(fpn[i])) return(1);
   if(feof(fpn[i]))
   {
    if(first) return(1);
    else      break;
   }
   if(strlen(temp)<(SBFLEN-1) || temp[SBFLEN-2]=='\n') break;
  }
  return(0);
 }
 return(1);
}



int filereads(int fp)
{
 return(filereads2(fp,0));
}


int filereadtext(int fp)
{
 return(filereads2(fp,1));
}



/* int    fileput(int i,int handle);              // put byte to file */
/* return the character written or EOF on error */

int fileputc(int fp)
{
 int i=stack[fp+1]-1;

// cprintf("put %d",stack[fp]);

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(fputc(stack[fp],fpn[i]));
 }
 return(EOF);
}




/* int    fileget(int handle);                    // get byte from file */
/* return byte or EOF on error */

int filegetc(int fp)
{
 int i=stack[fp]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(fgetc(fpn[i]));
 }
 return(EOF);
}



/* int    fileseek(int offset,int handle);  */
/* return non zero for an improper request
   or 0 if OK */


int fileseek(int fp)
{
 int i=stack[fp+1]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return(fseek(fpn[i],stack[fp],SEEK_SET));
 }
 return(1);
}


/* int    filetell(int handle);  */
/* return -1 on error or the file position >=0 if OK. */

int filetell(int fp)
{
 int i=stack[fp]-1;

 if(i>=0 && i<MAXFILE && fpn[i])
 {
  return((int)ftell(fpn[i]));
 }
 return(-1);
}


// void scrapname(int sh,string & name)

void scrapname(int fp)
{
 char * p;

 p=sc_namex(stack[fp]);

 zreport(assignstring(stack[fp+1],p));
}


// int scrapcreate(void)

int scrapcreate(int fp)
{
 int sh;

 zreport(sc_create(&sh));

 return(sh);
}

// void scrapremove(int sh)

void scrapremove(int sh)
{

 zreport(sc_remove(sh,NULL));
}





/* void gettimestring(string & format,string &  result) */

void xtimestring(int fp)
{
 arctime timex;
 char    format[128];
 char    result[128];

 getcurtime(&timex);

 xzstrncpy(format,stringptr(stack[fp]),sizeof(format));

 writets(result,format,&timex);

 assignstring(stack[fp+1],result);
}



/* void gettimestamp(string & format,string & result,string & path); */

void gettimestamp(int fp)
{
 arctime timex;
 char    format[128];
 char    result[128];
 fstat   f;

 fs_stat(stringptr(stack[fp+2]),&f);
 filetime(&f,&timex);

 xzstrncpy(format,stringptr(stack[fp]),sizeof(format));
 writets(result,format,&timex);
 assignstring(stack[fp+1],result);
}



/* void gettimeformat(string & date,string & time) */

void xtimeformat(int fp)
{
 assignstring(stack[fp],sysdstring);
 assignstring(stack[fp+1],syststring);
}




void xerrorbox(int fp)
{
 zraise(ZUSER,stringptr(stack[fp]));
}

int xmessagebox(int fp)
{
 return(messagebox(stringptr(stack[fp])));
}


int xconfirm(int fp)
{
 int result;
 confirmparent(NULL,CONYN,&result,stringptr(stack[fp]));
 return(result);
}


int xconfirmparent(int fp)
{
 int result;
 confirmparent(stack[fp+1],CONYN,&result,stringptr(stack[fp]));
 return(result);
}



void xexit(int fp)
{
 zraise(ZEXIT);
 fp=0;
}


int xobjectexists(int fp)
{
 int type;
 if(fs_exists(stringptr(stack[fp]),&type)) type=0;
 return(type);
}


static fsscanhandle xscanposn;

void xstartscan(int fp)
{
 fs_loadscan(xscanposn);
 fs_endscan();
 fs_startscan();
 fs_savescan(&xscanposn);
 USE(fp);
}




int xnextobject(int fp)
{
 os_error * err;
 fxstat     f;
 int        eof;

 fs_loadscan(xscanposn);
 err=fs_nextitem(stringptr(stack[fp]),&f,stringptr(stack[fp+1]),&eof);
 fs_savescan(&xscanposn);
 if(!err)
 {
  if(!eof)
  {
   assignstring(stack[fp+2],f.name);
   return(f.f.object);
  }
  else return(0);
 }
 else return(0);
}




int xosversion(int fp)
{
 return(osversion());
 USE(fp);
}




static int pauseflag;

static void xpausezero(int userhandle)
{
 pauseflag=1;
 USE(userhandle);
}

void xpause(int fp)
{
 pauseflag=0;
 addscheduledevent(xpausezero,0,stack[fp]);
 while(!pauseflag) poll();
}


int * xstackptr(void)
{
 return(stack);
}







typedef struct programstage
{
 int code;
 int stage;
 int nostrings;
} programstage;



static programstage * prstack; 
static int            prstages;



/* removes the last file */

os_error * xremfile(void)
{
 if(prstages)
 {
  prstages--;

  xcodesize=prstack[prstages].code;
  flex_chunk((flex_ptr)&xcodeheap,xcodesize,XCODECHUNK);

  xremstage(prstack[prstages].stage);

  setstrings(prstack[prstages].nostrings);

  flex_chunk((flex_ptr)&prstack,prstages*sizeof(programstage),PRSTACKCHUNK);
 }
 return(NULL);
}



static os_error * xrunmain(int * result)
{
 if(xfinds("main",xnsyms)!=XSNOTFOUND)
 {
  return(xexec("main",result,""));
 }
 return(NULL);
}




static os_error * xrunmain2(int * result,int rarg,int inval,int inval2)
{
 if(xfinds("main",xnsyms)!=XSNOTFOUND)
 {
  return(xexec("main",result,"sII",rarg,inval,inval2));
 }
 return(NULL);
}




/* adds another file to program */
/* return 1 OK 0 ERROR          */

os_error * xaddfile(char * filename,char * data,int length,int rarg,int exec,
                    int * result,int inval,int inval2)
{
 os_error * err;
 int        mode;
 int        remove;

 mode=((exec & 0xF0)>>4);
 remove=exec & 0x2;
 exec=exec & 0x1;

 *result=0;

/* dprintf(0,"xadd %s",filename); */


//		cprintf("xaddfile");

 err=lexstart(filename,mode,data,length);
 if(!err)
 {
  if(!setjmp(xraisejmp))
  {

   err=flex_chunk((flex_ptr)&prstack,
                         (prstages+1)*sizeof(programstage),PRSTACKCHUNK);
   if(!err)
   {
    prstack[prstages].code=xcodesize;
    prstack[prstages].stage=xaddstage();
    prstack[prstages].nostrings=nostrings;
    prstages++;

//		cprintf("xaddfile parse");

    err=xparse();
   }



   if(!err) err=lexend(mode);
   else         lexend(mode);

//			cprintf("xadd err %x exec %d",err,exec);

   if(exec)
   {
    if(rarg) xrunmain2(result,rarg,inval,inval2);
    else     xrunmain(result); /* NB we are using result to flag */
                               /* compilation not run result     */
   }


   if(remove) xremfile();



   *result=1;
   return(err);
  }
  else
  {
   err=lexend(mode);
   xremfile();
  /* *result=ZRLEXERR; */
   return(err);
  }
 }


 return(err);
}



/* think about name not found, apart from real errors */

os_error * addfiles(char * name,int remove)
{
 os_error   * err;
 fxstat       f;
 char         temp[MAX_PATH];
 int          code;
 char       * p;
 int          eof;
 fsscanhandle scan;

 err=fs_stat(name,&f.f);
 if(!err && f.f.object==2)
 {
  xzstrncpy(temp,name,sizeof(temp));
  p=temp+strlen(temp);
	 
  err=fs_startsortscan(temp,TEXT("*.csc"),0,&scan);
  if(!err)
  {
   while(1)
   {
    err=fs_nextsortitem(scan,&f,&eof);
   	if(err) break;
    if(eof) break;
//    fs_savescan(&save);

    if(f.f.object==1)
    {
     *p='\\';
     xzstrncpy(p+1,f.name,sizeof(temp)-(p-temp));

     xaddfile(temp,NULL,0,0,1,&code,0,0);
     if(remove && code) xremfile();

     *p=0;
    }

//    fs_loadscan(save);
   }

   fs_endsortscan(&scan);
  }
 }

 return(err);
}







os_error * adddoublefiles(char * name0,char * name1,int remove)
{
 os_error   * err;
 fxstat       f;
 TCHAR        temp[MAX_PATH];
 int          code;
 int          eof;
 fsscanhandle scan;
 int          flags;


 err=fs_stat(name0,&f.f);
 if(!err && f.f.object==2)
 {
  err=fs_startdoublesortscan(name0,name1,TEXT("*.csc"),0,&scan);
  if(!err)
  {
   while(1)
   {
    err=fs_nextdoublesortitem(scan,&f,&eof,&flags);
   	if(err) break;
    if(eof) break;

    if(f.f.object==1)
    {
     fs_join(temp,NITEM(temp),(flags & 0x1)?name1:name0,f.name);
     xaddfile(temp,NULL,0,0,1,&code,0,0);
     if(remove && code) xremfile();
    }
   }

   fs_endsortscan(&scan);
  }
 }

 return(err);
}




/* return 1==OK 0==ERROR */

static int lastcode;

int runscript(char * filename,int exec)
{
 int code;

 xaddfile(filename,NULL,0,0,0,&code,0,0);
	lastcode=code;
 if(code && exec)
 {
  xrunmain(&code);
  xremfile();
		lastcode=0;
 }

 return(code);
}



void runscriptpost(void)
{
 int code;

	if(lastcode)
	{
  xrunmain(&code);
  xremfile();
	}
}



#ifdef NEVER

int xexecstuff(char * stuff,int rarg)
{
 int code;

 xaddfile(stuff,rarg,1|(rarg?(1<<5):(1<<4)),&code);
 if(code) xremfile();

 return(code);
}


os_error * xexecstuff2(char * stuff,int rarg)
{
 int code;

	xerrpointer=NULL;

 xaddfile(stuff,rarg,1|(rarg?(1<<5):(1<<4)),&code);
 if(code) xremfile();

 if(!code)
 {
	 if(xerrflags & XERRNOREPORT)	return(xerrpointer);
		else                         return(geterror(EREPORTED));
	}
 else      return(NULL);
}

#endif




os_error * xexecstuff3(char * stuff,int rarg,int inval,int inval2)
{
 int code;

//	cprintf("xe3 in ");

	xerrpointer=NULL;

 xaddfile(stuff,NULL,0,rarg,1|(rarg?(1<<5):(1<<4)),&code,inval,inval2);
 if(code) xremfile();

//	cprintf("xe3 ex ");

 if(!code)
 {
	 if(xerrflags & XERRNOREPORT)	return(xerrpointer);
		else                         return(geterror(EREPORTED));
	}
 else      return(NULL);
}



os_error * xerrormode(int flags)
{
	xerrflags=flags;

 return(NULL);
}




os_error * xstart(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&prstack,PRSTACKCHUNK);
 prstages=0;

 if(!err) err=xsymstart();
 if(!err) err=xstringstart();
 if(!err) err=xcodestart();
 if(!err) err=xfiletypesinit();

 return(err);
}

