/*->c.clip */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "alloc.h"
#include "transform.h"
#include "xprocess.h"
#include "ram.h"


#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "filetype.h"
#include "bf.h"
#include "trans.h"
#include "xmath.h"
#include "etc.h"
#include "oscbx.h"
#include "deb.h"
#include "dbhi.h"


#include "str.h"
#include "constants.h"
#include "units.h"
#include "xcolour.h"
#include "toolstr.h"
#include "tools.h"
#include "mhi.h"
#include "object.h"
#include "undo.h"
#include "chain.h"
#include "frameflow.h"
#include "objectdb.h"


#include "main.h"
#include "file.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"


#include "txstr.h"
#include "pxstr.h"

#include "new.h"
#include "newx.h"

#include "select.h"
#include "posn.h"
#include "impex.h"

#include "frametool.h"

#include "clip.h"






#define UPASTES        0x1200
#define UPASTEF        0x1201
#define UPASTEDEL      0x1202


#define CLIPMARGIN 6000


#define MAXFTYPE 16


typedef struct cbstr
{
 filestr * file;
 int       type;
 int       page;
 int       sect;
 int       object;
 int     * ftypes;
 int       fdata[MAXFTYPE];

} cbstr;


static int cbmax=1;     /* max number of cb's */
static int cbcur;       /* index of ccb       */

static cbstr * cbs;

static cbstr   ccb;



static int       cbshow;
static windowstr cbwindow;






/***************************************************************************/
/* Global clipboard */


static int globalclip;

static int localobjecttype;
static int localsectiontype;
static int localpixtype;
static int localtxtype;


typedef struct clipmapstr
{
 int filetype;
 int cliptype;

} clipmapstr;


#define CF_RTF  (-1)
#define CF_HTML (-2)


static clipmapstr clipmap[]=
{
	UNICODETEXTFILE,CF_UNICODETEXT,
 TEXTFILE,CF_TEXT,
#ifdef CLIPFANCY
	RTF,CF_RTF,
	HTMLFILE,CF_HTML,
#endif
 DIB,CF_DIB,
 EMETAF,CF_ENHMETAFILE,
 WMETAF,CF_METAFILEPICT,
 0,0


};




// add CF_DISPLAYFORMAT


static int clip_object[]=     // CLIP_OBJECT              0x0
{
 0,
 0,
};


static int clip_pixcontents[]=     // CLIP_PIXCONTENTS         0x1
{
 0,
 0,
};


static int clip_textcontents[]=     // CLIP_TEXTCONTENTS         0x2
{
 0,
 CF_TEXT,
	CF_UNICODETEXT,
#ifdef CLIPFANCY
	CF_RTF,
	CF_HTML,
#endif
 0,
};



static int clip_section[]=     // CLIP_SECTION              0x4
{
 0,
 0,
};




static int * cbformats[5]=
{
 clip_object,
 clip_pixcontents,
 clip_textcontents,
 NULL,                 // CLIP_GLOBAL              0x3
 clip_section,

};



int clipgetfiletype(int cbformat)
{
 clipmapstr * map;

 map=clipmap;
 while(1)
 {
  if(map->cliptype==0) break;
  if(map->cliptype==cbformat) return(map->filetype);
  map++;
 }

 return(0);
}



int clipgetformat(int filetype)
{
 clipmapstr * map;

 map=clipmap;
 while(1)
 {
  if(map->cliptype==0) break;
  if(map->filetype==filetype) return(map->cliptype);
  map++;
 }

 return(0);
}



static os_error * cbrender(int format)
{
	os_error * err;
 int        ack;
 void     * data;
 void     * global;
 int        length;
 int        filetype;

 ack=0;
 
 cprintf("cbrender %d",format);

 filetype=clipgetfiletype(format);

 event(EVENT_GLOBALPASTE,(void*)&ack,filetype);
 if(!ack)
 {
  ramnextwritefile(&data,&length);
  err=savedocs("",ccb.file,FTYPE2);
		if(!err)
		{
			if(data!=NULL && length!=0)
 		{
    oscballoc((void**)&global,length);
    memcpy(global,data,length);
			}
		}
//  cprintf("ramwrite off2");
  ramwriteoff();
 }

 return(NULL);
}



static int cbemptydefeat; // don't want claim to issue empty and scrap what is on cb

static os_error * cbempty(void)
{
 os_error * err;

 err=NULL;

 if(cbemptydefeat==0)
 {
           err=clipstart(NULL,NULL,NULL,NULL);
  if(!err) err=clipend(CLIP_EMPTY,NULL);

  cprintf("cbempty");
 }

 return(err);
}




static os_error * claimclipboard(int type,int * ftypes)
{
 os_error * err;
 int        formats[MAXFTYPE];
 int      * formatp;
 int      * p;
 int      * q;
 int        w;
 int        cbf;

 err=NULL;

 if(globalclip)
 {
  cprintf("claim clipboard %x",ftypes);

  if(ftypes)
  {
   q=formatp=formats;

   p=cbformats[type];
   while((w=*p)!=0)
   {
    *q++=*p++;
   }

   p=ftypes;

   cprintf("ftype[0] %x",ftypes[0]);

   while((w=*p)!=0)
   {
    cprintf("add ftype %x",w);

    cbf=clipgetformat(w);
    if(cbf)
    {
     cprintf("add %d",cbf);

     *q++=cbf;
    }
    p++;
   }

   *q++=0;
  }
  else
  {
   formatp=cbformats[type];
  }


  cbemptydefeat=1;
  oscbcopy(formatp,cbrender,cbempty,0); 
  cbemptydefeat=0;
 }

 return(err);
}





// loading an unknown file type from clipboard - can this happen on Win?

static os_error * dopasteglobal(filestr * file)
{
 os_error   * err;
 viewstr    * view;
 sobjectstr * sob;
 int          page;
 int          section;
 sectionstr * sectionp;
 int          object;
 posnstr      loadposn;
 int          cbtype;
 int        * ftypes;

 err=NULL;

	cprintf("dopasteglobal");


 if(nselected(&object,file)==1)
 {
  memset(&loadposn,0,sizeof(posnstr));
  
  sob=(sobjectstr*)fob_find(object,file);
  loadposn.object=object;
  loadposn.otype=sob->type;
  loadposn.file=file;

  pagesectionof((chainobject*)sob,file,&page,&section);

  loadposn.page=page;
  loadposn.section=section;

  sectionp=(sectionstr*)fob_find(section,file);
  view=file->view;
  while(view)
  {
   if((int)sectionp->branch==view->branch) break;
   view=view->next;
  }

  if(view)
  {
   loadposn.view=view;

   clipboardtype(&cbtype,&ftypes);

			cprintf("dopaste global importglobal %x %x",ftypes[0],ftypes[1]);

   err=importglobal(NULL,&loadposn,ftypes[0],OBDIRECTLOAD);
  }
 }

 return(err);
}









static os_error * globalclipboardinit(void)
{
 os_error * err;
#ifdef CLIPFANCY
	int        rtftype=0;
	int        htmltype=0;
#endif
	int        i;

 err=NULL;

//          err=oscbinit(OSCB_OLE);
            err=oscbinit(0);
 if(!err) err=oscbnametype("Ovation object",&localobjecttype);
 if(!err) err=oscbnametype("Ovation chapter",&localsectiontype);
 if(!err) err=oscbnametype("Ovation text",&localtxtype);
 if(!err) err=oscbnametype("Ovation picture",&localpixtype);


#ifdef CLIPFANCY
 if(!err) err=oscbnametype("Rich Text Format",&rtftype);
 if(!err) err=oscbnametype("HTML Format",&htmltype);
#endif


 clip_object[0]=localobjecttype;
 clip_pixcontents[0]=localpixtype;
 clip_textcontents[0]=localtxtype;
 clip_section[0]=localsectiontype;

#ifdef CLIPFANCY

	for(i=0;i<sizeof(clipmap);i++)
	{
		if(clipmap[i].cliptype==CF_RTF) clipmap[i].cliptype=rtftype;
		if(clipmap[i].cliptype==CF_HTML) clipmap[i].cliptype=htmltype;
	}

	for(i=0;i<sizeof(clip_textcontents);i++)
	{
		if(clip_textcontents[i]==CF_RTF) clip_textcontents[i]=rtftype;
		if(clip_textcontents[i]==CF_HTML) clip_textcontents[i]=htmltype;
	}


#endif

 return(err);
}



static os_error * globalclipboardfinit(void)
{
 os_error * err;
 
 
 err=oscbfinit(0);
 

 return(err);
}



/****************************************************************************/
/* clip board code */




/* another in c.dbnew */

static newstr clipnewdata=
{
  595276,             /* width         */
  841890,             /* height        */
  "A4",               /* size A4       */

  OURWHITE, OURWHITE, /* page colour         */
  
  FILLSTR,  FILLSTR,  /* fill                */

  0,0,                /* mainkey             */


  0,                  /* portrait      */
  0,                  /* user size     */
  0,                  /* spare         */


  0,                  /* single sided  */


  0,                  /* omit header   */
  0,                  /* omit footer   */
  PNFNUMERIC,         /* page number format  */
  1,                  /* start               */
  0,                  /* start on right      */
  1,                  /* number              */



  0,                  /* section number      */



  NEWMODEBOTH,

  1,        1,        /* columns             */
  0,        0,        /* principle frame     */
  34016,    34016,    /* top margin          */
  56692,    56692,    /* bot margin          */
  34016,    34016,    /* left margin         */
  34016,    34016,    /* right margin        */
  0,        0,        /* header margin       */
  0,        0,        /* footer margin       */


  0,                  /* column mode         */
  0,                  /* column guides       */
  MMSIZE,             /* guide width         */
  14173,              /* column width        */
  OURBLACK,           /* column guide colour */


  0,                  /* right hand values   */
  0,
  MMSIZE,
  14173,
  OURBLACK,


  MILIMS,             /* units               */


  0,0,0,0             /* spare [4]            */

};




#define FTCHUNK (8*sizeof(int))


os_error * clipboardtype(int * cbtype,int ** ftypes)
{
 os_error * err;
 int      * formats;
 int      * f;
 static int * ftypestack;
 int        fcount;
 int        filetype;

 if(globalclip)
 {
  err=oscbavailable(&formats);
  if(*formats==OSCB_LOCAL)
  {
   *cbtype=ccb.type;
  }
  else
  {
   if(formats[0]==0)                *cbtype=CLIP_EMPTY;
   else
   if(formats[0]==localobjecttype)  *cbtype=CLIP_OBJECT;
   else
   if(formats[0]==localsectiontype) *cbtype=CLIP_SECTION;
   else
   if(formats[0]==localpixtype)     *cbtype=CLIP_PIXCONTENTS;
   else
   if(formats[0]==localtxtype)      *cbtype=CLIP_TEXTCONTENTS;
   else
   {
    *cbtype=CLIP_GLOBAL;
    if(ftypes)
    {
     f=formats;
     fcount=1;
     while(1)
     {
      err=schunk((flex_ptr)&ftypestack,fcount*sizeof(int),FTCHUNK);
      if(err) break;

      cprintf("cb type %d",*f);

      if(*f==0)
      {
       ftypestack[fcount-1]=0;
       break;
      }
   	  else
      {
	      filetype=clipgetfiletype(*f);
	      if(filetype)
       {
        ftypestack[fcount-1]=filetype;
								fcount++;
								cprintf("filetype %x",filetype);
//        break;
       }
      }
      f++;
     }
     *ftypes=ftypestack;
    }
   }
  }
//  cprintf("cbtype %d formats[0]=%d",*cbtype,formats[0]);
 }
 else
 {
  *cbtype=ccb.type;
 }

 return(NULL);
}





/*****************************************************************************/
/* hints used to see if we can copy from inside current file                 */

typedef struct cliphintstr
{
 int       old;
 int       xnew;
 filestr * file;
 filestr * cbfile;
} cliphintstr;


#define CLIPHINTCHUNK (8*sizeof(cliphintstr))


static cliphintstr * cliphints;
static int           clipn;


void setcliphint(filestr * xsfile,int xnew,int xold)
{
 int i;

 for(i=0;i<clipn;i++)
 {
  if(cliphints[i].file==xsfile && cliphints[i].cbfile==ccb.file &&
     cliphints[i].xnew==xnew && cliphints[i].old==xold) break;
 }

 if(i>=clipn)
 {
  if(!flex_chunk((flex_ptr)&cliphints,(clipn+1)*sizeof(cliphintstr),
                                                           CLIPHINTCHUNK))
  {
   cliphints[clipn].file=xsfile;
   cliphints[clipn].cbfile=ccb.file;
   cliphints[clipn].xnew=xnew;
   cliphints[clipn++].old=xold;
  }
 }
}


int getcliphint(filestr * file,int xnew)
{
 int i;

 cprintf("get clip hint");

 for(i=0;i<clipn;i++)
 {
  if(file==cliphints[i].file && ccb.file==cliphints[i].cbfile &&
       xnew==cliphints[i].xnew)
  {
   if(fob_find(cliphints[i].old,file)) {cprintf("clip hint hit %x",cliphints[i].old);return(cliphints[i].old);}
   break;
  }
 }
 return(0);
}



int getcliphintr(filestr * file,int old)
{
 int i;

 cprintf("get clip hint reverse");

 for(i=0;i<clipn;i++)
 {
  if(file==cliphints[i].file && ccb.file==cliphints[i].cbfile &&
      old==cliphints[i].old)
  {
   return(cliphints[i].xnew);
  }
 }
 return(0);
}





static os_error * cliphintclose(int eventn,int user,filestr * file,int data1)
{
 int r;
 int w;

 for(w=r=0;r<clipn;r++)
 {
  if(file!=cliphints[r].file)
  {
   if(r!=w) cliphints[w]=cliphints[r];
   w++;
  }
 }

 clipn=w;

 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}



static void scrapcliphints(filestr * cbfile)
{
 int r;
 int w;

 for(w=r=0;r<clipn;r++)
 {
  if(cbfile!=cliphints[r].cbfile)
  {
   if(r!=w) cliphints[w]=cliphints[r];
   w++;
  }
 }

 clipn=w;
}



static os_error * cliphintstart(void)
{
 clipn=0;
 if(!cliphints) return(flex_alloc((flex_ptr)&cliphints,CLIPHINTCHUNK));
 return(NULL);
}


/*****************************************************************************/



os_error * clipupdate(void)
{
 sectionstr * sectp;

 ccb.sect=ccb.file->hdr.section[DOC];

 sectp=(sectionstr*)fob_find(ccb.sect,ccb.file);
 ccb.page=sectp->chain.child;

 return(NULL);
}





os_error * clipstart(boxstr * box,int * page,int * sect,filestr ** file)
{
 os_error   * err;
 char         name[64];
 viewstr    * view;


 err=NULL;

 cbshow=0;

 if(ccb.file)
 {
  if(ccb.file->viewn[DOC])
  {
   view=ccb.file->view;
   cbshow=view->handle;
   viewsetwindow(view,&cbwindow);
  }

  closefile(ccb.file);
  closedoc(ccb.file);
  scrapcliphints(ccb.file);
 }



 if(box)
 {
  clipnewdata.sectiondata.width=box->w+2*CLIPMARGIN;
  clipnewdata.sectiondata.height=box->h+2*CLIPMARGIN;
  box->x-=CLIPMARGIN;
  box->y-=CLIPMARGIN;
 }

 if(cbmax>1) tsprintf(sizeof(name),name,"{CB00}%d",cbcur+1);
 else        tsprintf(sizeof(name),name,"{CB00}");

	clipnewdata.compatability=maxcompatability;

 if(!err) err=createnewdoc(&clipnewdata,&ccb.file,name);
 if(!err)
 {
  undozerosize(ccb.file);

  ccb.file->permanent=ccb.file->alwayspermanent=1;
  ccb.file->notools=1;
  ccb.file->notuserfile=1;

  ccb.file->hdr.viewdata.noclicks=1;
  ccb.file->hdr.viewdata.nomenu=1;
  ccb.file->hdr.viewdata.noload=1;
  ccb.file->hdr.viewdata.nodnd=1;
  ccb.file->hdr.viewdata.help2=1;
  ccb.file->hdr.viewdata.infopal=0;
  ccb.file->hdr.viewdata.tools=0;
  ccb.file->hdr.viewdata.buttons=0;
  ccb.file->hdr.viewdata.dble=0;
  ccb.file->hdr.viewdata.pasteboard=0;

  event(EVENT_FOPEN,ccb.file,0);

  if(file) *file=ccb.file;

  clipupdate();
 
  if(sect) *sect=ccb.sect;
  if(page) *page=ccb.page;
 }

 return(err);
}


// idea pass in list of filetypes

os_error * clipend(int type,int * ftypes)
{
 os_error * err;
 pagestr  * pagep;
 int        w;
 int        i;

 err=NULL;

 ccb.type=type;

 ccb.file->hdr.viewdata.guides=(type==CLIP_OBJECT);

 if(ftypes)
 {
  ccb.ftypes=ccb.fdata;
  i=0;
  while((w=ftypes[i])!=0 && i<(MAXFTYPE-1))
  {
   ccb.fdata[i]=w;
   i++;
  }
  ccb.fdata[i]=0;
 }
 else
 {
  ccb.ftypes=NULL;
 }


 /* once we used the view nodeletewindow flag and then did a */
 /* viewrefresh after create newview                         */

 if(cbshow)
 {
  err=createnewview(ccb.file,DOC,&cbwindow,0);
 }

 pagep=(pagestr*)fob_find(ccb.page,ccb.file);
 ccb.object=pagep->chain.child;

 if(ccb.object) claimclipboard(type,ftypes);

 return(err);
}



os_error * clipinfo(int * child,int * page,int * section,filestr ** file)
{
 if(child)   *child=ccb.object;
 if(page)    *page=ccb.page;
 if(section) *section=ccb.sect;
 if(file)    *file=ccb.file;

 return(NULL);
}





static filestr * clipopenfile;



static os_error * clipimport(void * data,int length)
{
 os_error * err;

 err=NULL;

 cprintf("clip import paste length %d",length);


 ramnextreadfile(data,length);

 loaddoc("",FTYPE2,0,1);
 clipopenfile=xloadfile;
 xloadfile->noview=1;
 xloadfile->permanent=1;
 xloadfile->notuserfile=1;
 loaddocpost(0);

 ramreadoff();

 return(err);
}




os_error * clipopen(int * child,int * page,int * section,filestr ** file)
{
 os_error   * err;
 int        * formats;
 int          sectionk;
 sectionstr * sectionp;
 int          pagek;
 pagestr    * pagep;

 cprintf("clipopen 0");
 if(globalclip)
 {
  cprintf("clipopen 1");
  
  err=oscbavailable(&formats);
  if(*formats==OSCB_LOCAL)
  {
   if(child)   *child=ccb.object;
   if(page)    *page=ccb.page;
   if(section) *section=ccb.sect;
   if(file)    *file=ccb.file;
  }
  else
  {
   cprintf("clipopen 2 format %x",formats[0]);

   err=oscbpaste(formats[0],clipimport);
   if(!err)
   {
    if(file) *file=clipopenfile;
    sectionk=clipopenfile->hdr.section[DOC];
    if(section) *section=sectionk;
    if(sectionk)
    {
     sectionp=(sectionstr*)fob_find(sectionk,clipopenfile);
     pagek=sectionp->chain.child;
     if(page) *page=pagek;
     if(pagek)
     {
      pagep=(pagestr*)fob_find(pagek,clipopenfile);
      if(child) *child=pagep->chain.child;
     }
    }
   }
  } 
 }
 else
 {
  if(child)   *child=ccb.object;
  if(page)    *page=ccb.page;
  if(section) *section=ccb.sect;
  if(file)    *file=ccb.file;
 }

 return(NULL);
}



os_error * clipclose(filestr * file)
{

 if(file==clipopenfile)
 {
  closefile(file);
  clipopenfile=NULL;
 }

 return(NULL);
}



/****************************************************************************/

static void setcb(int newcb,int * oldcb)
{
 cbs[cbcur]=ccb;
 *oldcb=cbcur;
 cbcur=newcb;
 ccb=cbs[cbcur];
}


static void restorecb(int oldcb)
{
 cbs[cbcur]=ccb;
 cbcur=oldcb;
 ccb=cbs[cbcur];
}



static os_error * changecb(int newcb)
{
	int old;

 old=cbcur;
 cbs[cbcur]=ccb;
 cbcur=newcb;
 ccb=cbs[cbcur];

 if(ccb.object) claimclipboard(ccb.type,ccb.ftypes);

 return(event(EVENT_SETCLIPBOARD,(void*)old,cbcur));
}



static os_error * initclipboards(int f,int lt)
{
 os_error * err;
 int        scbcur;

 err=NULL;

 memset(cbs+f,0,(lt-f)*sizeof(cbstr));

 cbs[cbcur]=ccb;
 scbcur=cbcur;

 for(cbcur=f;cbcur<lt;cbcur++)
 {
  ccb=cbs[cbcur];

           err=clipstart(NULL,NULL,NULL,NULL);
  if(!err) err=clipend(CLIP_EMPTY,NULL);
  if(err) break;

  cbs[cbcur]=ccb;
 }

 cbcur=scbcur;
 ccb=cbs[cbcur];

 return(err);
}





int setcurrentclipboard(int fp)
{
 os_error * err;
 int        next;
 viewstr  * view;


 err=NULL;

 next=stack[fp] % cbmax;
 if(next<0) next+=cbmax;

 if(next!=cbcur)
 {
  if(ccb.file->viewn[DOC])
  {
   view=ccb.file->view;
   cbshow=view->handle;
   viewsetwindow(view,&cbwindow);
   closefile(ccb.file);
  }
  else
  {
   cbshow=0;
  }

		changecb(next);

  if(cbshow)
  {
   err=createnewview(ccb.file,DOC,&cbwindow,0);
  }
 }

 zreport(err);

 return(cbcur);
}


int getcurrentclipboard(int fp)
{
 return(cbcur);
 USE(fp);
}


/* called from general choices in c.dbmore */

os_error * setclipboardchoices(int useglobal,int nmax)
{
 os_error * err;
 int        i;
 int        old;

 err=NULL;

 globalclip=useglobal;

 if(nmax>0 && nmax!=cbmax)
 {
  if(!cbs)
  {
   old=cbmax;
   cbmax=nmax;
   event(EVENT_SETNOCLIPBOARD,(void*)old,cbmax);
  }
  else
  {
   if(nmax<cbmax)
   {
    if(cbcur>=nmax)
    {
					changecb(nmax-1);
    }

    for(i=nmax;i<cbmax;i++)
    {
     if(cbs[i].file)
     {
      closefile(cbs[i].file);
      closedoc(cbs[i].file);
     }
    }
   }

   err=flex_extend((flex_ptr)&cbs,nmax*sizeof(cbstr));

   if(!err)
   {
    old=cbmax;
    cbmax=nmax;

    if(nmax>old)
    {
     initclipboards(old,nmax);
    }

    event(EVENT_SETNOCLIPBOARD,(void*)old,cbmax);
   }
  }
 }

 return(err);
}



void getclipboardchoices(int * useglobal,int * nmax)
{
 *useglobal=globalclip;
 *nmax=cbmax;
}




int getclipboard(int fp)
{
 return(ccb.file->viewn[DOC]);
 USE(fp);
}



void setclipboard(int fp)
{
 int        show;
 int        onshow;
 os_error * err;

 err=NULL;
 show=stack[fp];
 onshow=ccb.file->viewn[DOC];

 if(show && !onshow)
 {
  err=createnewview(ccb.file,DOC,NULL,0);
 }
 else
 if(!show && onshow)
 {
  closefile(ccb.file);
 }

 zreport(err);
}



/*****************************************************************************/

static int pastecb;


static pointstr paste_ptr=
{
 "p_paste",6,6
};




/* tagged to UPASTES */

/* this function is always called last in undo/redo */

static pagesectionstr xpastepagesection;

static os_error * unpasteselections(filestr * file) 
{
 frflflush(file);
 vxflush(file,VRBACK,xpastepagesection.page,xpastepagesection.section);

 frflvalid(file);

 frflscrap(file);
 vxscrap();


 return(undowritefn(file,UPASTEF,&xpastepagesection,sizeof(pagesectionstr)));
}


/* tagged to UPASTEF */

static os_error * unpasteselectionf(filestr * file)
{
 undoread(file,&xpastepagesection,sizeof(pagesectionstr));

 frflstart(file);
 vxstart(file);

 return(undowritefn(file,UPASTES,NULL,0));
}



/* tagged to UPASTEDEL */

static os_error * unpastedelete(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(objectdelete((objhdrstr*)fob_find(object,file),0,file));
}


/*
static os_error * unpastescrap(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(objectdelete(fob_find(object,file),DELETESCRAP,file));
}
*/


static os_error * pasteselection(posnstr * posn)
{
 os_error    * err;
 int           after;
 int           parent;
 objectloc     sloc;
 objectloc     dloc;
 transformstr  tr;
 filestr     * dfile;
 filestr     * sfile;
 int           object;
 int           page;
 int           section;
 int           next;
 chainobject * link;
 int           first;
 int           scb=0;
 int           local;



 local=oscblocal();
 if(local) setcb(pastecb,&scb);

 err=clipopen(&object,&page,&section,&sfile);
 if(!err)
 {
  dfile=posn->file;

// unicode compatability check
		err=checkcompatability(sfile,object,CHECKC_CHAIN,dfile);
		if(!err) err=modfile(dfile,posn->section);
  if(!err)
  {
   pagenext(dfile,posn->page,&after,&parent);

   xpastepagesection.page=posn->page;
   xpastepagesection.section=posn->section;

   unpasteselectionf(dfile);

   frflstart(dfile);
   vxstart(dfile);

   first=0;
 
   while(object)
   {
    link=(chainobject*)fob_find(object,sfile);
    next=link->chain.next;

    sloc.file=sfile;
    sloc.object=object;
    sloc.page=page;
    sloc.section=section;
    sloc.parent=0;
    sloc.after=0;
    sloc.chain=0;
    sloc.branch=0;
    sloc.copymode=LOCCLIP;

    dloc.file=dfile;
    dloc.object=0;
    dloc.page=posn->page;
    dloc.section=posn->section;
    dloc.parent=parent;
    dloc.after=after;
    dloc.chain=0;
    dloc.branch=posn->branch;
    dloc.copymode=0;

    tr_setshift(&tr,posn->x-CLIPMARGIN,posn->y-CLIPMARGIN);

    err=objectcopy(&sloc,&dloc,&tr);

    after=dloc.object;
    if(!first) first=after;

    undowritefn(dfile,UPASTEDEL,&after,sizeof(int));

    parent=0;
    object=next;
   }

 
   frflflush(dfile);
   vxflush(dfile,VRBACK,posn->page,posn->section);

   frflvalid(dfile);

   frflscrap(dfile);
   vxscrap();


   if(first)
   {
    object=first;
    while(object)
    {
     selectobject(object,posn->page,posn->section,dfile);
     link=(chainobject*)fob_find(object,dfile);
     object=link->chain.next;
    }
   }

   unpasteselections(dfile);
  }

  clipclose(sfile);
 }

 if(local) restorecb(scb);

 return(err);
}




int paste_name(int fp)
{
 char       * name;
 sobjectstr * sob;
 int          type;
 int          n;
 objectdbstr  cont;
 char         string[ODBCONLEN];
 int          object;
 int          cbtype;


 name=NULL;

 clipboardtype(&cbtype,NULL);

 if(cbtype==CLIP_EMPTY)
 {
  name="";
 }
 if(cbtype!=CLIP_GLOBAL)
 {
  event(EVENT_PASTENAME,menufile,(int)&name);
  if(name)
  {
   tsprintf(sizeof(string),string,name);
   name=string;
  }
  else
  {
   if(!ccb.object) name="";
   else
   {
    object=ccb.object;
    type=0;
    n=0;
    sob=NULL;  /* compiler */
    name=string;

    while(object)
    {
     sob=(sobjectstr*)fob_find(object,ccb.file);
     object=sob->chain.next;

     if(!type) type=sob->type;
     else
     if(type!=sob->type) break;
     n++;
    }
 
    if(object) strcpy(string,"{SEL01}");
    else
    {
     cont.name=string;

     if(n==1) cont.type=ODB_OBJECTNAME;
     else     cont.type=ODB_OBJECTNAMEPLURALC;

     objectdb((objhdrstr*)sob,ccb.file,ccb.file->view,&cont);
    }

    trans(string,sizeof(string));
   }
  }
 }
 else
 {
  name=string;
  tsprintf(sizeof(string),string,"{CB01}");
 }

 return(createstring(name)); 

 USE(fp);
}



static os_error * pasteclick(toolboxstr * toolbox,posnstr * posn)
{
 os_error      * err;
 int             claim;
 toolrecordstr * record;
 filestr       * file;
 posnstr         xposn;

 err=NULL;

 file=posn->file;
 toolrecord(file,&record);

 if(posn->buttons==VBCLICKS)
 {
  if(!posn->ghost)
  {
   findbox(posn,-1);

   err=undostart(file);;
   if(!err)
   {
    event(EVENT_PASTECLICK0,posn->view,0);

    clearselection();

    claim=0;

    xposn=*posn;
    framesnap(&xposn);

    posn->x=xposn.x;
    posn->y=xposn.y;

    event(EVENT_PASTE,posn,(int)&claim);
    if(!claim)
    {
     err=pasteselection(posn);
    }

    toolselect(record->prevtoolkey,record->prevadjust,file->view,file);

    event(EVENT_PASTECLICK1,posn->view,0);
  
    undoend(file);
   }
  }
 }
 else
 {
  err=undostart(file);
  if(!err)
  {
   toolselect(record->prevtoolkey,record->prevadjust,file->view,file);
   undoend(file);
  }
 }

 return(err);

 USE(toolbox);
}




static os_error * pastemove(toolboxstr * toolbox,posnstr * posn,int move)
{

 toolschangepointer(0,USERPOINTER,&paste_ptr);

 return(NULL);
 USE(posn);
 USE(move);
 USE(toolbox);
}




static os_error * cliprefresh(viewstr * view,int handle,int code)
{
 if(code==-1) 
 {
  writeiconf(view->info,IP_HELPI,"%s","{PT00}");
 }

 return(NULL);
 USE(handle);
 USE(view);
}


static ipstr clipstr=
{
 NULL,           /* click    */
 NULL,           /* key      */
 NULL,           /* icon map */
 0,              /* template */
 0,              /* code     */
 cliprefresh,    /* refresh  */

};






static os_error * pasteselect(toolboxstr * toolbox,viewstr * view,
                                            filestr * file,int select)
{
 if(!undoactive(file))
 {
  if(select) clearselectionlo();
 }

 ipchangepane(toolbox,IP_PANE1,select?&clipstr:NULL);

 return(NULL);

 USE(view);
 USE(select);
 USE(toolbox);
}


static os_error * pasteptr(toolboxstr * toolbox,posnstr * posn)
{
 toolschangepointer(0,USERPOINTER,&paste_ptr);

 return(NULL);

 USE(posn);
 USE(toolbox);
}


static os_error * pastecancel(toolboxstr * toolbox,viewstr * view,
                                            filestr * file)
{

 return(NULL);

 USE(view);
 USE(file);
 USE(toolbox);
}


static os_error * pastemenu(toolboxstr * toolbox,viewstr * view,
                                          filestr * file,wimp_mousestr * m)
{
 return(openmenu("main_menu"));

 USE(view);
 USE(file);
 USE(m);
 USE(toolbox);
}


static os_error * pastekey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 menukey(key);
 if(*key==-1) *fk=menukey;
 return(NULL);

 USE(toolbox);
}


static toolstr paste=
{
 TL_PASTE,
 "paste",
 "t_paste\0t_ppaste",
 "{PASTIP}",
 0,
 pasteclick,
 pastemove,
 pasteselect,
 pasteptr,
 pastecancel,
 NULL,
 NULL,
 pastemenu,
 pastekey,
 NULL,
 NULL,
 NULL,
 0,       /* group     */

 0,       /* preselect */
 1,       /* no icon   */ 
 0,       /*  spare2    */
 0,       /*  spare3    */
 0,       /*  spare4    */ 
 0,       /*  spare5    */
 0,       /*  spare6    */
 0,       /*  spare7    */


 TPOINTER,
 0,
 0,
 0x200,  /*  rank  */
};



// this is called if event EVENT_PASTESELECTION fails to get a response
// it will get a response for text or pictures

os_error * dopaste(filestr * file)
{
 os_error * err;
 int        cbtype;

 err=NULL;

	cprintf("dopaste");

 pastecb=cbcur;

 clipboardtype(&cbtype,NULL);
 if(cbtype!=CLIP_GLOBAL)
 {
  if(toolcurrent(file)!=TL_PASTE && cbtype==CLIP_OBJECT)
  {
   err=undostart(file);
   if(!err)
   {
    err=toolselect(TL_PASTE,0,file->view,file);
    undoend(file);
   }
  }
 }
 else
 {
  dopasteglobal(file);
 }

 return(err);
}


/*****************************************************************************/

/* int clipboardtype(int objecttype); */
/*  cf activetype() in selaction      */
/* return 0 not selected, 1 selected, 2 contents selected */


int cliptype(int fp)
{
 int cbtype;

 clipboardtype(&cbtype,NULL);
 return(cbtype);

 USE(fp);
}



void embedobject(int fp)
{
 os_error * err;
 int        claim;
 int        cbtype;

 err=NULL;
 clipboardtype(&cbtype,NULL);

 if(cbtype==CLIP_OBJECT)
 {
  cprintf("embed object");
  claim=0;
  err=event(EVENT_EMBED,menufile,(int)&claim);
 }

 zreport(err);

 USE(fp);
}



/****************************************************************************/






#define UNDOS 3

static undofnstr undos[UNDOS]=
{
 unpasteselections,     NULL,         UPASTES,      "{UPASTE}",
 unpasteselectionf,     NULL,         UPASTEF,      "{UPASTE}",
 unpastedelete,         NULL,         UPASTEDEL,    NULL,
};



static os_error * cliprun(int eventn,int user,void * data,int data1)
{
 os_error * err;

          err=flex_alloc((flex_ptr)&cbs,cbmax*sizeof(cbstr));
 if(!err) err=cliphintstart();
 if(!err) err=initclipboards(0,cbmax);


 remevent(EVENT_RUNPROGRAM2,(eventfn)cliprun,0); /* even if error */

 return(err);

 USE(data);
 USE(data1);
 USE(user);
 USE(eventn);
}



os_error * clipboardinit(void)
{
 os_error * err;

          err=addevent(EVENT_RUNPROGRAM2,(eventfn)cliprun,0);
 if(!err) err=addevent(EVENT_FCLOSE,(eventfn)cliphintclose,0);
 if(!err) err=toolregister(&paste);
 if(!err) err=undoaddblock(undos,UNDOS);

 if(!err) err=globalclipboardinit();

 return(err);
}


os_error * clipboardfinit(void)
{
 os_error * err;

	err=globalclipboardfinit();

	return(err);
}
