/*->c.colsep */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"

#include "err.h"
#include "etc.h"
#include "bits.h"
#include "xmath.h"
#include "bf.h"
#include "poll.h"
#include "dbhi.h"
#include "xprocess.h"




#include "str.h"
#include "constants.h"

#include "object.h"
#include "file.h"
#include "view.h"



#include "xredraw.h"

#include "xxcolour.h"
#include "xcolour.h"
#include "chart.h"
#include "cconv.h"

#include "prstr.h"


#include "colsep.h"
#include "colseplink.h"





static colsepblockstr * cblock;



int colsepactive(void)
{
 return(cblock!=NULL);
}



os_error * csgetspotinfo(viewstr * view,int * key,int * spotmode)
{
 if(cblock && cblock->getspotinfo) 
                       return(cblock->getspotinfo(view,key,spotmode));
 else
 {
  *key=*spotmode=0;
 }

 return(NULL);
}



int cscurrentplate(void * prjob)
{
 if(cblock && cblock->currentplate) return(cblock->currentplate(prjob));
 else                               return(-1);
}



os_error * opencolsep(viewstr * view,dboxstr * dbox)
{
 if(cblock && cblock->open) return(cblock->open(view,dbox));
 else                       return(NULL);
}




os_error * colseparationprint(void * prjob,int code)
{
 if(cblock && cblock->print) return(cblock->print(prjob,code));
 else
 {
  if(code==CSPR_STARTJOB)
  {
   ((prjobstr*)prjob)->doseparations=0;
   ((prjobstr*)prjob)->separations=1;
  }
  return(NULL);
 }
}



os_error * colseparationpict(viewredrawstr * v,int pict,int process,int code)
{
 if(cblock && cblock->pict) return(cblock->pict(v,pict,process,code));
 return(NULL);
}




os_error * xrgb2hsv(viewstr * view,filestr * file,quadstr * rgb,quadstr * hsv)
{
 if(cblock && cblock->rgb2hsv) return(cblock->rgb2hsv(view,file,rgb,hsv));
 else
 {
  rgb2hsv(rgb,hsv);
  return(NULL);
 }
}



os_error * xhsv2rgb(viewstr * view,filestr * file,quadstr * hsv,quadstr * rgb)
{
 if(cblock && cblock->hsv2rgb) return(cblock->hsv2rgb(view,file,hsv,rgb));
 else
 {
  hsv2rgb(hsv,rgb);
  return(NULL);
 }
}



os_error * xrgb2cmyk(viewstr * view,filestr * file,quadstr *rgb,quadstr * cmyk)
{
 if(cblock && cblock->rgb2cmyk) return(cblock->rgb2cmyk(view,file,rgb,cmyk));
 else
 {
  rgb2cmyk(rgb,cmyk);
  return(NULL);
 }
}




os_error * xcmyk2rgb(viewstr * view,filestr * file,quadstr * cmyk,quadstr *rgb)
{
 if(cblock && cblock->cmyk2rgb) return(cblock->cmyk2rgb(view,file,cmyk,rgb));
 else
 {
  cmyk2rgb(cmyk,rgb);
  return(NULL);
 }
}


os_error * xcmyk2rgb3232(viewstr * view,int * s,int * d,int size)
{
 if(cblock && cblock->cmyk2rgb3232) return(cblock->cmyk2rgb3232(view,s,d,size));
 else
 {
  cmyk2rgb3232(s,d,size);
  return(NULL);
 }
}


os_error * xcmyk2bgr3232(viewstr * view,int * s,int * d,int size)
{
 if(cblock && cblock->cmyk2bgr3232) return(cblock->cmyk2bgr3232(view,s,d,size));
 else
 {
  cmyk2bgr3232(s,d,size);
  return(NULL);
 }
}




os_error * csprocess(viewstr * view,void * d,
                                    void * s,
                                    int    size,
                                    int    dtype,
                                    int    stype)
{
 if(cblock && cblock->colprocess)
            return(cblock->colprocess(view,d,s,size,dtype,stype));
 else       return(NULL);
}








os_error * xcconv(viewstr * view,filestr * file,
                  quadstr * s,int stype,quadstr * d,int dtype)
{
 quadstr q;


 if(stype==RGBMODEL)
 {
  if(dtype==CMYKMODEL) return(xrgb2cmyk(view,file,s,d));
  else
  if(dtype==HSVMODEL)  return(xrgb2hsv(view,file,s,d));
 }
 else
 if(stype==CMYKMODEL)
 {
  if(dtype==RGBMODEL) return(xcmyk2rgb(view,file,s,d));
  else
  if(dtype==HSVMODEL)
  {
   xcmyk2rgb(view,file,s,&q);
   return(xrgb2hsv(view,file,&q,d));
  }
 }
 else
 if(stype==HSVMODEL)
 {
  if(dtype==RGBMODEL) return(xhsv2rgb(view,file,s,d));
  else
  if(dtype==CMYKMODEL)
  {
   xhsv2rgb(view,file,s,&q);
   return(xrgb2cmyk(view,file,&q,d));
  }
 }

 *d=*s;
 return(NULL);
}





int modelgetpal(viewstr * view,filestr * file,int model,quadstr * quad)
{
 quadstr q2;
 int     r;
 int     g;
 int     b;
 int     pal;


 switch(model)
 {
   case RGBMODEL:
                 q2=*quad;
                 break;

   case HSVMODEL:
                 xhsv2rgb(view,file,quad,&q2);
                 break;

  case CMYKMODEL:
                 xcmyk2rgb(view,file,quad,&q2);
                 break;
 }

 r=q2.type.rgb.r-1;
 if(r<0) r=0;
 b=q2.type.rgb.b-1;
 if(b<0) b=0;
 g=q2.type.rgb.g-1;
 if(g<0) g=0;

 pal=(r & 0xFF00)|((g & 0xFF00)<<8)|((b & 0xFF00)<<16);


/* 

 dprintf(2,"r=%d g=%d b=%d",(q2.type.rgb.r*100)/0x10000,
                            (q2.type.rgb.g*100)/0x10000,
                            (q2.type.rgb.b*100)/0x10000);

 r=(q2.type.rgb.r*255+0x7FFF)/0x10000;
 g=(q2.type.rgb.g*255+0x7FFF)/0x10000;
 b=(q2.type.rgb.b*255+0x7FFF)/0x10000;

 pal=(r<<8)|(g<<16)|(b<<24);

*/

 return(pal);
}






int modelgetpalnaive(viewstr * view,filestr * file,int model,quadstr * quad)
{
 quadstr q2;
 int     r;
 int     g;
 int     b;
 int     pal;


 switch(model)
 {
   case RGBMODEL:
                 q2=*quad;
                 break;

   case HSVMODEL:
                 hsv2rgb(quad,&q2);
                 break;

  case CMYKMODEL:
                 cmyk2rgb(quad,&q2);
                 break;
 }

 r=q2.type.rgb.r-1;
 if(r<0) r=0;
 b=q2.type.rgb.b-1;
 if(b<0) b=0;
 g=q2.type.rgb.g-1;
 if(g<0) g=0;

 pal=(r & 0xFF00)|((g & 0xFF00)<<8)|((b & 0xFF00)<<16);

 return(pal);

 USE(file);
 USE(view);
}







int colourgetpal(colourstr * cs,viewstr * view,filestr * file)
{
 if(!cblock || cs->model.no==RGBMODEL) return(cs->model.pal);
 else
 return(modelgetpal(view,file,cs->model.no,&cs->model.data.quad));
}




os_error * setprocess(int processkey,viewstr * view,processstr * pr)
{
 if(cblock && cblock->process) return(cblock->process(processkey,view,pr));
 else
 {
  pr->mode=PROCESSNONE;
  pr->usespots=0;
  pr->spotplate=0;
  pr->separation=0;
  return(NULL);
 }
}



os_error * deleteprocess(int processkey,filestr * file)
{
 if(cblock && cblock->deleteprocess)
 {
  return(cblock->deleteprocess(processkey,file));
 }
 else
 {
  return(NULL);
 }
}


os_error * copyprocess(int skey,int * dkey,filestr * file)
{
 if(cblock && cblock->copyprocess)
 {
  return(cblock->copyprocess(dkey,file,skey,file,0));
 }
 else
 {
  *dkey=0;
  return(NULL);
 }
}


os_error * copyprocessm(int * dkey,filestr * dfile,
                        int   skey,filestr * sfile,int mode)
{
 if(cblock && cblock->copyprocess)
 {
  return(cblock->copyprocess(dkey,dfile,skey,sfile,mode));
 }
 else
 {
  *dkey=0;
  return(NULL);
 }
}



os_error * dswriteprocess(int processkey,buffer * bf,filestr * file)
{
 if(cblock && cblock->dswriteprocess)
 {
  return(cblock->dswriteprocess(processkey,bf,file));
 }
 else
 {
  return(NULL);
 }
}


os_error * defltprocess(int * key,filestr * file)
{
 if(cblock && cblock->defltprocess)
 {
  return(cblock->defltprocess(key,file));
 }
 else
 {
  *key=0;
  return(NULL);
 }
}



int cmpprocess(int key1,filestr * file1,int key2,filestr * file2)
{
 if(cblock && cblock->cmpprocess)
 {
  return(cblock->cmpprocess(key1,file1,key2,file2));
 }
 else
 {
  return(0);
 }
}



os_error * openscreen(int process,filestr * file,dboxstr * parent,
                                                 closescreenfn csfn)
{
 if(cblock && cblock->openscreen)
 {
  return(cblock->openscreen(process,file,parent,csfn));
 }
 else
 {
  return(NULL);
 }
}



os_error * registercolsep(colsepblockstr * xcblock)
{
 cblock=xcblock;
 return(NULL);
}





