/*->h.colseplink */


typedef os_error * (*colsepopenfn)(viewstr * view,dboxstr * dbox);
typedef os_error * (*colsepprintfn)(void * prjob,int code);
typedef os_error * (*colconvfn)(viewstr * view,filestr * file,
                                             quadstr * rgb,quadstr * hsv);

typedef os_error * (*colprocessfn)(viewstr * view,
                                    void * d,
                                    void * s,
                                    int    size,
                                    int    dtype,
                                    int    stype);

typedef os_error * (*setprocessfn)(int key,viewstr * view,processstr * pr);

typedef os_error * (*deleteprocessfn)(int processkey,filestr * file);
typedef os_error * (*copyprocessfn)(int * dkey,filestr * dfile,
                                     int skey,filestr * sfile,int mode);
typedef os_error * (*dswriteprocessfn)(int processkey,buffer * bf,
                                       filestr * file);

typedef os_error * (*defltprocessfn)(int * key,filestr * file);
typedef int        (*cmpprocessfn)(int key1,filestr * file1,
                                   int key2,filestr * file2);

typedef os_error * (*colseppictfn)(viewredrawstr * v,int pict,
                                                     int process,int code);



typedef os_error * (*getspotinfofn)(viewstr * view,int * key,int * spotmode);


typedef os_error * (*cmyk2rgb3232fn)(viewstr * view,int * s,int * d,int size);



typedef int        (*colsepcpfn)(void * prjob);




typedef os_error * (*openscreenfn)(int process,filestr * file,dboxstr * parent,
                                                      closescreenfn csfn);


typedef struct colsepblockstr
{
 colsepopenfn     open;
 colsepprintfn    print;
 colconvfn        rgb2hsv;
 colconvfn        hsv2rgb;
 colconvfn        rgb2cmyk;
 colconvfn        cmyk2rgb;
 setprocessfn     process;
 deleteprocessfn  deleteprocess;
 copyprocessfn    copyprocess;
 dswriteprocessfn dswriteprocess;
 defltprocessfn   defltprocess;
 cmpprocessfn     cmpprocess;
 colseppictfn     pict;
 colsepcpfn       currentplate;
 colprocessfn     colprocess;
 getspotinfofn    getspotinfo;
 cmyk2rgb3232fn   cmyk2rgb3232;
 openscreenfn     openscreen;
 cmyk2rgb3232fn   cmyk2bgr3232;

 int              spare[6];

} colsepblockstr;




extern os_error * registercolsep(colsepblockstr * xcblock);

