/*->c.curvep */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "BezierArc.h"

#include "err.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "xmath.h"
#include "deb.h"


#include "constants.h"
#include "str.h"
#include "object.h"


#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "xcolour.h"
#include "xredraw.h"
#include "geometry.h"


#include "posn.h"



#include "curvelo.h"
#include "curve.h"


/*****************************************************************************/



typedef struct psegstr
{
 segstr seg;
 int    angle1;
 int    angle2;
 segstr nseg;


} psegstr;





#define PSEGCHUNK (32*sizeof(psegstr))



static void parallelseg(segstr * nseg,segstr * seg)
{
 int s1;
 int s2;
 int temp;

 if(seg->cx[1].x==seg->cx[0].x) nseg->cx[1].x=nseg->cx[0].x;
 else
 if(seg->cx[1].x==seg->cx[3].x)  nseg->cx[1].x=nseg->cx[3].x;
 else
 {
  temp=nseg->cx[0].y-nseg->cx[3].y;
  temp-=scale(nseg->cx[0].x,seg->cx[1].y-seg->cx[0].y,
                            seg->cx[1].x-seg->cx[0].x);

  temp+=scale(nseg->cx[3].x,seg->cx[1].y-seg->cx[3].y,
                            seg->cx[1].x-seg->cx[3].x);


  s1=scale(0x10000,seg->cx[1].y-seg->cx[3].y,seg->cx[1].x-seg->cx[3].x);
  s2=scale(0x10000,seg->cx[1].y-seg->cx[0].y,seg->cx[1].x-seg->cx[0].x);
  nseg->cx[1].x=scale(temp,0x10000,s1-s2);
 }

 if(seg->cx[1].y==seg->cx[0].y) nseg->cx[1].y=nseg->cx[0].y;
 else
 if(seg->cx[1].y==seg->cx[3].y) nseg->cx[1].y=nseg->cx[3].y;
 else
 {
  temp=nseg->cx[0].x-nseg->cx[3].x;
  temp-=scale(nseg->cx[0].y,seg->cx[1].x-seg->cx[0].x,
                            seg->cx[1].y-seg->cx[0].y);

  temp+=scale(nseg->cx[3].y,seg->cx[1].x-seg->cx[3].x,
                            seg->cx[1].y-seg->cx[3].y);


  s1=scale(0x10000,seg->cx[1].x-seg->cx[3].x,seg->cx[1].y-seg->cx[3].y);
  s2=scale(0x10000,seg->cx[1].x-seg->cx[0].x,seg->cx[1].y-seg->cx[0].y);
  nseg->cx[1].y=scale(temp,0x10000,s1-s2);
 }

 if(seg->cx[2].x==seg->cx[0].x) nseg->cx[2].x=nseg->cx[0].x;
 else
 if(seg->cx[2].x==seg->cx[3].x) nseg->cx[2].x=nseg->cx[3].x;
 else
 {
  temp=nseg->cx[3].y-nseg->cx[0].y;
  temp-=scale(nseg->cx[3].x,seg->cx[2].y-seg->cx[3].y,
                            seg->cx[2].x-seg->cx[3].x);

  temp+=scale(nseg->cx[0].x,seg->cx[2].y-seg->cx[0].y,
                            seg->cx[2].x-seg->cx[0].x);


  s1=scale(0x10000,seg->cx[2].y-seg->cx[0].y,seg->cx[2].x-seg->cx[0].x);
  s2=scale(0x10000,seg->cx[2].y-seg->cx[3].y,seg->cx[2].x-seg->cx[3].x);
  nseg->cx[2].x=scale(temp,0x10000,s1-s2);
 }

 if(seg->cx[2].y==seg->cx[0].y) nseg->cx[2].y=nseg->cx[0].y;
 else
 if(seg->cx[2].y==seg->cx[3].y) nseg->cx[2].y=nseg->cx[3].y;
 else
 {
  temp=nseg->cx[3].x-nseg->cx[0].x;
  temp-=scale(nseg->cx[3].y,seg->cx[2].x-seg->cx[3].x,
                            seg->cx[2].y-seg->cx[3].y);

  temp+=scale(nseg->cx[0].y,seg->cx[2].x-seg->cx[0].x,
                            seg->cx[2].y-seg->cx[0].y);

  s1=scale(0x10000,seg->cx[2].x-seg->cx[0].x,seg->cx[2].y-seg->cx[0].y);
  s2=scale(0x10000,seg->cx[2].x-seg->cx[3].x,seg->cx[2].y-seg->cx[3].y);
  nseg->cx[2].y=scale(temp,0x10000,s1-s2);
 }
}




static psegstr  * psegs;
static int        pn;
static int        xpathsize;


static os_error * parallelsubpath(filestr * file,int * pathk,int ** pathp,
                                                                    int d)
{
 os_error * err;
 int        delta;
 int        i;
 int        j;
 int        prevangle;
 int        curangle;
 int     *  p;
 int     *  q;
 pathstr *  pathpp;
 int        size;
 int        lx;
 int        ly;
 cutstr     cut[MAXBCUT];
 int        clockwise;
 int        dx;
 int        dy;
 int        diff;
 int        n;


 err=NULL;



 p=q=NULL; /* compiler */

 delta=0;

 for(j=pn-1,i=0;i<pn;i++)
 {
  prevangle=psegs[j].angle2;
  curangle= psegs[i].angle1;

  diff=curangle-prevangle;
  if(diff>180*0x10000)  diff-=360*0x10000;
  if(diff<-180*0x10000) diff+=360*0x10000;

  delta+=diff;

  if(psegs[i].seg.type==2)
  {
   prevangle=psegs[i].angle1;
   curangle= psegs[i].angle2;

   diff=curangle-prevangle;
   if(diff>180*0x10000)  diff-=360*0x10000;
   if(diff<-180*0x10000) diff+=360*0x10000;

   delta+=diff;

  }

  if(++j>=pn) j=0;
 }


 clockwise=(delta>0);

 if(clockwise) d=-d;  /* clockwise */


 for(i=0;i<pn;i++)
 {
  if(psegs[i].seg.type==1)
  {
   dx=tr_sin(psegs[i].angle1,d);
   dy=tr_cos(psegs[i].angle1,d);

   psegs[i].nseg.type=1;

   psegs[i].nseg.cx[0].x=psegs[i].seg.cx[0].x-dx;
   psegs[i].nseg.cx[0].y=psegs[i].seg.cx[0].y+dy;

   psegs[i].nseg.cx[1].x=psegs[i].seg.cx[1].x-dx;
   psegs[i].nseg.cx[1].y=psegs[i].seg.cx[1].y+dy;
  }
  else
  {
   psegs[i].nseg.type=2;

   psegs[i].nseg.cx[0].x=psegs[i].seg.cx[0].x-tr_sin(psegs[i].angle1,d);
   psegs[i].nseg.cx[0].y=psegs[i].seg.cx[0].y+tr_cos(psegs[i].angle1,d);

   psegs[i].nseg.cx[3].x=psegs[i].seg.cx[3].x-tr_sin(psegs[i].angle2,d);
   psegs[i].nseg.cx[3].y=psegs[i].seg.cx[3].y+tr_cos(psegs[i].angle2,d);

   parallelseg(&psegs[i].nseg,&psegs[i].seg);
  }
 }


 for(j=pn-1,i=0;i<pn;i++)
 {
  prevangle=psegs[j].angle2;
  curangle=psegs[i].angle1;

  diff=curangle-prevangle;
  if(diff>180*0x10000)  diff-=360*0x10000;
  if(diff<-180*0x10000) diff+=360*0x10000;

  if((d<0 && diff<0) ||
     (d>0 && diff>0)) /* acute segment */
  {
   n=0;

   if(psegs[i].nseg.type==1 && psegs[j].nseg.type==1)
   {
    n=intersection(psegs[i].nseg.cx,psegs[j].nseg.cx,cut);
   }
   else
   if(psegs[i].nseg.type==1 && psegs[j].nseg.type==2)
   {
    n=bintersection(psegs[i].nseg.cx,psegs[j].nseg.cx,cut);
   }
   if(psegs[i].nseg.type==2 && psegs[j].nseg.type==1)
   {
    n=bintersection(psegs[j].nseg.cx,psegs[i].nseg.cx,cut);
   }
   else
   if(psegs[i].nseg.type==2 && psegs[j].nseg.type==2)
   {
    n=bbintersection(psegs[i].nseg.cx,psegs[j].nseg.cx,cut);
   }

   if(n)
   {
    if(psegs[j].nseg.type==1)
    {
     psegs[j].nseg.cx[1].x=cut[n-1].c.x;
     psegs[j].nseg.cx[1].y=cut[n-1].c.y;
    }
    else
    {
     psegs[j].nseg.cx[3].x=cut[n-1].c.x;
     psegs[j].nseg.cx[3].y=cut[n-1].c.y;
    }

    psegs[i].nseg.cx[0].x=cut[n-1].c.x;
    psegs[i].nseg.cx[0].y=cut[n-1].c.y;
   }
  }
  else                                  /* not */
  {


  }

  if(++j>=pn) j=0;
 }

 size=((2*pn+2)*7)*sizeof(int);


 if(pathk)
 {
  if(*pathk)
  {
   err=fob_change(*pathk,file,sizeof(pathstr)+xpathsize*sizeof(int)+size,
                                                          (fobjptr)&pathpp);
   if(!err)
   {
    q=pathpp->data;
    p=q+xpathsize;
   }
  }
  else
  {
   err=fob_create(sizeof(pathstr)+size,file,OPATH,(fobjptr)&pathpp);
   if(!err)
   {
    *pathk=pathpp->key;
    p=q=pathpp->data;
   }
  }
 }
 else
 if(pathp)
 {
  if(*pathp)
  {
   err=flex_extend((flex_ptr)pathp,xpathsize*sizeof(int)+size);
   q=*pathp;
   p=q+xpathsize;
  }
  else
  {
   err=flex_alloc((flex_ptr)pathp,size);
   p=q=*pathp;
  }
 }


 if(!err)
 {
  *p++=DRAWMOVE;
  if(psegs[pn-1].nseg.type==1)
  {
   *p++=lx=psegs[pn-1].nseg.cx[1].x;
   *p++=ly=psegs[pn-1].nseg.cx[1].y;
  }
  else
  {
   *p++=lx=psegs[pn-1].nseg.cx[3].x;
   *p++=ly=psegs[pn-1].nseg.cx[3].y;
  }


  for(i=0;i<pn;i++)
  {
   if(lx!=psegs[i].nseg.cx[0].x || ly!=psegs[i].nseg.cx[0].y)
   {
    *p++=DRAWDRAW;
    *p++=psegs[i].nseg.cx[0].x;
    *p++=psegs[i].nseg.cx[0].y;
   }

   if(psegs[i].nseg.type==1)
   {
    *p++=DRAWDRAW;
    *p++=lx=psegs[i].nseg.cx[1].x;
    *p++=ly=psegs[i].nseg.cx[1].y;
   }
   else
   if(psegs[i].nseg.type==2)
   {
    *p++=DRAWCURVE;
    *p++=psegs[i].nseg.cx[1].x;
    *p++=psegs[i].nseg.cx[1].y;
    *p++=psegs[i].nseg.cx[2].x;
    *p++=psegs[i].nseg.cx[2].y;
    *p++=lx=psegs[i].nseg.cx[3].x;
    *p++=ly=psegs[i].nseg.cx[3].y;
   }
  }

  *p++=DRAWCLOSE;

  xpathsize=p-q;
 }

 return(err);
}




os_error * parallelpath2(filestr * file,int path,int ** spathp,
                                        int * pathk,int ** pathp,int d)
{
 os_error * err;
 segstr     seg;
 pathstr  * pathpp;


 newsegment(&seg);

 pn=0;
 err=flex_alloc((flex_ptr)&psegs,PSEGCHUNK);
 if(!err)
 {
  while(1)
  {
   if(path)   nextsegmentpath(&seg,path,file);
   else
   if(spathp) nextsegment(&seg,*spathp);

   if(seg.type==0) break;
 
   if(seg.type==3) /* close path */
   {
    parallelsubpath(file,pathk,pathp,d);
    pn=0;
   }
   else
   if(seg.type==1 || seg.type==2)
   {
    if(seg.type==1)
    {
     err=flex_chunk((flex_ptr)&psegs,(pn+1)*sizeof(psegstr),PSEGCHUNK);

     psegs[pn].seg=seg;

     psegs[pn].angle1=psegs[pn].angle2=
                 scaleatan2(seg.cx[1].y-seg.cx[0].y,seg.cx[1].x-seg.cx[0].x);
    }
    else
    {
     err=flex_chunk((flex_ptr)&psegs,(pn+1)*sizeof(psegstr),PSEGCHUNK);

     psegs[pn].seg=seg;

     psegs[pn].angle1=
                scaleatan2(seg.cx[1].y-seg.cx[0].y,seg.cx[1].x-seg.cx[0].x);

     psegs[pn].angle2=
                scaleatan2(seg.cx[3].y-seg.cx[2].y,seg.cx[3].x-seg.cx[2].x);
    }

    pn++;
   }
  }
  flex_free((flex_ptr)&psegs);
 }

 if(pathk && *pathk)
 {
  err=fob_change(*pathk,file,sizeof(pathstr)+(xpathsize+1)*sizeof(int),
                                                            (fobjptr)&pathpp);
  pathpp->data[xpathsize]=DRAWEND;
 }
 else
 if(pathp && *pathp)
 {
  err=flex_extend((flex_ptr)pathp,(xpathsize+1)*sizeof(int));
  (*pathp)[xpathsize]=DRAWEND;
 }

 return(err);
}




static os_error * parallelpath(filestr * file,curvestr * f,curvestr * c,int d)
{
 os_error * err;
 int        pathk;
 int        path;

 err=NULL;

 c->box.w=f->box.w+2*d;
 c->box.h=f->box.h+2*d;
 c->box.x=f->box.x-d;
 c->box.y=f->box.y-d;
 c->type=f->type;

#ifndef PROD
 if(debugactive2()) return(copycurve(c,file,f,file));
#endif

 if(!d) 
 {
  err=copycurve(c,file,f,file);
 }
 else
 {
  pathk=0;
  path=f->data.path.path;

  parallelpath2(file,path,NULL,&pathk,NULL,d);

  c->data.path.path=pathk;
 }

 return(err);
}





/* make c a curve parallel to f, at distance d */

os_error * parallelcurve(filestr * file,curvestr * f,curvestr * c,int d)
{
 os_error * err;

 err=NULL;

 switch(f->type)
 {
     case CBOXR:
                c->data.rbox.xradius=f->data.rbox.xradius+d;
                c->data.rbox.yradius=f->data.rbox.yradius+d;
                c->box.w=f->box.w+2*d;
                c->box.h=f->box.h+2*d;
                c->box.x=f->box.x-d;
                c->box.y=f->box.y-d;
                if(c->data.rbox.xradius<=0 || c->data.rbox.yradius<=0) c->type=CBOX;
                else                                                   c->type=f->type;
                break;

      case CBOX:
  case CELLIPSE:
                c->box.w=f->box.w+2*d;
                if(c->box.w<0)
                {
                 c->box.w=0;
                 c->box.x=f->box.x+f->box.w/2;
                }
                else
                {
                 c->box.x=f->box.x-d;
                }

                c->box.h=f->box.h+2*d;
                if(c->box.h<0)
                {
                 c->box.h=0;
                 c->box.y=f->box.y+f->box.h/2;
                }
                else
                {
                 c->box.y=f->box.y-d;
                }
                
                c->type=f->type;
                break;

     case CPATH:
                err=parallelpath(file,f,c,d);
                break;
 }

 return(err);
}





os_error * parallelcurve2(filestr * file,curvestr * f,curvestr * c,
                                                     int d,int * border)
{
 if(border)
 {
  if(f->type==CBOX)
  {
   c->box.w=f->box.w+2*d+border[1]+border[3];
   c->box.h=f->box.h+2*d+border[0]+border[2];
   c->box.x=f->box.x-d-border[3];
   c->box.y=f->box.y-d-border[0];
   c->type=f->type;
   return(NULL);
  }
  else
  return(parallelcurve(file,f,c,d+border[0]));
 }
 else return(parallelcurve(file,f,c,d));
}


