/*->c.mhi */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "flex.h"
#include "wimp.h"

#include "err.h"
#include "alloc.h"
#include "xext.h"
#include "wos.h"
#include "poll.h"
#include "bits.h"
#include "dbhi.h"

#include "mlo.h"
#include "key.h"
#include "trans.h"
#include "transform.h"
#include "deb.h"


#include "etc.h"


#include "reslink.h"

#include "str.h"
#include "file.h"
#include "view.h"
#include "mhi.h"




#define MPOPUP 1
#define FIRSTFREEINDEX 1
#define MBASE  (2-FIRSTFREEINDEX)
#define MMDEPTH 16



#define MENUIDBASE 0x100


static os_error * maindynamic(int * menu,char * handle,int window);
static os_error * maindecode(int * menu,int window);
static os_error * popupdynamic(int * menu,char * handle,int window);
static os_error * popupdecode(int * menu,int window);



static menustr menubasetable[]=
{
 MPOPUP,  NULL,      NULL,  0, 0, 0,  0,   0, popupdecode,popupdynamic,
 MLAST,   NULL,      NULL,  0, 0, 0,  0,   0, NULL,      NULL,
};


#define MENUTABLECHUNK 32

static int menutablen=sizeof(menubasetable)/sizeof(menustr);


static menustr * menutable;


static menulink mlink;


static int mainhandle;













#define MENUCHUNK 0x1000


typedef struct himenustr
{
 int       handle;        /* unique menu handle */
 int       type;          /* menu/window */
 union
 {
  char   *  data;          /* pointer to real menu data */
  int       window;
  int       menuno;
 } data;
 int       n;             /* number of entries  */
 int       textsize;
                          /* menu name, followed by 5 function names */
                          /* for each menu entry */
} himenustr;


#define MMENU 0
#define MDBOX 1


static int    menuhandle;
static char * menudata;
static int    menusize;
static int    menun;
static int  * mprevious;
static int    mpreviouslimit;

static int    lastmenu[MMDEPTH];
static int    lastmenuno[MMDEPTH];


#define MENUPTR(ptr) ((himenustr*)(menudata+(ptr)))







static os_error * insertmemory(int at,int size,himenustr ** m,char ** p)
{
 os_error * err;
 char     * oldmenudata;

 at=ROOF(at,menusize);

 oldmenudata=menudata;

 if(size>0)
 {
  err=flex_chunk((flex_ptr)&menudata,menusize+size,MENUCHUNK);
  if(!err)
  {
   memmove(menudata+at+size,menudata+at,menusize-at);
   menusize+=size;
  }

 }
 else
 if(size<0)
 {
  memmove(menudata+at,menudata+at-size,menusize-(at-size));
  err=flex_chunk((flex_ptr)&menudata,menusize+size,MENUCHUNK);
  if(!err)
  {
   menusize+=size;
  }
 }
 else err=NULL;

 if(p) *p=*p+(menudata-oldmenudata);
 if(m) *m=(himenustr*)((char*)(*m)+(menudata-oldmenudata));

 return(err);
}




/* return offset of himenustr in menu data */

static int mxptr(int handle)
{
 char    * p;
 int       i;
 himenustr * m;

 p=menudata;

 for(i=0;i<menun;i++)
 {
  m=(himenustr*)p;
  if(m->handle==handle) break;
  p+=sizeof(himenustr)+m->textsize;
 }

 if(i>=menun) return(-1);
 else         return(p-menudata);
}



void delete_menu(int fp)
{
 int       handle;
 int       ptr;
 himenustr * m;
 int       size;

 handle=stack[fp];

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  m=(himenustr*)(menudata+ptr);
  size=sizeof(himenustr)+m->textsize;
  insertmemory(ptr,-size,NULL,NULL);
  menun--;
 }
}



int create_menu(int fp)
{
	os_error  * err;
 int         len;
 int         ptr;
 himenustr * m;
 char        title[256];


 xzstrncpy(title,stringptr(stack[fp]),NITEM(title));
 trans(title,sizeof(title));

 len=strlen(title)+1;
 len=(len+0x3) & (~0x3);

 ptr=menusize;

 err=insertmemory(ptr,len+sizeof(himenustr),NULL,NULL);
	if(!err)
	{
  m=(himenustr*)(menudata+ptr);

  m->handle=menuhandle++;
  m->type=MMENU;
  m->data.data=NULL;
  m->n=0;
  m->textsize=len;

  strcpy(menudata+ptr+sizeof(himenustr),title);		// safe memory allocated

  menun++;

  return(m->handle);
	}

	zreport(err);

	return(0);
}



int create_dbox(int whandle,int oldmenuhandle)
{
 int       ptr;
 int       optr;
 himenustr * m;

 if(oldmenuhandle) optr=mxptr(oldmenuhandle);
 else              optr=0;

 if(!optr)
 {
  ptr=menusize;
  insertmemory(ptr,sizeof(himenustr),NULL,NULL);
 }
 else
 {
  ptr=optr;
 }

 m=(himenustr*)(menudata+ptr);

 if(!optr)
 {
  m->handle=menuhandle++;
  m->type=MDBOX;
  m->n=0;
  m->textsize=0;
  menun++;
 }

 m->data.window=whandle;

 return(m->handle);
}



void delete_dbox(int handle)
{
 int         ptr;
 himenustr * m;
 int         size;

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  m=(himenustr*)(menudata+ptr);
  size=sizeof(himenustr)+m->textsize;
  insertmemory(ptr,-size,NULL,NULL);
  menun--;
 }
}



/*
static int entrysize(char * p)
{
 int sum;
 int j;

 int n=*((int*)p);

 sum=8;
 for(j=0;j<5;j++) sum+=strlen(p+sum)+1;
 sum=(sum+0x3) & (~0x3);

 dprintf(0,"n=%d sum=%d",n,sum);

 return(sum);
}
*/


void rementry_menu(int fp)
{
 int         handle;
 int         entry;
 int         ptr;
 char      * p;
 char      * q;
 int         nsize;
 himenustr * m;
 int         i;


 handle=stack[fp];
 entry=stack[fp+1];

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  p=(menudata+ptr);
  m=(himenustr*)p;
  if(entry<m->n)
  {
   p+=sizeof(himenustr);
   q=p;

   p+=((strlen(p)+1)+0x3) & (~0x3);

   for(i=0;i<entry;i++) p+=*((int*)p); /* p+=entrysize(p); */
   nsize=*((int*)p);  /* entrysize(p); */

   /* p now points at menu entry */

   insertmemory(ptr+(p-q)+sizeof(himenustr),-nsize,&m,NULL);

   m->textsize-=nsize;
   m->n--;
  }
 }
}


static int addsentry_menu(int handle,int index,int fp,int translate)
{
 int         ptr;
 char        data[256];
 char      * p;
 char      * q;
 int         i;
 himenustr * m;
 int         nsize;
 int         code;
// char      * oldmenudata;

 code=0; /* keep compiler happy */


// cprintf("adds %d %s",index,stringptr(stack[fp+4]));

 p=data+8;
 for(i=0;i<5;i++)
 {
  if(i==3) /* keypress */
  {
   code=keycanonicaltype(stringptr(stack[fp+i]));
   if(code<0) *p=0;
   else
   {
    strcpy(p,keystringcanonical(code));
    code=keycanonical2code(code);
   }
  }
  else
  {
   strcpy(p,stringptr(stack[fp+i]));
   if(i==4 && translate)
   {
    trans(p,(data+sizeof(data))-p);
   }
  }
  p+=strlen(p)+1;
 }

 nsize=p-data;
 nsize=(nsize+3)&~0x3;

 *((int*)data)=nsize;
 *((int*)(data+4))=code;

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  p=(menudata+ptr);
  m=(himenustr*)p;
  p+=sizeof(himenustr);
  q=p;


  p+=((strlen(p)+1)+0x3) & (~0x3);

  if(index<0 || index>m->n) index=m->n;

  for(i=0;i<index;i++)
  {
   /* p+=entrysize(p); */
   p+=*((int*)p);
  }

  /* p now points where next menu entry should go */

 /* size=m->textsize;
  size=(((p-q)-size+nsize)+0x3) & (~0x3); */

  insertmemory(ptr+(p-q)+sizeof(himenustr),nsize,&m,&p);

  m->textsize+=nsize;
  XMEMCPYX(p,data,nsize);
  m->n++;

  return(index);
 }
 return(-1);
}


int addentry_menu(int fp)
{
 return(addsentry_menu(stack[fp],-1,fp+1,1));
}


int insertentry_menu(int fp)
{
 return(addsentry_menu(stack[fp],stack[fp+1],fp+2,1));
}


int addentryl_menu(int fp)
{
 return(addsentry_menu(stack[fp],-1,fp+1,0));
}




/* tell the code in Menus file to create a menu */

static os_error * findmenu(char * name,int * handle)
{
 os_error * err;
 int        result;

 /* int create_menu(int open), 1 is open, handle is passed back menu */

 err=xexec(name,&result,"I/R",1,handle);
 if(err || result) *handle=-1;

 return(err);
}



static int getfreemenu(void)
{
 os_error * err;
 int        freemenu;
 int        i;

 freemenu=FIRSTFREEINDEX;
 while(1)
 {
  if(menutable[freemenu].menuno==MLAST)
  {
   cprintf("menus exhausted");

   err=srealloc((flex_ptr)&menutable,(menutablen+MENUTABLECHUNK)*sizeof(menustr));
   if(!err)
   {
    i=menutablen-1;
    memset(menutable+menutablen,0,MENUTABLECHUNK*sizeof(menustr));
    menutablen+=MENUTABLECHUNK;
    for(;i<menutablen;i++) menutable[i].menuno=i+MBASE;
    menutable[menutablen-1].menuno=MLAST;
    updatemenus(menutable,&mlink);
   }
   else
   {
    freemenu--;
   }
   break;
  }

  if(menutable[freemenu].parent==0 && menutable[freemenu].menuptr==0) break;
  freemenu++;
 }

// cprintf("freemenu %d",freemenu);

 return(menutable[freemenu].menuno);
}




static os_error * generatemenu(int handle,int menuno)
{
 os_error * err;
 int        ptr;
 int        sptr;
 int        cptr;
 int        i;
 int        n;
 int        title;
 int        action;
 int        flags;
 int        submenu;
 int        keypress;
 int        text;
 int        bits;
 himenustr  * m;
 char     * name;
 int        result;
 char       temp[256];
 int        child;


 err=NULL;

// cprintf("generate %d",handle);

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  m=(himenustr*)(menudata+ptr);
  if(m->type==MMENU)
  {
   m->data.menuno=menuno;
			menutag(menuno,handle);

//   cprintf("asign menuno=%d ptr=%d",menuno,ptr);
   n=m->n;

   cptr=ptr+sizeof(himenustr);
   title=cptr;

   cptr+=strlen(menudata+cptr)+1;
   cptr=(cptr+0x3) & (~0x3);

   sptr=cptr;

   for(i=0;i<n;i++)
   {
    cptr+=8;
    action=cptr;
    cptr+=strlen(menudata+cptr)+1;
    flags=cptr;
    cptr+=strlen(menudata+cptr)+1;
    submenu=cptr;
    cptr+=strlen(menudata+cptr)+1;
    keypress=cptr;
    cptr+=strlen(menudata+cptr)+1;
    text=cptr;
    cptr+=strlen(menudata+cptr)+1;
    cptr=(cptr+0x3) & (~0x3);

    xzstrncpy(temp,menudata+text,NITEM(temp));

    if(*(name=(menudata+flags)))
    {
     err=xexec(name,&result,"IS/RVNS",i,temp,&bits,sizeof(temp),temp);
     /* if(err || result) *handle=-1; */
    }
    else
    {
     bits=0;
    }

    if(*(menudata+keypress))
    {
     strcat(temp,"\t");
     strcat(temp,(menudata+keypress));
    }


    addusermenu(menuno,temp,bits,i+MENUIDBASE);

    if(*(menudata+submenu))
    {                           // create submenu, link it in
     child=getfreemenu();
     createusermenu(child,NULL,NULL);
     linkmenu(child,menuno,i);
//     cprintf("link child %d parent %d entry %d",child,menuno,i);
    }


//    menudata+title
   }
  }
 }
 return(err);
}






static os_error * openupmenusub(int window,int handle,int menuno)
{
 os_error  * err;
 int         ptr;
 char      * p;
 himenustr * m;

 err=NULL;

 lastmenu[0]=handle;
	lastmenuno[0]=menuno;

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  p=(menudata+ptr);
  m=(himenustr*)p;

  if(m->type==MMENU)
  {
   err=openupmenu(window,menuno);
  }
 }

 return(err);
}



/* passed name of menu, call function and get back menu handle */
/* use menu handle to generate real menu                       */

os_error * openmenuparent(char * name,int window)
{
 os_error * err;
 int        handle;

 mprevious=NULL;
 mpreviouslimit=0;

 err=findmenu(name,&handle);
 if(!err && handle>=0)
 {
           err=createusermenu(MPOPUP,popupdecode,popupdynamic);
  if(!err) err=generatemenu(handle,MPOPUP);
  if(!err) err=openupmenusub(window,handle,MPOPUP);
 }

 return(err);
}


os_error * openmenu(char * name)
{
 return(openmenuparent(name,menuview?menuview->handle:NULL));
}



void openmenuhandle(int fp)
{
 os_error * err;
 int        handle;

 handle=stack[fp];

 mprevious=NULL;
 mpreviouslimit=0;

          err=createusermenu(MPOPUP,popupdecode,popupdynamic);
 if(!err) err=generatemenu(handle,MPOPUP);
 if(!err) err=openupmenusub(menuview?menuview->handle:NULL,handle,MPOPUP);

 zreport(err);
}



/* get clicks on menus */

static os_error * menuhandler(int * menux)
{
 os_error * err;
 int        ptr;
 int        i;
 int        max;
 int        j;
 int        result;
 int        rvalue;
 int        cptr;
 int        action;
 int        parentp;
 int        menu[MMDEPTH];
 int        len;


 mprevious=menu;

 parentp=0;    /* compiler */
 action=0;     /* compiler */


// setrepopflag();

 rvalue=-1;

 i=0;
 while(1)
 {
  menu[i]=menux[i];
  if(menu[i]>=MENUIDBASE) menu[i]-=MENUIDBASE;
  if(menu[i]==-1) break;
  i++;
 }
 max=i;

 while(i-->0)
 {
  mpreviouslimit=i-1;

  ptr=mxptr(lastmenu[i]);

  if(ptr>=0)
  {
   /* menu[i] gives the entry in this menu to exec */

   cptr=ptr+sizeof(himenustr);

   cptr+=strlen(menudata+cptr)+1;
   cptr=(cptr+0x3) & (~0x3);

   for(j=0;j<=menu[i];j++)
   {
    action=cptr+8;
    len=*((int*)(menudata+cptr));
    cptr+=len;
   }

   if(*(menudata+action))
   {
//    cprintf("exec %d %d",i,menu[i]);
    err=xexec(menudata+action,&result,"II/R",menu[i],rvalue,&rvalue);
   }
  }
 }


 return(NULL);
}









static os_error * generatecombomenu(int handle,dboxstr * dbox,int icon,int * tick)
{
 os_error * err;
 int        ptr;
 int        sptr;
 int        cptr;
 int        i;
 int        n;
 int        title;
 int        action;
 int        flags;
 int        submenu;
 int        keypress;
 int        text;
 int        bits;
 himenustr  * m;
 char     * name;
 int        result;
 char       temp[256];



 err=NULL;

 cprintf("generate %d",handle);

 ptr=mxptr(handle);
 if(ptr>=0)
 {
  m=(himenustr*)(menudata+ptr);
  if(m->type==MMENU)
  {
   m->data.menuno=-1;
   n=m->n;

   cptr=ptr+sizeof(himenustr);
   title=cptr;

   cptr+=strlen(menudata+cptr)+1;
   cptr=(cptr+0x3) & (~0x3);

   sptr=cptr;

 cprintf("generate %d",n);

   for(i=0;i<n;i++)
   {
    cptr+=8;
    action=cptr;
    cptr+=strlen(menudata+cptr)+1;
    flags=cptr;
    cptr+=strlen(menudata+cptr)+1;
    submenu=cptr;
    cptr+=strlen(menudata+cptr)+1;
    keypress=cptr;
    cptr+=strlen(menudata+cptr)+1;
    text=cptr;
    cptr+=strlen(menudata+cptr)+1;
    cptr=(cptr+0x3) & (~0x3);

    xzstrncpy(temp,menudata+text,NITEM(temp));

    if(*(name=(menudata+flags)))
    {
     err=xexec(name,&result,"IS/RVNS",i,temp,&bits,sizeof(temp),temp);
     /* if(err || result) *handle=-1; */
    }
    else
    {
     bits=0;
    }

				if((bits & MTICK) && (tick!=NULL)) *tick=i;

    if(*(menudata+keypress))
    {
     strcat(temp,"\t");
     strcat(temp,(menudata+keypress));
    }

				cprintf("generate %s",temp);

				dbaddcomboboxstring(dbox,icon,temp);
   }
  }
 }
 return(err);
}



static os_error * decodecombomenu(int handle,int n)
{
	os_error * err;
	int        cptr;
	int        ptr;
	int        j;
	int        action=0;
	int        len;
	int        result;
	int        rvalue;

	err=NULL;

 ptr=mxptr(handle);

 if(ptr>=0)
 {
  cptr=ptr+sizeof(himenustr);

  cptr+=strlen(menudata+cptr)+1;
  cptr=(cptr+0x3) & (~0x3);

  for(j=0;j<=n;j++)
  {
   action=cptr+8;
   len=*((int*)(menudata+cptr));
   cptr+=len;
  }

  if(*(menudata+action))
  {
   err=xexec(menudata+action,&result,"II/R",n,rvalue,&rvalue);
  }
 }

	return(err);
}



os_error * menucombo(dboxstr * dbox,int icon,char * menuname,int event,int index,int * hit,uservalue * userp)
{
 os_error * err;
 int        handle;
	int        n;
	int        tick;


	err=NULL;


	if(event==DBCOMBOINIT || event==DBCOMBOCHANGE)
	{
		cprintf("%s index %d flags %x",event==DBCOMBOINIT?"comboinit":"combochange",index,dbox->dbicon[index].flags);

		if(dbox->dbicon[index].flags & DBCOMBOSTATIC)
		{
   err=findmenu(menuname,&handle);

//			cprintf("findmenu %s err %x handle %x",menuname,err,handle);

   if(!err && handle>=0)
   {
 			*userp=handle;
 			*hit=1;
    generatecombomenu(handle,dbox,icon,&tick);

//				cprintf("tick %d",tick);

				if(tick>=0)
				{
					dbselectcombobox(dbox,icon,tick);
				}
				else
				{
					dbselectcombobox(dbox,icon,*dbox->dbicon[index].value);
				}
  	}
		}
	}
	else
	if(event==CBN_DROPDOWN)
	{
  mprevious=NULL;
  mpreviouslimit=0;

		dbclearcombobox(dbox,icon);

  err=findmenu(menuname,&handle);
  if(!err && handle>=0)
  {
			*userp=handle;
			*hit=1;
   generatecombomenu(handle,dbox,icon,&tick);

 		if(dbox->dbicon[index].flags & DBCOMBOSTATIC)
 		{
				if(tick>=0)
				{
					dbselectcombobox(dbox,icon,tick);
				}
				else
				{
					dbselectcombobox(dbox,icon,*dbox->dbicon[index].value);
				}
			}

		}
	}
	else
	if(event==CBN_SELCHANGE)
	{

  dbgetselectioncombobox(dbox,icon,&n);

//		cprintf("sel change %d",n);

  decodecombomenu(*userp,n);
	}
	else
	if(event==CBN_SELENDOK)
	{

  dbgetselectioncombobox(dbox,icon,&n);

//		cprintf("sel OK %d",n);

  decodecombomenu(*userp,n);
	}


	return(err);
}




#ifdef NEVER

static void menudebug(void)
{
 int       i;
	viewstr * view;
	filestr * file;
	int       active;
	int       roots;
	int       seen0;
 int       index;

	cprintf("menu debug");
	cprintf("menutablen %d",menutablen);

	active=0;
	roots=0;
 i=0;
 index=MPOPUP;
 while(1)
 {
  if(menutable[i].menuno==MLAST) break;

  if(menutable[i].menuno!=index) cprintf("out of order %d %d",i,menutable[i].menuno);
  index++;

  if(menutable[i].menuptr) active++;
		if(menutable[i].menuptr && menutable[i].parent==0) roots++;
  i++;
 }

	cprintf("active %d roots %d",active,roots);


	roots=0;
	file=firstfile;
	while(file)
	{
		view=file->view;
		while(view)
		{
			if(view->mhandle) roots++;

			active=0;
   i=0;
			seen0=0;
   while(1)
   {
    if(menutable[i].menuno==MLAST) break;
		  if(menutable[i].menuptr && menutable[i].parent==view->mhandle)
    {
//					if(menutable[i].tag==0) cprintf("error tag is zero %d",menutable[i].entryinparent);
					if(menutable[i].entryinparent==0)
					{
						if(seen0!=0) cprintf("error more than one zero entry in parent");
						seen0=1;
					}
     active++;
				}
    i++;
   }

			cprintf("window root %d has %d children",view->mhandle,active);

			view=view->next;
		}
		file=file->next;
	}
	cprintf("window roots %d",roots);




}


void menuvdebug(int fp)
{
 if(menuview)
 {
  menudebug();
  debugosmenu(menuview->mhandle);
 }
}

#endif




static int findmenuno(int parent,int entryinparent)
{
 int i;

// cprintf("findmenuno parent=%d entry=%d",parent,entryinparent);

 i=0;
 while(1)
 {
  if(menutable[i].menuno==MLAST) break;
//		cprintf("menuno %d ptr %d parent %d in %d tag %d",menutable[i].menuno,menutable[i].menuptr,menutable[i].parent,menutable[i].entryinparent,menutable[i].tag);

  if(menutable[i].menuptr &&
     menutable[i].parent==parent && 
     menutable[i].entryinparent==entryinparent) return(menutable[i].menuno);
  i++;
 }

 return(-1);
}


static os_error * menumessage(int * menu)
{
 os_error * err;
 int        nextmenu;
 int        i;
 int        j;
 int        handle;
 int        ptr;
 int        cptr;
 int        lasthandle;
 int        len;
 int        mi;
 int        menuno;
	int        parentmenuno;

 err=NULL;


 nextmenu=0;

 i=0;
 while(menu[i]!=-1) i++;
 i--;
 mi=menu[i];
 mprevious=menu;
 mpreviouslimit=i;

 lasthandle=lastmenu[i];
	parentmenuno=lastmenuno[i];
 ptr=mxptr(lasthandle);

 if(ptr>=0)
 {
  /* menu[i] gives the entry in this menu to exec */
  /* menu[i] may not be constant...               */

//  menuno=findmenuno(((himenustr*)(menudata+ptr))->data.menuno,mi);
  menuno=findmenuno(parentmenuno,mi);
		if(menuno>=0)
		{
//  cprintf("menumessage mi=%d menuno=%d ptr=%d",mi,menuno,ptr);

   cptr=ptr+sizeof(himenustr);

   cptr+=strlen(menudata+cptr)+1;
   cptr=(cptr+0x3) & (~0x3);

   for(j=0;j<mi;j++)
   {
    len=*((int*)(menudata+cptr));
    cptr+=len;
   }

   cptr+=8;
   cptr+=strlen(menudata+cptr)+1;
   cptr+=strlen(menudata+cptr)+1;
   nextmenu=cptr;

   err=findmenu(menudata+nextmenu,&handle);

   if(!err && handle>=0)
   {
             err=clearmenu(menuno);
    if(!err) err=generatemenu(handle,menuno);
    if(!err)
    {
     lastmenu[i+1]=handle;
					lastmenuno[i+1]=menuno;
				}
   }
  }
 }

 return(err);
}




static os_error * maindynamic(int * menu,char * handle,int window)
{

// cprintf("maindynamic");

 if(menu[1]==-1)
 {
  lastmenu[0]=mainhandle;
  menuview=findview(window);
		lastmenuno[0]=menuview->mhandle;
  menufile=menuview->file;
//  cprintf("setting lastmenu");
 }

 return(menumessage(menu));
 USE(handle);
}



static os_error * maindecode(int * menu,int window)
{
 return(menuhandler(menu));
 USE(menu);
 USE(window);
}



static os_error * popupdynamic(int * menu,char * handle,int window)
{
 return(menumessage(menu));
 USE(menu);
 USE(handle);
 USE(window);
}



static os_error * popupdecode(int * menu,int window)
{
 return(menuhandler(menu));
 USE(menu);
 USE(window);
}














static os_error * menukeyf(int * key,int find)
{
 os_error * err;
 int        i;
 int        j;
 int        result;
 int        rvalue;
 int        cptr;
 int        hit;
 int        ch;
 int        len;
 himenustr  * m;

 cptr=0;
 hit=0;
 ch=*key;

 if(ch>=0)
 {
  for(i=0;i<menun;i++)
  {
   m=(himenustr*)(menudata+cptr);

   cptr+=sizeof(himenustr);
   if(m->type==MMENU)     /* dboxes don't have this structure */
   {
    cptr+=strlen(menudata+cptr)+1;
    cptr=(cptr+0x3) & (~0x3);

    for(j=0;j<m->n;j++)
    {
     if(*((int*)(menudata+cptr+4))==ch) break;
     len=*((int*)(menudata+cptr));
     cptr+=len;
    }

    if(j<m->n)
    {
     if(*(menudata+cptr+8))
     {
      rvalue=-2;/*so that we can tell the difference between keys and clicks */
      
      if(!find)
        err=xexec(menudata+cptr+8,&result,"II/R",j,rvalue,&rvalue);
      *key=-1;
     }
     break;
    }
   }
  }
 }

 return(NULL);
}


os_error * menukey(int * key)
{
 return(menukeyf(key,0));
}


// if writes always write to all copies of a menu
// any read will return the same value
// because there are no writeable menu entries...


// void writemenustring(int handle,int index,string & text);

void writemenustring(int fp)
{
 int handle;
 int entry;
 int ptr;
 int change;
	int i;
	int changeany;

//	cprintf("writemenu %s",stringptr(stack[fp+2]));

 handle=stack[fp];
 entry=stack[fp+1];
 ptr=mxptr(handle);
	if(ptr>=0)
	{
		i=0;
		changeany=0;
		while(menutable[i].menuno!=MLAST)
		{
			if(menutable[i].tag==handle && menutable[i].menuptr)
			{
    writemenu(menutable[i].menuno,entry,stringptr(stack[fp+2]),&change);
				changeany=changeany || change;
			}
			i++;
		}

		if(changeany) viewrefreshallmenubars();
	}
}


int menustring(int fp)
{
 int    handle;
 int    entry;
 int    ptr;
 char   buffer[256];
	int    i;

 handle=stack[fp];
 entry=stack[fp+1];
 ptr=mxptr(handle);
	if(ptr>=0)
	{
// cprintf("menustring %d",entry);

		i=0;
		while(menutable[i].menuno!=MLAST)
		{
			if(menutable[i].tag==handle && menutable[i].menuptr)
			{
    readmenu(menutable[i].menuno,entry,sizeof(buffer),buffer);
			}
			i++;
		}

// p=(int*)(((himenustr*)(menudata+ptr))->data.data);
// if(!p) zreport(geterror(ENOMENU));
// return(createstring(menuaddr(p,entry)));

  return(createstring(buffer));
	}

 return(createstring(""));
}



/* int menudefstring(int handle,int entry,int index,string & s); */

int menudefstring(int fp)
{
 int         handle;
 int         entry;
 int         index;
 int         s;
 int         i;
 int         ptr;
 himenustr * m;
 char      * p;
 char        temp[256];


 handle=stack[fp];
 entry=stack[fp+1];
 index=stack[fp+2];
 s=stack[fp+3];

 ptr=mxptr(handle);
	if(ptr>=0)
	{
  m=(himenustr*)(menudata+ptr);

  if(entry>=m->n || entry<0) return(0);

  p=(char*)m;
  p+=sizeof(himenustr);

  p+=((strlen(p)+1)+0x3) & (~0x3);
  for(i=0;i<entry;i++) p+=*((int*)p); /* p+=entrysize(p); */
  p+=8;
  for(i=0;i<index;i++) p+=strlen(p)+1;

  xzstrncpy(temp,p,sizeof(temp));

  assignstring(s,temp);

  return(1);
	}

	return(0);
}



int menuprevious(int fp)
{
 int n;

 n=stack[fp];

 if(!mprevious || n>mpreviouslimit) return(-1);
 else                               return(mprevious[mpreviouslimit-n]);
}




os_error * createwindowmenu(int window,char * menuname,int * mhandle)
{
 os_error * err;
 int        handle=0;

 err=NULL;
/*
 if(menutable[0].menuptr==NULL)
 {
           err=createmainmenu(MMAIN,maindecode,maindynamic);
  if(!err) err=findmenu(menuname,&handle);
  if(!err && handle>=0)
  {
   mainhandle=handle;
   err=generatemenu(handle,MMAIN);
  }
 }
*/

	*mhandle=getfreemenu();

//	*mhandle=MMAIN;

          err=createmainmenu(*mhandle,maindecode,maindynamic);
 if(!err) err=findmenu(menuname,&handle);
 if(!err && handle>=0)
 {
  mainhandle=handle;
  err=generatemenu(handle,*mhandle);
 }

 if(!err)
 {
  addwindowmenu(window,*mhandle);
 }

 return(err);
}



os_error * remwindowmenuhi(int handle,int mhandle)
{
	os_error * err;

          err=remwindowmenu(handle,mhandle);
	if(!err) err=deletemainmenu(mhandle);

	return(err);
}




os_error * menuhistart(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&menudata,MENUCHUNK);
 if(!err)
 {
  err=salloc((flex_ptr)&menutable,(menutablen+MENUTABLECHUNK)*sizeof(menustr));
  if(!err)
  {
   XMEMCPYX(menutable,menubasetable,sizeof(menubasetable));

   err=addmenus(NULL,NULL,menutable,&mlink);
   if(!err)
   {
    menusize=0;
    menuhandle=1;
    lastmenu[0]=0;
   }
  }
 }
 return(err);
}

