/*->h.toolstr */


#define TPOINTER 1
#define TTOGGLE  2
#define TBUTTON  3
#define TRADIO   4



#define IPMAXPANES 2


#define IP_PANE1 0
#define IP_PANE2 1

#define IP_HELPI 12


#define IP_FSUB  0x1
#define IP_TIPS  0x2


typedef struct iconmap
{
 char originalicon;   /* icon number in original template */
 char realicon;       /* icon number in info pal window   */
 char modded;         /* changed ?                        */
 char flags;
} iconmap;



typedef os_error * (*iprefresh)(viewstr * view,int handle,int code);

typedef os_error * (*ipredraw)(viewstr * view,int handle,
                                              wimp_redrawstr * redraw);


typedef struct ipstr
{
 clickfn   click;
 keyfn     key;
 iconmap * map;
 int       htemplate;
 ipredraw  redraw;
 iprefresh refresh;

} ipstr;



typedef struct toolstatestr       /* one for each tool int each toolbox */
{       
 int    selected;
 void * common;                   /* pointer to common workspace  */
 void * hprivate;                  /* pointer to private workspace */
 int    spare[1];
} toolstatestr;


typedef struct toolrecordstr
{
 int adjust;
 int toolkey;
 int prevadjust;
 int prevtoolkey;
} toolrecordstr;



typedef struct toolboxstr         /* one for each file */
{
 int                 current;     /* current pointer tool */
 int                 handle;      /* handle for tool pane */
 viewstr           * view;
 struct toolboxstr * next;
 struct toolboxstr * prev;

 ipstr             * ipx[IPMAXPANES];
 int                 iphandle[IPMAXPANES];
// int                 ipmax[IPMAXPANES];
// int                 ipmin[IPMAXPANES];
 int                 ipchange[IPMAXPANES];
 ipstr             * iplast[IPMAXPANES];

 toolrecordstr       record;

 int                 spare[2];
 toolstatestr        toolstate[1];

} toolboxstr;



typedef os_error * (*tptrfn)(toolboxstr * toolbox,posnstr * posn);

typedef os_error * (*tclickfn)(toolboxstr * toolbox,posnstr * posn);

typedef os_error * (*tselectfn)(toolboxstr * toolbox,viewstr * view,
                                                 filestr * file,int select);

typedef os_error * (*tmovefn)(toolboxstr * toolbox,posnstr * posn,int move);

typedef os_error * (*tcancelfn)(toolboxstr * toolbox,viewstr * view,
                                                 filestr * file);

typedef os_error * (*tredrawfn)(toolboxstr * toolbox,viewredrawstr * v);

typedef os_error * (*tdragend)(toolboxstr * toolbox,posnstr * posn,
                                                     wimp_box * box);

typedef os_error * (*tmenufn)(toolboxstr * toolbox,viewstr * view,
                                           filestr * file,wimp_mousestr * m);


typedef os_error * (*fkeyfn)(int * key);
typedef os_error * (*tkeyfn)(toolboxstr * toolbox,int * key,fkeyfn * fkey);

typedef os_error * (*tcaretfn)(toolboxstr * toolbox,viewstr * view,int gain);



#define TSAVEPOSN       0x1
#define TACTPOINT       0x2
#define TSELECTOBJECT   0x3
#define TCLAIMSUB       0x4


typedef os_error * (*tmessagefn)(toolboxstr * toolbox,filestr * file,
                                                    int message,void * data);



#define TINITBOOT   0x0
#define TINITCREATE 0x1
#define TINITDELETE 0x2

typedef os_error * (*tinitfn)(toolboxstr * toolbox,int code);






typedef struct subtoolstr
{
 int                 tooln;
 tclickfn            click;         /* click in window       */
 tmovefn             move;          /* pointer moves or not  */
 tselectfn           select;        /* tool selected or not  */
 tptrfn              pointer;       /* gain lose pointer     */
 tcancelfn           cancel;        /* stop it               */
 tredrawfn           redraw;
 tdragend            dragend;
 tmenufn             menu;
 tkeyfn              key;
 tcaretfn            caret;
 tinitfn             init;
 tmessagefn          message;
 int               * pass;          /* 0 prepass 1 post pass   */
 int               * claim;         /* set to 0 to claim event */
} subtoolstr;



typedef struct toolstr
{
 int          tooln;
 char       * name;
 char       * ticonvalid;
 char       * ticontip;
 int          ticonlen;
 tclickfn     click;         /* click in window       */
 tmovefn      move;          /* pointer moves or not  */
 tselectfn    select;        /* tool selected or not  */
 tptrfn       pointer;       /* gain lose pointer     */
 tcancelfn    cancel;        /* stop it               */
 tredrawfn    redraw;
 tdragend     dragend;
 tmenufn      menu;
 tkeyfn       key;
 tcaretfn     caret;
 tinitfn      init;
 tmessagefn   message;
 int          group;

 unsigned int preselect:1;
 unsigned int noicon:1;
 unsigned int spare2:1;
 unsigned int spare3:1;
 unsigned int spare4:1;
 unsigned int spare5:1;
 unsigned int spare6:1;
 unsigned int spare7:1;

 int          type;          /* kind of tool          */

 int          commonsize;
 int          privatesize;
 int          rank;

} toolstr;




extern os_error * toolregister(toolstr * tool);
extern os_error * subtoolregister(subtoolstr * subtool);

extern void       toolrecord(filestr  * file,toolrecordstr ** record);


/*****************************************************************************/

extern toolstr pathedit;

extern os_error * ipchangepane(toolboxstr * toolbox,int pane,ipstr * ip);
extern void       iprefreshpane(filestr * file,int code,int pane);

extern os_error * ipinitsubpanes(toolboxstr * toolbox);


