/*->h.undo */


/* pict      0x1000     */
/* select    0x1100     */
/* clip      0x1200     */
/* text      0x2000     */
/* line      0x3000     */
/* gline     0x3100     */
/* group     0x5000     */
/* act       0x6000     */
/* mx        0x6100     */
/* link      0x6200     */
/* xcolour   0x7000     */
/* newx      0x7100     */
/* modchap   0x7200     */
/* chsect    0x7300     */
/* colseps   0x7400     */
/* ustyle    0x8000     */
/* frametool 0x9000     */
/* editpath  0x9100     */
/* tools     0x9200     */
/* prefs     0xA000     */
/* border    0xC000     */
/* fill      0xD000     */



typedef os_error * (*undofn)(filestr * file);
typedef os_error * (*undosbfn)(int c,filestr * file);
typedef char     * (*undosbnamefn)(int c);

typedef struct undofnstr
{
 undofn  undo;
 undofn  scrap;
 int     tag;
 char  * name;
} undofnstr;



extern int saveundo;     /* save undo buffer ?       */
extern int undosize;     /* default undo buffer size */


extern os_error * newundobuffer(filestr * file);


extern os_error * undowrite(filestr * file,void * data,int size);
extern os_error * undowritefn(filestr * file,int fn,void * data,int size);
extern os_error * undowritefn2(filestr * file,int fn,void * data,
                                                     int size1,int size2);

extern int undoscrapcheck(filestr * file,int size);

extern os_error * undoread(filestr * file,void * data,int size);

extern os_error * undostart(filestr * file);
extern os_error * undoend(filestr * file);

extern os_error * undobyte(filestr * file,int c);
extern os_error * undoaddblock(undofnstr * undos,int size);
extern os_error * undoaddsbfn(undosbfn sbfn,undosbnamefn sbnamefn);
extern int        undoforward(filestr * file);
extern int        undoactive(filestr * file);

extern os_error * undozerosize(filestr * file);
extern os_error * undosetsize(int size);
extern os_error * undosavefile(filestr * file,int type);
extern os_error * undopostsavefile(filestr * file);
extern os_error * undoloadfile(filestr * file);


extern int        canundos(filestr * file);
extern os_error * undosx(viewstr * view,filestr * file);

extern os_error * undov(viewstr * view);
extern os_error * redov(viewstr * view);



extern os_error * initundo(void);

extern int  undostring(int fp);
extern int  redostring(int fp);
extern int  canundo(int fp);
extern int  canredo(int fp);
extern void undo(int fp);
extern void redo(int fp);
extern void flushundobuffer(int fp);
