/*->c.view */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"
#include "akbd.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "alloc.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"

#include "mlo.h"
#include "trans.h"
#include "xmath.h"
#include "conf.h"
#include "etc.h"
#include "dbhi.h"
#include "scrap.h"
#include "xhelp.h"
#include "save.h"
#include "colour.h"
#include "deb.h"
#include "osole.h"
#include "oshelp.h"
#include "bits.h"


#include "str.h"
#include "constants.h"

#include "mhi.h"
#include "reslink.h"
#include "file.h"
#include "object.h"

#include "rulers.h"
#include "tools.h"
#include "buttons.h"
#include "infopal.h"
#include "caret.h"
#include "select.h"
#include "selaction.h"
#include "undo.h"

#include "posn.h"

#include "dscript.h"

#include "transload.h"

#include "dbfile.h"
#include "dbscale.h"
#include "dbmore.h"
#include "pref.h"
#include "units.h"
#include "dbpref.h"
#include "dbnew.h"
#include "dbprint.h"

#include "txext.h"
#include "txstr.h"
#include "dbfind.h"
#include "spchk.h"

#include "new.h"
#include "main.h"

#include "viewo.h"
#include "viewr.h"

#include "view.h"


static os_error * closeview(int handle,int userhandle);


filestr * menufile;
viewstr * menuview;


/* minimum width of vdi window   */

#define MINWWIDTH  460

/* minimum height of vdi window  */

#define MINWHEIGHT 80


viewdatastr defviewdata=
{
 0, /* double page */
 0, /* rulers      */
 1, /* zoom        */
 1,
 80, /* def zoom   */
 100,
 ZOOM100,/* zoom opt */
 0, /* units       */
 1, /* tools       */
 1, /* buttons     */
 1, /* info pal    */
 1, /* guides      */
 1, /* pictures    */
 0, /* margins     */
 0, /* invisibles  */
 0, /* tabruler    */
 0, /* colour pal  */

 0, /* show grid           */
 0, /* show baseline grid  */
 1, /* baseline colour     */
 0, /* spare bits          */
 0, /* lock                */
 8, /* grid colour         */
 72000, /* spacing         */
 1,     /* grid div        */
 4, /* sub div             */
 0, /* spare               */
 0,

 72000,   /* paste board width  */
 72000,   /* paste board height */
 0,       /* paste board on/off */

 100,100, /* previous zoom      */
 ZOOM100, /* prev. zoom opt */

 0,       /* no clicks          */
 0,       /* no load            */
 0,       /* no dnd             */
 0,       /* no deletewindow    */
 0,       /* ordinary help      */
 0,       /* spell check        */
 0,       /* noproxies          */
 0,       /* no menu            */
 0,       // toolbox docked
 0,       // info pal docked

 0,       /* xruler offset      */
 0,       /* yruler offset      */

 0,       /* guideline fb       */

 -2,      /* toolbox x shift  */
 66,      /* toolbox y shift  */
 1,       /* toolbox n width  */
 12,      /* toolbox n height */

 0,       /* infopal x shift  */
 1024,    /* infopal y shift  */
 1000,    /* window owning infopal height */

	0,							// x	window coordinates
	0,							// y
	0,							// w
	0,							// h

 /* spare 4 */
};


/*****************************************************************************/


viewstr * getmenuview(void)
{
 return(menuview);
}



#define BASEFACTOR ((0x10000+200)/400)


int bosunits(int ourunits)
{
 return(fastdiv400(ourunits));
}


int osunits(int ourunits,viewstr * view)
{
 if(view->data.zoom.mul==view->data.zoom.div) return(fastdiv400(ourunits));
 else
 return(scale(ourunits,view->data.zoom.mul,400*view->data.zoom.div));

// if(view->scalefactor==BASEFACTOR) return(fastdiv400(ourunits));
// else                              return(ttmul(ourunits,view->scalefactor));
}


int bourunits(int osunits)
{
 return(osunits*400);
}


int ourunits(int osunits,viewstr * view)
{
 if(view->data.zoom.div==view->data.zoom.mul) return(osunits*400);
 else
 return(scale(osunits,400*view->data.zoom.div,view->data.zoom.mul));
 
// if(view->scalefactor==BASEFACTOR) return(osunits*400);
// else                       return(scale(osunits,0x10000,view->scalefactor));
}


int dosunits(int osunits) 
{
 return(osunits*256);
}


int dourunits(int ourunits,viewstr * view)
{
 return(osunits(256*ourunits,view));
}



void setviewscalefactor(viewstr * view)
{
// view->scalefactor=scale(0x10000,view->data.zoom.mul,400*view->data.zoom.div);
	USE(view);
}



/* perhaps the way to look at this, is that the distances */
/* calculated by the transform and osunits() should match */

void getdrtr(transformstr * tr,transformstr * itr,viewredrawstr * v)
{
 int          x0;
 int          y0;
 transformstr tr1;

// x0=v->ox*256+osunits(v->xpo*256,v->view);  

 x0=v->ox*256+scale(v->xpo,16*v->view->data.zoom.mul,25*v->view->data.zoom.div);

// y0=v->oy*256-osunits(v->ypo*256,v->view);    

 y0=v->oy*256-scale(v->ypo,16*v->view->data.zoom.mul,25*v->view->data.zoom.div);


 tr_setshift(&tr1,x0,y0);

 tr_addscale(&tr1,25*v->view->data.zoom.div,16*v->view->data.zoom.mul,25*v->view->data.zoom.div,-16*v->view->data.zoom.mul);

/*
 if(v->view->scalefactor==BASEFACTOR) tr_addscale(&tr1,25,16,25,-16);
 else      tr_addscale(&tr1,0x100,v->view->scalefactor,
                            0x100,-v->view->scalefactor);
*/

 if(itr) tr_multiply(tr,itr,&tr1);
 else    *tr=tr1;
}





#ifdef NEVER


void setscreenscale(viewstr * view,transformstr * tr)
{
 if(view->scalefactor==BASEFACTOR) tr_addscale(tr,1,1,1,1);
 else      
 tr_addscale(tr,0x10000,view->scalefactor*400,0x10000,view->scalefactor*400);
}



/* tr_addscale(&screentr,v->view->data.zoom.div,v->view->data.zoom.mul,
                         v->view->data.zoom.div,v->view->data.zoom.mul); */


void tr_o2d(transformstr * tr)
{
 transformstr temp1;
 transformstr temp2;

 temp1=*tr;
 tr_setscale(&temp2,25,16,25,-16);

 tr_multiply(tr,&temp1,&temp2);
}

static void tr_d2o(transformstr * tr)
{
 transformstr temp1;
 transformstr temp2;

 temp1=*tr;
 tr_setscale(&temp2,16,25,16,-25);

 tr_multiply(tr,&temp1,&temp2);
}









int bosunits(int ourunits)
{
 return(ourunits/400);
}


int osunits(int ourunits,viewstr * view)
{
 if(view->scalefactor==400) return(fastdiv400(ourunits));
 else                       return(ourunits/view->scalefactor);
}
/* return(scale(ourunits,view->data.zoom.mul,400*view->data.zoom.div)); */
/* else                       return(ourunits/view->scalefactor); */



int bourunits(int osunits)
{
 return(osunits*400);
}


int ourunits(int osunits,viewstr * view)
{
 if(view->scalefactor==400) return(osunits*400);
 else                       return(osunits*view->scalefactor);
}

/* else return(scale(osunits,400*view->data.zoom.div,view->data.zoom.mul)); */
/* else                       return(osunits*view->scalefactor); */


int dosunits(int osunits) 
{
 return(osunits*256);
}


int dourunits(int ourunits,viewstr * view)
{
 return(osunits(256*ourunits,view));
}


void setviewscalefactor(viewstr * view)
{
 view->scalefactor=(400*view->data.zoom.div)/view->data.zoom.mul;
}


#endif

/*****************************************************************************/

/* final act of getting rid of view structure */

os_error * deleteview(viewstr * view,filestr * file)
{
 os_error * err;
 viewstr  * next;
 viewstr  * prev;

 next=view->next;
 prev=view->prev;

 if(next) next->prev=prev;
 if(prev) prev->next=next;
 if(view==file->view) file->view=next;

 file->viewn[view->branch]--;

 err=sfree((flex_ptr)&view);

 return(err);
}


static os_error * makeview(viewstr ** viewp,filestr * file,int master)
{
 os_error    * err;
 viewstr     * view;
 prefdatastr * prefs;


 err=salloc((flex_ptr)&view,sizeof(viewstr));

 if(!err)
 {
  if(file->view) (file->view)->prev=view;
  view->next=file->view;
  file->view=view;

  file->viewn[master]++;

  view->file=file;
  view->branch=master;

  view->data=file->hdr.viewdata;

  prefs=prefp(file);
  view->data.units=prefs->units;
  view->data.pasteboardxwidth=prefs->pasteboardx;
  view->data.pasteboardywidth=prefs->pasteboardy;
  view->data.rulerx=prefs->rulerx;
  view->data.rulery=prefs->rulery;
  view->data.guidelinefb=prefs->guidelinefb;

  *viewp=view;
 }

 return(err);
}



/**********************************************************************/

#ifdef CMOSSETTINGS

#define LONGMINTIME (dragtime/2)
#define DRAGXRANGE  (2*cvdu.deltax)
#define DRAGYRANGE  (2*cvdu.deltay)
#define DBLEXRANGE  (dbleclickdistance) 
#define DBLEYRANGE  (dbleclickdistance)
#define DBLETIME    (dbleclicktime)


static int dbleclickdistance;
static int dbleclicktime;
static int dragdistance;
static int dragtime;


#else

#define LONGMINTIME 100
#define MXRANGE     (2*cvdu.deltax)
#define MYRANGE     (2*cvdu.deltay)

int longclick=LONGMINTIME;


#endif


/* 

problems here

(1) whatever the click does may take a long time and upset timeouts
(2) bad to skip out on a double click

*/



static os_error * viewicon(int handle,int userhandle,wimp_mousestr * mz)
{
 os_error      * err;
 mousestr        mx;
 wimp_mousestr   m;
 static mousestr omx;
 static int      otime;
 static int      ltime;
 static int      mousepend;
 static int      mouseclicks;
 int             diffx;
 int             diffy;
 int             diffbuttons;
 int             mouseskip;


 err=NULL;

 mouseskip=0;
 menuview=(viewstr*)userhandle;
 menufile=menuview->file;
 m=*mz;

// cprintf("view icon mousepend %d",mousepend);

 if(mousepend)
 {
  getpointer(&mx);

  diffx=ABS(mx.x-omx.x);
  diffy=ABS(mx.y-omx.y);
  diffbuttons=(mx.buttons!=omx.buttons);

//  cprintf("diffbuttons %d",diffbuttons);

//  cprintf("clock %d (ltime+35)%d mouse %d diffx %d diffy %d",clock(),(ltime+35),mouseclicks,diffx,diffy);

#ifdef CMOSSETTINGS
  if(clock()<(otime+(1+mouseclicks)*DBLETIME) && mouseclicks<6 && 
                        diffx<DBLEXRANGE && diffy<DBLEYRANGE && !diffbuttons)
#endif
#ifdef OLDSTYLE
  if(clock()<(otime+15+mouseclicks*20) && mouseclicks<6 && 
                        diffx<=MXRANGE && diffy<=MYRANGE && !diffbuttons)
#else
  if(clock()<(ltime+350) && mouseclicks<6 &&
                        diffx<=MXRANGE && diffy<=MYRANGE && !diffbuttons)
#endif
  {
   mouseclicks++;
//   cprintf("clicks %d",mouseclicks);
   if(m.bbits & (VBCLICKS|VBCLICKA)) m.bbits=(wimp_bbits)(((int)m.bbits)<<(mouseclicks+2)*4);
   else
   if(m.bbits & (VBDBLCLICKS|VBDBLCLICKA)) m.bbits=(wimp_bbits)(((int)m.bbits)<<(mouseclicks)*4);
  }
  else
  {
   if(m.bbits & (VBDBLCLICKS|VBDBLCLICKA)) mouseskip=1;
   if(m.bbits & (VBCLICKS|VBCLICKA)) mouseclicks=1;   // added for Win
   // click on picture frame, circle, double click, move back to picture
   // gadget try to drag handle, fails

   mousepend=0;
  }
 }
 else
 {
  if(m.bbits & (VBCLICKS|VBCLICKA)) mouseclicks=1;
 }


 if(!mouseskip)
 {
  if(m.bbits & (VBCLICKS|VBCLICKM|VBCLICKA))
  {
   getpointer(&omx);
   otime=ltime=clock();
  }
  else
  if(m.bbits & (VBDRAGS|VBDRAGM|VBDRAGA))
  {
   getpointer(&mx);

   /* if position has not changed, then promote to a long drag */

   diffx=ABS(mx.x-omx.x);
   diffy=ABS(mx.y-omx.y);

//   cprintf("promote? %d %d time %d",diffx,diffy,clock()-otime);

#ifdef CMOSSETTINGS
   if(diffx<DRAGXRANGE && diffy<DRAGYRANGE && ((clock()-otime)>LONGMINTIME))
#else
   if(diffx<=MXRANGE && diffy<=MYRANGE && ((clock()-otime)>longclick))
#endif
   {
//    cprintf("promoted pend %d clicks %d",mousepend,mouseclicks);
    if(mousepend || mouseclicks>1) mouseskip=1;
    else
    {
     m.bbits=(wimp_bbits)(((int)m.bbits)/VBDRAGA);
     m.bbits=(wimp_bbits)(((int)m.bbits)*VBLONGCLICKA);
    }
   }
  }
  else
  if(m.bbits & (VBDBLCLICKS|VBDBLCLICKA))
  {
   mousepend=1;
   mouseclicks=2;
   ltime=otime=clock();
  }

//  cprintf("noclicks %d skip %d",menuview->data.noclicks,mouseskip);

  if(!menuview->data.noclicks && !mouseskip) 
  {

//   cprintf("view click event %x",m.bbits);
   err=event(EVENT_VIEWCLICK,menuview,(int)&m);
   if(!err && m.bbits) err=toolsicon(menuview,menufile,&m);
  }

  if(mousepend) ltime=clock();
 }

 return(err);

 USE(handle);
}



static os_error * viewmousemove(int handle,int userhandle,wimp_mousestr * mz)
{
 os_error * err;

 err=toolmousemove(handle,userhandle,mz);

 return(err);
}



static os_error * viewsetcursor(int handle,int userhandle,wimp_mousestr * m,int * set)
{
 os_error * err;

 err=toolsetcursor(handle,userhandle,m,set);

 return(err);
}



static os_error * viewwheel(int handle,int userhandle,int delta,int buttons,int horizontal,int * ack)
{
 os_error * err;
 viewstr  * view;
 int        cscale;
 int        lines;
 mousestr   mx;

 err=NULL;

 if((buttons & MK_CONTROL))
 {
  view=(viewstr*)userhandle;

  lines=wimp_wheelgetlines(handle,delta,horizontal);

  cscale=(view->data.zoom.mul*100)/view->data.zoom.div;
  cscale+=lines;

  view->data.defzoom.mul=CUT(cscale,ZOOMMIN,ZOOMMAX);
  view->data.defzoom.div=100;

  getpointer(&mx);

  err=zoomdef(view,mx.x-view->mainwindow.x0,mx.y-view->mainwindow.y1);//mainpane

  *ack=1;
 }

 return(err);
}


#define APPCOMMAND_BROWSER_BACKWARD       1
#define APPCOMMAND_BROWSER_FORWARD        2
#define APPCOMMAND_HELP                   27
#define APPCOMMAND_FIND                   28
#define APPCOMMAND_NEW                    29
#define APPCOMMAND_OPEN                   30
#define APPCOMMAND_CLOSE                  31
#define APPCOMMAND_SAVE                   32
#define APPCOMMAND_PRINT                  33
#define APPCOMMAND_UNDO                   34
#define APPCOMMAND_REDO                   35
#define APPCOMMAND_COPY                   36
#define APPCOMMAND_CUT                    37
#define APPCOMMAND_PASTE                  38
#define APPCOMMAND_SPELL_CHECK            42



static os_error * viewappcommand(int handle,int userhandle,int source,int cmd,int device,int buttons,int * ack)
{
	os_error * err;


	err=NULL;

 menuview=(viewstr*)userhandle;
 menufile=menuview->file;


	switch(cmd)
	{

  case APPCOMMAND_BROWSER_BACKWARD:
																																			err=prevscreen(1);
																																			break;

  case  APPCOMMAND_BROWSER_FORWARD:
																																			err=nextscreen(1);
																																			break;


		case	 APPCOMMAND_HELP:
																								helptopic(menuview->handle,"<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\OvnPro.chm>");
                        break;

  case  APPCOMMAND_FIND:
																								err=openfind2();
																								break;

  case   APPCOMMAND_NEW:
																								err=opennewbox2();
																								break;

  case  APPCOMMAND_OPEN:
																								err=fileopenbox();
																								break;

  case APPCOMMAND_CLOSE:
																								err=closeviews(menuview,menufile);
																								break;

  case  APPCOMMAND_SAVE:
																							 if(menufile->saved) err=savedocs(menufile->name,menufile,FTYPE2);
                        else	               err=filepopsave(menufile,0);

																								break;

  case APPCOMMAND_PRINT:
																								err=openprintdbox(menuview);
																								break;

  case  APPCOMMAND_UNDO:
																								err=undov(menuview);
																								break;

  case  APPCOMMAND_REDO:
																								err=redov(menuview);
																								break;

  case  APPCOMMAND_COPY:
																								err=copyselection2();
																								break;

  case   APPCOMMAND_CUT:
																								err=cutselection2();
																								break;

  case APPCOMMAND_PASTE:
																								err=pasteselection2(menuview);
																								break;

  case APPCOMMAND_SPELL_CHECK:
																								err=checkstory2(0);
																								break;


		default:
										return(NULL);
										break;
	}


	*ack=1;

	return(err);

	USE(buttons);
	USE(source);
	USE(device);
	USE(handle);
}





/************************************************************************/

static posnstr  loadposn;
static int      checkload;
static int      scraphandle;
static int      loadtype;
static char   * loadname;
static int      loadvolatile;


static os_error * loadviewname(char * leaf,char * name,int userhandle)
{
 os_error * err;

 err=NULL;

 if(!scraphandle) err=sc_create(&scraphandle);
 if(!err) strcpy(name,sc_name(scraphandle));

 return(err);

 USE(leaf);
 USE(userhandle);
}


static os_error * loadview(char * name,int type,int userhandle,int xvolatile)
{
 os_error  * err;


 if(loadtype & 0x1000)
 {
  err=loadanyfile(name,FLNOLOAD);
 }
 else
 if(loadtype==DTYPE2)
 {
  err=dsinsertload(name,xvolatile,&loadposn,name);
 }
 else
 if(checkload) 
 {
  err=NULL;
  loadname=name;
  loadvolatile=xvolatile;
 }
 else
 {
  err=objectload(name,type,xvolatile,&loadposn);
 }

 cprintf("loadview %x",err);

 return(err);

 USE(userhandle);
}




os_error * transview(int postflags,char * loadname,int loadtype,int loadvolatile,posnstr * loadposn,int transflags)
{
 os_error * err;
 int        load;
 int        method;
 int        transhandle;
 char       transname[FILENAMELEN];
 int        transtype=0;
 void     * eh;


 cprintf("trans view loadname %s",loadname);

 err=sc_create(&transhandle);
 if(!err)
 {
  err=xzstrncpye(transname,sc_name(transhandle),sizeof(transname));
  if(!err) err=transloadflags(loadname,transname,&transtype,transflags);
  if(err)
  {
   if(err->errnum==ENOTRANS)
   {
    err=NULL;

    confirmparent((loadposn->view)->handle,CONYN,&load,"{FS16}",fs_typestring(loadtype));
    if(load==1)
    {
					method=0;
     cprintf("trans view post confirm loadname %s",loadname);
     err=objectloadtype(loadname,TEXTFILE,loadposn,&method);
     if(method)
     {
      err=objectload(loadname,TEXTFILE,loadvolatile,loadposn);
      if(!err) err=objectloadpost(loadposn,postflags);
      checktools(loadposn->view,loadposn->file);
     }
    }
   }
  }
  else
  {
   if(transtype==DTYPE2)
   {
    err=dsinserttype(loadposn,&method);
    if(!err && method)
    {
     err=dsinsertload(transname,1,loadposn,loadname);
     if(!err) err=dsinsertloadpost(loadposn);
     checktools(loadposn->view,loadposn->file);
    }
   }
   else
   {
				method=0;

    err=objectloadtype(transname,transtype,loadposn,&method);
    if(!err && method)
    {
     err=objectload(transname,transtype,1,loadposn);
     if(!err) err=objectloadpost(loadposn,postflags);
     checktools(loadposn->view,loadposn->file);
    }
   }
  }
  eh=errsave(err);
  fs_delete(sc_name(transhandle));
  sc_remove(transhandle,err);
  err=errload(eh,NULL);
 }

 
 return(err);
}







static os_error * loadviewpost(int userhandle)
{
 os_error * err;


 if(loadtype & 0x1000)
 {
  err=NULL;

 }
 else
 if(loadtype==DTYPE2)
 {
  err=dsinsertloadpost(&loadposn);
  checktools(loadposn.view,loadposn.file);
 }
 else
 if(checkload)
 { 
  err=transview(0,loadname,loadtype,loadvolatile,&loadposn,0);

  if(scraphandle)
  {
   fs_delete(sc_name(scraphandle));
   sc_remove(scraphandle,err);
   scraphandle=0;
  }
 }
 else
 {
  err=objectloadpost(&loadposn,0);

  if(scraphandle)
  {
   sc_remove(scraphandle,err);
   scraphandle=0;
  }

  checktools(loadposn.view,loadposn.file);
 }

 return(err);

 USE(userhandle);
}



static os_error *loadviewtype(char * name,int type,mousestr * m,int userhandle,int *method)
{
 os_error      * err;
 viewstr       * view;
 filestr       * file;

 err=NULL;

 checkload=0;

 view=(viewstr*)userhandle;
 file=view->file;

 if(view->data.noload)
 {
  *method=0;
 }
 else
 {
  loadtype=type;

  {
   initposn(&loadposn,view,file,(wimp_mousestr*)m);

   err=getposn(&loadposn);
 
   if(!err && loadposn.valid)
   {
    if(findboxhandle(&loadposn))
    {
    /* drop on a  box handle ignore */


    }
    else
    {
     if(findbox(&loadposn,-1))
     {
      if(type==DTYPE2)
      {
       err=dsinserttype(&loadposn,method);
      }
      else
      {
       err=objectloadtype(name,type,&loadposn,method);
       if(!err && !(*method))
       {
       /* assume this means we don't understand the filetype */
       /* get a scrap/real file - then have another go at it */

        if(type & 0x1000)  // route for Impression !doc documents
        {
         *method=2;
        }
        else
        {
         cprintf("file type %x",type);

         if(type<0x1000) /* chop out directories etc. */
         {
          checkload=1;
          *method=2;
         }
        }
       }
      }
     }
     else
     {
      if(type & 0x1000)  // route for Impression !doc documents
      {
       *method=2;
      }
     }
    }
   }
  }
 }

 return(err);

 USE(userhandle);
}




os_error * viewimport(char * name,int type,viewstr * view)
{
 os_error          * err;
 filestr           * file;
 int                 page;
 int                 section;
 int                 selectn;
 selectedobjectstr * selectionp;
 int                 method;
 sobjectstr        * sob;



 err=NULL;

 file=getselection(&page,&section,&selectionp,&selectn);
 if(file==view->file && selectn==1)
 {
  method=0;

  loadtype=type;
  loadname=name;
  loadvolatile=0;

  initposn(&loadposn,view,file,NULL);

  loadposn.section=section;
  loadposn.page=page;
  loadposn.object=selectionp[0].object;

  sob=(sobjectstr*)fob_find(loadposn.object,file);
  loadposn.otype=sob->type;
  err=objectloadtype(name,type,&loadposn,&method);
  if(!err)
  {
   if(method==0)
   { /* assume this means we don't understand the filetype */
     /* get a scrap/real file - then have another go at it */

    transview(OBCARETLOAD,loadname,loadtype,loadvolatile,&loadposn,0);
   }
   else
   {
    if(!err) err=objectload(name,type,0,&loadposn);
    if(!err) err=objectloadpost(&loadposn,OBCARETLOAD);
   }
  }
 }

 return(err);
}



/************************************************************************/



static int viewnb(filestr * file,int brn)
{
 viewstr * view;
 int       n;

 n=0;

 view=file->view;
 while(view)
 {
  if(view->branch==brn && !view->printview) n++;
  view=view->next;
 }

 return(n);
}


static void makeviewtitle(viewstr * view,filestr * file)
{
 int    brn;
 char * master[2]={"","{MASTER} "};
 char * modded[2]={""," *"};
 int    ch;
 char   scales[16];
 int    sx;
 int    n;

 brn=view->branch;

 ch=(file->modded[DOC]>0)||(file->modded[MST]>0);

 sx=scale(100,view->data.zoom.mul,view->data.zoom.div);

 if(sx!=100)
 {
  tsprintf(sizeof(scales),scales," at %d%%",sx);
 }
 else scales[0]=0;

 n=viewnb(file,brn);

 if(n>1)
  tsprintf(sizeof(view->name),view->name,"%s%s%s %d%s",master[brn],
         fs_leaf(file->name),modded[ch],n,scales);
 else 
  tsprintf(sizeof(view->name),view->name,"%s%s%s%s",master[brn],
         fs_leaf(file->name),modded[ch],scales); 

}



void updateviewtitle(viewstr * view)
{
 makeviewtitle(view,view->file);
 if(view->handle) writetitle(view->handle,view->name);
}



void updatealltitles(filestr * file)
{
 viewstr * view;

 view=file->view;
 while(view)
 {
  updateviewtitle(view);
  view=view->next;
 }
}




static os_error * viewhelp(int handle,int userhandle,int icon,char ** p)
{
 viewstr    * view;

 view=(viewstr*)userhandle;
 *p=helpfindtagstring(TMAIN,view->data.help2?128:0);

 return(NULL);

 USE(icon);
 USE(handle);
}




/* we are going to close this view */

static os_error * closeviewlo(viewstr * view,filestr * file)
{
 os_error * err;

 clearactiveview(view);

 event(EVENT_VCLOSE,view,0);

 err=closerulers(view);
 err=closebuttons(view);
 err=closeinfopal(view);
 err=closetools(view,file);
 err=vxcclose(view);


 osolefinitdrop(view->handle,&view->olehandle);


 remclickevent(viewicon,view->handle,(int)view); //mainpane
 remmousemoveevent(viewmousemove,view->handle,(int)view); //mainpane
 remsetcursorevent(viewsetcursor,view->handle,(int)view); //mainpane
 remcloseevent(closeview,view->handle,(int)view);
 remopenevent(viewopen,view->handle,(int)view);
// remopenevent(viewopenmainpane,view->handle,(int)view);//mainpane
 remredrawevent(viewredraw,view->handle,(int)view);//mainpane 
 remcaretevent(carethandler,view->handle,(int)view);
 remkeyevent(keyhandler,view->handle,(int)view);
 remhelpevent(viewhelp,view->handle,(int)view);
 remwheelevent(viewwheel,view->handle,(int)view);
	remappcommandevent(viewappcommand,view->handle,(int)view);

 remwindowmenuhi(view->handle,view->mhandle);

 if(!err) err=remdataload(view->handle,(int)view,loadview);
 if(!err) err=remdataloadpost(view->handle,(int)view,loadviewpost);
 if(!err) err=remdataloadtype(view->handle,(int)view,loadviewtype);
 if(!err) err=remdataloadname(view->handle,(int)view,loadviewname);

 if(!err) err=remtoolstr(view);  /* uses view->handle */

 if(!view->data.nodeletewindow)
 {
//  closedown(&view->mainpane);
  closedown(&view->handle);
 }


 err=deleteview(view,file);
 updatealltitles(file);

 if(view==menuview) menuview=NULL;

 return(err);
}




/* return 1 to keep window open */

static int closeviewstuff(viewstr * view,filestr * file)
{

#ifdef NEVER 
 mousestr mouse;

 getpointer(&mouse);

 cprintf("buttons %d icon %d",mouse.buttons,mouse.icon);

 if((mouse.buttons & 0x1) && mouse.icon==-3)
 {
  char   string[256];
  char * p=fs_leaf(file->name);
  int    len=p-file->name;

  strcpy(string,"Filer_OpenDir ");
  strcat(string,file->name);
  string[len+14-1]=0;
  os_cli(string);

  return(isshift);
 }
 else 
 {
  return(0);
 }

#endif

 return(0);

 USE(view);
	USE(file);
}







static int dcsfiles(filestr * file,viewstr * view)
{
 int result;

	
#ifdef _DEBUG 

 flex_checkheap("dcs");
 wimp_check("dcs");
 poll_check("dcs");
 fs_scanstats();

#endif

 confirmparent(view?view->handle:NULL,CONDCS|(debugactive()?0:CONFORCE),&result,"{FS08}");
                                 /* This document has been modified? */

 if(result==1)
 {
  filepopsave(file,1);
  return(1);
 }
 else
 if(result==-1)
 {
  return(1);
 }

 return(0);
}



int dcsfile(int fp)
{
 return(dcsfiles((filestr*)stack[fp],NULL));
}



/* return 1 to keep window open */

static int closeviewotherstuff(viewstr * view,filestr * file)
{
 int claim;

 if(file->viewn[0]==1)
 {
  if(!file->alwayspermanent)
  {
   claim=0;
   event(EVENT_FILESCRAP,file,(int)&claim);
   file->permanent=(claim!=0);
  }

  if(file->modded[0] && !file->permanent)
  {
   return(dcsfiles(file,view));
  }
 }

 return(0);
}



/* hi level close view, sort out last views and save */

os_error * closeviews(viewstr * view,filestr * file)
{
 os_error * err;
 int        code;

 dbstacksmash(&dbviewstack);

 err=NULL;
 code=0;

 if(!closeviewstuff(view,file))
 {
  if(view->branch==DOC && file->viewn[DOC]==1 && file->modded[MST])
  {
   err=geterror(FS11); /* Master pages edited */
  }
  else
  {
   if(view->branch==MST)
   {
    if(file->viewn[MST]==1) err=quitmasteredit(file);
   }
   else
   {
    code=closeviewotherstuff(view,file);
   }

   if(!code && !err)
   {
    err=closeviewlo(view,file);
    if(!err)
    {
     if(file->viewn[DOC]==0 && file->viewn[MST]>0) closemasterviews(file);

     if((file->viewn[DOC]+file->viewn[MST])==0)
     {
      if(!file->permanent)
      {
       err=closedoc(file);
      }
      else
      if(!file->notools)
      {
       undosavefile(file,FRSAVEUNDO);
      }
     }
    }
   }
  }
 }

 if(!err)
 {
  zerofilesquit(NULL);
 }

 return(err);
}


int userfiles(void)
{
 filestr * file;
 int       count;

 count=0;
 file=firstfile;
 while(file)
 {
  if(!file->notuserfile) count++;
  file=file->next;
 }

 return(count);
}




/* hi level close view, sort out last views and save */

static os_error * closeview(int handle,int userhandle)
{
 os_error * err;
 viewstr  * view;
 filestr  * file;


 view=(viewstr*)userhandle;
 file=view->file;

 err=closeviews(view,file);

 return(err);

 USE(handle);
}



os_error * closemasterviews(filestr * file)
{
 os_error * err;
 viewstr  * view;
 viewstr  * nextview;

 err=NULL;

 nextview=file->view;
 while(nextview)
 {
  view=nextview;
  nextview=nextview->next;

  if(view->branch)
  {
   err=closeviewlo(view,file);
  }
 }

 return(err);
}


os_error * openmasterview(filestr * file)
{
 return(createnewview(file,MST,NULL,0));
}




os_error * scrapviews(filestr * file)
{
 os_error * err;
 viewstr  * view;
 viewstr  * nextview;

 err=NULL;

 nextview=file->view;
 while(nextview)
 {
  view=nextview;
  nextview=nextview->next;
  err=closeviewlo(view,file);
 }

 return(err);
}



os_error * closefile(filestr * file)
{
 os_error * err;

 err=scrapviews(file);

 if(!err && !file->alwayspermanent)
 {
  err=closedoc(file);
 }

 return(err);
}



/* get rid of all the windows and documents - no arguing */
/*
void closeallfiles(void)
{
 filestr * nextfile;
 filestr * file;

 nextfile=firstfile;
 while(nextfile)
 {
  file=nextfile;
  nextfile=nextfile->next;
  closefile(file);
 }
}
*/


os_error * viewrefreshallmenubars(void)
{
 os_error * err;
 viewstr  * view;
 filestr  * file;

 err=NULL;

 file=firstfile;
 while(file)
 {
  view=file->view;

  while(view)
  {
   err=refreshmenubar(view->handle);
   if(err) break;
   view=view->next;
  }

  file=file->next;
 }

 return(err);
}



os_error * validview(viewstr * target)
{
 os_error * err;
 viewstr  * view;
 filestr  * file;

 err=generror(0,"Bad view handle");

 file=firstfile;
 while(file)
 {
  view=file->view;

  while(view)
  {
   if(view==target) return(NULL);
   view=view->next;
  }

  file=file->next;
 }

 return(err);
}




viewstr * findview(int handle)
{
 filestr * file;
 viewstr * view;

 file=firstfile;
 while(file)
 {
  view=file->view;
  while(view)
  {
   if(view->handle==handle) return(view);
   view=view->next;
  }
  file=file->next;
 }

 return(NULL);
}



viewstr * file1view(filestr * file,viewstr * menuview)
{
 viewstr * view;

 view=file->view;
 while(view)
 {
  if(view==menuview) break;
  view=view->next;
 }

 if(!view) view=file->view;

 return(view);
}







static os_error * createviewwindow(viewstr * view,
                                              windowstr * window,int handle)
{
 os_error  * err;

 err=NULL;

 if(!handle)
 {
  err=createwindow(TMAIN,&view->handle);
//  if(!err) createwindowparent(TMAINPANE,&view->mainpane,view->handle);
 }
 else view->handle=handle;

 if(window) view->mainwindow=*window;
 else
 {
  getw(view->handle,&view->mainwindow);

	}

 return(err);
}


os_error * createnewprintview(viewstr ** viewp,filestr * file,int master)
{
 os_error * err;
 viewstr  * view;

 err=makeview(&view,file,master);
 if(!err)
 {
  view->data.zoom.mul=view->data.zoom.div=1;
  setviewscalefactor(view);
  setviewborders(view);
  *viewp=view;
  view->printview=1;
  err=xzstrncpye(view->name,fs_leaf(file->name),sizeof(view->name));
 }

 return(err);
}


/* use the contents of the new structure to create a new file */

os_error * createnewview(filestr * file,int master,
                                            windowstr * window,int handle)
{
 os_error * err;
 viewstr  * view=NULL;
 int        page;
 int        section;

 cprintf("create new view");

 err=NULL;

 if(master & 0x2)
 {
  page=(int)window;
  section=handle;
  window=0;
  handle=0;
  master&=~0x2;
 }
 else
 {
  page=section=0;
 }

 if(!file->readable) err=geterror(ENORD);
 if(!err) err=makeview(&view,file,master);
 if(!err)
 {
  setviewscalefactor(view);
  setviewborders(view);

  setspellerrorx(view,view->data.spell);

  updatealltitles(file); /* oh so cleverly before this window has a handle */

  err=createviewwindow(view,window,handle);

  if(!err) err=addtoolstr(view);  /* uses view->handle */
  if(!err) err=addinfostr(view);

	if(err)  cprintf("create new error 7");


  if(!err)
  {
   wimp_setwindowbackground(view->handle,CCWIMPBASE+WIMPWHITE);
   wimp_setwindowflags(view->handle,WINDOWNOSCROLLCHILD |WINDOWAUTOCENTRE,0);
   wimp_setwindowflags(view->handle,WINDOWUNICODE,0);

   writetitle(view->handle,view->name);

   addclickevent(viewicon,view->handle,(int)view);//mainpane
   addmousemoveevent(viewmousemove,view->handle,(int)view); //mainpane
   addsetcursorevent(viewsetcursor,view->handle,(int)view);//mainpane
   addcloseevent(closeview,view->handle,(int)view);
   addopenevent(viewopen,view->handle,(int)view);
//   addopenevent(viewopenmainpane,view->handle,(int)view);//mainpane
   addredrawevent(viewredraw,view->handle,(int)view);//mainpane
   addcaretevent(carethandler,view->handle,(int)view);
   addkeyevent(keyhandler,view->handle,(int)view);
   addhelpevent(viewhelp,view->handle,(int)view);
   addwheelevent(viewwheel,view->handle,(int)view);
			addappcommandevent(viewappcommand,view->handle,(int)view);

   if(!err && !view->data.nomenu)
   {
    err=createwindowmenu(view->handle,"main_menu",&view->mhandle);
   }

				if(err)  cprintf("create new error 8");


   if(!err) err=adddataload(view->handle,(int)view,loadview);
   if(!err) err=adddataloadpost(view->handle,(int)view,loadviewpost);
   if(!err) err=adddataloadtype(view->handle,(int)view,loadviewtype);
   if(!err) err=adddataloadname(view->handle,(int)view,loadviewname);

   if(!err) err=createrulers(view);

   if(!err) err=createbuttons(view);

   if(!err) err=osoleinitdrop(view->handle,&view->olehandle);


   event(EVENT_VOPEN,view,0);


   if(!err) err=popupview(view,file,window,page,section);

				if(err)  cprintf("create new error 9");

   if((file->viewn[master]==1 ||1 ) && !view->data.noclicks && !err)
   {
             err=opentools(view,file);
    if(!err) err=openinfopal(view,file);

    setactiveview(view);

    if(file->viewn[DOC]==1 && file->viewn[MST]==0)
    {
     if(canundos(file))
     {
      undosx(view,file);
     }
     else
     {
      setinittoolposn(view);  /* later this should generalise to a position */
     }
    }

    caretensure(view);
   }

   event(EVENT_VOPENPOST,view,0);
  }
 }

	
	if(err)  cprintf("create new error 10");

 return(err);
}


static int gspace[]={3600000,72000,72000};
static int gspacediv[]={127,1,1};
static int gdiv[]  ={2,4,6};

static os_error * newviewdata(filestr * file,filestr * deffile)
{
 prefdatastr  * p;
 viewdatastr    viewdata;


 if(deffile)
 {
  viewdata=deffile->hdr.viewdata;
 }
 else
 {
  viewdata=defviewdata;

  p=prefp(file);

  viewdata.units=p->units;

  viewdata.grid.spacing=gspace[p->units];
  viewdata.grid.spacediv=gspacediv[p->units];
  viewdata.grid.subdiv=gdiv[p->units];

  viewdata.pasteboardxwidth=p->pasteboardx;
  viewdata.pasteboardywidth=p->pasteboardy;
 }

 file->hdr.viewdata=viewdata;

 return(NULL);
}




os_error * updateviewdata(viewstr * view)
{
 filestr  * file;

 file=view->file;
 file->hdr.viewdata=view->data;

 return(NULL);
}



/* called on load file */

void defaultviewdata(filestr * file)
{
 if(deffile)
 {
  file->hdr.viewdata.toolsxshift=deffile->hdr.viewdata.toolsxshift;
  file->hdr.viewdata.toolsyshift=deffile->hdr.viewdata.toolsyshift;
  file->hdr.viewdata.toolboxx=deffile->hdr.viewdata.toolboxx;
  file->hdr.viewdata.toolboxy=deffile->hdr.viewdata.toolboxy;
  file->hdr.viewdata.infoxshift=deffile->hdr.viewdata.infoxshift;
  file->hdr.viewdata.infoyshift=deffile->hdr.viewdata.infoyshift;
  file->hdr.viewdata.infowheight=deffile->hdr.viewdata.infowheight;
 }
}



void newview(int fp)
{
 int          master;
 sectionstr * sectionp;
 int          section;
 int          page;
 int          bits;

 master=stack[fp]|(menuview?menuview->branch:0);

 bits=master|0x2;

 if(master && menufile->viewn[MST]==0)
 {
  gomasteredit(menufile);

  sectionp=(sectionstr*)fob_find(menuview->dsection,menufile);
  section=sectionp->dual;
  sectionp=(sectionstr*)fob_find(section,menufile);
  page=sectionp->chain.child;
 }
 else
 {
  if(menuview)
  {
   section=menuview->dsection;
   page=menuview->dpage;
  }
  else
  {
   page=section=0;
   bits&=~0x2;
  }
 }

 zreport(createnewview(menufile,bits,(windowstr*)page,section));
}



int ismasterview(int fp)
{
 return(menuview->branch);
 USE(fp);
}



int nextview(int fp)
{
 viewstr * view;
 filestr * file;

 view=(viewstr*)stack[fp];
 file=(filestr*)stack[fp+1];

 if(file)
 {
  if(!view) view=file->view;
  else      view=view->next;
 }
 else
 {
  view=view->next;
 }

 return((int)view);
}


int view_handle(int fp)
{
	return(((viewstr*)stack[fp])->handle);
}




os_error * refreshview(viewstr * view)
{
 return(refreshwindow(view->handle)); //mainpane
}


os_error * refreshfile(filestr * file)
{
 os_error * err;
 viewstr  * view;

 err=NULL;

 view=file->view;
 while(view)
 {
  err=refreshview(view);
  if(err) break;
  view=view->next;
 }

 return(err);
}



os_error * refreshall(void)
{
 os_error * err;
 filestr  * file;

 err=NULL;
 file=firstfile;
 while(file)
 {
  err=refreshfile(file);
  if(err) break;
  file=file->next;
 }

 return(err);
}



/* repaint(int view,int file) */

void viewrepaint(int fp)
{
 viewstr * view;
 filestr * file;

 view=(viewstr*)stack[fp];
 file=(filestr*)stack[fp+1];

 if(view) zreport(refreshview(view));
 else
 if(file) zreport(refreshfile(file));
 else     zreport(refreshall());
}



int getguides(int fp)
{
 return(menuview->data.guides);
 USE(fp);
}


void setguides(int fp)
{
 int       show;
 viewstr * view;

 show=stack[fp];
 view=menuview;

// cprintf("show %d guides %d",show,view->data.guides);

 if((show && !view->data.guides) || (!show && view->data.guides))
 {
  view->data.guides=show;
  cprintf("refresh view");
  refreshview(view);
  updateviewdata(view);
 }
}



void toggleguides(viewstr * view)
{
// cprintf("guides %d",view->data.guides);

 view->data.guides^=1;
 refreshview(view);
 updateviewdata(view);
}



int getmargins(int fp)
{
 return(menuview->data.margins);
 USE(fp);
}


static void xsetmargins(viewstr * view,int show)
{
 if((show && !view->data.margins) || (!show && view->data.margins))
 {
  if(view->data.margins) viewrefreshview(view,VRPRINT|VRONELAYER);
  view->data.margins=show;
  if(view->data.margins) viewrefreshview(view,VRPRINT|VRONELAYER);
  updateviewdata(view);
 }
}

void setmargins(int fp)
{
 xsetmargins(menuview,stack[fp]);
}

void togglemargins(viewstr * view)
{
 xsetmargins(view,view->data.margins^1);
}



int getpictures(int fp)
{
 return(menuview->data.pictures);
 USE(fp);
}


void setpictures(int fp)
{
 int       show;
 viewstr * view;

 show=stack[fp];
 view=menuview;

 if((show && !view->data.pictures) || (!show && view->data.pictures))
 {
  view->data.pictures=show;
  refreshview(view);
  updateviewdata(view);
 }
}



int getdouble(int fp)
{
 return(menuview->data.dble);
 USE(fp);
}


void setdouble(int fp)
{
 int       show;
 viewstr * view;

 show=stack[fp];
 view=menuview;

 if((show && !view->data.dble) || (!show && view->data.dble))
 {
  xsetdouble(view,show,1);
  updateviewdata(view);
 }
}



int getinvisibles(int fp)
{
 return(menuview->data.invisibles);
 USE(fp);
}


void setinvisibles(int fp)
{
 int       show;
 viewstr * view;

 show=stack[fp];
 view=menuview;

 if((show && !view->data.invisibles) || (!show && view->data.invisibles))
 {
  view->data.invisibles=show;
  refreshview(view);
  updateviewdata(view);
 }
}



void toggleinvisibles(viewstr * view)
{
 view->data.invisibles^=1;
 refreshview(view);
 updateviewdata(view);
}



int getpasteboard(int fp)
{
 return(menuview->data.pasteboard);
 USE(fp);
}


void setpasteboard(int fp)
{
 int       show;
 viewstr * view;

 show=stack[fp];
 view=menuview;

 if((show && !view->data.pasteboard) || (!show && view->data.pasteboard))
 {
  view->data.pasteboard=show;
  xsetdouble(view,view->data.dble,1);
  updateviewdata(view);
 }
}




static os_error * viewmkstyle(int eventn,int user,filestr * file,
                                                    filestr * ofile)
{
 return(newviewdata(file,ofile));
 USE(eventn);
 USE(user);
}



static os_error * viewnewevent(int eventn,int user,filestr * file,
                                                   filestr * deffile)
{
 return(newviewdata(file,deffile));
 USE(eventn);
 USE(user);
}



static os_error * viewbareevent(int eventn,int user,filestr * file,
                                                    filestr * deffile)
{
 return(newviewdata(file,deffile));
 USE(eventn);
 USE(user);
}




os_error * viewinit(void)
{
 os_error * err;

          err=dbmoreinit();
 if(!err) err=dbprefinit();

 if(!err) err=addevent(EVENT_MKSTYLE4,(eventfn)viewmkstyle,0);
 if(!err) err=addevent(EVENT_NEWDOC4,(eventfn)viewnewevent,0);
 if(!err) err=addevent(EVENT_BAREDOC4,(eventfn)viewbareevent,0);


#ifdef CMOSSETTINGS
 if(!err)
 {
  /* these eor magic numbers are the default values with 0 in the CMOS */

  cmosread(221,&dragtime);
  dragtime=10*(dragtime ^ 5);
  cmosread(222,&dragdistance);
  dragdistance^=32;
  cmosread(223,&dbleclicktime);
  dbleclicktime=10*(dbleclicktime ^ 10);
  cmosread(22,&dbleclickdistance);
  dbleclickdistance^=32;
 }
#endif

 return(err);
}


