/*->h.dscript */



#define DSTENDLIST 0x0
#define DSTINT     0x1
#define DSTSTR     0x2
#define DSTUNISTR  0x3

#define DSTCOMPULSORY (1<<30)




#define DSTBOX         0x100
#define DSTELLIPSE     0x101
#define DSTPATH        0x102
#define DSTFCURVE      0x103
#define DSTOCURVE      0x104
#define DSTPCURVE      0x105
#define DSTMOVE        0x106
#define DSTDRAW        0x107
#define DSTCURVE       0x108
#define DSTCLOSE       0x109
#define DSTEND         0x10A
#define DSTANGLE       0x10B
#define DSTSKEW        0x10C
#define DSTNAME        0x10D
#define DSTW           0x10E
#define DSTH           0x10F
#define DSTX           0x110
#define DSTY           0x111
#define DSTICURVE      0x112
#define DSTDOC         0x113
#define DSTLINECOLOUR  0x114
#define DSTFILLCOLOUR  0x115
#define DSTTHICKNESS   0x116
#define DSTRADIUS      0x117
#define DSTINSET       0x118
#define DSTTEXTFLOW    0x119
#define DSTCOLOURVALUE 0x11A
#define DSTTYPE        0x11B
#define DSTSELF        0x11C
#define DSTKEY         0x11D
#define DSTMASTER      0x11E
#define DSTLOCAL       0x11F
#define DSTASPECT      0x120
#define DSTSCALE       0x121
#define DSTLOCK        0x122
#define DSTSPREAD      0x123
#define DSTFEATURE     0x124
#define DSTUNICODE     0x125




typedef struct dsobjectstr
{
 int type;
 int len;

 union
 {
  int  integer;
  char string[1];
  int  array[1];
		unsigned short unistring[1];
  curvestr curve;

 } data;

} dsobjectstr;


extern int * dsstack;



#define DSCREATEIMMEDIATE 0x1
#define DSCREATECOPY      0x2
#define DSPRESERVELOC     0x4


#define DSIMMINIT  0
#define DSIMMLAST -1
#define DSIMMERR  -2

#define DSCOPY    -3


#define DEFDSSIZE 0x1000



/* immediate creator called on every argument as created          */
/* initial call with argc==0, then argc, finally with argc==-1 */
/* or -2 error */


typedef os_error * (*dscreatefn)(int sp,int n,objectloc * loc);



typedef struct dscreator
{
 int            parent;
 int            sibls[2];
 int            balance;
 char         * name;
 dscreatefn     create;
 int            flags;
 int            type;
 int          * arglist;

} dscreator;



extern os_error * dsaddblock(dscreator * ds,int n);

extern int * dsstackptr(void);



extern os_error * dsloadfile(char * name,int type,int userhandle,
                                                  int xvolatile);
extern os_error * dsloadfilepost(int userhandle);


extern os_error * dsinsertloadpost(posnstr * posn);
extern os_error * dsinsertload(char * name,int xvolatile,posnstr * posn,char * basename);
extern os_error * dsinsertload2(char * name,int xvolatile,posnstr * posn,char * basename,int postflags);
extern os_error * dsinserttype(posnstr * posn,int * method);


extern os_error * dschain(int next,filestr * file,buffer * bf);

extern os_error * dsbox(boxstr * box,transformstr * tr,buffer * bf);
extern os_error * dstransform(boxstr * box,transformstr * tr,buffer * bf);
extern os_error * dscurve(curvestr * c,transformstr * tr,char * tag,
                                                buffer * bf,filestr * file);


extern char * dsmkunistr2(unsigned short * src,char * temp,int maxlen);
extern char * dsmkunistr1(char * src,char * temp,int maxlen);


extern os_error * dstextflow(textflowstr * f,buffer * bf,filestr * file);

extern os_error * dssavefile(char * name,filestr * file);

extern os_error * dsneeddoc(objectloc * loc);

extern os_error * dsexec(char * name,int mode);

extern void dscode(int fp);


extern os_error * dsmapadd(int value,int * count);
extern os_error * dsmapinit(void);
extern os_error * dsmapfinit(void);



extern os_error * dsinit(void);


typedef struct dslocmessagestr
{
 posnstr     * posn;
 objectloc   * loc;
} dslocmessagestr;


