/*->c.macros */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>



#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"


#include "filetype.h"
#include "alloc.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "conf.h"
#include "osreg.h"
#include "deb.h"
#include "err.h"

#include "xext.h"



#include "str.h"
#include "constants.h"
#include "reslink.h"

#include "codes.h"


#include "dbmore.h"

#include "dbmacros.h"


#include "macros.h"







       macro * macros;        /* holds header for each macro */
       char  * mstrings;      /* holds macro strings */


       int  macrostot;        /* number of macros defined */
       int  mstringsize;


/*****************************************************************************/




int nextbuttonmacro(int n)
{
 while(++n<macrostot)
 {
  if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE))
  {
   return(n);
  }
 }
 return(-1);
}



int prevbuttonmacro(int n)
{
 int m;

 for(m=0;m<n;m++)
 {
  if(macros[m].type==TYPEBUTTON && (macros[m].flags & MACACTIVE))
  {
   return(m);
  }
 }
 return(-1);
}




/* find macro, by type or name */
/* return -1 if not found      */


int findmacro(char * name,int value)
{
 int i;

 if(name)
 {
  for(i=0;i<macrostot;i++)
  {
   if(!cstrcmp(macros[i].name,name)) return(i);
  }
 }
 else
 {
  for(i=0;i<macrostot;i++)
  {
   if(macros[i].type==TYPEKEY)
   {
    if(value==macros[i].data.value) return(i);
   }
  }
 }

 return(-1);
}



/* lo level delete macro number n */

void delmacron(int n)
{
 int     len;
 int     offset;
 int     moffset;
 int     i;

 if(n>=0 && n<macrostot)
 {
  offset=macros[n].defn;
  moffset=n*sizeof(macro);
  len=strlen(mstrings+offset);
  flex_midextend((flex_ptr)&mstrings,offset+len+1,-(len+1));
  mstringsize-=(len+1);
  flex_midextend((flex_ptr)&macros,moffset+sizeof(macro),-(int)sizeof(macro));
  macrostot--;

  for(i=0;i<macrostot;i++)
  {
   if(macros[i].defn>offset) macros[i].defn-=len+1;
  }
 }
}




// field 0 == definition
// field 1 == help
// field 2 == applet name
// field 3 == tip

static os_error * updatemacrofield(int mn,int field,char * string)
{
	os_error * err;
	int        i;
 int        oldlen;
 int        newlen;
 int        delta;
 int        offset;

	err=NULL;


	if(string)
	{
//		cprintf("update mac field %s",string);

 	i=0;
  newlen=strlen(string)+1;

  offset=macros[mn].defn;
 	while(i++<field)
 	{
 		offset+=strlen(mstrings+offset)+1;
 	}

  oldlen=strlen(mstrings+offset)+1;
  delta=newlen-oldlen;

  if(delta) err=flex_midextend((flex_ptr)&mstrings,offset+oldlen,delta);
  if(!err)
  {
   mstringsize+=delta;
   strcpy(mstrings+offset,string);
   for(i=0;i<macrostot;i++)
   {
    if(macros[i].defn>offset) macros[i].defn+=delta;
   }
  }
	}

	return(err);
}


os_error * updatemacro(int mn,char * definition,char * help,char * aname,char * ttip)
{
	os_error * err;

	         err=updatemacrofield(mn,0,definition);
	if(!err) err=updatemacrofield(mn,1,help);
	if(!err) err=updatemacrofield(mn,2,aname);
	if(!err) err=updatemacrofield(mn,3,ttip);

 return(err);
}


#define MCHUNK  (16*sizeof(macro))
#define MSCHUNK 1024



os_error * addmacro(int type,char * name,char * definition,int value,
                                         char * data,char * help,char * aname,char * ttip,int * n)
{
 os_error * err;
 int        mn;
 int        delta;
 int        dlen;
 int        hlen;
	int        alen;
 int        flags;

 err=NULL;

 flags=0;
 if(type & TYPEBUTTONA)      flags|=MACACTIVE;
 if(type & TYPEBUTTONG)      flags|=MACGAP;
 if(type & TYPEBUTTONL)      flags|=MACNL;
 if(type & TYPEBUTTONX)      flags|=MACEXTERN;
 if(type & TYPEBUTTONEXTEND) flags|=MACEXTEND;
 if(type & TYPEBUTTONEXTEXT) flags|=MACEXTEXT;

 flags|=((type & TYPEBUTTONTXWIDTH)>>TYPEBUTTONTXSHIFT)<<MACTXSHIFT;

// cprintf("add macro %s %s %s",name,definition,help);


 type&=TYPEMASK;

 mn=findmacro(name,value);

 if(mn>-1)      /* this macro exists */
 {
  *n=mn;

  if(data) xzstrncpy(macros[mn].data.data,data,MDLEN);
  else     macros[mn].data.value=value;

  macros[mn].flags=flags;

//		cprintf("update macro");

  err=updatemacro(mn,definition,help,aname,ttip);
 }
 else           /* creating a new one */
 {
  err=flex_chunk((flex_ptr)&macros,(macrostot+1)*sizeof(macro),MCHUNK);
  if(!err)
  {
   delta=dlen=strlen(definition)+1;
   if(help) hlen=strlen(help)+1;
   else     hlen=1;
   delta+=hlen;

   if(aname) alen=strlen(aname)+1;
   else      alen=1;
			delta+=alen;

   if(ttip)  delta+=strlen(ttip)+1;
   else      delta+=1;

   err=flex_chunk((flex_ptr)&mstrings,mstringsize+delta,MSCHUNK);
   if(!err)
   {
    mn=macrostot;
    *n=mn;

    macros[macrostot].flags=flags;
    macros[macrostot].type=type;
    xzstrncpy(macros[macrostot].name,name,MNLEN);

    if(data) xzstrncpy(macros[macrostot].data.data,data,MDLEN);
    else     macros[macrostot].data.value=value;

    macros[macrostot].defn=mstringsize;
    strcpy(macros[macrostot].defn+mstrings,definition);

    if(help) strcpy(macros[macrostot].defn+mstrings+dlen,help);
    else     *(macros[macrostot].defn+mstrings+dlen)=0;

    if(aname) strcpy(macros[macrostot].defn+mstrings+dlen+hlen,aname);
    else      *(macros[macrostot].defn+mstrings+dlen+hlen)=0;

				if(ttip)	 strcpy(macros[macrostot].defn+mstrings+dlen+hlen+alen,ttip);
    else      *(macros[macrostot].defn+mstrings+dlen+hlen+alen)=0;

    mstringsize+=delta;
    macrostot++;
   }
  }
 }
 return(err);
}



int macroextbits(int i)
{
 int type;

 type=macros[i].type;

 if(macros[i].type==TYPEBUTTON)
 {
  if(macros[i].flags & MACACTIVE) type|=TYPEBUTTONA;
  if(macros[i].flags & MACGAP)    type|=TYPEBUTTONG;
  if(macros[i].flags & MACNL)     type|=TYPEBUTTONL;
  if(macros[i].flags & MACEXTERN) type|=TYPEBUTTONX;
  if(macros[i].flags & MACEXTEND) type|=TYPEBUTTONEXTEND;
  if(macros[i].flags & MACEXTEXT) type|=TYPEBUTTONEXTEXT;
  type|=((macros[i].flags & MACTXWIDTH)>>MACTXSHIFT)<<TYPEBUTTONTXSHIFT;
 }

 return(type);
}





os_error * macrossave(char * filename,int delall)
{
 os_error * err;
 int        i;
 char       scrap[512];
 char       scrap2[64];
 char       scrap3[64];
 char       help[256];
 char       aname[64];
	char       ttip[80];
 buffer     bf;
 int        type;
 int        dlen;
 int        hlen;
	int        alen;


 macrosstash();

 err=bf_open(filename,'w',DEFBUFFSIZE,&bf);

 if(!err)
 {
  stdfileheader(&bf,fs_leaf(filename));
  bf_printf(&bf,"void main(void)\r\n{\r\n");

  if(delall) bf_printfeol(&bf,"delallmacros();");

  for(i=0;i<macrostot;i++)
  {
   if(!(macros[i].flags & MACEXTERN))
   {
    type=macroextbits(i);

    dlen=strlen(macros[i].defn+mstrings)+1;
    hlen=strlen(macros[i].defn+mstrings+dlen)+1;
				alen=strlen(macros[i].defn+mstrings+dlen+hlen)+1;

    if(*(macros[i].defn+mstrings+dlen+hlen)==0 && *(macros[i].defn+mstrings+dlen+hlen+alen)==0)	// no tip and no applet name
    {
     if(*(macros[i].defn+mstrings+dlen)==0)			// no help
     {
      err=bf_printfeol(&bf,"defmacro(%d,\"%s\",\"%s\",\"%s\");",
                   type,
                   unquotec(macros[i].name,scrap2),
                   unquotec(macros[i].defn+mstrings,scrap),
                   ((type & TYPEMASK)==0)?(unquotec(macros[i].data.data,scrap3)):""
                   );
     }
     else																																				// help
     {
      err=bf_printfeol(&bf,"defmacro2(%d,\"%s\",\"%s\",\"%s\",\"%s\");",
                   type,
                   unquotec(macros[i].name,scrap2),
                   unquotec(macros[i].defn+mstrings,scrap),
                   ((type & TYPEMASK)==0)?(unquotec(macros[i].data.data,scrap3)):"",
                   unquotec(macros[i].defn+mstrings+dlen,help)
                   );
     }
    }
    else
				if(*(macros[i].defn+mstrings+dlen+hlen+alen)==0)	// no tooltip	+ but there is applet name
    {
     err=bf_printfeol(&bf,"defmacro3(%d,\"%s\",\"%s\",\"%s\",\"%s\",\"%s\");",
                   type,
                   unquotec(macros[i].name,scrap2),
                   unquotec(macros[i].defn+mstrings,scrap),
                   ((type & TYPEMASK)==0)?(unquotec(macros[i].data.data,scrap3)):"",
                   unquotec(macros[i].defn+mstrings+dlen,help),
                   unquotec(macros[i].defn+mstrings+dlen+hlen,aname)
                   );
    }
				else																																													// tooltip
				{
     err=bf_printfeol(&bf,"defmacro4(%d,\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\");",
                   type,
                   unquotec(macros[i].name,scrap2),
                   unquotec(macros[i].defn+mstrings,scrap),
                   ((type & TYPEMASK)==0)?(unquotec(macros[i].data.data,scrap3)):"",
                   unquotec(macros[i].defn+mstrings+dlen,help),
                   unquotec(macros[i].defn+mstrings+dlen+hlen,aname),
                   unquotec(macros[i].defn+mstrings+dlen+hlen+alen,ttip)
                   );
				}
   }
   if(err) break;
  }

  bf_printfeoln(&bf,2,"}");
  err=bf_closec(&bf,err,filename,SCRIPT2);
 }

 return(err);
}


static char * macrospath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\AutoRun\\!Macros.csc";
static char * macrosbasepath="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\AutoRun\\!Macros.csc";


os_error * savedefaultmacros(void)
{
 os_error * err;
 int        result;

 err=confirmparent(NULL,CONYN,&result,"{MACC}");
 if(result==1)
 {
  err=fs_validatepath(multiuser?macrospath:macrosbasepath,0);
  if(!err) err=macrossave(multiuser?macrospath:macrosbasepath,0);
 }
 return(err);
}


static macro * smacros;        /* holds header for each macro */
static char  * smstrings;      /* holds macro strings */
static int     smacrostot;

os_error * savemacros(void)
{
 os_error * err;
 int        size;
 int        i;

 flex_free((flex_ptr)&smacros);
 flex_free((flex_ptr)&smstrings);

 flex_size((flex_ptr)&macros,&size);
 err=flex_alloc((flex_ptr)&smacros,size);
 if(!err)
 {
  XMEMCPYX(smacros,macros,size);
 }

 flex_size((flex_ptr)&mstrings,&size);
 err=flex_alloc((flex_ptr)&smstrings,size);
 if(err)
 {
  flex_free((flex_ptr)&smacros);
 }
 else
 {
  XMEMCPYX(smstrings,mstrings,size);
 }

 smacrostot=macrostot;

 for(i=0;i<smacrostot;i++) smacros[i].flags&=~MACINUSE;

 return(err);
}


os_error * clearmacros(void)
{
 flex_free((flex_ptr)&smacros);
 return(flex_free((flex_ptr)&smstrings));
}


os_error * loadmacros(void)
{
 flex_swop((flex_ptr)&smstrings,(flex_ptr)&mstrings);
 flex_swop((flex_ptr)&smacros,(flex_ptr)&macros);
 macrostot=smacrostot;
 return(clearmacros());
}







static macrokeyhandler mkeyfn;

/* typical string output function */

static os_error * keyoutput(int ch)
{
 return(mkeyfn(&ch));
}


/* passed a key press, and a function to pass keypresses to */
/* look up key number in macro table                        */
/* if present expand definition, and pass on                */
/* else just pass the key on                                */

os_error * keymacro(macrokeyhandler keyfn,int * key,int macenv,int macview)
{
 os_error * err;
 int        ch;
 int        nm;
 int        mr=-1;

 ch=*key;

 mr=macrorecordermacro();
 nm=findmacro(NULL,ch);

 if(nm!=-1 && nm!=mr)
 {
  mkeyfn=keyfn;
  err=expandamacro(keyoutput,nm,macenv,macview);
  *key=-1;
 }
 else
  err=keyfn(key);

 if(*key==-1 && ch!=-1) macrorecorder(ch);

 return(err);
}





/*******************************************************************************/


/* a token is a non space, followed by a space or zero */

static char * gettok(char * string,int * len)
{
 int    tlen;
 char * p;
 char * q;

 p=string;
 while(*p==' ' || *p==';') p++;
 q=p;
 while(*q && *q!=';') q++;

 tlen=q-p;
 if(*q)
 {
  *q=0;
  tlen++;
 }

 *len=tlen;

 return(p);
}




typedef struct glyphnamestr
{
 char * name;
 int    unicode;

} glyphnamestr;



static glyphnamestr * glyphnames;
static char         * glyphstrings;
static int            glyphn;
static int            gstringsize;


#define GCHUNK (128*sizeof(glyphnamestr))
#define GSCHUNK (256)


static int cmpglyph(const void * p1,const void * p2)
{
 
 return(strcmp(((glyphnamestr*)p1)->name,((glyphnamestr*)p2)->name));
}



static os_error * macrogetglyphs(void)
{
 os_error * err;
 buffer     bf;
 char       string[MAX_PATH];
 int        eof;
 int        len;
 char    *  p;
 int        slen;
 int        i;


 sprintf(string,"<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\UK\\glyphlist.txt");


          err=flex_alloc((flex_ptr)&glyphnames,GCHUNK);
 if(!err) err=flex_alloc((flex_ptr)&glyphstrings,GSCHUNK);
 if(!err) err=bf_open(string,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
  eof=0;

  while(!eof)
  {
   err=bf_getstring(&bf,string,sizeof(string),&eof);
   if(err) break;

   err=flex_chunk((flex_ptr)&glyphnames,(glyphn+1)*sizeof(glyphnamestr),GCHUNK);
   if(err) break;

   p=gettok(string,&len);
   if(len)
   {
    if(*p=='#')
    {

    
    }
    else
    {
     err=flex_chunk((flex_ptr)&glyphstrings,(gstringsize+len),GSCHUNK);
     if(err) break;

     slen=len;
     glyphnames[glyphn].name=(char*)gstringsize;
     strcpy(glyphstrings+gstringsize,p);


     p=gettok(p+len,&len);
     if(len)
     {
      glyphnames[glyphn].unicode=atoix(p,NULL);
      glyphn++;
      gstringsize+=slen;
     }
    }
   }
  }
  err=bf_close(&bf,err);

  if(glyphn)
  {
   for(i=0;i<glyphn;i++)
   {
    glyphnames[i].name=glyphstrings+(int)glyphnames[i].name;
   }
   qsort(glyphnames,glyphn,sizeof(glyphnamestr),cmpglyph);

  }
 }
 return(err);
}



int macrofindglyph(char * string)
{
 glyphnamestr * p;
 glyphnamestr   target;

 target.name=string;

 p=(glyphnamestr*)bsearch(&target,glyphnames,glyphn,sizeof(glyphnamestr),cmpglyph);


// cprintf("find glyph %x",p);

 if(p) return(p->unicode);

 return(-1);
}


int macrofindnearestglyph(char * string)
{
 glyphnamestr * p;
 glyphnamestr   target;

 target.name=string;

 p=(glyphnamestr*)bnearest(&target,glyphnames,glyphn,sizeof(glyphnamestr),cmpglyph);

 if(p) return(p->unicode);

 return(-1);
}




int xmacrofindglyph(int fp)
{
	return(macrofindglyph(stringptr(stack[fp])));
}



char * macrofindglyphname(int unicode)
{
 int i;

 for(i=0;i<glyphn;i++)
 {
  if(glyphnames[i].unicode==unicode)
  {
   return(glyphnames[i].name);
  }
 }

 return("");
}

int xmacrofindglyphname(int fp)
{
	return(createstring(macrofindglyphname(stack[fp])));
}



/*****************************************************************************/


char * uncode(char * string,int byte)
{
 if(byte>127)
 {
  *string++='|';
  *string++='!';
  byte&=0x7F;
 }

 if(byte<32 && byte>=0)
 {
  *string++='|';
  *string++=(char)(byte+'@');
 }
 else
 if(byte=='|')
 {
  *string++='|';
  *string++='|';
 }
 else
 if(byte=='\"')
 {
  *string++='|';
  *string++='\"';
 }
 else
 if(byte=='<')
 {
  *string++='|';
  *string++='<';
 }
 else
 if(byte==127)
 {
  *string++='|';
  *string++='?';
 }
 else
 if(byte=='{')
 {
  *string++='|';
  *string++='{';
 }
 else
 if(byte>0)
 {
  *string++=(char)byte;
 }

 *string=0;

 return(string);
}



#ifdef NEVER


static int    cmaxlen;
static int    clen;
static char * cres;


static os_error * consub(int byte)
{
 *cres++=byte;

 clen++;

 /* return(clen>=cmaxlen); */  /* error */

 return(NULL);
}



int convert(char * string,char * result,int * len,int maxlen)
{
 int code;

 code=0;

 cmaxlen=maxlen;
 clen=0;
 cres=result;

 expandmacro(consub,string);

 *len=clen;

 return(code);
}


int codechar(char * string)
{
 char       buffer[20];
 int        len;
 if(strlen(string)==0) return(-1);
 convert(string,buffer,&len,20);
 if(len==1) return(buffer[0]);
 else       return(-1);
}


#endif


/*****************************************************************************/

#ifdef NEVER


static fixedmacrostr * fmroot=(fixedmacrostr*)(-1);


static int fmcmpcs(void * key1,void * key2)
{
 return(strcmp(*((char**)key1),*((char**)key2)));
}



static int fixedmacro(expandfn exfn)
{
  se=(scripteventstr*)avlfind(&sfp->eventno,(int)sbroot,0,sbcmpcs);


}



os_error * registermacroblock(fixedmacrostr * mb,int n);
{

 while(n--)
 {
  avlsearch((int)mb,(int*)&sbroot,0,fmcmpcs);
  sb++;
 }

 return(NULL);
}


#endif


/*****************************************************************************/



typedef struct tokstring
{
 char * token;
 int    value;
} tokstring;



/* !!! the entries in this table are in alpha order */


static tokstring tokcaptab[]=
{
 "OE",U_OE,
 "Wcircumflex",U_WCIRC,
 "Ycircumflex",U_YCIRC,
};


static tokstring toktab[]=
{
 "activedate",XACTDATE,
 "chapternumber",XCHAPNO,
 "dagger",U_DAGGER,
 "daggerdouble",U_DAGGERDBL,
 "date",XDATE,
 "datetime",XDATETIME,
 "deleteb",XDELETEB,
 "deletef",XDELETEF,
 "ellipsis",U_ELLIPSIS,
 "emdash",U_EMDASH,
 "emspace",XEMSPACE,
 "emspace_d",XEMSPACED,
 "emspace_n",XEMSPACEN,
 "emspace_nd",XEMSPACEND,
 "endash",U_ENDASH,
 "enspace",XENSPACE,
 "enspace_d",XENSPACED,
 "enspace_n",XENSPACEN,
 "enspace_nd",XENSPACEND,
 "euro",U_EURO,
 "fi",U_LIGFI,
 "filedir",XDOCDIR,
 "filename",XDOCNAME,
 "filepath",XDOCPATH,
 "fl",U_LIGFL,
 "guilsingleleft",U_GUISL,
 "guilsingleright",U_GUISR,
 "hardhyphen",XNBHYPH,
 "hardspace",XNBSPACE,
 "minus",U_MINUS,
 "newframe",XEOBOX,
 "newline",XNEWLINE,
 "newpage",XEOPAGE,
 "newpara",XNEWPARA,
 "oe",U_oe,
 "pagenumber",XPAGENO,
 "perthousand",U_PERTHOUSAND,
 "quotedoubleleft",U_QDBLL,
 "quotedoubleright",U_QDBLR,
 "quotesingleleft",U_QSINGL,
 "quotesingleright",U_QSINGR,
 "softhyphen",XDCHYPH,
 "tabchar",XTABCH,
 "time",XTIME,
 "trademark",U_TRADEMARK,
 "wcircumflex",U_wCIRC,
 "ycircumflex",U_yCIRC,
};





static int tokcapcmp(const void * p,const void * q)
{
 char * p1=((tokstring*)p)->token;
 char * q1=((tokstring*)q)->token;

 return(strcmp(p1,q1));
}





static int tokcmp(const void * p,const void * q)
{
 int f;
 int s;
 char * p1=((tokstring*)p)->token;
 char * q1=((tokstring*)q)->token;

 while(1)
 {
  f=tolower(*p1++);
  s=(*q1++);
  if(f!=s) return(f-s);
  if(!f) break;
 }

 return(0);
}


int macrofindtoken(char * string)
{
 tokstring * p;
 tokstring   target;

 target.token=string;

 p=(tokstring*)bsearch(&target,tokcaptab,sizeof(tokcaptab)/sizeof(tokstring),
                                         sizeof(tokstring),tokcapcmp);

 if(!p)
 {
  p=(tokstring*)bsearch(&target,toktab,sizeof(toktab)/sizeof(tokstring),
                                          sizeof(tokstring),tokcmp);
 }

 if(p) return(p->value);

 return(-1);
}




char * macrofindtokenname(int unicode)
{
 int i;

 for(i=0;i<sizeof(tokcaptab)/sizeof(tokstring);i++)
 {
  if(tokcaptab[i].value==unicode) return(tokcaptab[i].token);
 }

 for(i=0;i<sizeof(toktab)/sizeof(tokstring);i++)
 {
  if(tokcaptab[i].value==unicode) return(tokcaptab[i].token);
 }

 return(NULL);
}




static os_error * sysmacro(expandfn exfn,char * string)
{
 os_error * err;
 char       buff[1024];
 char     * p;
 int        size;


 buff[0]=0;


 if(isnumberstring(string))
 {
  err=exfn(getint(string,NULL));
 }
 else
 {
  if(*string=='%')
  {
   err=osreadvar(string,buff,sizeof(buff));
  }
  else
  {
   size=sizeof(buff);
   err=regreadstr(string,buff,&size);
 //  cprintf("mac %s %s",string,buff);
  }
 

  if(!err)
  {
   p=buff;
   while(*p)
   {
    err=exfn(*p++);
    if(err) break;
   }
  }
 }

 return(err);
}



/* internal macro, can be keycode, 'keycode, token, or stuff */


static os_error * intmacro(expandfn exfn,char * string,int macenv,int macview)
{
 os_error * err;
 int        c;
 int        d;
 int        s;
 int        len;

 err=NULL;

 macenv+=0x1000000;

 if((c=macrofindtoken(string))>=0) err=exfn(c);
 else
 if((c=macrofindglyph(string))>=0) err=exfn(c);
//	else
//	if((c==macrofindnumber(string))>=0) err=exfn(c);
 else
 if(*string=='\'')
 {                   /* better be key macro */
  if((c=keytypetext(string+1))>=0) {/*cprintf("keytype returns %x",c);*/err=exfn(c);}  // mess here because c is a key press i.e. bits set for shift etc. legacy expects a key code, keytypetext() attempts to sort this out.
 }
 else
 {             /* maybe key macro, or macro, or else stuff */
  if((c=keytype(string))>=0)
  {
   d=findmacro(NULL,c);

//   cprintf("find macro %x",d);

   if(d>=0) err=expandamacro(exfn,d,macenv,macview);
   else
   {
    c=keytypetext(string);  // mess here because c is a key press i.e. bits set for shift etc. legacy expects a key code, keytypetext() attempts to sort this out.
    err=exfn(c);
   }
  }
  else
  if((c=findmacro(string,0))>=0)
  {
   err=expandamacro(exfn,c,macenv,macview);  /* need to return error */
  }
/*  else
  if(fixedmacro(string,exfn)) return(0); */
  else 
  {    /* stuff */
   s=createstring("");
   err=xexecstuff3(string,s,macenv,macview);
   if(!err)
   {
    d=0;
    len=stringlen(s);
    while(d<len)
    {
     c=*(stringptr(s)+d++);
     err=exfn(c);
					if(err) break;
    }
    rmstring(s);
   }
   else
   {
    rmstring(s);
   }
  }
 }

 return(err);
}




#define BAR0 0
#define BAR1 1
#define BAR2 2
#define BAR3 3


#define MAC0 0
#define MAC1 1
#define MAC2 2


os_error * expandmacro2(expandfn exfn,char * string,int macenv,int macview)
{
 os_error * err;
 int        i;
 int        ch;
 int        barstate;
 int        mstate;
 char       buff[256];
 int        m;
 int        curlys;


 err=NULL;
 curlys=0;
 m=0;
 barstate=BAR0;
 mstate=MAC0;

 for(i=0;i<(int)strlen(string);i++)
 {
  ch=string[i];

  switch(barstate)
  {
   case BAR0:                  /* the state looking for | seqs */
             if(ch=='|') 
             {
              barstate=BAR1;
              continue;
             }
             break;


   case BAR2:                  /* must be a | */
             if(ch!='|') 
             {
              ch+=128;
             }
             else
             {
              barstate=BAR3;
              continue;
             }
             break;

   case BAR3:
   case BAR1:                  /* | something */

             switch(ch)
             {
              case '!':
                       barstate=BAR2;
                       continue;

              case '?':
                       ch=127;
                       break;


               default:
                       if(ch>='@' && ch<='_') ch=ch-'@';
                       break;
             }
             if(barstate==BAR3) ch+=128;
             break;
  }

  /* now got a code 0..255 */

  switch(mstate)
  {
   case MAC0:
             if(ch=='<' && !barstate)
             {
              mstate=MAC1;
              m=0;
             }
             else
             if(ch=='{' && !barstate)
             {
              mstate=MAC2;
              curlys=0;
              m=0;
             }
             else
             {
              err=exfn(ch);
             }
             break;

   case MAC1:        /* a <something> seq, accumulate then expand */
             if(ch=='>')
             {
              buff[m]=0;
              err=sysmacro(exfn,buff);
              mstate=MAC0;
             }
             else
              buff[m++]=(char)ch;
             break;

   case MAC2:        /* a {something} seq, accumulate then expand */
             if(ch=='}' && !curlys && !barstate)
             {
              buff[m]=0;
              err=intmacro(exfn,buff,macenv,macview);
              mstate=MAC0;
             }
             else
             {
              buff[m++]=(char)ch;
              if(!barstate)
              {
               if(ch=='}') curlys--;
               else
               if(ch=='{') curlys++;
              }
             }
             break;

  }
  barstate=0;
  if(err) break;
 }

 if(mstate && !err)
 {
  for(i=0;i<m;i++) 
  {
   if((err=exfn(buff[i]))!=NULL) break;
  }
 }

 return(err);
}



os_error * expandmacro(expandfn exfn,char * string)
{
 return(expandmacro2(exfn,string,0,0));
}





os_error * expandamacro(expandfn exfn,int n,int macenv,int macview)
{
 os_error * err;
 char       string[MACLEN];

/* if(macros[n].flags & MACINUSE) return(0); */ /* macro in use */

 macros[n].flags|=MACINUSE;
 xzstrncpy(string,macros[n].defn+mstrings,MACLEN);
 err=expandmacro2(exfn,string,macenv,macview);
 macros[n].flags&=~MACINUSE;

 return(err);
}




os_error * macrohelp(char ** p,int n)
{
 char * q;
 q=macros[n].defn+mstrings;
 q+=strlen(q)+1;

//	cprintf("mac help %s",q);

 *p=q;
 return(NULL);
}



os_error * macrotip(char ** p,int n)
{
 char * q;
 q=macros[n].defn+mstrings;
 q+=strlen(q)+1;
 q+=strlen(q)+1;
 q+=strlen(q)+1;

//	cprintf("mac tip %s",q);

 *p=q;
 return(NULL);
}




int isdefmacro(int fp)
{
 int mn;

 mn=findmacro(stringptr(stack[fp]),0);
 if(mn>-1)
 {
  return(macroextbits(mn));
 }
 else
 {
  return(-1);
 }
}



// macrorename(string & old,string & new)

void macrorename(int fp)
{
 os_error * err;
 int        mn;
 int        value;
 
 err=NULL;

 mn=findmacro(stringptr(stack[fp]),0);
 if(mn>-1)
 {
  value=findmacro(stringptr(stack[fp+1]),0);
  if(value>-1) err=geterror(MAC8);
  if(!err)
  {
   value=keytype(stringptr(stack[fp+1]));
   if(value>=0)
   {
    if((macros[mn].type & TYPEMASK)!=TYPEKEY) err=geterrorf(MAC9,stringptr(stack[fp+1]));
    if(!err)
    {
     macros[mn].data.value=value;
    }
   }
   else
   {
    if((macros[mn].type & TYPEMASK)==TYPEKEY) err=geterror(MACA);
   }

   if(!err)
   {
    xzstrncpy(macros[mn].name,stringptr(stack[fp+1]),MNLEN);
   }
  }
 }

 zreport(err);
}




//int macrostring(string & name,string & macrostring,int n)

int macrostring(int fp)
{
 int n;
 int mn;
 int dlen;


 mn=findmacro(stringptr(stack[fp]),0);
 if(mn>-1)
 {
  n=stack[fp+2];

  if(n==0)
  {
   if((macros[mn].type & TYPEMASK)==TYPEBUTTON)
   {
    assignstring(stack[fp+1],macros[mn].data.data);
   }
  }

  if(n==1)
  {
   assignstring(stack[fp+1],macros[mn].defn+mstrings);
  }

  if(n==2)
  {
   dlen=strlen(macros[mn].defn+mstrings)+1;
   assignstring(stack[fp+1],macros[mn].defn+mstrings+dlen);
  }

  if(n==3)
  {
   dlen=strlen(macros[mn].defn+mstrings)+1;
   dlen+=strlen(macros[mn].defn+mstrings+dlen)+1;
   assignstring(stack[fp+1],macros[mn].defn+mstrings+dlen);
  }

  return(macros[mn].type);
 }

 return(-1);
}





#define FCHUNK2 0x200

static unsigned short ** xfield2;
static int               xfieldn2;



static os_error * fexfn2(int c)
{
 os_error * err;
 int        ch;


 err=schunk((flex_ptr)xfield2,(xfieldn2+1)*sizeof(unsigned short),FCHUNK2);
 if(!err) 
 {
  ch=-1;

  switch(c)
  {
         case XTABCH:
                     ch='\t';
                     break;
          
       case XNEWPARA:
            case  '\r':
//         case RETURN:            /* i.e. \r */
                     ch='\n';
                     break;

           case '\n':
       case XNEWLINE:
//    case SHFT_RETURN:
                     ch='\r';
                     break;

    case CTRL_RETURN:
        case XEOPAGE:
                     ch=EOPAGE;
                     break;

  /*  case SHFT_ENTER: */ // this could be taken out using the extended flag
    case     XEOBOX:
                    ch=EOBOX;
                    break;

    case     XDCHYPH:
    case  CTRL_MINUS:
                     ch=DCHYPH;
                     break;

     case     NBHYPH:
     case    XNBHYPH:
                     ch=NBHYPH;
                     break;

     case    NBSPACE:
     case   XNBSPACE:
                     ch=NBSPACE;
                     break;
     

             default:
                     if(c>255)
                     {
                      ch=code16inv(c);
																						if(ch<0) ch=c;
                     }
                     else
                     {
 	                    ch=code8symbolinv(c);
                     }
                     break;
  }

  if(ch>=0)
  {
   (*xfield2)[xfieldn2++]=(unsigned short)ch;
  }

//  cprintf("ch %d",ch);
 }

 return(err);
}



os_error * expandmacrostringfinit2(unsigned short ** result)
{

 return(sfree((flex_ptr)result));
}



os_error * expandmacrostring2(char * source,unsigned short ** result,int flags)
{
 os_error * err;

 err=NULL;

 xfieldn2=0;
 xfield2=result;

          err=salloc((flex_ptr)xfield2,FCHUNK2);
 if(!err) err=expandmacro(fexfn2,source);

 if(!err)
 {
  (*xfield2)[xfieldn2++]=0;
 }
 else
 {
  sfree((flex_ptr)xfield2);
 }


 return(err);

 USE(flags);
}









#define FCHUNK 0x100

static char ** xfield;
static int     xfieldn;



static os_error * fexfn(int c)
{
 os_error * err;
 int        ch;


 err=schunk((flex_ptr)xfield,xfieldn+1,FCHUNK);
 if(!err) 
 {
  ch=-1;

  switch(c)
  {
         case XTABCH:
                     ch='\t';
                     break;
          
       case XNEWPARA:
            case  '\r':
//         case RETURN:            /* i.e. \r */
                     ch='\n';
                     break;

           case '\n':
       case XNEWLINE:
//    case SHFT_RETURN:
                     ch='\r';
                     break;

    case CTRL_RETURN:
        case XEOPAGE:
                     ch=EOPAGE;
                     break;

  /*  case SHFT_ENTER: */ // this could be taken out using the extended flag
    case     XEOBOX:
                    ch=EOBOX;
                    break;

    case     XDCHYPH:
    case  CTRL_MINUS:
                     ch=DCHYPH;
                     break;

     case     NBHYPH:
     case    XNBHYPH:
                     ch=NBHYPH;
                     break;

     case    NBSPACE:
     case   XNBSPACE:
                     ch=NBSPACE;
                     break;
     

             default:
                     if(c>255)
                     {
                      ch=code16inv(c);
                     }
                     else
                     {
 	                    ch=code8symbolinv(c);

                      if(ch<0)
                      {
                       c=code16win(c);
                      }
                     }
                     break;
  }

  if(ch>=0)
  {
   (*xfield)[xfieldn++]=(char)ch;
  }

//  cprintf("ch %d",ch);
 }

 return(err);
}



os_error * expandmacrostringfinit(char ** result)
{

 return(sfree((flex_ptr)result));
}



os_error * expandmacrostring(char * source,char ** result,int flags)
{
 os_error * err;

 err=NULL;

 xfieldn=0;
 xfield=result;

          err=salloc((flex_ptr)xfield,FCHUNK);
 if(!err) err=expandmacro(fexfn,source);

 if(!err)
 {
  (*xfield)[xfieldn++]=0;
 }
 else
 {
  sfree((flex_ptr)xfield);
 }


 return(err);

 USE(flags);
}



os_error * macrotostring(char * in,char * out,int maxlen)
{
	os_error * err;
 char     * result;

 err=expandmacrostring(in,&result,0);
	if(!err)
	{
  err=xzstrncpye(out,result,maxlen);
  expandmacrostringfinit(&result);
	}

 return(err);
}



os_error * macrotostring2(char * in,unsigned short * out,int maxlen)
{
	os_error * err;
 unsigned short * result;

 err=expandmacrostring2(in,&result,0);
	if(!err)
	{
  err=xzstrncpye22(out,result,maxlen);
  expandmacrostringfinit2(&result);
	}

 return(err);
}



os_error * expandcode(int c,char ** outp,char * lt)
{
	os_error * err;
	int        c8;
	int        c16;
	char     * p;
	char     * out;
	int        len;


	out=*outp;

 c8=code8(c);				// c8 Windows Western
 if(c8<0)
 {
		c16=code16(c);	// c16 Unicode

         p=macrofindtokenname(c16);
		if(!p) p=macrofindglyphname(c16);

//		cprintf("xpandcode %x %s",c16,p);

		if(!*p)
		{
   err=xsprintf(lt-out,&len,out,"<%d>",c16);
			if(!err)
			{
 			out+=len;
			}
		}
		else
		{
 		len=strlen(p);
   if(out<(lt-len-2))
   {
    *out++='{';
    strcpy(out,p);
    out+=len;
    *out++='}';
   }
		}
 }
 else
 {
		if(out<lt)
		{
   *out++=(char)c8;
		}
	}

	*outp=out;

	return(NULL);
}


// input string in our format
// output string in Windows + macro expansion format
// similar code in vgetword()

os_error * stringtomacro(char * in,char * out,int maxlen)
{
 int    c;
	char * lt;


	lt=out+maxlen-1;

 while(1)
 {
  c=*in++;

  if(c>0)
  {
			expandcode(c,&out,lt);
  }
  else
  {
   break;
  }
 }

 *out=0;

 return(NULL);
}


// input string in our format
// output string in Windows + macro expansion format
// similar code in vgetword()


os_error * stringtomacro2(unsigned short * in,char * out,int maxlen)
{
 int    c;
	char * lt;


	lt=out+maxlen-1;

 while(1)
 {
  c=*in++;

  if(c>0)
  {
			expandcode(c,&out,lt);
  }
  else
  {
   break;
  }
 }

 *out=0;

 return(NULL);
}








int evalmacro(int fp)
{
 os_error * err;
 char       string[256];
 int        s;
 char     * result;

 xzstrncpy(string,stringptr(stack[fp]),sizeof(string));

 err=expandmacrostring(string,&result,0);

 zreport(err);

 s=createstring(result);

 /* don't get here if errors */

 expandmacrostringfinit(&result);

 return(s);
}




os_error * macrosboot(void)
{
 os_error * err;

 macrostot=0;

          err=flex_alloc((flex_ptr)&macros,0);
 if(!err) err=flex_alloc((flex_ptr)&mstrings,0);

 if(!err) err=dbmacrosinit();

 if(!err) macrogetglyphs();

 return(err);
}





