/*->c.dbpict */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"
#include "xmath.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "fsx.h"
#include "bf.h"


#include "dbhi.h"
#include "mhi.h"



#include "str.h"
#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "geometry.h"
#include "posn.h"
#include "object.h"
#include "select.h"
#include "pref.h"


#include "dbscale.h"
#include "dbcolour.h"
#include "view.h"
#include "viewr.h"


#include "pxstr.h"
#include "pict.h"
#include "dbpict.h"




/*****************************************************************************/

extern dboxstr pictbox;

static boxbitstr           ob;
static boxbitstr           nb;
static unpackedpictdatastr pd;

static filestr     * cfile;
static viewstr     * cview;
static int           cobject;

static pictchangebits cbits;


#define PICCOLICON 20




static os_error * colredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,PICCOLICON,
                       vfindcolour2(NULL,cfile,&pd.pictdata.colour));
  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}


static os_error * pictredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) colredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void pickclose(colourvalue * colour)
{
 pd.pictdata.colour=*colour;
 wimp_set_icon_state(pictbox.handle,PICCOLICON,(wimp_iconflags)0,(wimp_iconflags)0);
}


static os_error * picticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case 24:            /* fill */
          break;

  case 21:            /* colour */
          err=pickcolour(cfile,&pd.pictdata.colour,pickclose,&pictbox);
          break;
 }

 return(NULL);

 handle=handle;
 userhandle=userhandle;

 return(err);
}

#define MINWIDTH         500
#define MAXWIDTH      2590000
#define MINHEIGHT        500
#define MAXHEIGHT     2590000


static os_error * validpict(boxbitstr * nb,pictdatastr * pd)
{
 int error;

 error=ENONE;

 if(nb->width<MINWIDTH)   error=BOX01; /* width too small */
 else
 if(nb->width>MAXWIDTH)   error=BOX02; /* width too large */
 else
 if(nb->height<MINHEIGHT) error=BOX03; /* height too small */
 else
 if(nb->height>MAXHEIGHT) error=BOX04; /* height too large */
 else
 if(2*pd->i>nb->width)    error=BOX05;  /* Inset too big */
 else
 if(pd->i<0)              error=BOX06;  /* Inset too small */

 return(geterror(error));
}



static os_error * pictup(int pict,filestr * file)
{
 os_error            * err;
 pictboxstr          * pictp;

 err=pictboxupdate(pict,file,&pd,&cbits);

 if(cbits.xtransform) 
 {
  pictp=(pictboxstr*)fob_find(pict,file);
  err=transpict(pictp,file,boxtrans,0);
 }

 return(err);
}



static os_error * pictclose(int code)
{
 os_error      * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY) 
 {
  err=validpict(&nb,&pd.pictdata);
  if(!err)
  {
   pictchanges(cobject,cfile,&pd,&cbits);
   if((cbits.xtransform=(cmpboxbits(&ob,&nb)!=0))!=0)
   {
    setboxtrans(&ob,&nb);
    ob=nb;
   }
   modifyselection(pictup);
  }
 }
 return(err);
}


static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}


static os_error * outi(int value,char * string)
{
 if(pd.pictdata.changei) *string=0;
 else                    strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * ini(int * value,char * string)
{
 if(*string)
 {
  pd.pictdata.changei=0;
  return(stringtounits(string,value,cview->data.units));
 }
 else
 {
  return(NULL);
 }
}



static os_error * outux(int value,char * string)
{
 strcpy(string,unitstostring(value-prefp(cfile)->rulerx,cview->data.units));
 return(NULL);
}

static os_error * inux(int * value,char * string)
{
 os_error * err;
 int        n;
 err=stringtounits(string,&n,cview->data.units);
 *value=n+prefp(cfile)->rulerx;
 return(err);
}



static os_error * outuy(int value,char * string)
{
 strcpy(string,unitstostring(value-prefp(cfile)->rulery,cview->data.units));
 return(NULL);
}

static os_error * inuy(int * value,char * string)
{
 os_error * err;
 int        n;
 err=stringtounits(string,&n,cview->data.units);
 *value=n+prefp(cfile)->rulery;
 return(err);
}







static dbiconstr picticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */
   22,  &nb.orgx,    DBWRITE,  0,   0,      -1, -1, 3, -1,    inux, outux,
    3,  &nb.orgy,    DBWRITE,  0,   0,      -1, -1, 5,  1,    inuy, outuy,
    5,  &nb.width,   DBWRITE,  0,   0,      -1, -1, 7,  3,    inu,  outu,
    7,  &nb.height,  DBWRITE,  0,   0,      -1, -1, 9,  5,    inu,  outu,

    9,  &nb.angle,   DBWRITE,  0,   DBASSOCINC,      -1, -1,24,  7,readangle,writeangle,
   16,  &nb.skew,    DBWRITE,  0,   DBASSOCINC,      -1, -1,24,  7,readskew,writeskew,

   18,  &pd.pictdata.radius,DBWRITE,0,0,    -1, -1,18,  9,    inu,  outu,
   26,  &pd.pictdata.i,     DBWRITE,0,0,    -1, -1,-1, 23,    ini,  outi,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,
   31, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,      0,0,NULL, 0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   11, &nb.angle,    DBDEC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                                        MINANGLE,NULL,0,

   12, &nb.angle,    DBINC   ,0,    0,       -0x10000,-1,MAXANGLE,
                                                        MINANGLE,NULL,0,

   28, &nb.skew,     DBDEC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                                        MINSKEW,NULL,0,

   29, &nb.skew,     DBINC   ,0,    0,       -0x10000,-1,MAXSKEW,
                                                        MINSKEW,NULL,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   13, &pd.lock,     DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,
   14, &pd.spread,   DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr pictbox=
{
 0,
 TPXFRAME,
 DBFIX,
 0,
 pictclose,
 picticon,
 NULL,
 pictredraw,
 picticondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * openpictbox(pictboxstr * pictp,filestr * file,viewstr * view)
{
 os_error        * err;

 cfile=file;
 cview=view;
 cobject=pictp->key;

 pd.pictdata=pictp->data;
 pd.lock=pictp->flags.locked;
 pd.spread=pictp->flags.spread;

 getboxbits(&pictp->fcurve.box,&pictp->transform,&ob);
 nb=ob;

 err=dodboxspparent(&pictbox,1,&pictbox,&dbviewstack,cview->handle);
 return(err);
}

