/*->c.pxds */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"
#include "bits.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "dbhi.h"



#include "constants.h"
#include "str.h"

#include "geometry.h"
#include "reslink.h"

#include "view.h"
#include "file.h"
#include "chain.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"
#include "object.h"
#include "infopal.h"

#include "select.h"
#include "splib.h"
#include "editpath.h"
#include "objectdb.h"
#include "undo.h"
#include "units.h"
#include "frameflow.h"
#include "dscript.h"


#include "xcolour.h"
#include "xxcolour.h"
#include "colsep.h"

#include "border.h"
#include "fillstub.h"


#include "txstr.h"
#include "text.h"


#include "pxstr.h"

#include "pict.h"
#include "impex.h"
#include "dbpicture.h"
#include "pxchoices.h"
#include "pixtool.h"
#include "croptool.h"
#include "xtracex.h"
#include "dbpict.h"
#include "pxconstant.h"
#include "pxref.h"


#include "pxds.h"




#define DSTPICT          0x1000
#define DSTPICTURE       0x1001
#define DSTPICTUREDATA   0x1002
#define DSTPLOCKMODE     0x1003
#define DSTPASPECTLOCK   0x1004
#define DSTPAUTOSCALE    0x1005
#define DSTPHIDE         0x1006
#define DSTPREFERENCE    0x1007
#define DSTPPROXY        0x1008
#define DSTPTILE         0x1009
#define DSTPBOTLEFT      0x100A
#define DSTPVISIBLE      0x100B
#define DSTPSCALETOFIT   0x100C



static os_error * pdsub(unpackedpicturedatastr * pd,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           splimit;


 ds=(dsobjectstr*)(dsstack+sp);
 splimit=sp+ds->len/sizeof(int);

 sp+=2;

 while(sp<splimit)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case   DSTPLOCKMODE:
                       pd->pd.lockmode=ds1->data.integer;
                       break;

   case DSTPASPECTLOCK:
                       pd->pd.fixaspect=ds1->data.integer;
                       break;

   case  DSTPAUTOSCALE:
                       pd->pd.autoscale=ds1->data.integer;
                       break;

   case       DSTPHIDE:
                       pd->pd.hbits&=~HBHIDE;
                       if(ds1->data.integer) pd->pd.hbits|=HBHIDE;
                       break;

   case       DSTPVISIBLE:
                       pd->pd.hbits&=~HBVISIBLE;
                       if(ds1->data.integer) pd->pd.hbits|=HBVISIBLE;
                       break;



   case    DSTPBOTLEFT:
                       pd->pd.hbits&=~HBBOTLEFT;
                       if(ds1->data.integer) pd->pd.hbits|=HBBOTLEFT;
                       break;


   case           DSTX:
                       pd->pd.xshift=ds1->data.integer;
                       break;

   case           DSTY:
                       pd->pd.yshift=ds1->data.integer;
                       break;

   case       DSTSCALE:
                       pd->pd.scale=ds1->data.integer;
                       break;

   case      DSTASPECT:
                       pd->pd.aspect=ds1->data.integer;
                       break;

   case       DSTANGLE:
                       pd->pd.angle=-ds1->data.integer;
                       break;

   case        DSTSKEW:
                       pd->pd.skew=-ds1->data.integer;
                       break;

   case       DSTPTILE:
                       pd->tile=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       pd->tiledx=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+6);
                       pd->tiledy=ds1->data.integer;
                       break;
  }
  sp=nsp;
 }

 return(NULL);
}





static os_error * dspict(int fp,int argc,objectloc * loc)
{
 os_error               * err;
 pictdatastr              data;
 unpackedpicturedatastr   pictdata;
 int                      sp;
 int                      nsp;
 dsobjectstr            * ds;
 dsobjectstr            * ds1;
 curvestr                 c;
 curvestr                 t;
 curvestr                 ic;
 curvestr                 oc;
 curvestr                 pc;
 textflowstr              flow;
 transformstr             tr;
 int                      angle;
 int                      skew;
 int                      master;
 int                      local;
 int                      frame;
 pictboxstr             * pictp;
 textboxstr             * textp;
 int                      changei;
 int                      changeo;
 int                      pixcurve;
 int                      processkey;
 int                      lock;
 int                      spread;


 sp=fp+2; /* skip leading type/len */

 data=defltpictdata;
 pictdata=defltpicturedata;
 flow=defltpicttextflow;
 tr_setidentity(&tr);
 angle=skew=master=local=frame=0;
 changei=changeo=pixcurve=processkey=spread=lock=0;

 nullcurve(&c);
 nullcurve(&ic);
 nullcurve(&oc);
 nullcurve(&pc);

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);


  switch(ds->type)
  {
   case     DSTLOCAL:
                     local=ds1->data.integer;
                     break;

   case    DSTMASTER:
                     master=ds1->data.integer;
                     pictp=(pictboxstr*)fob_find(master,loc->file);

                     if(pictp->type==OPICTBOX)
                     {
                      data=pictp->data;
                      frame=pictp->frame;

                      unpackpicturedata(&pictdata,pictp);

                      tr=pictp->transform;
                      t=pictp->fcurve;
                      deletecurve(&c,loc->file);
                      copycurve(&c,loc->file,&t,loc->file);
                      lock=pictp->flags.locked;
                      spread=pictp->flags.spread;
                     }
                     else
                     {
                      textp=(textboxstr*)pictp;
                      data.colour=textp->data.colour;
                      data.fill=textp->data.fill;
                      data.radius=textp->data.radius;
                      frame=textp->frame;
                      tr=textp->transform;
                      c=textp->fcurve;
                      lock=textp->flags.locked;
                      spread=textp->flags.spread;
                     }

                     copyborder(&frame,frame,loc->file);
                     copyfill(&data.fill,&data.fill,loc->file);
                     break;


   case DSTFILLCOLOUR:
                      data.colour.data.tint.key=ds1->data.integer;
                      ds1=(dsobjectstr*)(dsstack+sp+2+3);
                      data.colour.data.tint.tint=ds1->data.integer;
                      if(nsp>(sp+2+6))
                      {
                       ds1=(dsobjectstr*)(dsstack+sp+2+6);
                       data.colour.data.tint.overprint=ds1->data.integer;
                      }
                      break;

   case     DSTRADIUS:
                      data.radius=ds1->data.integer;
                      break;

   case     DSTFCURVE:
                      deletecurve(&c,loc->file);
                      c=ds->data.curve;
                      break;

   case     DSTICURVE:
                      ic=ds->data.curve;
                      changei=1;
                      break;

   case     DSTOCURVE:
                      oc=ds->data.curve;
                      changeo=1;
                      break;

   case     DSTPCURVE:
                      pc=ds->data.curve;
                      pixcurve=1;
                      break;

   case      DSTINSET:
                      data.i=ds1->data.integer;
                      break;

   case   DSTTEXTFLOW:
                      flow.fmode=ds1->data.integer;
                      ds1=(dsobjectstr*)(dsstack+sp+2+3);
                      flow.omode=ds1->data.integer;
                      ds1=(dsobjectstr*)(dsstack+sp+2+6);
                      flow.o=ds1->data.integer;
                      break;

    case     DSTANGLE:
                      angle=-ds1->data.integer;
                      break;

    case      DSTSKEW:
                      skew=-ds1->data.integer;
                      break;

  case DSTPICTUREDATA:
                      pdsub(&pictdata,sp);
                      break;

  case DSTFRAMEBORDER:
                      frame=ds->data.integer;
                      break;


   case       DSTFILL:
                      data.fill.fill=ds->data.integer;
                      break;

   case    DSTPROCESS:
                      processkey=ds->data.integer;
                      break;
  }
  sp=nsp;
 }


 getboxtransform(&tr,&c,skew,angle);

 err=createpict1(loc,&c,&data,&pictdata,&flow,&tr,frame,
                 changei?&ic:NULL,changeo?&oc:NULL,pixcurve?&pc:NULL);
 if(!err)
 {
  pictp=(pictboxstr*)fob_find(loc->object,loc->file);
  pictp->flags.local=local;
  pictp->master=master;
  pictp->process.process=processkey;
  pictp->flags.locked=lock;
  pictp->flags.spread=spread;

  loc->after=loc->object;
  loc->parent=0;

  ds=(dsobjectstr*)(dsstack+fp);
  ds->data.integer=loc->object;
  ds->len=3*sizeof(int);
 }

 deletecurve(&c,loc->file);
 deletecurve(&ic,loc->file);
 deletecurve(&oc,loc->file);
 deletecurve(&pc,loc->file);

 return(err);
}



static os_error * dspicture(int fp,int argc,objectloc * loc)
{
 os_error          * err;
 int                 sp;
 int                 nsp;
 dsobjectstr       * ds;
 dsobjectstr       * ds1;
 pictboxstr        * pictp;
 picturestr        * picturep;
 int                 picture;
 int                 ftype;
 filestr           * file;
 char                name[FILENAMELEN];
 char                expandedname[FILENAMELEN];
 fstat               fs;
 pxproxystr          proxy;
 int                 seenproxy;
 int                 scaletofit;

 err=NULL;

 seenproxy=0;
 picture=0;
	scaletofit=0;
 file=loc->file;

 sp=fp+2; /* skip leading type/len */

 if(argc==DSCOPY)
 {
  ds=(dsobjectstr*)(dsstack+fp);
  picture=ds->data.integer;
  if(picture)
  {
   fob_copy((fobjptr)&picturep,file,picture,file);
   picture=picturep->key;
  }
 }
 else
 {
  while(argc--)
  {
   ds=(dsobjectstr*)(dsstack+sp);
   nsp=sp+ds->len/sizeof(int);
   ds1=(dsobjectstr*)(dsstack+sp+2);


   switch(ds->type)
   {

   case DSTPSCALETOFIT:
                       scaletofit=ds1->data.integer;
                       break;

    case       DSTDATA:
                       picture=ds->data.integer;
                       break;

    case DSTPREFERENCE:
                                err=xzstrncpyu(name,ds1->data.string,NITEM(name));
    																			if(!err) err=pxexpandpath(expandedname,NITEM(expandedname),name,file);
	    																		if(!err)	err=fs_stat(expandedname,&fs);
                       /* error missing file? */
																							if(!err)
																							{
																								if(fs.object!=1) err=geterrorf(EREFPX,expandedname);
																							}
                       if(!err) err=importreferenceload(name,fs.type,&picture,file);

                       break;

    case     DSTPPROXY:
                       memset(&proxy,0,sizeof(pxproxystr));
                       proxy.dither=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       proxy.scale=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+6);
                       proxy.bpp=ds1->data.integer;
                       seenproxy=1;
                       break;
   }
   sp=nsp;
  }
 }

 if(picture)
 {
  picturep=(picturestr*)fob_find(picture,file);
  ftype=picturep->ftype;
  pictp=(pictboxstr*)fob_find(loc->object,file);
  pictp->picture=picture;
  pictp->ftype=ftype;

  if(pictp->master && !pictp->flags.masterdata)
  {
   pictp=(pictboxstr*)fob_find(pictp->master,file);
   if(pictp->type==OPICTBOX && pictp->picture)
   {
    pictp=(pictboxstr*)fob_find(loc->object,file);
    pictp->flags.masterdata=1;
   }
  }


  if(scaletofit)
  {
   pictscaletofit(loc->object,NULL,file);
  }

  pictcalctransform(loc->object,file);

  if(seenproxy)
  {
   importmakeproxy(ftype,picture,file,&proxy);
  }
 }

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=picture;
 ds->len=3*sizeof(int);

 return(err);
}






static os_error * picturesave(int picture,int ftype,filestr * file,buffer * bf)
{
 os_error           * err;
 int                  count;
 picturestr         * picturep;
 pxpreftagstaticstr   pxreftag;
 pxproxytagstr        pxproxytag;
 char                 temp[FILENAMELEN];

 err=NULL;

 if(picture)
 {
  err=dsmapadd(picture,&count);

  if(!err)
  {
   if(count)
   {
    err=bf_printfeoln(bf,2,"PICTURE_%02x_%02x=PICTURE_%02x",
                                                picture,count,picture);
   }
   else
   {
    err=bf_printfeol(bf,"PICTURE_%02x={picture",picture);
    if(!err)
    {
     pxreadtag((pxtagstr*)&pxreftag,PXPREF1TAG,picture,file);
     pxreadtag((pxtagstr*)&pxproxytag,PXPROXYTAG,picture,file);

     picturep=(picturestr*)fob_find(picture,file);
     if(picturep->imagelen)
     {
      err=dsexport(ftype,picture,file,bf);
     }
     else
     if(pxreftag.len)
     {
      unquotec(pxreftag.name,temp);
      bf_printfeol(bf,"{reference \"%s\"}",temp);
     }

     if(pxproxytag.len)
     {
      bf_printfeol(bf,"{proxy %d %d %d}",pxproxytag.proxy.dither,
                                        pxproxytag.proxy.scale,
                                        pxproxytag.proxy.bpp);
     }

     if(!err) err=bf_printfeoln(bf,2,"}");
    }
   }
  }
 }
 return(err);
}




static os_error * pxdssave(pictboxstr * pictp,filestr * file,buffer * bf)
{
 os_error   * err;
 int          pict;
 sobjectstr * sobj;
 transformstr tr;
 int          masteristext;


 masteristext=0;

 pict=pictp->key;


 err=bf_printfeol(bf,"PICT_%02x={pictframe",pict);

 if(pictp->master)
 {
  sobj=(sobjectstr*)fob_find(pictp->master,file);
  masteristext=(sobj->type!=OPICTBOX);

  bf_printfeol(bf,"{master %s_%02x}{local %d}",masteristext?"TEXT":"PICT",
                                            pictp->master,pictp->flags.local);
 }


 if(!pictp->master || pictp->flags.local)
 {
  bf_printfeol(bf,"{lock %d} {spread %d}",pictp->flags.locked,
                                         pictp->flags.spread);

  bf_printfeol(bf,"{fillcolour %s}",dscvstring2(&pictp->data.colour,file));

  bf_printfeol(bf,"{radius %d}",pictp->data.radius);

  dswritefill(&pictp->data.fill,bf,file);

  if(pictp->data.changei)
  {
   dscurve(&pictp->icurve,&pictp->transform,"icurve",bf,file);
  }
  else
  {
   bf_printfeol(bf,"{inset %d}",pictp->data.i);
  }

  dstextflow(&pictp->textflow,bf,file);

  if(pictp->textflow.changeo)
  {
   dscurve(&pictp->ocurve,&pictp->transform,"ocurve",bf,file);
  }

  if(pictp->textflow.omode==FROUSER && pictp->pcurve.type!=CNULL)
  {
   tr_setidentity(&tr);
   dscurve(&pictp->pcurve,&tr,"pcurve",bf,file);
  }

  dscurve(&pictp->fcurve,&pictp->transform,"fcurve",bf,file);
  dstransform(&pictp->fcurve.box,&pictp->transform,bf);

  dswriteframeborder(pictp->frame,bf,file);
 }


 if(!pictp->master || pictp->flags.local || masteristext)
 {
  bf_printfeol(bf,"{picturedata");

  bf_printfeol(bf,"{lockmode %d}",pictp->pictdata.lockmode);
  bf_printfeol(bf,"{aspectlock %d}",pictp->pictdata.fixaspect);
  bf_printfeol(bf,"{autoscale %d}",pictp->pictdata.autoscale);
  bf_printfeol(bf,"{hide %d}",(pictp->pictdata.hbits & HBHIDE)!=0);
  bf_printfeol(bf,"{visible %d}",(pictp->pictdata.hbits & HBVISIBLE)!=0);
  bf_printfeol(bf,"{bottomleft %d}",(pictp->pictdata.hbits & HBBOTLEFT)!=0);
  bf_printfeol(bf,"{x %d}",pictp->pictdata.xshift);
  bf_printfeol(bf,"{y %d}",pictp->pictdata.yshift);
  bf_printfeol(bf,"{scale 0x%x}",pictp->pictdata.scale);
  bf_printfeol(bf,"{aspect 0x%x}",pictp->pictdata.aspect);
  bf_printfeol(bf,"{angle 0x%x}",-pictp->pictdata.angle);
  bf_printf(bf,"{skew 0x%x}",-pictp->pictdata.skew);
  if(pictp->flags.version>0)
  {
   bf_printf(bf,"\r\n{tile %d %d %d}}\r\n",pictp->tile,
                                       pictp->tiledx,pictp->tiledy);
  }
  else
  {
   bf_printfeol(bf,"}");
  }
  dswriteprocess(pictp->process.process,bf,file);
 }


 err=bf_printfeoln(bf,2,"}");

 picturesave(pictp->picture,pictp->ftype,file,bf);

 return(err);
}




os_error * pxdsmessage(pictboxstr * pictp,int * message,
                                          filestr * file,buffer * bf)
{

 switch(*message)
 {
  case OM_DSSAVE:
                 return(pxdssave(pictp,file,bf));
                 break;

  case OM_DSNAME:
                 sprintf((char*)bf,"PICT_%02x",pictp->key);
                 break;
 }

 return(NULL);
}




static int dsnulllist[]={
                           DSTENDLIST
                          };



static dscreator dsdefs[]=
{
 0,0,0,0, "pictframe",  dspict,   0, DSTPICT,       dsnulllist,
 0,0,0,0, "picture",    dspicture,DSCREATECOPY,DSTPICTURE,dsnulllist,
 0,0,0,0, "picturedata",NULL,     0, DSTPICTUREDATA,dsnulllist,
 0,0,0,0, "lockmode",   NULL,     0, DSTPLOCKMODE,  dsnulllist,
 0,0,0,0, "aspectlock", NULL,     0, DSTPASPECTLOCK,dsnulllist,
 0,0,0,0, "autoscale",  NULL,     0, DSTPAUTOSCALE, dsnulllist,
 0,0,0,0, "hide",       NULL,     0, DSTPHIDE,      dsnulllist,
 0,0,0,0, "reference",  NULL,     0, DSTPREFERENCE, dsnulllist,
 0,0,0,0, "proxy",      NULL,     0, DSTPPROXY,     dsnulllist,
 0,0,0,0, "tile",       NULL,     0, DSTPTILE,      dsnulllist,
 0,0,0,0, "bottomleft", NULL,     0, DSTPBOTLEFT,   dsnulllist,
 0,0,0,0, "visible",    NULL,     0, DSTPVISIBLE,   dsnulllist,
 0,0,0,0, "scaletofit", NULL,     0, DSTPSCALETOFIT,dsnulllist,
};


os_error * pxdsinit(void)
{
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 return(NULL);
}


