/*->c.dbspchk */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "bf.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "dbhi.h"
#include "deb.h"


#include "constants.h"

#include "obj.h"

#include "mhi.h"

#include "str.h"
#include "reslink.h"

#include "view.h"
#include "file.h"
#include "undo.h"
#include "macros.h"

#include "dbscale.h"


#include "txstr.h"
#include "vec.h"
#include "act.h"
#include "find.h"

#include "dc.h"
#include "spell.h"
#include "spchk.h"

#include "dbspchk.h"



extern dboxstr dictionary[2];


static int         selectedn;
static int         oldselectedn;
static int         focusn;
static int         oldfocusn;


static int         dict;
static domainstr * d;
static int         guessmode=1;
static int         curdict;
static int         adddict;

static char        spstring[SPMAXLEN];

static int         checkcode;

#define SPTEXTICON 22


/***************************************************************************/
/* dictionary selector pane */

#define PANETOPMARGIN  8
#define PANESTEP       32
#define PANEHEIGHT     28

#define PANETEXTSHIFT  0
#define PANEBLOCKX     0
#define PANEBLOCKY     24
#define PANELEFTMARGIN 4
#define PANETEXT       SPMAXLEN*16
#define PANEBLOCKSHIFT 8


static os_error * setpaneextent(int handle)
{
 os_error * err;
 windowstr  window;
 int        height;
 int        width;

 err=getw(handle,&window);
 if(!err)
 {
  width=window.x1-window.x0;
  height=MAX(window.y1-window.y0,PANETOPMARGIN+nowords(dict,d)*PANESTEP);

  err=extent(handle,0,-height,width,0);
 }
 return(err);
}


static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error    * err;
 int           ox;
 int           oy;
 int           ylo;
 int           yhi;
 int           n;
 int           y;
 word          words;
 int           now;


 err=NULL;

	if(more)
	{
  wimpfontstart(0);

  now=nowords(dict,d);

  while(more)
  {
   if(now)
   {
    ox=redrawstr->box.x0-redrawstr->scx;
    oy=redrawstr->box.y1-redrawstr->scy;

    ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
    yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

    n=(ylo-PANETOPMARGIN)/PANESTEP;
    if(n<0) n=0;
    y=n*PANESTEP+PANETOPMARGIN;

    if(locword(n,dict,&words,d))
    {
     while(y<=yhi && n<now)
     {
      if(n==selectedn || n==oldselectedn || n==oldfocusn)
      {
       wimp_setcolour(n==selectedn?WIMPBLACK:WIMPWHITE);
       bbc_rectanglefilli(ox+PANELEFTMARGIN,oy-y,
                         PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT,-PANEHEIGHT);
      }

      if(n==focusn)
      {
       wimp_setcolour(WIMPWHITE);
       wimp_setcolour(0xF0+WIMPBLACK);
       bbc_setstyle(1);
       bbc_rectanglei(ox+PANELEFTMARGIN,oy-y,PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT,-PANEHEIGHT);
      }

      stringat(ox+PANELEFTMARGIN+PANEBLOCKX+PANEBLOCKSHIFT,oy-y-PANETEXTSHIFT,
        words.string,
        n==selectedn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
        PANEHEIGHT);  

      y+=PANESTEP;
      n++;
      nextword(dict,&words,d);
     }
    }
   }
   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}

 return(err);
 USE(handle);
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-cvdu.extrax;
 r.box.x1=r.box.x0+PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT+2*cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}




static void paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 wimp_open_wind(&wblock.o);
}


static void paneselectn(int handle,int n,int focustoo)
{
 oldfocusn=focusn;
 oldselectedn=selectedn;
 selectedn=focusn=-1;
 if(oldselectedn>=0) panerefreshline(handle,oldselectedn);
 else
 if(oldfocusn>=0) panerefreshline(handle,oldfocusn);
 selectedn=n;
 if((oldfocusn>=0 && selectedn>=0) || focustoo) focusn=selectedn;

 if(n>=0) panerefreshline(handle,n);
}


static os_error * checkrepcont(int handle)
{
 os_error * err;
 char     * p;

 err=iconaddr(handle,SPTEXTICON,&p);
 if(!err)
 {
           err=checkreplace(p);
  if(!err) err=checkcontinue();
 }
 return(err);
}



static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 windowstr  window;
 int        now;

 err=NULL;

 if(gain)
 {
  if(selectedn>=0) focusn=selectedn;
  else
  {
   err=getw(handle,&window);
   if(!err)
   {
    focusn=(-window.scy-PANETOPMARGIN+(window.y1-window.y0)/2)/PANESTEP;
    now=nowords(dict,d);
    if(focusn<0) focusn=0;
    if(focusn>=now) focusn=now-1;
   }
  }
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}




static os_error * panekey(int panehandle,int userhandle,int icon,int * key)
{
 os_error * err;
 int        n;
 int        now;
 int        mainhandle;
 int        next;
 int        ch;

 err=NULL;


 mainhandle=dictionary[0].handle;

 ch=*key;

 if(ch==CUP || ch==CDOWN)
 {
  now=nowords(dict,d);
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=now) n=now-1;

  if(n!=selectedn)
  {
   writeicon(mainhandle,SPTEXTICON,wordn(n,dict,d));
   paneselectn(panehandle,n,1);
   paneopenline(panehandle,n);
  }
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }

 return(err);

 USE(icon);
 USE(userhandle);
}






static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=getw(handle,&window);
 if(!err)
 {
  n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;

  if(n>=0 && n<nowords(dict,d))
  {
   if(m->bbits==wimp_BLEFT)
   {
    paneselectn(handle,n,1);
    writeicon(dictionary[0].handle,SPTEXTICON,wordn(selectedn,dict,d));
    setfocus(dictionary[1].handle);
   }
   else
   if(m->bbits==wimp_DOUBLELEFT)
   {
    err=checkrepcont(dictionary[0].handle);
   }
  }
 }
 return(err);
 userhandle=userhandle;
}

/****************************************************************************/

/* called from zero when words window is open */
/* if word icon has changed, reopen window at appropriate point */

static void spdemon(void)
{
 os_error * err;
 int        found;
 int        n;
 int        handle;
 int        flags=0;
 word       words;
 char       buff[64];
 char     * p;
 char     * result;


 handle=dictionary[1].handle;

 err=iconaddr(dictionary[0].handle,SPTEXTICON,&p);
 cprintf("spdemon %s",p);

 if(!err)
 {
  err=expandmacrostring(p,&result,0);
		if(!err)
		{
   spstripstring(buff,result,sizeof(buff));
   expandmacrostringfinit(&result);

   found=findwordabs(buff,dict,&words,&flags,d);
   n=words.wordn;

   if(found && n==selectedn) return;
   paneopenline(handle,n);
   paneselectn(handle,found?n:-1,0);
		}
 }
}



static os_error * spupdate(int handle,int icon,int userhandle)
{
 spdemon();
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}



/***************************************************************************/

/* int getuserdict(int i,string & s); */

int getuserdict(int fp)
{
 int        spellk;
 spellstr * spellp;
 int        n;
 int        i;

 if(menufile)
 {
  spellk=menufile->hdr.spell;
  spellp=(spellstr*)fob_find(spellk,menufile);

  n=stack[fp];

  for(i=0;i<spellp->nodc;i++)
  {
   if(!spellp->spdict[i].ignore) n--;

   if(n<0)
   {
    assignstring(stack[fp+1],spellp->spdict[i].name);
    return(1);
   }
  }
 }

 return(0);

 USE(fp);
}



static int user2index(int user)
{
 int        spellk;
 spellstr * spellp;
 int        n;
 int        i;

 spellk=checkfile->hdr.spell;
 spellp=(spellstr*)fob_find(spellk,menufile);

 n=-1;

 for(i=0;i<spellp->nodc;i++)
 {
  if(!spellp->spdict[i].ignore) n++;
  if(n==user) break;
 }

 return(i);
}


static int index2user(int index)
{
 int        spellk;
 spellstr * spellp;
 int        n;
 int        i;

 spellk=checkfile->hdr.spell;
 spellp=(spellstr*)fob_find(spellk,menufile);

 n=-1;

 for(i=0;i<spellp->nodc;i++)
 {
  if(!spellp->spdict[i].ignore) n++;
  if(i==index) break;
 }

 return(n);
}


static void getdcs(void)
{
 int        spellk;
 spellstr * spellp;
 int        i;

 spellk=checkfile->hdr.spell;
 spellp=(spellstr*)fob_find(spellk,checkfile);

 adddict=curdict=-1;

 for(i=0;i<spellp->nodc;i++)
 {
  if(spellp->spdict[i].addto)  adddict=i;
  if(spellp->spdict[i].browse) curdict=i;
 }

 if(adddict<0 || curdict<0)
 {
  for(i=0;i<spellp->nodc;i++)
  {
   if(curdict<0 && !cstrcmp(spellp->spdict[i].name,maindictionary)) curdict=i;
   if(adddict<0 && !cstrcmp(spellp->spdict[i].name,userdictionary)) adddict=i;
  }

  if(curdict<0)
  {
   if(spellp->spdict[0].ignore) curdict=1;
   else                         curdict=0;
   if(adddict<0) adddict=curdict;
  }
  else
  if(adddict<0)
  {
   i=0;

   while(i<spellp->nodc)
   {
    if(!spellp->spdict[i].ignore && i!=curdict) 
    {
     adddict=i;
     break;
    }
    i++;
   }

   if(i>=spellp->nodc) adddict=curdict;
  }
 }
}


static void setdcs(void)
{
 int        spellk;
 spellstr * spellp;
 int        i;

 spellk=checkfile->hdr.spell;
 spellp=(spellstr*)fob_find(spellk,checkfile);

 for(i=0;i<spellp->nodc;i++)
 {
  spellp->spdict[i].addto=spellp->spdict[i].browse=0;
 }

 spellp->spdict[adddict].addto=1;
 spellp->spdict[curdict].browse=1;
}


typedef os_error * (*setuserdictmenuhandler)(int n);
typedef os_error * (*getuserdictmenuhandler)(int * n);


static setuserdictmenuhandler ssmh;
static getuserdictmenuhandler gsmh;


void setuserdict(int fp)
{
 if(ssmh) ssmh(stack[fp]);
}


int isuserdict(int fp)
{
 int style;
 style=-1;
 if(gsmh) gsmh(&style);
 return(style==stack[fp]);
}



static void setuserdictmenu(setuserdictmenuhandler xssmh,getuserdictmenuhandler xgsmh)
{
 ssmh=xssmh;
 gsmh=xgsmh;
}


/*
static os_error * openuserdictmenu(setuserdictmenuhandler xssmh,
                                   getuserdictmenuhandler xgsmh,int handle)
{
	setuserdictmenu(xssmh,xgsmh);
 return(openmenuparent("userdict_menu",handle));
}
*/

static os_error * dictionarykey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 int        xhandle;
 int        now;
 int        n;

 err=NULL;

 cprintf("dictkey");

 if(*key==13)
 {
  err=checkrepcont(handle);
  *key=-1;
 }
 else
 if(*key==CUP || *key==CDOWN)
 {
  xhandle=dictionary[1].handle;

  now=nowords(dict,d);
  n=selectedn+((*key==CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=now) n=now-1;

  if(n!=selectedn)
  {
   writeicon(handle,0,wordn(n,dict,d));
   paneselectn(xhandle,n,0);
   paneopenline(xhandle,n);
  }
  *key=-1;
 }


 return(err);

 USE(icon);
 USE(userhandle);
}





static os_error * getbrowse(int * n)
{
 *n=index2user(curdict);
 return(NULL);
}



static os_error * changedictionary(void);


static os_error * setbrowse(int n)
{
 curdict=user2index(n);
// dbchangevalue(&curdict,dictionary);
 changedictionary();
 return(NULL);
}




static os_error * getadd(int * n)
{
 *n=index2user(adddict);
 return(NULL);
}


static os_error * setadd(int n)
{
 adddict=user2index(n);
// dbchangevalue(&adddict,dictionary);
 return(NULL);
}




static os_error * dictionaryicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 char     * p;

 err=iconaddr(handle,SPTEXTICON,&p);

 switch(m->i)
 {
  case   2:								/* cancel	*/
           err=checkfinish();
           break;

  case  11:        /* ignore word */
           if(checkcode!=SPCHKDBL) err=checkignoreword(p);
           if(!err) err=checkcontinue();
           break;

   case  1:       /* replace    */
           err=checkreplace(p);
           if((!isctrl) && !err) err=checkcontinue();
           break;

   case 10:							/* add	*/
           err=checkaddword(p,adddict);
           if(!err)
           {
            if(guessmode || curdict==adddict) err=changedictionary();
            if((!isctrl) && !err) err=checkcontinue();
           }
           break;

			case	12:						/* next */
											err=checkcontinue();
											break;

//   case  5:
//           err=openuserdictmenu(setbrowse,getbrowse,handle);
//           break;

//   case  8:
//           err=openuserdictmenu(setadd,getadd,handle);
//           break;
 }

 return(err);

 USE(handle);
 USE(userhandle);
}




static os_error * dictionaryclose(int code)
{
 os_error * err;

 err=NULL;

 remeditevent(spupdate,dictionary[0].handle,0);
 remcaretevent(panecaret,dictionary[1].handle,0);
// remkeyeventicon(dictionary[0].handle,10);

 setdcs();

 return(err);

 USE(code);
}



static void setdictionary(void)
{
 spellstr * spellp;

 spellp=(spellstr*)fob_find(checkfile->hdr.spell,checkfile);

 if(guessmode)
 {
  dict=guessdc;
  d=ddomain;
 }
 else
 {
  if(spellp->spdict[curdict].embedded) 
  {
   dict=spellp->spdict[curdict].index;
   d=checkfile->domain;
  }
  else
  {
   dict=dtable[spellp->spdict[curdict].index].dict;
   d=ddomain;
  }
 }
}



static os_error * changedictionary(void)
{
 os_error    * err;

 setdictionary();

 if(focusn>=0)    focusn=0;        // perhaps better choice
 if(selectedn>=0) selectedn=0;

 err=setpaneextent(dictionary[1].handle);

 if(!err) err=refreshwindow(dictionary[1].handle);
 if(!err) spdemon();

 return(err);
}



static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 return(changedictionary());

 USE(handle);
 USE(userhandle);
 USE(m);
}


/*
static os_error * wrdict(int value,char * string)
{
 spellstr * spellp;

 spellp=(spellstr*)fob_find(checkfile->hdr.spell,checkfile);
 strcpy(string,spellp->spdict[value].name);
 return(NULL);
}
*/

static os_error * curcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

	setuserdictmenu(setbrowse,getbrowse);
 err=menucombo(dictionary,4,"userdict_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}



static os_error * addcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

	setuserdictmenu(setadd,getadd);
 err=menucombo(dictionary,7,"userdict_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}




static dbiconstr dictionaryicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

  100, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   31, &guessmode,   DBRADIO,  0,   0,      1,  F1, 0, 0,(dbreadfn)optfn ,0,
   32, &guessmode,   DBRADIO,  0,   0,      0,  F1, 0, 0,(dbreadfn)optfn ,0,

    4, &curdict,     DBCOMBO,  0,   DBCOMBOSTATIC,   0,  0, 0, 0,         NULL ,(dbwritefn)curcombo,
    7, &adddict,     DBCOMBO,  0,   DBCOMBOSTATIC,   0,  0, 0, 0,         NULL ,(dbwritefn)addcombo,


 SPTEXTICON,(int*)&spstring,DBWRITE,  0,  DBSUBCLASS,      -2, -2, -2, -2,     NULL, NULL,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr dictionary[2]=
{
 0,
 TSPELLCHECK,
 DBFIX,
 0,
 dictionaryclose,
 dictionaryicon,
 dictionarykey,
 NULL,
 dictionaryicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

 0,
 TSPELLPANE,
 DBPANE,
 0, //DBFITICON,
 NULL,
 paneicon,
 panekey,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0, //13,

};



os_error * opencheck(int code,char * string,viewstr * view)
{
 os_error * err;

 err=NULL;

 checkcode=code;

 if(!dictionary[0].handle)
 {
  selectedn=-1;
  focusn=-1;
  getdcs();
  setdictionary();

           err=dodboxspparent(dictionary,2,dictionary,&dbviewstack,view->handle);
  if(!err) err=addeditevent(spupdate,dictionary[0].handle,0);
  if(!err) err=addcaretevent(panecaret,dictionary[1].handle,0);
//  if(!err) err=addkeyeventicon(dictionary[0].handle,SPTEXTICON);

  setfocus(dictionary[1].handle);
 }
 else
 {
  if(guessmode) 
  {
   selectedn=focusn=-1;
   refreshwindow(dictionary[1].handle);
  }
 }

 if(!err)
 {
  err=setpaneextent(dictionary[1].handle);
  writeicon(dictionary[0].handle,SPTEXTICON,string);
  writeiconf(dictionary[0].handle,15,code==SPCHKDBL?"{SP11}":"");
  wimp_setwindowbackground(dictionary[1].handle,CCRGB|PALWHITE);
  wimp_setwindowflags(dictionary[1].handle,WINDOWNOTDIALOGUE,0);
  spdemon();
 }

 return(err);
}


os_error * closecheck(void)
{
 os_error * err;

 err=NULL;

 if(dictionary[0].handle) 
 {
  dbclose(dictionary,DBCANCEL);

  if(act.valid && zone)
  {
   err=undostart(checkfile);
   if(!err)
   {
    unsaveact();
    findreset(checkview);
    undoend(checkfile);
   }
  }
 }

 setdcs();

 return(err);
}



int checkisopen(void)
{
 return(dictionary[0].handle!=0);
}


