/*->c.dbsped */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "filetype.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "bf.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "trans.h"
#include "dbhi.h"
#include "save.h"
#include "load.h"
#include "hourglass.h"
#include "deb.h"

#include "constants.h"

#include "obj.h"

#include "mhi.h"

#include "str.h"
#include "reslink.h"

#include "view.h"
#include "file.h"
#include "dbscale.h"
#include "macros.h"


#include "dc.h"
#include "spell.h"

#include "dbsped.h"


extern dboxstr dictionary[2];



static int     selectedn;
static int     oldselectedn;
static int     focusn;
static int     oldfocusn;

static int         dict;
static domainstr * d;
static int         editn;



/***************************************************************************/
/* dictionary selector pane */

#define PANETOPMARGIN  8
#define PANESTEP       32 //36
#define PANEHEIGHT     28 //36

#define PANETEXTSHIFT  0  // 4
#define PANEBLOCKX     0
#define PANEBLOCKY     24  //36
#define PANELEFTMARGIN 1
#define PANETEXT       SPMAXLEN*16
#define PANEBLOCKSHIFT 8







static os_error * setpaneextent(int handle)
{
 os_error * err;
 windowstr  window;
 int        height;
 int        width;
 int        n;

 err=getw(handle,&window);
 if(!err)
 {
  n=nowords(dict,d);

/* if(bbc_inkey(-1)) checkdict(dict,d);   */

  width=window.x1-window.x0;
  height=MAX(window.y1-window.y0,PANETOPMARGIN+n*PANESTEP);

  writeiconf(dictionary[0].handle,32,"%d",n);

  err=extent(handle,0,-height,width,0);
 }
 return(err);
}


static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error    * err;
 int           ox;
 int           oy;
 int           ylo;
 int           yhi;
 int           n;
 int           y;
 word          words;
 int           now;


 err=NULL;

	if(more)
	{
  wimpfontstart(0);

  now=nowords(dict,d);


  while(more)
  {
   if(now)
   {
    ox=redrawstr->box.x0-redrawstr->scx;
    oy=redrawstr->box.y1-redrawstr->scy;

    ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
    yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

    n=(ylo-PANETOPMARGIN)/PANESTEP;
    if(n<0) n=0;
    y=n*PANESTEP+PANETOPMARGIN;

    if(locword(n,dict,&words,d))
    {
     while(y<=yhi && n<now)
     {
      if(n==selectedn || n==oldselectedn || n==oldfocusn)
      {
       wimp_setcolour(n==selectedn?WIMPBLACK:WIMPWHITE);
       bbc_rectanglefilli(ox+PANELEFTMARGIN,oy-y,PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT,-PANEHEIGHT);
      }

      if(n==focusn)
      {
       wimp_setcolour(WIMPWHITE);
       wimp_setcolour(0xF0+WIMPBLACK);
       bbc_setstyle(1);
       bbc_rectanglei(ox+PANELEFTMARGIN,oy-y,PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT,-PANEHEIGHT);
      }

      stringat(ox+PANELEFTMARGIN+PANEBLOCKX+PANEBLOCKSHIFT,oy-y-PANETEXTSHIFT,
               words.string,
               n==selectedn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
               PANEHEIGHT);  

      y+=PANESTEP;
      n++;
      nextword(dict,&words,d);
     }
    }
   }
   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}


 return(err);
 USE(handle);
}



static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err && more) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-cvdu.extrax;
 r.box.x1=r.box.x0+PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT+2*cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}


static void paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// cprintf("bot %d lt %d",bot,(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0)));

 // wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 wimp_open_wind(&wblock.o);
}


/****************************************************************************/


/* a file of words has been dropped onto the edit window */

static os_error *loaddctxtype(char * name,int type,mousestr * m,int userhandle,int *method)
{
 *method=(type==TEXTFILE)||(type==UNICODETEXTFILE);
 return(NULL);
 USE(userhandle);
 USE(m);
 USE(name);
}



static os_error * loaddctext(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;
 buffer     bf;
 char       string[SPMAXLEN];
 int        eof;
 int        ecount;
 int        code;


 err=bf_open(name,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
  hourglasson();

 
  eof=0;
  ecount=0;

  while(!eof)
  {
   err=bf_getstring(&bf,string,SPMAXLEN,&eof);
   if(*string)
   {
    code=addword(string,dict,d);
    if(editn>=0) dtable[editn].modded|=code;
   }

   if(ecount--<0)
   {
//    if(bbc_inkey(0)==27) err=geterror(ESCAPERR);
    if(akbd_pollesc()) err=geterror(ESCAPERR);
    if(err) break;
    ecount=100;
   }
  }

  err=bf_close(&bf,err);

  setpaneextent(dictionary[1].handle);
  refreshwindow(dictionary[1].handle);           

  hourglassoff();
 }

 return(err);

 USE(type);
 USE(userhandle);
 USE(xvolatile);
}



/* save dictionary as text */
                  
static os_error * savedctext(char * name,int type)
{
 os_error * err;
 buffer     bf;
 word       words;

 err=NULL;

 if(nowords(dict,d))
 {
  err=bf_open(name,'w',DEFBUFFSIZE,&bf);
  if(!err)
  {
   locword(0,dict,&words,d);
   do
   {
    bf_write(&bf,words.string,strlen(words.string));
    bf_putc(&bf,'\r');
    bf_putc(&bf,'\n');
   } while(nextword(dict,&words,d));

   bf_closec(&bf,err,name,type);
  }
 }

 return(err);
}


#ifdef NEVER
static os_error * savedcint(mousestr * m,char * name,int type)
{
 return(NULL);
 USE(m);
 USE(name);
 USE(type);
}

#endif


static os_error * opendcsave(void)
{
 os_error * err;
 TCHAR      name[FILENAMELEN];

 xzstrncpyu(name,TEXT("TextFile"),NITEM(name));
 err=opensave(name,NITEM(name),TEXTFILE,savedctext);

 return(err);
}


os_error * openexportwords(int fp)
{
 os_error * err;
 TCHAR      name[FILENAMELEN];

 xzstrncpyu(name,TEXT("TextFile"),NITEM(name));

 err=opensaveparent(name,NITEM(name),TEXTFILE,savedctext,dictionary[0].handle);

 return(err);
 USE(fp);
}







static os_error * openedit(int handle)
{
 os_error * err;
 loadoptstr opts;
 int        xtype=TEXTFILE;
 int        copt;
 char       name[FILENAMELEN];

 opts.description="Text file of words (*.txt)";
 opts.ntypes=1;
 opts.types=&xtype;

 strcpy(name,"");

 err=openloadparent(name,&copt,&opts,1,loaddctext,0,handle);

 return(err);
}





os_error * openimportwords(int fp)
{
 os_error * err;

 err=openedit(dictionary[0].handle);

 return(err);
 USE(fp);
}



/****************************************************************************/


static void paneselectn(int handle,int n,int focustoo)
{
 oldfocusn=focusn;
 oldselectedn=selectedn;
 selectedn=focusn=-1;
 if(oldselectedn>=0) panerefreshline(handle,oldselectedn);
 else
 if(oldfocusn>=0) panerefreshline(handle,oldfocusn);
 selectedn=n;
 if((oldfocusn>=0 && selectedn>=0) || focustoo) focusn=selectedn;

 if(n>=0) panerefreshline(handle,n);
}



static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 windowstr  window;
 int        now;

 err=NULL;

 if(gain)
 {
  if(selectedn>=0) focusn=selectedn;
  else
  {
   err=getw(handle,&window);
   if(!err)
   {
    focusn=(-window.scy-PANETOPMARGIN+(window.y1-window.y0)/2)/PANESTEP;
    now=nowords(dict,d);
    if(focusn<0) focusn=0;
    if(focusn>=now) focusn=now-1;
   }
  }
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}




static os_error * panegoton(int n,int now,int panehandle,int mainhandle)
{
 os_error * err;

 err=NULL;

 if(n<0) n=0;
 if(n>=now) n=now-1;

 if(n!=selectedn)
 {
  writeicon(mainhandle,10,wordn(n,dict,d));
  paneselectn(panehandle,n,1);
  paneopenline(panehandle,n);
 }

 return(err);
}







static os_error * panekey(int panehandle,int userhandle,int icon,int * key)
{
 int       ch;
 int       mainhandle;
 int       now;
 int       n;
 int       next;
 windowstr window;


 mainhandle=dictionary[0].handle;

 ch=*key;

 if(ch==HOME)
 {
  now=nowords(dict,d);
  panegoton(0,now,panehandle,mainhandle);
  *key=-1;
 }
 else
 if(ch==COPY)
 {
  now=nowords(dict,d);
  panegoton(now-1,now,panehandle,mainhandle);
  *key=-1;
 }
 if(ch==PAGEUP || ch==PAGEDOWN)
 {
  now=nowords(dict,d);
  getw(panehandle,&window);
  next=(window.y1-window.y0)/PANESTEP;
  n=focusn;
  n+=((*key==PAGEDOWN)?next:-next);
  panegoton(n,now,panehandle,mainhandle);
  *key=-1;
 }
 else
 if(ch==CUP || ch==CDOWN)
 {
  now=nowords(dict,d);
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  panegoton(n,now,panehandle,mainhandle);
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }
 else
 if(ch>=' ' && ch<256) // move to next entry that starts with ch
 {
  word words;
  int  flags=0;
  char buff[4];
  int  found;

  now=nowords(dict,d);

  n=focusn+1;
  if(n<now) locword(n,dict,&words,d);
  if(n>=now || toupper(*words.string)!=toupper(ch))
  {
   buff[0]=ch;
   buff[1]=0;
   found=findwordabs(buff,dict,&words,&flags,d);
   n=words.wordn;
   if(!found) n++;

  }

  if(n!=focusn)
  {
   panegoton(n,now,panehandle,mainhandle);
   *key=-1;
  }
 }


 return(NULL);

 USE(userhandle);
 USE(icon);
}





static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;


 if(m->bbits==1)
 {
  err=openmenuparent("dc_menu",handle);
 }
 else
 if(m->bbits==2)
 {
  err=opendcsave();
 }
 else
 {
  err=getw(handle,&window);
  if(!err)
  {
   n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;
   paneselectn(handle,n,1);
   writeicon(dictionary[0].handle,10,wordn(selectedn,dict,d));
   setfocus(dictionary[1].handle);
  }
 }

 return(err);

 USE(userhandle);
}


/***************************************************************************/

/* called from zero when words window is open */
/* if word icon has changed, reopen window at appropriate point */

static void editdemon(void)
{
 os_error * err;
 int    found;
 int    n;
 int    handle;
 int    flags=0;
 word   words;
 char   buff[64];
 char * p;
 char * result;


 handle=dictionary[1].handle;

 err=iconaddr(dictionary[0].handle,10,&p);
 if(!err)
 {
  err=expandmacrostring(p,&result,0);
		if(!err)
		{
   spstripstring(buff,result,sizeof(buff));
   expandmacrostringfinit(&result);

   found=findwordabs(buff,dict,&words,&flags,d);
   n=words.wordn;

   if(found && n==selectedn) return;
   paneopenline(handle,n+1);
   paneselectn(handle,found?n:-1,0);
		}
 }
}


static os_error * editupdate(int handle,int icon,int userhandle)
{
 editdemon();
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}



/***************************************************************************/

static os_error * adddictword(int handle)
{
 os_error * err;
 char       buff[256];
 char     * p;
 int        code;
 char     * result;

 err=iconaddr(handle,10,&p);
	if(!err)
	{
  err=expandmacrostring(p,&result,0);
		if(!err)
		{
   spstripstring(buff,result,sizeof(buff));
   expandmacrostringfinit(&result);


   code=addword(buff,dict,d);
   if(editn>=0) dtable[editn].modded|=code;

   setpaneextent(dictionary[1].handle);
   refreshwindow(dictionary[1].handle);           
   editdemon();
		}
	}
 return(NULL);
}


static os_error * deletedictword(void)
{
 int   code;
 word  words;

 if(selectedn>=0 && selectedn<nowords(dict,d))
 {
  code=locword(selectedn,dict,&words,d);
  if(code)
  {
   code=remword(dict,&words,d);
   if(editn>=0) dtable[editn].modded|=code;
  }
  
  setpaneextent(dictionary[1].handle);
  refreshwindow(dictionary[1].handle);
  editdemon();
 }

 return(NULL);
}




static os_error * dictionaryicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;


 if(m->bbits==2)
 {
  err=opendcsave();
 }
 else
 {
  switch(m->i)
  {
   case 3:
          err=adddictword(handle);
          break;

   case 4:
          err=deletedictword();
          break;
  }
 }

 return(err);

 USE(userhandle);
}





static os_error * dictionarypanegoton(int n,int now,int panehandle,int mainhandle)
{
 os_error * err;

 err=NULL;

 if(n<0) n=0;
 if(n>=now) n=now-1;

 if(n!=selectedn)
 {
  writeicon(mainhandle,0,wordn(n,dict,d));
  paneselectn(panehandle,n,0);
  paneopenline(panehandle,n);
 }

 return(err);
}




static os_error * dictionarykey(int handle,int userhandle,int icon,int * key)
{
 int       ch;
 int       panehandle;
 int       now;
 int       n;
 int       next;
 windowstr window;


 ch=*key;

// cprintf("dict key %d",ch);

 if(ch==RETURN)
 {
  *key=-1;
  return(adddictword(handle));
 }
 else
 if(ch==HOME)
 {
  panehandle=dictionary[1].handle;
  now=nowords(dict,d);
  dictionarypanegoton(0,now,panehandle,handle);
  *key=-1;
 }
 else
 if(ch==COPY)
 {
  panehandle=dictionary[1].handle;
  now=nowords(dict,d);
  dictionarypanegoton(now-1,now,panehandle,handle);
  *key=-1;
 }
 if(ch==PAGEUP || ch==PAGEDOWN)
 {
  panehandle=dictionary[1].handle;
  now=nowords(dict,d);
  getw(handle,&window);
  next=(window.y1-window.y0)/PANESTEP;
  n=selectedn;
  n+=((*key==PAGEDOWN)?next:-next);
  dictionarypanegoton(n,now,panehandle,handle);
  *key=-1;
 }
 else
 if(ch==CUP || ch==CDOWN)
 {
  panehandle=dictionary[1].handle;
  now=nowords(dict,d);
  n=selectedn+((*key==CDOWN)?1:-1);
  dictionarypanegoton(n,now,panehandle,handle);
  *key=-1;
 }

 return(NULL);

 USE(userhandle);
 USE(icon);
}




static os_error * dictionaryclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(editn>=0) err=spsavechanges();
 }
 else
 if(code==DBCANCEL)
 {
  err=spscrapchanges();
 }

 if(!err && code!=DBAPPLY) 
 {
  if(editn>=0) dtable[editn].uses--;
  remdataload(dictionary[1].handle,0,loaddctext);
  remdataloadtype(dictionary[1].handle,0,loaddctxtype);
  remeditevent(editupdate,dictionary[0].handle,0);
  remcaretevent(panecaret,dictionary[1].handle,0);
//  remkeyeventicon(dictionary[0].handle,10);
 }

 return(err);
}




static dbiconstr dictionaryicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

   21, NULL,         DBACTION, 0,   0,      DBOK,-1,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
   10, &selectedn,   DBWRITE,  0,   DBSUBCLASS,      -2, -2, -2, -2,      NULL ,NULL,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr dictionary[2]=
{
 0,
 TEDITDICT,
 DBFIX,
 0,
 dictionaryclose,
 dictionaryicon,
 dictionarykey,
 NULL,
 dictionaryicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

 0,
 TEDITPANE,
 DBPANE,
 0,
 NULL,
 paneicon,
 panekey,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,

};


static os_error * edwritetitle(char * name)
{
 os_error  * err;
 char        temp[256];

 err=NULL;

 if(dictionary[0].handle)
 {
  xsprintf(sizeof(temp),NULL,temp,"{SP08} %s",name);
  trans(temp,sizeof(temp));
  writetitle(dictionary[0].handle,temp);
 }

 return(err);
}



os_error * editdictionary(char * name,int n,dboxstr * parent,
                                               int dc,domainstr * domain)
{
 os_error * err;
 char       temp[DCNAMELEN];


 err=xzstrncpye(temp,name,sizeof(temp));
	if(!err)
	{
  selectedn=focusn=-1;

  if(n>=0) err=loaddcn(n);
  if(!err)
  {
   if(n>=0)
   {
    dict=dtable[n].dict;
    dtable[n].uses++;
   }
   else
   {
    dict=dc;
   }

   d=domain;
   editn=n;


   err=dodboxsp(dictionary,2,parent,&dbviewstack);
   if(!err) err=setpaneextent(dictionary[1].handle);
   if(!err) err=adddataload(dictionary[1].handle,0,loaddctext);
   if(!err) err=adddataloadtype(dictionary[1].handle,0,loaddctxtype);
   if(!err) err=wimp_setwindowbackground(dictionary[1].handle,CCRGB|PALWHITE);

   if(!err) err=wimp_setwindowflags(dictionary[1].handle,WINDOWNOTDIALOGUE,0);

   if(!err) err=addeditevent(editupdate,dictionary[0].handle,0);

   if(!err) err=addcaretevent(panecaret,dictionary[1].handle,0);

//  addkeyeventicon(dictionary[0].handle,10);



   if(!err) err=edwritetitle(temp);
   if(!err) writeicon(dictionary[0].handle,10,"");
  }
	}

 return(err);
}

