/*->c.dbtabs */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "bbc.h"
#include "akbd.h"
#include "flex.h"
#include "font.h"
#include "transform.h"
#include "etc.h"
#include "xmath.h"

#include "wos.h"
#include "sp.h"
#include "sprx.h"
#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "colour.h"
#include "drag.h"
#include "fsx.h"
#include "bf.h"
#include "osunits.h"
#include "deb.h"
#include "bits.h"
#include "dbhi.h"





#include "str.h"
#include "constants.h"

#include "object.h"

#include "mhi.h"
#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "posn.h"
#include "dbscale.h"
#include "macros.h"


#include "dbcolour.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "rulers.h"
#include "tools.h"

#include "txstr.h"
#include "codes.h"
#include "tx.h"
#include "style.h"
#include "tabs.h"

#include "tabruler.h"
#include "dbtabs.h"



/*****************************************************************************/




typedef struct xtabstr
{
 unsigned short leader2[LEADERMAXLEN];
 unsigned short dectab2[DECTABMAXLEN];
 unsigned int   posn:27;
 unsigned int   type:4;
 unsigned int   selected:1;
} xtabstr;




#define TABMARGIN 40
#define TABTOP    32
#define TABICON   0

#define TABKEYICON 5


#define TABCHUNK 16*sizeof(xtabstr)



static filestr  * cfile;
static viewstr  * cview;
static dbtabstr   ctabs;
static dtbfn      dtbf;


static xtabstr * tabs;
static int       ntab;

static int       selopt;
static int       parawidth;


static unsigned short leader2[LEADERMAXLEN];
static unsigned short dectab2[DECTABMAXLEN];


static int       currtab;
static int       tabposn;

static int       apply;



extern dboxstr tabbox;


static char * tabsp[12]={"","lefttab","righttab","decimaltab","centretab",
          "1stindent","lindent","rindent","lrule","vrule","rrule","tabdata"};

static char   tabspw[12]={0,12,12,12,12,12,12,14,10,10,10,10};		// os units
static char   tabspp[12]={0, 2, 3, 2, 2, 0, 0,7, 0, 4, 8, 4};		// pixels


static char   tabyt[12]={0,
                         0,
                         0,
                         0,
                         0,
                         0,
                         TABTOP/2+2,
                         0,
                         0,
                         0,
                         0,
                         0,
                        };


static char   tabyb[12]={
                         0,
                         TABTOP,
                         TABTOP,
                         TABTOP,
                         TABTOP,
                         TABTOP/2,
                         TABTOP,
                         TABTOP,
                         TABTOP,
                         TABTOP,
                         TABTOP,
                         TABTOP,
                        };






static int tabrulerhandle;


static int dragstartposn;
static int dragtabposn;
static int dragposn;
static int dragactive;
static int dragshift;
static int dragydrop;
static int dragydropredraw;


static os_error * tabchangeposn(void);

static void tpfn(void);



static void autoapply(void)
{
 if(apply==0)
 {
  apply=1;
  dbchangevalue(&apply,&tabbox);
 }
}




static int inrange(int osxlo,int osxhi,int osposn,int itype)
{
 int posnlo;
 int posnhi;

 posnlo=osposn-xpix2os(tabspp[itype]+1)-1;
 posnhi=posnlo+xpix2os(tabspw[itype]+1)+1;


//if(itype==TLINDENT) cprintf("osx %d lo %d hi %d",osxlo,posnlo,posnhi);

 return(
        (osxlo>=posnlo && osxlo<=posnhi) || (osxhi>=posnlo && osxhi<=posnhi) ||
        (posnlo>=osxlo && posnlo<=osxhi) || (posnhi>=osxlo && posnhi<=osxhi)
       );
}


static void findit(int x,int y,int * temptab,int * temptype)
{
 int iposn;
 int itab;
 int itype;

 *temptype=0;
 *temptab=-1;

 for(itab=0;itab<ntab;itab++)
 {
  iposn=tabs[itab].posn;
  itype=tabs[itab].type;

  if(y>=tabyt[itype] && y<=tabyb[itype])
  {
   if(inrange(x,x,osunits(iposn,cview),itype))
   {
    *temptype=tabs[itab].type;
    *temptab=itab;
   }
  }
 }
}



static int findtabtype(int ttype)
{
 int itab;

 for(itab=0;itab<ntab;itab++)
 {
  if(tabs[itab].type==(unsigned int)ttype)
  {
   return(itab);
  }
 }
 return(-1);
}



static int findselectedtab(void)
{
 int itab;

 for(itab=0;itab<ntab;itab++)
 {
  if(tabs[itab].selected)
  {
   return(itab);
  }
 }
 return(-1);
}




static void saveleader(int read)
{
 int i;

 if(read) dbreadvalues(&tabbox);

 for(i=0;i<ntab;i++)
 {
  if(tabs[i].selected)
  {
   xzstrncpye22(tabs[i].leader2,leader2,sizeof(tabs[i].leader2)/sizeof(unsigned short));
   xzstrncpye22(tabs[i].dectab2,dectab2,sizeof(tabs[i].dectab2)/sizeof(unsigned short));
  }
 }
}




static void setcurrtab1(int t)
{
 currtab=t;

 if(t>=0)
 {
		cprintf("set curtab %d",t);

  tabposn=tabs[t].posn;
  xzstrncpye22(leader2,tabs[t].leader2,sizeof(leader2)/sizeof(unsigned short));
  xzstrncpye22(dectab2,tabs[t].dectab2,sizeof(dectab2)/sizeof(unsigned short));
 }

 tabchangeposn();
}




static void setcurrtab(int t)
{
 setcurrtab1(t);
 dbchangevalue(&currtab,&tabbox);
}






static os_error * redrawtabs(int bx,int by,int iposn,int yposn,
                                                     int itype,int selected)
{
 sprite_id       spr;
 int             palette[16];
 int             entries=0;
 newsprite_header * sph=NULL;


// cprintf("posn %d selected %d",iposn,selected);

 if(itype<TABDATA)
 {
  if(selected)
  {
   sph=sprite_find((sprite_area*)sprites,tabsp[itype]);
   spgetpal(sph,&entries,palette);
//   cprintf("entries %d p0 %x p1 %x",entries,palette[0],palette[1]);
   SWOP(palette[0],palette[1]);
   spsetpal(sph,entries,palette);
  }

  spr.s.name=tabsp[itype];
  spr.tag= sprite_id_name;
// sprite_put_given((sprite_area*)sprites,&spr,0,xpix2os(xos2pix(bx+osunits(iposn,cview))-tabspp[itype]),by-yposn);
  sprite_put_givenpx((sprite_area*)sprites,&spr,0,xos2pix(bx+osunits(iposn,cview))-tabspp[itype],-yos2pix(by-yposn));

  if(selected)
  {
   SWOP(palette[0],palette[1]);
   spsetpal(sph,entries,palette);
//   cprintf("entries %d p0 %x p1 %x",entries,palette[0],palette[1]);
  }

  return(NULL);
 }
 else
 {
  return(NULL);
 }
}



static void tabsize(int tabn,int type,int * xlo,int * xhi)
{
 int x;
 x=tabs[tabn].posn;
 *xlo=osunits(x,cview)-xpix2os(tabspp[type])-cvdu.extrax;
 *xhi=*xlo+xpix2os(tabspw[type])+2*cvdu.extrax;
}






static os_error * tabredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 int        n;
 windowstr  window;
 int        measure;
 int        hstep;
 int        hbstep;
 int        ubstep;
 char     * pattern;
 int        osxlo;
 int        osxhi;
 int        xlo;
 int        xhi;
 int        xps;
 int        xpe;
 int        x;
 int        u;
 int        itab;
 int        iposn;
 int        itype;
 int        mz;
 int        nmax;
 int        yposn;

 err=NULL;

	if(more)
	{
  measure=cview->data.units;

  hstep =hsteps[mz=mzone(cview)][measure];
  hbstep=hbsteps[mz][measure];
  ubstep=ubsteps[mz][measure];
  pattern=hpattern[mz][measure];

  rulerfontstart();

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx-cvdu.deltax;
   oy=redrawstr->box.y1-redrawstr->scy;

   osxlo=redrawstr->g.x0-ox;
   osxhi=redrawstr->g.x1-ox;

   wimp_setcolour(0);
   bbc_rectanglefill(ox+osxlo,oy-TABICON,osxhi-osxlo,-TABTOP-TABMARGIN);

   wimp_setcolour(7);
   bbc_move(ox+osxlo,oy-TABTOP-TABICON);
   bbc_draw(ox+osxhi,oy-TABTOP-TABICON);

/*
  bbc_move(ox+osxlo,oy-TABICON);
  bbc_draw(ox+osxhi,oy-TABICON);
*/

   xlo=ourunits(redrawstr->g.x0-ox,cview);
   xhi=ourunits(redrawstr->g.x1-ox,cview);

   getw(handle,&window);

   xps=0;
   xpe=parawidth;

   nmax=(xpe-xps)/(hstep*hbstep);
   n=(xhi-xps)/(hstep*hbstep);
   if(n<nmax) xhi=xps+(n+1)*hstep*hbstep;
   nmax*=ubstep;

   n=(xlo-xps)/(hstep*hbstep);
   xlo=xps+n*hstep*hbstep;
   u=0;
   n*=ubstep;

   for(x=xlo;x<=xhi;x+=hstep)
   {
    if(x>0)
    {
     bbc_move(ox+osunits(x,cview),oy-(TABTOP+TABICON/*+TABMARGIN*/));

     bbc_draw(ox+osunits(x,cview),oy-(/*TABMARGIN+*/TABTOP+TABICON)-
                                 ((pattern[u]-'0')*TABMARGIN)/PATTERNSCALE);
    }

    if(u==0)
    {
     rulerprint(n,xcoordpix2os(xcoordos2pix(ox+osunits(x,cview))-2),oy-(TABTOP+TABICON+TABMARGIN),1+4);
     n+=ubstep;
    }

    if(++u==hbstep) u=0;
   }


   for(itab=0;itab<ntab;itab++)
   {
    iposn=tabs[itab].posn;
    yposn=TABTOP+TABICON-cvdu.deltay;   
    itype=tabs[itab].type;

    if(tabs[itab].selected && dragactive)
    {
     iposn+=dragshift;
     if(dragydrop && 
        itype!=TFINDENT && 
        itype!=TLINDENT && 
        itype!=TRINDENT) yposn=TABTOP+TABICON+(3*TABMARGIN)/4-cvdu.deltay;
    }

    if(inrange(osxlo,osxhi,osunits(iposn,cview),itype)) 
    {
     redrawtabs(ox,oy,iposn,yposn,itype,tabs[itab].selected);
    }
   }

   wimp_get_rectangle(redrawstr,&more);
  }

  rulerfontend();
	}

 return(err);
}


static os_error * tabredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) tabredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}



static os_error * refreshbit(int handle,int xlo,int xhi)
{
 os_error       * err;
 wimp_redrawstr   r;
 int              more;

 r.box.x0=xlo-cvdu.deltax; /* shift */
 r.box.x1=xhi-cvdu.deltax; /* shift */

 r.box.y1=-TABICON;

 if(dragydropredraw) r.box.y0=r.box.y1-TABTOP-TABMARGIN;
 else                r.box.y0=r.box.y1-TABTOP;

 r.w=handle;

          err=wimp_update_wind(&r,&more);
 if(!err) err=tabredrawsub(handle,&r,more);

 return(err);
}




/* refresh the bit of the ruler at this position */

static void refreshtab(int handle,int tabn,int type)
{
 int xlo;
 int xhi;

 tabsize(tabn,type,&xlo,&xhi);

 refreshbit(handle,xlo,xhi);
}





static void unselecttab(int handle,int n)
{
 if(tabs[n].selected)
 {
  tabs[n].selected=0;
  refreshtab(handle,n,tabs[n].type);
 }
}


static void unselectall(int handle)
{
 int i;
 for(i=0;i<ntab;i++) unselecttab(handle,i);
}


static void setopt(int type)
{
 selopt=type;
 dbchangevalue(&selopt,&tabbox);
}


static void selecttab(int handle,int temptab,int temptype)
{
 if(temptab>=0)
 {
  tabs[temptab].selected=1;
  refreshtab(handle,temptab,temptype);
 }
}







/* add a tab with the given x coordinate */

static int addatab(int x,int type)
{
 int i,j;

 flex_chunk((flex_ptr)&tabs,(ntab+1)*sizeof(xtabstr),TABCHUNK);

 for(i=0;i<ntab;i++)
 {
  if(tabs[i].posn>(unsigned)x) break;
 }

 /* i is posn to insert before */

 for(j=ntab;j>i;j--)
 {
  tabs[j]=tabs[j-1];
 }

 tabs[i].posn=x;
 tabs[i].type=type;
 xzstrncpye22(tabs[i].dectab2,dectab2,sizeof(tabs[i].dectab2)/sizeof(unsigned short));
 xzstrncpye22(tabs[i].leader2,leader2,sizeof(tabs[i].leader2)/sizeof(unsigned short));


	cprintf("addatab %x",dectab2[0]);

 ntab++;

 return(i);
}



/* get rid of the tab number n */

static void remtab(int n)
{
 int i;

 for(i=n;i<ntab-1;i++)
 {
  tabs[i]=tabs[i+1];
 }
 ntab--;
}



/* we call this to see if the object already exists */
/* because there can be only one of certain things  */

static int indentposn(int type,int * tab)
{
 int i;

 if(type==TFINDENT || type==TLINDENT || type==TRINDENT || 
                      type==TLRULE || type==TRRULE)
 {
  for(i=0;i<ntab;i++)
  {
   if(tabs[i].type==(unsigned)type)
   {
    *tab=i;
    return(tabs[i].posn);
   }
  }
 }

 *tab=-1;
 return(-1);
}



static void settabposn(int handle,int tabn,int type,int xposn,int update)
{
 int xlo; 
 int xhi;

 tabsize(tabn,type,&xlo,&xhi);
 tabs[tabn].posn=xposn;
 if(tabn==currtab)
 {
  tabposn=xposn;
  if(update) tabchangeposn();
 }
 autoapply();

 refreshbit(handle,xlo,xhi);
 refreshtab(handle,tabn,type);
}



/* create a new tab in the middle of the ruler */

static int createatab(int handle,int type,int newposn)
{
 int newtab;

 indentposn(type,&newtab);

 if(newtab<0)
 {
   /* we have to actually create something */
  unselectall(handle);
  newtab=addatab(newposn,type);
  autoapply();
 }
 else
 {
  settabposn(handle,newtab,type,newposn,1);
 }

 selecttab(handle,newtab,type);

 return(newtab);
}






static int tabunitstep(viewstr * view)
{

 switch(view->data.units)
 {
  case  INCHES:
               return(72000/20);
               break;

  case  POINTS:
               return(3*1000);
               break;

  case  MILIMS:
       default:
               return(MMSIZE);
               break;

 }

}



static int tabsnap(viewstr * view,int posn)
{
 int mul;
 int div;

	if(posn<0) posn=0;

 switch(view->data.units)
 {
  case  INCHES:
               mul=(72000/20);
               div=1;
               break;

  case  POINTS:
               mul=(3*1000);
               div=1;
               break;

  case  MILIMS:
       default:
               mul=360000;
               div=127;
               break;
 }

 posn=scale(posn,div,mul);
 posn=scale(posn,mul,div);

 return(posn);
}



static int txsu(int u,int step)
{
 return(tabsnap(cview,u));
 USE(step);
}





static int drgxmin;
static int drgxmax;
static int dragminshift;
static int dragmaxshift;

static int scrollhandle;
static int skiponemove; // opening the parent (e.g. scroll) generates a move message
                        // problem with scrolling the ruler when moving a tab causing large scrolls in document
                        // have to limit scrolling to area of ruler. Done this by not scrolling once pointer not above tab ruler.


static void scrollzero(int handle);


#define MINTIME 8

static os_error * tabsdrag(int handle,windowstr * window)
{
 return(userdrag(handle,window->x0,
                        window->y0 /*+TABMARGIN/8 */,
                        window->x1,
                        window->y1-TABTOP-TABICON));
}




static os_error * tabzero(int handle,wimp_mousestr * m)
{
// wimp_mousestr m;
 windowstr     window;
 int           x;
 int           y;
 int           oldshift;
 int           xmax;
 int           xmin;
 int           nydrop;


// wimp_get_point_info(&m);
 getw(handle,&window);

 x=m->x-window.bx;
 y=window.by-m->y;
 nydrop=(y>(TABICON+TABTOP+TABMARGIN/2));

 if(x!=dragposn || nydrop!=dragydrop)
 {
  dragposn=x;
  oldshift=dragshift;

  tabposn=dragtabposn+ourunits(x-dragstartposn,cview);
  tabposn=tabsnap(cview,tabposn);

  dragshift=tabposn-dragtabposn;

  if(dragshift<-dragminshift)
  {
   dragshift=-dragminshift;
   tabposn=dragtabposn+dragshift;
  }

  if(dragshift>dragmaxshift)
  {
   dragshift=dragmaxshift;
   tabposn=dragtabposn+dragshift;
  }

  if(dragshift!=oldshift || nydrop!=dragydrop)
  {
   tabchangeposn();

   dragydrop=nydrop;

   if(nydrop && !dragydropredraw) dragydropredraw=1;

   if(oldshift<dragshift) 
   {
    xmin=drgxmin+osunits(oldshift,cview);
    xmax=drgxmax+osunits(dragshift,cview);
   }
   else
   {
    xmin=drgxmin+osunits(dragshift,cview);
    xmax=drgxmax+osunits(oldshift,cview);
   }

   refreshbit(handle,xmin,xmax);

   if(!nydrop && dragydropredraw) dragydropredraw=0;
  }
 }


 if(m->w==handle)   // limit scrolling to whilst tab is over ruler
 {
  if(autoscroll(cview,m))
  {
   skiponemove=1;
   getw(handle,&window);
   tabsdrag(handle,&window);
   scrollhandle=handle;
   addscheduledevent((zerofn)scrollzero,scrollhandle,MINTIME);
  }
 }

 return(NULL);

 USE(handle);
}



static void scrollzero(int handle)
{
 wimp_mousestr m;

 wimp_get_point_info(&m);

 tabzero(handle,&m);
}



static os_error * tabdragmove(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(skiponemove)
 {
  skiponemove=0;
  return(NULL);
 }


 if(scrollhandle)
 {
  remscheduledevent((zerofn)scrollzero,scrollhandle);
  scrollhandle=0;
 }

 err=tabzero(handle,m);

 return(err);

 USE(userhandle);
}




static os_error * tabdragend(int handle,int userhandle,wimp_box * box)
{
 os_error * err;
 windowstr  window;
 int        shift;
 int        i;


 dragactive=0;

 if(scrollhandle)
 {
  remscheduledevent((zerofn)scrollzero,scrollhandle);
  scrollhandle=0;
 }


// remzeroevent(tabdragzero,handle);

 err=getw(handle,&window);

 i=0;
 while(i<ntab)
 {
  if(tabs[i].selected)
  {
   if(dragydrop &&
       !(tabs[i].type==TFINDENT || 
         tabs[i].type==TLINDENT || tabs[i].type==TRINDENT))
   {
    remtab(i);
    if(i==currtab) setcurrtab(-1);
   }
   else
   {
    tabs[i].posn+=dragshift;
    i++;
   }
  }
  else i++;
 }

 shift=osunits(dragshift,cview);
 refreshbit(handle,drgxmin+shift,drgxmax+shift);

 dragydropredraw=0;
 autoapply();

 return(err);

 USE(box);
 USE(userhandle);
}



static os_error * tabdrag(int handle)
{
 os_error  * err;
 windowstr   window;
 int         i;
 int         xlo;
 int         xhi;
 int         first;


          err=getw(handle,&window);
 if(!err) err=tabsdrag(handle,&window);
 if(!err) err=startdrag2(handle,0,tabdragend,tabdragmove);
// if(!err) err=addzeroevent(tabdragzero,handle);

 first=1;
 dragminshift=0;

 for(i=0;i<ntab;i++)
 {
  if(tabs[i].selected)
  {
   tabsize(i,tabs[i].type,&xlo,&xhi);

   if(first) 
   {
    drgxmin=xlo;
    drgxmax=xhi;
    dragminshift=tabs[i].posn;
    dragmaxshift=tabs[i].posn;
    first=0;
   }
   else
   {
    drgxmin=MIN(drgxmin,xlo);
    drgxmax=MAX(drgxmax,xhi);
    dragminshift=MIN(tabs[i].posn,(unsigned)dragminshift);
    dragmaxshift=MAX(tabs[i].posn,(unsigned)dragmaxshift);
   }
  }
 }

 dragmaxshift=parawidth-dragmaxshift;

 dragactive=1;
 dragshift=0;
 dragydrop=dragydropredraw=0;

 return(err);
}



static os_error * tabrulericon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 windowstr  window;
 int        x;
 int        y;
 int        temptab;
 int        temptype;

 err=NULL;

 if(m->i==-1)
 {
  getw(handle,&window);
  x=m->x-window.bx+cvdu.deltax;
  y=m->y-window.by;

  if((m->bbits==0x4)||(m->bbits==0x1)||(m->bbits==0x40))
  {
   if(y>-(TABTOP+TABICON) && y<-TABICON)
   {
    findit(x,TABICON-y,&temptab,&temptype);
    if(temptype)
    {
     if(m->bbits==0x4)  /* Select */
     {
      if(!isctrl)
      {
       if(!tabs[temptab].selected) 
       {
//       cprintf("select tab");
        saveleader(1);
        unselectall(handle);
        selecttab(handle,temptab,temptype);
        setcurrtab(temptab);
       }
      }
      else
      {
       if(!tabs[temptab].selected)
       {
//       cprintf("adjust select");
        selecttab(handle,temptab,temptype);
        setcurrtab(temptab);
       }
       else
       {
//       cprintf("adjust unselect");
        if(temptab==currtab) 
        {
         saveleader(1);
        }
        unselecttab(handle,temptab);
        if(temptab==currtab) 
        {
         setcurrtab(findselectedtab());
        }
       }
      }
     }
     else              /* Adjust */
     if(m->bbits==0x1)
     {
      if(!tabs[temptab].selected)
      {
//       cprintf("adjust select");
       selecttab(handle,temptab,temptype);
       setcurrtab(temptab);
      }
      else
      {
//       cprintf("adjust unselect");
       if(temptab==currtab) 
       {
        saveleader(1);
        setcurrtab(-1);
       }
       unselecttab(handle,temptab);
      }
     }
     else
     if(m->bbits==0x40) /* Select drag */
     {
      dragtabposn=tabs[temptab].posn;
      dragstartposn=x;
      tabdrag(handle);
     }
     setopt(temptype);
    }
    else
    {
     if(m->bbits==0x4)
     {
      saveleader(1);
      temptab=createatab(handle,selopt,tabsnap(cview,ourunits(x,cview)));
      setcurrtab(temptab);
     }
    }
   }
   else
   {
    saveleader(1);
    unselectall(handle);
    setcurrtab(-1);
   }
  }
 }

 iecarrot(tabbox.handle,TABKEYICON);

 return(err);
 USE(userhandle);
}





static os_error * clearfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        i;
 int        j;
 int        type;
 int        hit;

 err=NULL;

 hit=0;

 for(i=j=0;i<ntab;i++)
 {
  type=tabs[i].type;
  if(type==TFINDENT || type==TLINDENT || type==TRINDENT || 
                       type==TLRULE   || type==TRRULE)
  {
   tabs[j++]=tabs[i];
  }
  else
  {
   hit=(i==currtab);
  }
 }

 ntab=j;

 if(hit) setcurrtab(-1);

 refreshbit(tabrulerhandle,0,parawidth);

 autoapply();


 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * tabzoomevent(int eventn,int user,filestr * file,
                                                   viewstr * view)
{

 if(tabrulerhandle && view==cview)
 {
  refreshwindow(tabrulerhandle);
 }

 return(NULL);

 USE(file);
 USE(eventn);
 USE(user);
}







static os_error * closetabruler(void)
{
 os_error * err;

 err=NULL;

 if(tabrulerhandle)
 {
  remclickevent(tabrulericon,tabrulerhandle,0);
  remredrawevent(tabredraw,tabrulerhandle,0);

  remevent(EVENT_ZOOM,(eventfn)tabzoomevent,0);

  err=closedown(&tabrulerhandle);

  cview->hpane2=0;
  cview=NULL;
 }

 flex_free((flex_ptr)&tabs);

 return(err);
}



os_error * opentabruler(viewstr * view,wimp_openstr * o)
{
 int       rx0; 
 int       rx1;
 int       ry0;
 int       ry1;
 int       rscx;
 int       rscy;
 int       noshow;
 int       bx;
 int       by;
 int       x0;
 int       x1;
 int       y0;
 int       y1;


 if(view==cview)
 {
  bx=o->box.x0-o->x;
  by=o->box.y1-o->y;

  noshow=0;

  rscx=0;
  rx0=bx+osunits(ctabs.parax,cview)+cvdu.deltax; /* shift */
  rx1=rx0+osunits(parawidth,cview)-cvdu.deltax;  /* shift */
  rscy=0;

  ry1=by-osunits(ctabs.paray,cview);
  ry0=ry1-TABMARGIN-TABTOP;

  x0=o->box.x0+view->left;
  x1=o->box.x1;
  y0=o->box.y0;
  y1=o->box.y1-view->top;




/*

  if(rx1<x0 || rx0>x1) noshow=1;

  if(rx0<x0) 
  {
   rscx=x0-rx0;
   rx0=x0;
  }

  if(rx1>x1)
  {
   rx1=x1;
  }




  if(ry1<y0 || ry0>y1) noshow=1;

  if(ry0<y0) 
  {
   ry0=y0;
  }

  if(ry1>y1)
  {
   rscy=y1-ry1;
   ry1=y1;
  }
  if(noshow) 
  {
   wimp_close_wind(tabrulerhandle);
   view->hpane2=0;
  }
  else  
*/
  if(tabrulerhandle)
  {
   open(tabrulerhandle,rx0,ry0,rx1,ry1,rscx,rscy,-2);//o->behind);
   view->hpane2=tabrulerhandle;
  }
 }
 else
 {
  view->hpane2=0;
 }

 return(NULL);
}




static os_error * createtabruler(void)
{
 os_error  * err;
 windowstr   window;
 wimp_wstate winds;

 err=NULL;

 if(!tabrulerhandle)
 {
  err=createwindowparent(TTABS,&tabrulerhandle,cview->handle);
  if(!err)
  {
   addclickevent(tabrulericon,tabrulerhandle,0);
   addredrawevent(tabredraw,tabrulerhandle,0);
   addevent(EVENT_ZOOM,(eventfn)tabzoomevent,0);
  }
 }

 if(!err)
 {
  err=getw(tabrulerhandle,&window);
  if(!err)
  {
   extent(tabrulerhandle,0,window.y0-window.y1,osunits(parawidth,cview),0);
   err=wimp_get_wind_state(cview->handle,&winds);
   if(!err) opentabruler(cview,&winds.o);
  }
 }

 return(err);
}


/*****************************************************************************/



static os_error * tabkey(int handle,int userhandle,int icon,int * key)
{
 char * string;
 int    value;
 int    shift;
 int    i;
 int    hit;
 int    temptab;

 if(*key==RETURN && icon==TABKEYICON)
 {
  *key=-1;
  hit=0;

  iconaddr(handle,TABKEYICON,&string);
  stringtounits(string,&value,cview->data.units);

  shift=value-tabposn;
  tabposn=value;

  for(i=0;i<ntab;i++)
  {
   if(tabs[i].selected)
   {
    settabposn(tabrulerhandle,i,tabs[i].type,tabs[i].posn+shift,0);
    hit=1;
   }
  }

  if(!hit)
  {
   temptab=createatab(tabrulerhandle,selopt,tabposn);
   setcurrtab(temptab);
  }
  else
  {
   tabchangeposn();
  }
 }

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}

static tabupdateactive;

static void tpfn(void)
{
 int value;
 int shift;
 int i;

 if(tabupdateactive) return;
 tabupdateactive=1;

 if(currtab>=0)
 {
  value=tabs[currtab].posn;
  shift=tabposn-value;
  if(shift)
  {
   for(i=0;i<ntab;i++)
   {
    if(tabs[i].selected)
    {
     settabposn(tabrulerhandle,i,tabs[i].type,tabs[i].posn+shift,0);
    }
   }
  }
 }

 tabupdateactive=0;
}


static os_error * tabchangeposn(void)
{
 os_error * err;

 tabupdateactive=1;
 err=dbchangevalue(&tabposn,&tabbox);
 tabupdateactive=0;

 return(err);
}



static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        i;

	err=NULL;


// cprintf("optnfn curr %d selopt %d",currtab,selopt);

 unselectall(tabrulerhandle);

 if(selopt==TLINDENT ||
    selopt==TFINDENT ||
    selopt==TRINDENT)
 {
  i=findtabtype(selopt);
  setcurrtab1(i);
  selecttab(tabrulerhandle,i,selopt);
 }
 else
 {
  setcurrtab(-1);
 }

 return(err);

 USE(m);
 USE(handle);
 USE(userhandle);
}




static int cmptabs(const void * p1,const void * p2)
{
 return(((xtabstr*)p1)->posn-((xtabstr*)p2)->posn);
}


static void sorttabs(xtabstr * tabs,int ntab)
{
 qsort(tabs,ntab,sizeof(xtabstr),cmptabs);
}


static os_error * tabclose(int code)
{
 os_error      * err;
 dbtabstr        dtabs;
 int             i;
 int             j;
 tabstr        * tabs2;
 unsigned short  cleader2[LEADERMAXLEN];
 unsigned short  cdectab2[DECTABMAXLEN];
 int             firsttab;
	char            temp[(MAX(LEADERMAXLEN,DECTABMAXLEN)+1)*3];		// big enough to hold escape+MAX(DECTABMAXLEN,LEADERMAXLEN)
	char          * p;
	int             len;

 err=NULL;

 if(code==DBOK || code==DBAPPLY) 
 {
  saveleader(0);

  tpfn(); // ensure last position typed in is read and applied

  dtabs.apply=apply;

  dtabs.oldtab=ctabs.oldtab;
  dtabs.lrule=-1;
  dtabs.rrule=-1;
  dtabs.parawidth=parawidth;

  sorttabs(tabs,ntab);

  firsttab=1;
  memset(dtabs.leader,0,sizeof(dtabs.leader));

  cdectab2[0]=0;
		cleader2[0]=0;

  err=flex_alloc((flex_ptr)&tabs2,ntab*sizeof(tabstr));
  if(!err)
  {
   j=0;
   for(i=0;i<ntab;i++)
   {
    err=flex_chunk((flex_ptr)&tabs2,(j+2)*sizeof(tabstr),ntab*sizeof(tabstr));
    if(err) break;

    if(tabs[i].type<=TCENTRE)
    {
					if(firsttab || xstrncmp22(cleader2,tabs[i].leader2,LEADERMAXLEN))
					{
      XMEMCPYX(cleader2,tabs[i].leader2,LEADERMAXLEN*sizeof(unsigned short));
						txstring21(cleader2,temp,sizeof(temp),&len);
						p=temp;

						if(firsttab)
						{
							XMEMCPYX(dtabs.leader,temp,LEADERLEN);
							len-=LEADERLEN;
							p+=LEADERLEN;
						}

						while(len>0)
						{
       err=flex_chunk((flex_ptr)&tabs2,(j+2)*sizeof(tabstr),ntab*sizeof(tabstr));
       if(err) break;

       tabs2[j].selected=0;
       tabs2[j].type=TABDATA;
       tabs2[j].posn=p[0]|(p[1]<<8)|(p[2]<<16)|(TSUBLEAD<<24);
							len-=3;
							p+=3;
       j++;
						}

						firsttab=0;
					}

//					cprintf("cdec %d %d",i,tabs[i].dectab2[0]);

     if(xstrncmp22(cdectab2,tabs[i].dectab2,DECTABMAXLEN))
     {
      XMEMCPYX(cdectab2,tabs[i].dectab2,DECTABMAXLEN*sizeof(unsigned short));
						txstring21(cdectab2,temp,sizeof(temp),&len);
						p=temp;

						cprintf("output dec tab %d",len);

						while(len>0)
						{
       err=flex_chunk((flex_ptr)&tabs2,(j+2)*sizeof(tabstr),ntab*sizeof(tabstr));
       if(err) break;

       tabs2[j].selected=0;
       tabs2[j].type=TABDATA;
       tabs2[j].posn=p[0]|(p[1]<<8)|(p[2]<<16)|(TSUBDEC<<24);
							len-=3;
							p+=3;
       j++;
						}
     }
    }

    switch(tabs[i].type)
    {
      case  TLEFT:
      case TRIGHT:
     case TCENTRE:
        case TDEC:
      case TVRULE:
                  tabs2[j].selected=0;
                  tabs2[j].type=tabs[i].type;
                  tabs2[j].posn=tabs[i].posn;
                  j++;
                  break;

    case TFINDENT:
                  dtabs.first=tabs[i].posn;
                  break;

    case TLINDENT:
                  dtabs.left=tabs[i].posn;
                  break;

    case TRINDENT:
                  dtabs.right=tabs[i].posn;
                  break;          

      case TLRULE:
                  dtabs.lrule=tabs[i].posn;
                  break;

      case TRRULE:
                  dtabs.rrule=tabs[i].posn;
                  break;
    }
   }

   if(!err)
   {
    err=addtabruler(cfile,&tabs2,0,j,&dtabs.newtab);
    if(!err)
    {
     if(dtbf) err=dtbf(&dtabs,code==DBAPPLY?TBFAPPLY:TBFOK);
    }
   }


   flex_free((flex_ptr)&tabs2);

  }
 }

 if(!err && code!=DBAPPLY) 
 {
  closetabruler();
 }

 return(err);
}


static os_error * rdld(int * value,char * string)
{
	os_error     * err;
	unsigned short temp[LEADERMAXLEN];

          err=macrotostring2(string,temp,NITEM(temp));
	if(!err)	err=txunccheckstring(temp,cfile);
	if(!err)	err=xzstrncpye22(leader2,temp,NITEM(leader2));
	if(cfile->compatability<UNICOMPAT)
	{
		leader2[LEADERLEN]=0;
	}

 return(err);
 USE(value);
}


static os_error * wrld(int value,char * string)
{
 if(currtab>=0 && tabs[currtab].type<=TCENTRE)
 {
  stringtomacro2(leader2,string,DBWRITEMAX);
 }
 else
 {
  *string=0;
 }
 return(NULL);
 USE(value);
}


static os_error * rddec(int * value,char * string)
{
	os_error     * err;
	unsigned short temp[DECTABMAXLEN];

	cprintf("rddec");

          err=macrotostring2(string,temp,NITEM(temp));
	if(!err)	err=txunccheckstring(temp,cfile);
	if(!err)	err=xzstrncpye22(dectab2,temp,NITEM(dectab2));

	if(cfile->compatability<UNICOMPAT)
	{
		dectab2[LEADERLEN]=0;
	}

 return(err);
 USE(value);
}


static os_error * wrdec(int value,char * string)
{
 if(currtab>=0 && tabs[currtab].type<=TCENTRE)
 {
  stringtomacro2(dectab2,string,DBWRITEMAX);
 }
 else
 {
  *string=0;
 }

 return(NULL);
 USE(value);
}


static os_error * wrposn(int value,char * string)
{
 if(currtab>=0) strcpy(string,unitstostring(value,cview->data.units));
 else           *string=0;
 return(NULL);
}


static os_error * rdposn(int * value,char * string)
{
	os_error * err;

 if(*string==0)
 {
  *value=0;
  return(NULL);
 }
 err=stringtounits(string,value,cview->data.units);
	if(!err)
	{
	 if(*value<0)
  {
  	err=geterror(ETXE8);
			*value=0;
		}
	}

	return(err);
}




/******************************************************************************/
static dbiconstr tabicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

// nb rely on index of these entries below when setting step
TABKEYICON,&tabposn, DBWRITE,  0,DBASSOCINC,-1, -1,  7, 14,   rdposn,wrposn,
   15,  &tabposn,    DBDEC,    0,    0,      1, -1, MAXINT,MININT, NULL,(dbwritefn)txsu,
   16,  &tabposn,    DBINC,    0,    0,      1, -1, MAXINT,MININT, NULL,(dbwritefn)txsu,
    0,  &tabposn,    DBUPDATE, 0,    0,     -1, -1, -1, -1, (dbreadfn)tpfn,NULL,

  101,  NULL,         DBACTION, 0,   0,      DBOK,-1,0,0,         NULL ,0,
    2,  NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   21,  &selopt,     DBRADIO,  0,   0,  TLEFT,   0,  1,  0,(dbreadfn)optfn,NULL,
    9,  &selopt,     DBRADIO,  0,   0, TRIGHT,   0,  1,  0,(dbreadfn)optfn,NULL,
    8,  &selopt,     DBRADIO,  0,   0,TCENTRE,   0,  1,  0,(dbreadfn)optfn,NULL,
    3,  &selopt,     DBRADIO,  0,   0,   TDEC,   0,  1,  0,(dbreadfn)optfn,NULL,
   10,  &selopt,     DBRADIO,  0,   0,TLINDENT,  0,  1,  0,(dbreadfn)optfn,NULL,     
   18,  &selopt,     DBRADIO,  0,   0,TFINDENT,  0,  1,  0,(dbreadfn)optfn,NULL,
   17,  &selopt,     DBRADIO,  0,   0,TRINDENT,  0,  1,  0,(dbreadfn)optfn,NULL,


   12,  &apply,      DBTOGGLE, 2,   0,      1,   0,  0,  0,   NULL,  NULL,

   11,  NULL,        DBACTION, 0,   0,        0,-1,0,0,(dbreadfn)clearfn,0,


    7,  &currtab,    DBWRITE,  0,   0,     -1,  -1,  14, 5,   rdld,  wrld,
   14,  &currtab,    DBWRITE,  0,   0,     -1,  -1,  5,  7,   rddec, wrdec,



   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr tabbox=
{
 0,
 TTABSTYLE,
 DBFIX,
 0,
 tabclose,
 NULL,
 tabkey,
 NULL,
 tabicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

};



/*

  The key point is that on return via the tab close function, one
  tabruler has been created, and none have been removed.

*/




os_error * opentabs(dbtabstr * dtb,dtbfn xdtbf,dboxstr * parent,viewstr * view,filestr * file)
{
 os_error     * err;
 int            i;
 int            j;
 int            stype;
 int            step;
	char           cleader1[(LEADERMAXLEN+1)*3];
	char         * pleader1;
	char           cdectab1[(DECTABMAXLEN+1)*3];
	char         * pdectab1;


 closetabruler();

 cfile=file;
 cview=view;
 ctabs=*dtb;
 dtbf=xdtbf;


	dectab2[0]=0;
	leader2[0]=0;

 XMEMCPYX(cleader1,ctabs.leader,LEADERLEN);
	pleader1=cleader1+LEADERLEN;
	*pleader1=0;
 strcpy(cdectab1,"");
	pdectab1=cdectab1;

 tabposn=0;
 currtab=-1;
 parawidth=ctabs.parawidth;
 ctabs.paray-=ourunits(TABMARGIN+TABTOP,cview);
 if(ctabs.paray<0) ctabs.paray=0;

 selopt=1;

 apply=ctabs.apply;

 if(apply<0) tabbox.htemplate=TTABEFFECT;
 else        tabbox.htemplate=TTABSTYLE;

 step=tabunitstep(cview);
 tabicondefs[1].data.stepbutton.step=step;
 tabicondefs[2].data.stepbutton.step=step;

 err=dodboxspparent(&tabbox,1,parent,&dbviewstack,cview->handle);

 dbshade(2,ctabs.lock?DBNOOFFG:0,&tabbox);

 /* there is a problem if the tabs are already open */
 /* double flex block and create ruler window twice */
 /* try to do dodboxsp first to escape this         */

 gettabruler(cfile,ctabs.oldtab);
 ntab=tabrulern;


 err=flex_alloc((flex_ptr)&tabs,(ntab+5)*sizeof(xtabstr)+TABCHUNK);
 if(!err)
 {
  j=0;
  for(i=0;i<ntab;i++) 
  {
   if(tabruler[i].type!=TABDATA)
   {
    tabs[j].posn=tabruler[i].posn;
    tabs[j].type=tabruler[i].type;
    tabs[j].selected=0;
				txstring12(cleader1,sizeof(cleader1),tabs[j].leader2,sizeof(tabs[j].leader2)/sizeof(unsigned short),NULL);
				txstring12(cdectab1,sizeof(cdectab1),tabs[j].dectab2,sizeof(tabs[j].dectab2)/sizeof(unsigned short),NULL);
				pleader1=cleader1;
				pdectab1=cdectab1;
    j++;
   }
   else
   {
    stype=(tabruler[i].posn>>24);
    if(stype==TSUBLEAD)
    {
     XMEMCPYX(pleader1,&tabruler[i],3);
					pleader1+=3;
     *pleader1=0;
    }
    else
    if(stype==TSUBDEC)
    {
     XMEMCPYX(pdectab1,&tabruler[i],3);
					pdectab1+=3;
     *pdectab1=0;
    }
   }
  }


  ntab=j;

  tabs[ntab].posn=ctabs.left;
  tabs[ntab].selected=0;
  tabs[ntab].leader2[0]=0;
  tabs[ntab].dectab2[0]=0;
  tabs[ntab++].type=TLINDENT;

  tabs[ntab].posn=ctabs.right;
  tabs[ntab].selected=0;
  tabs[ntab].leader2[0]=0;
  tabs[ntab].dectab2[0]=0;
  tabs[ntab++].type=TRINDENT;

  tabs[ntab].posn=ctabs.first;
  tabs[ntab].selected=0;
  tabs[ntab].leader2[0]=0;
  tabs[ntab].dectab2[0]=0;
  tabs[ntab++].type=TFINDENT;

  if(ctabs.lrule>=0)
  {
   tabs[ntab].posn=ctabs.lrule;
   tabs[ntab].selected=0;
   tabs[ntab].leader2[0]=0;
   tabs[ntab].dectab2[0]=0;
   tabs[ntab++].type=TLRULE;
  }

  if(ctabs.rrule>=0)
  {
   tabs[ntab].posn=ctabs.rrule;
   tabs[ntab].selected=0;
   tabs[ntab].leader2[0]=0;
   tabs[ntab].dectab2[0]=0;
   tabs[ntab++].type=TRRULE;
  }

  createtabruler();    // need ruler window before opening view
                       // used to be after code below

  {
   int px=osunits(ctabs.parax,cview);
   int py=osunits(ctabs.paray,cview);
   int sx= cview->mainwindow.scx;  //mainpane
   int sy=-cview->mainwindow.scy;

   if(px>(sx+cview->mainwindow.x1-cview->mainwindow.x0) || //mainpane
      px<(sx+cview->left)
     ) sx=px-cview->left;

   if(py<(sy+cview->top) || 
      py>(sy+cview->mainwindow.y1-cview->mainwindow.y0)  //mainpane
     ) sy=py-cview->top;

   if(sx!=cview->mainwindow.scx || sy!=-cview->mainwindow.scy) //mainpane
   {
    viewopenat(cview,cfile,sx,-sy);
   }
  }


 }

 return(err);
}
