/*->h.fl */

#define FLNONE   0
#define FLDELTA  1                 /* doing an insertion            */
#define FLDIRTY  2                 /* going over changed stuff      */
#define FLQUICK  3                 /* checking lines are OK         */
#define FLBULLET 4                 /* checking bullets              */


#define FLEXTENT 0xFF

#define FWAIT    0x0                 /* stack flow for future...       */
#define FLINE    0x1                 /* flow this line                 */
#define FPARA    0x2                 /* flow this para                 */
#define FSUB     0x4                 /* flow this sub box              */
#define FBOX     0x8                 /* flow this box                  */
#define FPAGE    0x10                /* flow this page                 */
#define FALL     0x20                /* flow the lot                   */
                                     /* always do at least the vectors */

#define FDATA    0x1000              /* data is present     */
#define FLV0     0x2000              /* vector 0 is present */
#define FLV1     0x4000              /* vector 1 is present */
#define FLPREV   0x8000              /* back a line         */



typedef struct flowstr
{
 int         opcode;          /* type of flow operation                */

 int         result;          /* used to pass back info on flow result */

 vector    * resultv[2];
 int         roff[2];

 flowdatablock data;

} flowstr;


extern os_error * flow(vector * start,flowstr * op);


#define FLVBOX     0x1
#define FLVNEXTBOX 0x2
#define FLVLEXTENT 0x3


extern os_error * flowvalidate(vector * v,int extent);
extern os_error * flowvalidoffset(vector * v,int * offset);
extern os_error * flowvalidfile(filestr * file);
extern os_error * flowvalidbox(int text,filestr * file);
extern os_error * flowvalidlimit(filestr * file,int source,
                                    vsourcestr * vsourcep,int * vlimitp);



/* parameters of OM_REFLOW message */

#define TXREFLOWVBOX       0x1000
#define TXREFLOWONEBOX     0x2000
#define TXREFLOWZERO       0x4000
#define TXREFLOWMASK       0xFF


extern os_error * pagereflowpage(int page,filestr * file);
extern os_error * pagereflowsectionplus(int page,filestr * file);
extern os_error * pagereflowsection(int section,filestr * file);

extern os_error * flowstackunlink(int vsource,filestr * file);


extern os_error * flowinit(void);

