/*->c.vec */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"
#include "deb.h"

#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"


#include "constants.h"
#include "str.h"

#include "object.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"



#include "xcolour.h"
#include "xredraw.h"
#include "posn.h"

#include "curve.h"

#include "undo.h"
#include "units.h"
#include "macros.h"



#include "txstr.h"
#include "tx.h"
#include "fx.h"
#include "vl.h"
#include "vi.h"
#include "fl.h"
#include "style.h"

#include "codes.h"

#include "text.h"



#include "vec.h"


/* locked vector only */

vlstr * vvlptr(vector * v)
{
 return(vlptr(v->textsrc.vsourcep,v->textsrc.voffset));
}


#define isspcetc(c) (((c)<=SPACE && (c)!=DCHYPH) || (c)==NBSPACE)


/* called on locked vector */

void vsetpage(vector * v)
{
 pagesectionof((chainobject *)v->textsrc.textp,v->file,&v->page,&v->section);
}



/* used to validate the offset of a vector      */
/* rule (1) vector can never be less than SNLEN */
/*      (2) skip style codes at start of para   */


os_error * vsvec(vector * v)
{
 vlstr * line;
 int     c;
 int     voffset;



 if(v->textsrc.offset<=SNLEN) v->textsrc.offset=SNLEN;
 else
 if(v->textsrc.voffset>0 && v->textsrc.offset==v->textsrc.loffset)
 {
  voffset=v->textsrc.voffset;
  while(voffset>0)
  {
   line=vlptr(v->textsrc.vsourcep,voffset-sizeof(vlstr));
   if(!line->line.xl)
   {
    if(line->line.eol!=ISNL) return(NULL);
    else                     break;
   }
   voffset-=sizeof(vlstr);
  }
 }
 else return(NULL);

 while(1)
 {
  c=*txptr(v->textsrc.sourcep,v->textsrc.offset);
  if(c==SNO)  v->textsrc.offset+=SNLEN;
  else        break;
 }

 return(NULL);
}





/* for the purposes of the spelling checker are we in a word */

int inword(vector * s)
{
 os_error * err;
 vector     v;
	int        pcv;

 pcv=0;
 v=*s;
 err=txlock(&v.textsrc,v.file);
 if(!err)
 {
  prevch(&v,&pcv);
  txunlock(&v.textsrc,v.file);
 }
 return(iswalnum((unsigned short)pcv) || pcv=='-');
}




int boxcontents(textboxstr * textp,int u,int * bytes,int * lines)
{
 int      n;
 int      i;
 int      sum;
 int      vsum;
 texsub * texup;
 int      usize;

 if(u) n=1;
 else  n=textp->data.columns;

 sum=vsum=0;

 if(textp->data.header || textp->data.footer)
 {
  usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
  if(u==0) usize+=2*sizeof(texsub);
  else
  if(u==2) usize+=sizeof(texsub);
 }
 else usize=sizeof(textboxstr)+sizeof(texsrc);

 texup=(texsub*)(((char*)textp)+usize);

 for(i=0;i<n;i++) 
 {
  sum+=texup[i].bytes;
  vsum+=texup[i].vlines;
 }

 if(bytes) *bytes=sum;
 if(lines) *lines=vsum;

 return(sum);
}





/* prev flow box, return 0 on failure don't change v */
/* leave vline pointing at last vline in box         */

static int prevfboxlog(vector * v)
{
 vlstr  * vline;
 int      fprev;
 int      lines;
 int      bytes;
 int      i;
 int      s;
 texsub * texup;

 fprev=v->textsrc.textp->fchain.prev;
 if(!fprev) return(0);

 txunlock(&v->textsrc,v->file);

 v->textsrc.text=fprev;

 txlock(&v->textsrc,v->file);


 if(v->textsrc.textp->data.header || v->textsrc.textp->data.footer) 
 {
  v->textsrc.usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
  if(v->textsrc.u==0) 
  {
   v->textsrc.usize+=2*sizeof(texsub);
   v->textsrc.columns=v->textsrc.textp->data.columns;
  }
  else
  {
   if(v->textsrc.u==2) v->textsrc.usize+=sizeof(texsub);
   v->textsrc.columns=1;
  }
 }
 else 
 {
  v->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
  v->textsrc.columns=v->textsrc.textp->data.columns;
 }


 s=v->textsrc.columns-1;


 texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
 while(s>0 && !texup[s].vlines) s--;

 v->textsrc.s=s;

 boxcontents(v->textsrc.textp,0,&bytes,&lines);

 v->boffset-=bytes;
 v->bvoffset-=lines;

 bytes=0;
 lines=0;
 texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
 for(i=0;i<=s;i++)
 {
  bytes+=texup[i].bytes;
  lines+=texup[i].vlines;
 }

 v->textsrc.offset=v->textsrc.loffset=v->boffset+bytes;
 v->textsrc.voffset=v->bvoffset+lines;

 lines=texup[s].vlines;
 while(lines)
 {
  lines-=sizeof(vlstr);
  v->textsrc.voffset-=sizeof(vlstr);

  vline=vlptr(v->textsrc.vsourcep,v->textsrc.voffset);
  if(!vline->line.xl)
  {
   v->astyle=vline->line.style;
   v->textsrc.loffset-=vline->line.len;
   v->textsrc.offset=v->textsrc.loffset;
   break;
  }
 }

 vsetpage(v);

 return(1);
}


static int prevfbox(vector * v)
{
 int      s;
 texsub * texup;

 if(v->textsrc.u!=0) return(0);

 while(1)
 {
  if(!prevfboxlog(v)) return(0);
  s=v->textsrc.s;
  texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
  if(texup[s].vlines) break;
 } 

 return(1);
}


/* just return a pointer to the previous line */
/* vector is not locked                       */

vlstr * prevline(vector * v)
{
 vlstr      * line;
 vsourcestr * vsrc;
 int          voffset;

 line=NULL;

 voffset=v->textsrc.voffset;

 while(voffset)
 {
  vsrc=(vsourcestr*)fob_find(v->textsrc.vsource,v->file);
  line=vlptr(vsrc,v->textsrc.voffset-sizeof(vlstr));
  if(!line->line.xl) break;
  voffset-=sizeof(vlstr);
 }


 return(line);
}



/* goes back by one v line         */
/* return 1 on success             */
/* do not modify v on failure      */

int prevvline(vector * v)
{
 vlstr  * line;
 int      s;
 int      i;
 int      vlimit;
 texsub * texup;
 int      voffset;


 voffset=v->textsrc.voffset;

 while(1)
 {
  if(!voffset) return(0);

  if(voffset==v->bvoffset) 
  {
   return(prevfbox(v));
  }
  else
  {
   voffset-=sizeof(vlstr);
   line=vlptr(v->textsrc.vsourcep,voffset);
   if(!line->line.xl)
   {
    v->textsrc.voffset=voffset;
    v->textsrc.loffset=v->textsrc.loffset-line->line.len;
    v->astyle=line->line.style;
    v->textsrc.offset=v->textsrc.loffset;

    s=v->textsrc.s;
    texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);

    vlimit=v->bvoffset;
    for(i=0;i<s;i++) vlimit+=texup[i].vlines;

    while((v->textsrc.voffset<vlimit || !texup[s].vlines) && s>0)
    {
     s--;
     vlimit-=texup[s].vlines;
    }

    v->textsrc.s=s;

    return(1);
   }
  }
 }
}



int prevvstrip(vector * v)
{
 vlstr * line;
 int     voffset;
 int     n;

 voffset=v->textsrc.voffset;

 n=1;

 while(1)
 {
  voffset-=sizeof(vlstr);
  if(voffset<0) return(0);
  line=vlptr(v->textsrc.vsourcep,voffset);
  if(!line->line.xl)
  {
   if(line->line.strip) break;
   n++;
  }
 }

 /* now pointing at last line of previous strip */

 while(1)
 {
  voffset-=sizeof(vlstr);
  if(voffset<0) break;
  line=vlptr(v->textsrc.vsourcep,voffset);
  if(!line->line.xl)
  {
   if(line->line.strip) break;
   n++;
  }
 }

 /* now pointing at first line of previous strip */

 while(n--) prevvline(v);

 return(1);
}


/* next flow box, return 0 on failure don't change v                 */
/* leave vline pointing at first vline in box                        */
/* moves vector from the last vline of one box to the first line of  */
/* the next.                                                         */
/* makes no attempt to check that the box is valid or that vline's   */
/* exist                                                             */


static int nextfboxlog(vector * v)
{
 vlstr  * vline;
 int      fnext;
 int      bytes;
 int      lines;
 int      s;
 texsub * texup;


 fnext=v->textsrc.textp->fchain.next;

 if(!fnext) return(0);

 boxcontents(v->textsrc.textp,0,&bytes,&lines);

 v->boffset=v->boffset+bytes;
 v->bvoffset=v->bvoffset+lines;

 txunlock(&v->textsrc,v->file);

 v->textsrc.text=fnext;

 txlock(&v->textsrc,v->file);


 if(v->textsrc.textp->data.header || v->textsrc.textp->data.footer) 
 {
  v->textsrc.usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
  if(v->textsrc.u==0) 
  {
   v->textsrc.usize+=2*sizeof(texsub);
   v->textsrc.columns=v->textsrc.textp->data.columns;
  }
  else
  {
   if(v->textsrc.u==2) v->textsrc.usize+=sizeof(texsub);
   v->textsrc.columns=1;
  }
 }
 else 
 {
  v->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
  v->textsrc.columns=v->textsrc.textp->data.columns;
 }

 texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
 s=0;
 while((s<(v->textsrc.columns-1)) && !texup[s].vlines) s++;
 v->textsrc.s=s;


/* v->page=pageof((chainobject*)v->textsrc.textp,v->file); */

 v->textsrc.offset=v->textsrc.loffset=v->boffset;
 v->textsrc.voffset=v->bvoffset;

 vline=vlptr(v->textsrc.vsourcep,v->bvoffset);
 v->astyle=vline->line.style;

 vsetpage(v);

 return(1);
}


static int nextfboxv(vector * v,int valid)
{
 int      s;
 texsub * texup;

 if(v->textsrc.u!=0) return(0);

 while(1)
 {
  if(valid) flowvalidate(v,FLVNEXTBOX);

  if(!nextfboxlog(v)) return(0);
  s=v->textsrc.s;
  texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
  if(texup[s].vlines) break;
 }

 return(1);
}



/* advances a vector by one v line */
/* return 1 on success             */
/* do not modify v on failure      */

int nextvlinev(vector * v,int valid)
{
 vlstr  * line;
 int      nextvloff;
 int      s;
 int      vlimit;
 int      i;
 texsub * texup;
 int      oldvoffset;
 int      oldloffset;
 int      olds;


 oldvoffset=v->textsrc.voffset;
 oldloffset=v->textsrc.loffset;
 olds=v->textsrc.s;

 while(1)
 {
  nextvloff=v->textsrc.voffset+sizeof(vlstr);

  if(valid) flowvalidate(v,FLVLEXTENT);

  if(nextvloff>=v->textsrc.vsourcep->len) break;

  s=v->textsrc.s;
  texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);

  vlimit=0;
  for(i=0;i<=s;i++) vlimit+=texup[i].vlines;

  if(nextvloff>=(v->bvoffset+vlimit))
  {
   if(s>=(v->textsrc.columns-1)) return(nextfboxv(v,valid));
   else                          s++;

   v->textsrc.s=s;
  }

  line=vlptr(v->textsrc.vsourcep,v->textsrc.voffset);
  if(!line->line.xl)
  {
   v->textsrc.loffset+=line->line.len;
  }

  v->textsrc.voffset=nextvloff;

  line=vlptr(v->textsrc.vsourcep,v->textsrc.voffset);
  if(!line->line.xl)
  {
   v->astyle=line->line.style;
   v->textsrc.offset=v->textsrc.loffset;
   return(1);
  }
 }


 v->textsrc.s=olds;
 v->textsrc.voffset=oldvoffset;
 v->textsrc.loffset=oldloffset;

 return(0);
}


int nextvline(vector * v)
{
 return(nextvlinev(v,1));
}



int nextvstripv(vector * v,int valid)
{
 vlstr * line;
 int     voffset;
 int     n;

 voffset=v->textsrc.voffset;

 n=1;

 while(1)
 {
  if(voffset>=(int)((v->textsrc.vsourcep)->len-sizeof(vlstr))) return(0); // changed to prevent access past end of vl buffer
  line=vlptr(v->textsrc.vsourcep,voffset);
  voffset+=sizeof(vlstr);

  if(!line->line.xl)
  {
   if(line->line.strip) break;
   n++;
  }
 }

/* dprintf(8,"ndown %d",n); */

 while(n--) nextvlinev(v,valid);

 return(1);
}



int nextvstrip(vector * v)
{
 return(nextvstripv(v,1));
}



os_error * findvlinex(int x,vector * v)
{
 vlstr * line;

 while(1)
 {
  line=vlptr(v->textsrc.vsourcep,v->textsrc.voffset);
  if(x>=(int)line->line.x && x<=(int)(line->line.x+MAXW(line))) break;
  if(x<(int)line->line.x) break;
  if(line->line.strip) break;
  if(!nextvline(v)) break;
 }

 return(NULL);
}





os_error * vfirstbox(vector * v)
{
 int fprev;

 if(v->textsrc.u==0)
 {
  v->textsrc.s=0;

  while(1)
  {
   fprev=v->textsrc.textp->fchain.prev;

  /* dprintf(0,"fprev=%d text=%d textp=%x",fprev,v->textsrc.textp->key,
                            v->textsrc.textp); */


   if(!fprev) break;

   txunlock(&v->textsrc,v->file);

   v->textsrc.text=fprev;

   txlock(&v->textsrc,v->file);
  }

  vgetusize(v);
  vsetpage(v);
 }

 return(NULL);
}



os_error * vsetupfirstbox(vector * v,int text,int u,filestr * file)
{
	textboxstr * textp;

	if(u==0)
	{
 	textp=(textboxstr*)fob_find(text,file);
 	while(textp && textp->fchain.prev)
 	{
 		text=textp->fchain.prev;
 	 textp=(textboxstr*)fob_find(text,file);
 	}
	}

	return(setvectorfrombox(v,u,text,file));
}




void vgetusize(vector * v)
{
 if(v->textsrc.textp->data.header || v->textsrc.textp->data.footer) 
 {
  v->textsrc.usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
  if(v->textsrc.u==0) 
  {
   v->textsrc.columns=v->textsrc.textp->data.columns;
   v->textsrc.usize+=2*sizeof(texsub);
  }
  else
  {
   if(v->textsrc.u==2) v->textsrc.usize+=sizeof(texsub);
   v->textsrc.columns=1;
  }
 } 
 else 
 {
  v->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
  v->textsrc.columns=v->textsrc.textp->data.columns;
 }
}




static int vnexts(vector * v)
{
 int fnext;

 if(v->textsrc.u==0)
 {
  if(v->textsrc.s<(v->textsrc.columns-1)) v->textsrc.s++;
  else
  {
   fnext=v->textsrc.textp->fchain.next;
   if(fnext)
   {
    txunlock(&v->textsrc,v->file);

    v->textsrc.text=fnext;

    txlock(&v->textsrc,v->file);

    vgetusize(v);
    vsetpage(v);
    v->textsrc.s=0;
   }
   else return(0);
  }
 }

 return(1);
}


/*
static int vprevs(vector * v)
{
 int      fprev;

 if(v->textsrc.u==0)
 {
  if(v->textsrc.s>0) v->textsrc.s--;
  else
  {
   fprev=v->textsrc.textp->fchain.prev;
   if(!fprev) return(0);

   txunlock(&v->textsrc,v->file);

   v->textsrc.text=fprev;

   txlock(&v->textsrc,v->file);

   vgetusize(v);
   vsetpage(v);
   v->textsrc.s=v->textsrc.columns-1;
  }
 }

 return(1);
}
*/





static os_error * vskipemptyboxesf(vector * v)
{
 texsub * texup;

 if(v->textsrc.u==0)
 {
  while(1)
  {
   texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
   if(texup[v->textsrc.s].vlines) break;
   if(!vnexts(v)) break;
  }
 }

 return(NULL);
}



/*
os_error * vskipemptyboxesb(vector * v)
{
 texsub * texup;

 if(v->textsrc.u==0)
 {
  while(1)
  {
   texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
   if(texup[v->textsrc.s].vlines) break;
   if(!vprevs(v)) break;
  }
 }

 return(NULL);
}
*/





/* set (locked) vector to start of text */

os_error * settosot(vector * v)
{
 char * p;

 v->textsrc.loffset=0;
 v->textsrc.voffset=0;
 v->boffset=0;
 v->bvoffset=0;

 vfirstbox(v);
 vskipemptyboxesf(v);

 /* style */

 p=txptr(v->textsrc.sourcep,0);
 v->astyle=p[1]+(p[2]<<8)+(p[3]<<16);

 v->textsrc.offset=SNLEN;
 return(vsvec(v));
}


/* given a valid vector, and a new offset update the vector */
/* does not go past end of text                             */

os_error * resetpoint(vector * v,int off)
{
 if(!off)
 {
  settosot(v);
 }
 else
 {
  if(off<v->textsrc.loffset)        /* go back     */
  {
   while(off<v->textsrc.loffset) prevvline(v);
  }
  else
  if(v->textsrc.voffset<v->textsrc.vsourcep->len) // new to stop access past end of vl buffer
  {
   if(off>=(int)(v->textsrc.loffset+vlptr(v->textsrc.vsourcep,v->textsrc.voffset)->line.len))
   {
    while(off>=(int)(v->textsrc.loffset+vlptr(v->textsrc.vsourcep,v->textsrc.voffset)->line.len)) 
    {
     if(!nextvline(v)) break;
    }
   }
  }

  v->textsrc.offset=off;

  if((v->textsrc.voffset>=v->textsrc.vsourcep->len) ||
     (off>=(int)(v->textsrc.loffset+
                 vlptr(v->textsrc.vsourcep,v->textsrc.voffset)->line.len)))
  {
   v->valid&=~VALIDPOSN;
  }
  else
  {
   v->valid|=VALIDPOSN;
  }
 }

 vsvec(v);

 return(NULL);
}



os_error * movevector(vector * s,int offset)
{
 os_error * err;

 err=txlock(&s->textsrc,s->file);
 if(!err)
 {
  resetpoint(s,offset);
  txunlock(&s->textsrc,s->file);
 }

 return(err);
}



os_error * vecinline(vector * s,int * valid)
{
 os_error * err;
 vlstr    * vline;

 err=txlock(&s->textsrc,s->file);
 if(!err)
 {
  vline=vvlptr(s);
  *valid=(s->textsrc.offset>=s->textsrc.loffset &&
          s->textsrc.offset<(int)(s->textsrc.loffset+vline->line.len));

  txunlock(&s->textsrc,s->file);
 }

 return(err);
}



/* set vector to end of text            */

os_error * settoeot(vector * s)
{
 return(resetpoint(s,s->textsrc.sourcep->len-1));
}



/* set vector to start of line            */

os_error * settosol(vector * s)
{
 s->textsrc.offset=s->textsrc.loffset;
 return(vsvec(s));
}


/* set vector to end of line             */
/* x==exclude any CR/LF's                */
/* be careful about EOT's                */

os_error * settoeol(vector * s,int x)
{
 vlstr * line;
 int     maxoffset;
 int     offset;
 int     len;
 int     c;

 line=vvlptr(s);
 maxoffset=offset=s->textsrc.loffset+line->line.len;

 if((x & 0x1) && (line->line.eol==ISBREAK || line->line.eol==ISNL)) offset--;
 else
 if(x & 0x2)
 {
  offset=s->textsrc.loffset;
  while(1)
  {
   c=*txptr(s->textsrc.sourcep,offset);
   len=codex[c] & CODELEN;
   if((offset+len)>=maxoffset) break;
   offset+=len;
  }
 }

 s->textsrc.offset=offset;

 maxoffset=s->textsrc.sourcep->len-1;
 if(s->textsrc.offset>maxoffset) s->textsrc.offset=maxoffset;

 return(NULL);
}


/* return char and length */

static int nextchlen(vector * s,int * len,int * cv)
{
 int    c=0;
 int    l;
	char * p;

 l=0;

 while(1)
 {
  p=txptr(s->textsrc.sourcep,s->textsrc.offset+l);
		c=*p;
  l+=codex[c] & CODELEN;
  if(c!=SNO)
  {
			if(cv)
			{
    if(c==UNC16)
 			{
 				*cv=(*(p+1))+((*(p+2))<<8);
 			}
				else
				{
					*cv=c;
				}
			}
//   if(c==EOT) break;

//   d=*txptr(s->textsrc.sourcep,s->textsrc.offset+l);
   break;
  }
 }

 *len=l;
 return(c);
}



/* return next char and update vector */
/* note returns EOT at end of text    */
/* prevch returns -1 at SOT           */


int nextch(vector * s,int * cv)
{
 int c;
 int len;

 c=nextchlen(s,&len,cv);
 if(c!=EOT) resetpoint(s,s->textsrc.offset+len);

 return(c);
}


os_error * nextchx(vector * s)
{
 nextch(s,NULL);
 return(NULL);
}


/* return prev char and update vector */

int prevch(vector * s,int * cv)
{
 int off;
 int len;
 int c;
 int newoffset;
 int linemax;

 off=s->textsrc.offset;
 c=-1;

 while(1)
 {
  if(s->textsrc.voffset<((s->textsrc.vsourcep)->len)) // changed to prevent access past end of vl buffer
  {
   s->textsrc.offset=s->textsrc.loffset;
   len=0;
   linemax=s->textsrc.loffset+vvlptr(s)->line.len;

   while(1)
   {
    newoffset=s->textsrc.offset+len;
    if(newoffset>=off || newoffset>=linemax) break;
    resetpoint(s,s->textsrc.offset+len);
    c=nextchlen(s,&len,cv);
   }
 
   if(s->textsrc.offset<off) break;
  }

  if(!prevvline(s)) return(-1);
 }

 return(c);
}


os_error * prevchx(vector * s)
{
 prevch(s,NULL);
 return(NULL);
}



/* set vector to start of previous para      */

static int settosops(vector * s,int prev)
{
 vlstr * line;
 int     voffset;


 line=NULL; /* compiler */


 while(1)
 {
  voffset=s->textsrc.voffset;

  while(1)
  {
   if(!s->textsrc.loffset || !voffset)
   {
    if(!prev) break;
    else      return(0);
   }

   line=vlptr(s->textsrc.vsourcep,voffset-sizeof(vlstr));
   if(!line->line.xl) break;
   voffset-=sizeof(vlstr);
  }

  if(!s->textsrc.loffset || !voffset)
  {
   if(!prev) break;
   else      return(0);
  }

  if(!prev && line->line.eol==ISNL) break;

  if(!prevvline(s)) return(0);
  prev=0;
 }

 s->textsrc.offset=s->textsrc.loffset;
 vsvec(s);

 return(1);
}


int settosop(vector * s)
{
 return(settosops(s,0));
}

os_error * settosopx(vector * s)
{
 if(!settosop(s)) settosot(s);
 return(NULL);
}


int settospp(vector * s)
{
 return(settosops(s,1));
}


/* set vector to point to start of next para */

int settosnp(vector * s)
{
 vlstr * line;
 int     eolcode;
 int     code;

 while(1)
 {
  if(s->textsrc.voffset>=((s->textsrc.vsourcep)->len)) break;  // changed to prevent access past end of vl buffer
  line=vvlptr(s);
  eolcode=line->line.eol;
  code=nextvline(s);
  if(eolcode==ISNL) return(1);
  if(!code) break;
 }

 return(0); 
}



os_error * settosnpx(vector * s)
{
 if(!settosnp(s)) return(settoeot(s));
 return(NULL);
}




/* set vector to end of para, leave before any LF */

int settoeop(vector * s)
{
 vlstr * line;

 while(1)
 {
  line=vvlptr(s);
  if(line->line.eol==ISNL)
  {
   s->textsrc.offset=s->textsrc.loffset+line->line.len-1;
   return(1);
  }
  if(!nextvline(s))
  {
   s->textsrc.offset=s->textsrc.sourcep->len-1;
   break;
  }
 }

 return(0);
}




/* set vector to start of next word     */

os_error * settosnw(vector * s)
{
 int    c;
	int    cv;
 int    offset;

 do
 {
  c=nextch(s,&cv);
 } while(!isspcetc(cv) && c!=EOT);

 do
 {
  offset=s->textsrc.offset;
  c=nextch(s,&cv);
 } while(isspcetc(cv) && c!=EOT);

 return(resetpoint(s,offset));
}




/* set vector to start of previous word */

os_error * settospw(vector * s)
{
 int c;
	int cv;
 int offset;

 do
 {
  c=prevch(s,&cv);
 } while(!isspcetc(cv)  && c!=-1);  

 do
 {
  c=prevch(s,&cv);
 } while(isspcetc(cv) && c!=-1);

 do
 {
  offset=s->textsrc.offset;
  c=prevch(s,&cv);
 } while(!isspcetc(cv) && c!=-1);

 return(resetpoint(s,offset));
}


os_error * settospwsp(vector * s)
{
 int c;
	int cv;
 int offset;

 do
 {
  c=prevch(s,&cv);
 } while((isspcetc(cv)  || cv=='.' || cv==',') && c!=-1);

 do
 {
  offset=s->textsrc.offset;
  c=prevch(s,&cv);
 } while(!isspcetc(cv) && c!=-1);

 return(resetpoint(s,offset));
}




int midword(vector * s)
{
 int c;
	int cv;
 int pc;
	int pcv;
 int len;
 int offset;

 offset=s->textsrc.offset;
 c=nextchlen(s,&len,&cv);
 pc=prevch(s,&pcv);
 resetpoint(s,offset);

 return(!isspcetc(cv) && !isspcetc(pcv));
}




/* set vector to start of word */

os_error * settosow(vector * s)
{
 int c;
	int cv;
 int pc;
	int pcv;
 int len;
 int offset;

 offset=s->textsrc.offset;
 c=nextchlen(s,&len,&cv);
 pc=prevch(s,&pcv);

 if(!(isspcetc(cv) && !isspcetc(pcv))) resetpoint(s,offset);
                /* if prev char is not white space leave vec one char back */

 if(isspcetc(cv))    /* not in word */
 {                                        /* skip to sow */
  do
  {
   offset=s->textsrc.offset;
   c=nextch(s,&cv);
  } while(isspcetc(cv) && c!=EOT);
 }
 else offset=s->textsrc.offset;

 /* at this point in a word  */

 while(1)
 {
  c=prevch(s,&cv);
  if(isspcetc(cv) || c==-1) break;
  offset=s->textsrc.offset;
 }
 
 return(resetpoint(s,offset));
}



/* set vector to end of word            */

os_error * settoeow(vector * s)
{
 int c;
	int cv;
 int len;
 int offset;

 c=nextchlen(s,&len,&cv);    

 if(isspcetc(cv))    /* not in word */
 {                                        /* skip to sow */
  do
  {
   offset=s->textsrc.offset;
   c=nextch(s,&cv);
  } while(isspcetc(cv) && c!=EOT);
 }
 else offset=s->textsrc.offset;

 while(1)
 {
  c=nextch(s,&cv);
  if(isspcetc(cv) || c==EOT || cv=='.' || cv==',' || cv==';' || cv==':') break;
  offset=s->textsrc.offset;
 }
 
 return(resetpoint(s,offset));
}



/* set vector to end of word, including trailing spaces */

os_error * settoeowx(vector * s)
{
 int offset;
 int      c;
	int      cv;

 settoeow(s);
 do
 {
  offset=s->textsrc.offset;
  c=nextch(s,&cv);
 } while(cv==SPACE || cv==NBSPACE);

 return(resetpoint(s,offset));
}



/* find the shift for a line, produced by vertical justification */

void txgetvshifts(textboxstr * textp,texsub * texup,int * vshiftp,int* vdeltap)
{
 int maxline;
 int vshift;
 int vdelta;
 int valign;

 maxline=texup->vlines;

 vshift=vdelta=0;

 if(maxline)
 {
  valign=textp->data.valign & 0x3;

  if(valign==VBOTTOM)
  {
   vshift=texup->vdelta;
  }
  else
  if(valign==VCENTRE)
  {
   vshift=texup->vdelta/2;
  }
  else
  if(valign==VJUSTIFY && maxline>sizeof(vlstr))
  {
   vdelta=texup->vdelta/((maxline/sizeof(vlstr))-1);
  }
 }

 *vshiftp=vshift;
 *vdeltap=vdelta;
}


int getvshift(vector * v)
{
 int      s;
 int      vshift;
 int      vlmax;
 int      align;
 texsub * texup;
 int      cvoffset;
 int      i;

 align=(v->textsrc.textp->data.valign) & 0x3;

 if(align==VTOP) return(0);
 else
 {
  s=v->textsrc.s;
  texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);
  vshift=texup[s].vdelta;

  if(align==VBOTTOM)
  {
   return(vshift);
  }
  else
  if(align==VCENTRE)
  {
   return(vshift/2);
  }
  else
  if(align==VJUSTIFY)
  {
   vlmax=texup[s].vlines;
   if(vlmax>sizeof(vlstr))
   {
    cvoffset=v->bvoffset;
    for(i=0;i<s;i++)
    {
     cvoffset+=texup[i].vlines;
    }
    return((vshift*(v->textsrc.voffset-cvoffset))/(vlmax-sizeof(vlstr)));
   }
  }
 }
 return(0);
}


#define YLIMIT 0x7FFFFFFF


/* use v->x and v->y to set off                   */
/* assumes x lies within v->vline  assumes loff   */

/* take v->x,y and set offset         */
/* then set x,y to nearest caret posn */


/* the problem here is lines which don't end with space or NL,CR,EOT     */
/* for those we can't put the caret past the last character in the line  */
/* but it would be desirable to mark past the end of the line            */
/* suggestion is to tackle the problem in extendvec() and not here       */

os_error * vsetcaretposn(vector * v)
{
 os_error      * err;
 font_string     fs;
 int             dx;
 int             ddx;
 int             ns;
 int             nc;
 vlstr           vline;
 vlstr           xline;
 int             xl;
 int             xr;
 int             lj;
 int             lmw;
 int             lw;
 int             item;
 int             llen;
 int             tlen;
 int             sl;
 int             s;
 int             vs;
 int             c;
 texsub        * texup;
 int             recalc;
 bulletdatastr   bulletdata;
 int             voffset;
 bulletdatastr * bdata;

 recalc=0;


 getvline(&vline,v->textsrc.vsourcep,v->textsrc.voffset);
 vs=getvshift(v);

 bdata=NULL;

 voffset=v->textsrc.voffset+sizeof(vlstr);

 if(voffset<v->textsrc.vsourcep->len)
 {
  getvline(&xline,v->textsrc.vsourcep,voffset);
  if(xline.line.xl && xline.ext.type==VLBULLET)
  {
   expandbulletdata(&xline,&bulletdata);
   bdata=&bulletdata;
  }
 }

 lj=vline.line.just;
 lmw=MAXWX(vline);
 lw=vline.line.w;
 tlen=llen=vline.line.len;
 xl=xr=0;

 sl=0; /* compiler */

 if(lj==RIGHT)   xl=(lmw-lw);
 else
 if(lj==CENTRE)  xl=(lmw-lw)>>1;
 else
 if(lj==JUSTIFY) xr=(lmw-lw);


/* dprintf(0,"before fx %d",llen); */

 /* can't move this because of use of fnexttolast() below */
 err=fxexpand(v,(vline.line.eol==ISDROP?FXDROP:0)|FXNBSP|(bdata?FXBULLET:0),
                                                                  llen,bdata);

/* dprintf(0,"after fx"); */

 s=v->textsrc.s;
 texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);

                                  /* check if point below last line in box */
 if(v->y>(int)(LY(vline.line.yy)+vline.line.h+vs) &&
    !((v->textsrc.voffset-v->bvoffset)<(texup[s].vlines-(int)sizeof(vlstr))))
 {
  llen=fnexttolast(&item);
  if(vline.line.eol==ISNL || vline.line.eol==ISBREAK) 
                                   v->x=(vline.line.x+xl+xr+vline.line.w);
  else                             recalc=1;
 }
 else
 if(v->x<(int)(vline.line.x+xl)) 
 {
  llen=0;
  item=0;
  v->x=(vline.line.x+xl);
 }
 else
 if(v->x>(int)(vline.line.x+xl+xr+vline.line.w))
 {
  llen=fnexttolast(&item);
  if(vline.line.eol==ISNL || vline.line.eol==ISBREAK) 
                                   v->x=(vline.line.x+xl+xr+vline.line.w);
  else                             recalc=1;
 }
 else
 {
  fs.s=fbuff;
  fs.x=v->x-(vline.line.x+xl);
  fs.y=LY(v->y-vline.line.yy)-vs;
  fs.split=-1;

  if(lj==JUSTIFY)
  {
   sl=striplen(v->textsrc.sourcep,llen,v->textsrc.loffset);
   fxtotals(v,sl,&ns,&nc);

   dx=(lmw-lw);
   fxcalcdxs(dx,ns,nc);

   dx=fxlinedx;
   ddx=fxlineddx;
  }
  else
  {
   dx=ddx=0;
  }

 /* dprintf(0,"fset"); */

  err=fxfsetcaret(&fs,dx,ddx,fxlineakern);

  llen=fequivi(fs.term,&item);

//  cprintf("feq %d fs.term %d",llen,fs.term);

  /* checking if past end of line->set to point to before next to last char */

  if(llen>=(int)vline.line.len || fs.term>=fmaxlen) 
  {
   llen=fnexttolast(&item);
   recalc=1;
  }

  v->x=fs.x+vline.line.x+xl;
 } 


/* dprintf(0,"pt0"); */

 /* setting to correct point in line */

 c=*txptr(v->textsrc.sourcep,v->textsrc.loffset+llen);
 if(c==ACTDATE || c==MACSEQ) recalc=1;

 while(llen>0 && llen<tlen)
 {
  c=*txptr(v->textsrc.sourcep,v->textsrc.loffset+fitem(item-1));
  if(c==SNO) 
  {
   item--;
   llen-=SNLEN;
  }
  else break;
 }

/* dprintf(0,"pt1"); */

 if(llen<0) 
 {
  llen=0;
  recalc=1;
 }

 v->textsrc.offset=v->textsrc.loffset+llen;
 v->y=LY(vline.line.yy)+vs+fmaxld;

 vsvec(v);

/* dprintf(0,"pt2 %d",recalc); */

 if(recalc) vsetxy(v);

 return(err);
}






#define XLIMIT 0x7FFFFFFF



/* set x and y from everything else */

os_error * vsetxy(vector * v)
{
 os_error      * err;
 font_string     fs;
 int             dx;
 int             ns;
 int             nc;
 int             totns;
 int             totnc;
 vlstr           vline;
 vlstr           xline;
 int             xl;
 int             lj;
 int             lmw;
 int             lw;
 int             sl;
 int             loffset;
 int             llen;
 int             vs;
 bulletdatastr   bulletdata;
 int             voffset;
 bulletdatastr * bdata;


 err=NULL;

 if(v->textsrc.voffset<v->textsrc.vsourcep->len) // changed to prevent access past end of vl buffer
 {
 
  getvline(&vline,v->textsrc.vsourcep,v->textsrc.voffset);
  vs=getvshift(v);

  bdata=NULL;

  voffset=v->textsrc.voffset+sizeof(vlstr);

  if(voffset<v->textsrc.vsourcep->len)
  {
   getvline(&xline,v->textsrc.vsourcep,voffset);
   if(xline.line.xl && xline.ext.type==VLBULLET)
   {
    expandbulletdata(&xline,&bulletdata);
    bdata=&bulletdata;
   }
  }

/* dprintf(7,"bdata %d",bdata); */


  lj=vline.line.just;
  lmw=MAXWX(vline);
  lw=vline.line.w;
  llen=vline.line.len;
  xl=0;


/* if(!(v->box)->u.text.lines || 
     (v->loff<v->boff) || (v->loff>(v->boff+(v->box)->u.text.bytes))
   )
   {
    v->x=(v->box)->x;
    v->y=(v->box)->y;
    return;
   }
  */


  if(lj==RIGHT)  xl=(lmw-lw);
  else
  if(lj==CENTRE) xl=(lmw-lw)>>1;

  err=fxexpand(v,(vline.line.eol==ISDROP?FXDROP:0)|FXNBSP|(bdata?FXBULLET:0),
                                                                  llen,bdata);
 
  loffset=v->textsrc.offset-v->textsrc.loffset;

 /* fs.x=lmw; */
  fs.x=XLIMIT;

  if(vline.line.eol==ISSPACE) /* (lj==JUSTIFY) */
  {
   sl=striplen(v->textsrc.sourcep,llen,v->textsrc.loffset);
   if(loffset>sl) fs.term=fequivcode(sl);
   else           fs.term=fequivcode(loffset);
  }
  else
  {
   fs.term=fequivcode(loffset);
   sl=llen; /* used for justified lines */
  }

  fs.split=-1;
  fs.s=fbuff;
  fs.y=vline.line.h;


/* dprintf(1,"fs.x=%d term=%d loff=%d",fs.x,fs.term,loffset); */

/* be careful this call can reset fs.term if doesn't fit in width */

/* with word/letter spacing, line width will be greater than lmw */
/* because no -'ve spacing on spaces                             */

  if(!fs.term)  fs.x=0;
  else
  {
   fxstrwidth(&fs,0,0,fxlineakern);
  }

/* dprintf(2,"fs.x=%d term=%d loff=%d",fs.x,fs.term,loffset);  */

  v->x=fs.x+vline.line.x+xl;
  v->y=LY(vline.line.yy)+vs+fmaxld;

  if(lj==JUSTIFY)
  {
   if(loffset>sl) fxtotals(v,sl,&ns,&nc);
   else           fxtotals(v,loffset,&ns,&nc);

   fxtotals(v,sl,&totns,&totnc);

 /* aleady not counting space at end of line        */
 /* if((EOLCHAR(line)==ISSPACE) && totns) totns--;  */

   dx=lmw-lw;

   fxcalcdxs(dx,totns,totnc);

//  cprintf("adjust %d",fxlinedx*ns);

   v->x+=fxlinedx*ns+fxlineddx*nc; /* == ns*(dx+ddx)+(nc-ns)*ddx */
  }
 }

 return(err);
}






os_error * setvectorfrombox(vector * v,int u,int textk,filestr * file)
{
 os_error   * err;
 textboxstr * textp;
 texsrc     * texsp;
 vlstr      * vline;
 int          voffset;
 char       * p;


 textp=(textboxstr*)fob_find(textk,file);

 v->valid=VALIDPOSN;
 v->textsrc.text=textk;
 v->file=file;
 pagesectionof((chainobject *)textp,file,&v->page,&v->section);

 v->textsrc.columns=textp->data.columns;

 v->textsrc.u=u;
 if(textp->data.header || textp->data.footer) 
 {
  v->textsrc.usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
  if(u==0) v->textsrc.usize+=2*sizeof(texsub);
  else
  {
   if(u==2) v->textsrc.usize+=sizeof(texsub);
   v->textsrc.columns=1;
  }
 }
 else v->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 texsp+=u;

 v->boffset=0;
 v->bvoffset=0;

 v->textsrc.s=0;
 v->textsrc.source=texsp->source;
 v->textsrc.vsource=texsp->vsource;

 textp=(textboxstr*)fob_find(textk,file);
 if(u==0) settextoffset(file,textp,&v->textsrc.voffset,&v->textsrc.offset);
 else
 {
  v->textsrc.voffset=v->textsrc.offset=0;
 }

 v->boffset=v->textsrc.loffset=v->textsrc.offset;
 v->bvoffset=v->textsrc.voffset;

 err=txlock(&v->textsrc,file);
 if(!err)
 {
  vsvec(v);

  voffset=v->textsrc.voffset;
  if(voffset>=(v->textsrc.vsourcep)->len && voffset>0) voffset=(v->textsrc.vsourcep)->len-sizeof(vlstr);

  if(voffset)
  {
   vline=vlptr(v->textsrc.vsourcep,voffset);
   v->astyle=vline->line.style;
  }
  else
  {
   p=txptr(v->textsrc.sourcep,0);
   v->astyle=p[1]+(p[2]<<8)+(p[3]<<16);
  }

  v->valid|=(v->textsrc.voffset<(v->textsrc.vsourcep)->len)?VALIDOFFSET:0;

  txunlock(&v->textsrc,file);
 }

 return(NULL);
}



os_error * setpagevectorfrombox(vector * v,int textk,filestr * file)
{
 textboxstr * textp;
 texsrc     * texsp;

 textp=(textboxstr*)fob_find(textk,file);

 v->file=file;
 pagesectionof((chainobject *)textp,file,&v->page,&v->section);

 v->textsrc.u=0;
 if(textp->data.header || textp->data.footer) 
 v->textsrc.usize=
         sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr)+2*sizeof(texsub);
 else 
 v->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);

 v->textsrc.columns=textp->data.columns;

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 v->boffset=0;
 v->bvoffset=0;

 v->textsrc.s=0;
 v->textsrc.source=texsp->source;
 v->textsrc.vsource=texsp->vsource;

 v->textsrc.text=textk;

 v->valid=VVECTOR;

 return(NULL);
}



os_error *  vvisible(vector * s,int * visible)
{
 viewredrawstr   v;
 viewstr       * view;

 initviewredraw(&v);

 *visible=0;

 v.file=s->file;
 view=(v.file)->view;

 while(view)
 {
  v.view=view;
  if(view->handle && (*visible=setcoords(&v,s->page))!=0) break;
  view=view->next;
 }

 return(NULL);
}


// similar code in stringtomacro()

os_error * vgetword(vector * s,char * string,int maxlen)
{
 os_error * err;
 vector     s1;
 vector     s2;
 int        offset;
 int        c;
 int        bits;
 char     * lt;
 char     * p;


	lt=string+maxlen;

 s1=*s;
 err=txlock(&s1.textsrc,s->file);
 if(!err)
 {
  settosow(&s1);
  s2=s1;
  settoeow(&s1);
  offset=s2.textsrc.offset;
 

  while(offset<s1.textsrc.offset)
  {
   p=(txptr(s1.textsrc.sourcep,offset));
			c=*p;
   bits=codex[c];
   offset+=(bits & CODELEN);

			if(c==UNC16) c=(*(p+1))|((*(p+2))<<8);

			cprintf("string %x code %d",string,c);

   if(c>=32)
   {
    expandcode(c,&string,lt);
   }
  }
  err=txunlock(&s1.textsrc,s->file);
 }

 *string=0;

 return(err);
}







/*

void debvec(vector * v)
{
 dprintf(0,"file=%x section=%d page=%d boffset=%d bvoffset=%d astyle=%d",
      v->file,
      v->section,
      v->page,
      v->boffset,
      v->bvoffset,
      v->astyle);

 dprintf(0,"valid=%d x=%d y=%d",v->valid,v->x,v->y);

 dprintf(0,"source=%d sourcep=%x vsource=%d vsourcep=%x",
                        v->textsrc.source,v->textsrc.sourcep,
                        v->textsrc.vsource,v->textsrc.vsourcep);

 dprintf(0,"offset=%d voffset=%d loffset=%d",
                 v->textsrc.offset,v->textsrc.voffset,v->textsrc.loffset);

 dprintf(0,"text=%d s=%d u=%d usize=%d cols=%d textp=%x",
             v->textsrc.text,v->textsrc.s,v->textsrc.u,
             v->textsrc.usize,v->textsrc.columns,v->textsrc.textp);
}

*/

