/*->c.appletrun */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"

#include "flex.h"

#include "err.h"
#include "trans.h"
#include "temp.h"
#include "sp.h"
#include "wos.h"
#include "poll.h"
#include "alloc.h"
#include "bits.h"
#include "etc.h"
#include "fsx.h"
#include "scanplus.h"
#include "xhelp.h"
#include "oserr.h"
#include "deb.h"

#include "xext.h"


#include "applet.h"



static os_error * arunscript(char * string,ascaninstance instance,char * leaf,int remove)
{
 os_error    * err;
 HANDLE        hDialog=NULL; 
 HRSRC         hRsrc;
 unsigned int  length=0;
 char        * q=NULL;
 int           result;

// cprintf("arunscript %s",leaf);

 err=XFindResource((HINSTANCE)instance,leaf,"CScript",&hRsrc);
 if(err)
 {
  err=NULL;   // might be no file
 }
 else
 {


           err=XLoadResource((HINSTANCE)instance,hRsrc,(HGLOBAL*)&hDialog);
  if(!err) err=XLockResource(hDialog,(LPVOID*)&q);
  if(!err) err=XSizeofResource((HINSTANCE)instance,hRsrc,&length);

//  cprintf("xaddfile length %d",length);

  xaddfile(leaf,q,length,0,1+(remove?2:0)+(3<<4),&result,0,0);

 }

 return(err);

 USE(string);
}



static os_error * aruni(char * string,ascaninstance instance,int index)
{
 os_error * err;
 
          err=arunscript(string,instance,"Library.csc",0);
 if(!err) err=arunscript(string,instance,"AutoRun.csc",1);

 return(err);

 USE(index);
}




/* called by main program just before poll() loop */

os_error * appletrun(void)
{
 os_error * err;
 fxstat     f;
 int        eof;
 char       string0[MAX_PATH];
 char       string1[MAX_PATH];
 int        len;
 int        scan;



 err=NULL;

 if(appsbasepath!=NULL)
 {
//  err=fs_startsortscan(p,"*.*",0,&scan);
  appletscanstart(&scan);
  if(!err)
  {
   while(1)
   {
//    err=fs_nextsortitem(scan,&f,&eof);
//    if(err) break;
    appletscannext(&scan,&f,&eof);
    if(eof) break;

//   fs_savescan(&dirposn);

    if(f.f.object>1)
    {
     len=strlen(f.name);
     if(len)
     {
      xsprintf(NITEM(string0),NULL,string0,"%s\\%s\\Library",appsbasepath,f.name);
      if(appspath) xsprintf(NITEM(string1),NULL,string1,"%s\\%s\\Library",appspath,f.name);
//      addfiles(string,0);     /* do library */
      adddoublefiles(string0,appspath?string1:NULL,0);

      xsprintf(NITEM(string0),NULL,string0,"%s\\%s\\AutoRun",appsbasepath,f.name);
      if(appspath) xsprintf(NITEM(string1),NULL,string1,"%s\\%s\\AutoRun",appspath,f.name);
//      addfiles(string,1);     /* auto run */ 
      adddoublefiles(string0,appspath?string1:NULL,0);
     }
    }
    else
    {
    }

//   fs_loadscan(dirposn);
   }

//   fs_endsortscan(&scan);
  }
 }

 if(!err)
 {
  err=appletscaninstance(aruni);
 }

 return(err);
}





os_error * appletscan(ascanfn ascan)
{
 os_error * err;
 fxstat     f;
 int        eof;
 char       string[MAX_PATH];
 int        len;
 char     * p;
 int        scan;

 err=NULL;

 if((p=appsbasepath)!=NULL)
 {
  appletscanstart(&scan);
//  err=fs_startsortscan(p,"*.*",0,&scan);
  if(!err)
  {
   while(1)
   {
    appletscannext(&scan,&f,&eof);
//    err=fs_nextsortitem(scan,&f,&eof);
//    if(err) break;
    if(eof) break;

    if(f.f.object>1)
    {
     len=strlen(f.name);
     if(len)
     {
      xsprintf(NITEM(string),NULL,string,"%s\\%s\\AResources",p,f.name);
      fs_stat(string,&f.f);
      if(f.f.object)
      {
       err=ascan(string);
      }
     }
    }
    if(err) break;
   }
// fs_endsortscan(&scan);
  }
 }

 return(err);
}




static os_error * asprites(char * string)
{
 return(addspritesx(string,TEXT("Sprites.spr")));
}


static os_error * aspritesi(char * string,ascaninstance instance,int index)
{
 if(!appletseensprites(index))
 {
  return(addspritesx2(NULL,"Sprites.spr",instance));
 }

 return(NULL);
 USE(string);
}


os_error * appletsprites(void)
{
 os_error * err;

          err=appletscan(asprites);
 if(!err) err=appletscaninstance(aspritesi);
 return(err);
}



static os_error * atemps(char * string,ascaninstance instance,int index)
{
 os_error * err;

 if(!appletseentemplates(index))
 {
  err=addtemplates2(NULL,NULL,NULL,NULL,instance);
  if(err && err->errnum==ETEMPF) return(NULL);
  else                           return(err);
 }

 return(NULL);
 USE(string);
}


os_error * applettemplates(void)
{
 return(appletscaninstance(atemps));
 return(NULL);
}


static os_error * amess(char * string)
{
 os_error * err;
 err=addtranstable(string,TEXT("Messages.txt"));
 if(err && (err->errnum==ENOTF || err->errnum==ENOTFOUND)) return(NULL);
 else                                                      return(err);
}


static os_error * amessi(char * string,ascaninstance instance,int index)
{
 os_error * err;

 err=NULL;

 if(!appletseenmessages(index))
 {
  err=addtranstable2(string,"Messages.txt",instance);
 }

 return(err);
}



os_error * appletmessages(void)
{
 os_error * err;

          err=appletscan(amess);
 if(!err) err=appletscaninstance(amessi);
 return(err);
}


static os_error * ahelp(char * string)
{
 os_error * err;
 err=addhelp(string,TEXT("Help.txt"));
 if(err && (err->errnum==ENOTF || err->errnum==ENOTFOUND)) return(NULL);
 else                                                      return(err);
}


static os_error * ahelpi(char * string,ascaninstance instance,int index)
{
 os_error * err;

 err=NULL;

 if(!appletseenhelp(index))
 {
  err=addhelp2(string,"Help.txt",instance);
 }

 return(err);
}



os_error * applethelp(void)
{
 os_error * err;

          err=appletscan(ahelp);
 if(!err) err=appletscaninstance(ahelpi);
 return(err);
}


