/ *->c.bbc */

#include <stdafx.h>


#include <stdio.h>
#include <stdarg.h>



#include "os.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "bbc.h"
#include "wimp.h"

#include "osglue.h"
#include "osgraphics.h"
#include "ossprite.h"
#include "osunits.h"
#include "oserr.h"
#include "etc.h"
#include "wos.h"
#include "xmath.h"
#include "deb.h"
#include "colour.h"




#define MAXPLOTPTS 4

static int plotindex;

static int xpts[MAXPLOTPTS];
static int ypts[MAXPLOTPTS];



os_error * bbc_setstyle(int style)
{
 return(graphicscreatepen2(PS_DOT,0,currentcolour,currenthdcptr));
}



os_error * bbc_endpath(void)
{
 EndPath(currenthdcptr->hdc);
 return(NULL);
}


os_error * bbc_startpath(void)
{
 BeginPath(currenthdcptr->hdc);
 return(NULL);
}


os_error * bbc_closefigure(void)
{
 CloseFigure(currenthdcptr->hdc);
 return(NULL);
}


os_error * bbc_setpolyfillmode(int alternate)
{
 SetPolyFillMode(currenthdcptr->hdc,alternate?ALTERNATE:WINDING);
 return(NULL);
}




os_error * bbc_strokefillpath(void)
{
 StrokeAndFillPath(currenthdcptr->hdc);
 return(NULL);
}


os_error * bbc_polybezierto(int x0,int y0,int x1,int y1,int x2,int y2)
{
 POINT pts[3];

 pts[0].x=GRXPIX(x0);
 pts[0].y=GRYPIX(y0);
 pts[1].x=GRXPIX(x1);
 pts[1].y=GRYPIX(y1);
 pts[2].x=GRXPIX(x2);
 pts[2].y=GRYPIX(y2);

 PolyBezierTo(currenthdcptr->hdc,pts,3); 
 return(NULL);
}



os_error *bbc_move(int x, int y)
{
 plotindex++;
 if(plotindex>=MAXPLOTPTS) plotindex=0;

 x=GRXPIX(x);
 y=GRYPIX(y);
 
 xpts[plotindex]=x;
 ypts[plotindex]=y;

 MoveToEx(currenthdcptr->hdc,x,y,NULL);
 return(NULL);
}


os_error *bbc_draw(int x, int y)
{
 plotindex++;
 if(plotindex>=MAXPLOTPTS) plotindex=0;

 x=GRXPIX(x);
 y=GRYPIX(y);

 xpts[plotindex]=x;
 ypts[plotindex]=y;

 LineTo(currenthdcptr->hdc,x,y);
 SetPixel(currenthdcptr->hdc,x,y,currentcolour);

 return(NULL);
}



os_error * bbc_getposition(int * x,int * y)
{
 POINT pt;

 GetCurrentPositionEx(currenthdcptr->hdc,&pt);

 *x=pt.x;
 *y=pt.y;

 return(NULL);
}


// FillRect does not follow the SetROP2 setting (eor'ing), so use Rectangle
// guaranteed to fill pixels x to x+w i.e. w+1 pixels






os_error *bbc_rectanglefill(int x,int y,int w,int h)
{
// RECT rect;
 int xl;
 int xr;
 int yt;
 int yb;

 yt=GRYPIX((y+h));
 yb=GRYPIX(y);
 if(yt>yb) SWOP(yt,yb);
 xl=GRXPIX(x);
 xr=GRXPIX((x+w));
 if(xl>xr) SWOP(xl,xr);


 Rectangle(currenthdcptr->hdc,xl,yt-1,xr+1,yb);

// rect.left=x;
// rect.top=(y+h);
// rect.right=x+w;
// rect.bottom=y;

// cprintf("fill hdc %x brush %x",currenthdcptr->hdc,currenthdcptr->currentbrush);

// FillRect(currenthdcptr->hdc,&rect,currenthdcptr->currentbrush);        // cf Rectangle function

 return(NULL);
}




os_error *bbc_rectanglefilli(int x,int y,int w,int h)
{
 int xl;
 int xr;
 int yt;
 int yb;

 yt=GRYPIX((y+h));
 yb=GRYPIX(y);
 if(yt>yb) SWOP(yt,yb);
 xl=GRXPIX(x);
 xr=GRXPIX((x+w));
 if(xl>xr) SWOP(xl,xr);


 Rectangle(currenthdcptr->hdc,xl,yt,xr,yb);

 return(NULL);
}




os_error *bbc_rectanglei(int x,int y,int w,int h)
{
 int xl;
 int xr;
 int yt;
 int yb;
 HBRUSH oldbrush;

 yt=GRYPIX((y+h));
 yb=GRYPIX(y);
 if(yt>yb) SWOP(yt,yb);
 xl=GRXPIX(x);
 xr=GRXPIX((x+w));
 if(xl>xr) SWOP(xl,xr);

 oldbrush=(HBRUSH)SelectObject(currenthdcptr->hdc,GetStockObject(NULL_BRUSH));

 Rectangle(currenthdcptr->hdc,xl,yt,xr,yb);

 SelectObject(currenthdcptr->hdc,oldbrush);


 return(NULL);
}





os_error *bbc_rectangle(int x, int y, int w, int h)
{
// POINT pt[5];

 MoveToEx(currenthdcptr->hdc,GRXPIX(x),GRYPIX(y),NULL);
 LineTo(currenthdcptr->hdc,GRXPIX(x+w),GRYPIX(y));
 LineTo(currenthdcptr->hdc,GRXPIX(x+w),GRYPIX(y+h));
 LineTo(currenthdcptr->hdc,GRXPIX(x),GRYPIX(y+h));
 LineTo(currenthdcptr->hdc,GRXPIX(x),GRYPIX(y));
 return(NULL);

// on NT4 (at least) the code below does not cover the same pixels
// e.g. create a rect frame drag with scrolling

#ifdef NEVER

 pt[0].x=x;
 pt[0].y=y;
 pt[1].x=x+w;
 pt[1].y=y;
 pt[2].x=x+w;
 pt[2].y=y+h;
 pt[3].x=x;
 pt[3].y=y+h;
 pt[4]=pt[0];

 Polyline(currenthdcptr->hdc,pt,5);

 return(NULL);

#endif
}



os_error * bbc_gflush(void)
{
 GdiFlush();
 return(NULL);
}


// there is a problem with eor mode if a pen is used to outline
// a filled area - pen pixels take out some of the fill


static os_error * bbc_polygon2(HDC hdc,POINT * pt,int n)
{
 HPEN oldpen;
 HPEN pen;

 pen=CreatePen(PS_NULL,0,0);
 oldpen=(HPEN)SelectObject(hdc,pen);

 Polygon(hdc,pt,n);

 SelectObject(hdc,oldpen);

 DeleteObject(pen);

 return(NULL);
}


static os_error * bbc_pie2(HDC hdc,int nLeftRect,   // x-coord of upper-left corner of rectangle
                                   int nTopRect,    // y-coord of upper-left corner of rectangle
                                   int nRightRect,  // x-coord of lower-right corner of rectangle
                                   int nBottomRect, // y-coord of lower-right corner of rectangle
                                   int nXRadial1,   // x-coord of first radial's endpoint
                                   int nYRadial1,   // y-coord of first radial's endpoint
                                   int nXRadial2,   // x-coord of second radial's endpoint
                                   int nYRadial2    // y-coord of second radial's endpoint
                           )

{
 HPEN oldpen;
 HPEN pen;

 pen=CreatePen(PS_NULL,0,0);
 oldpen=(HPEN)SelectObject(hdc,pen);

 Pie(currenthdcptr->hdc,nLeftRect,nTopRect,nRightRect,nBottomRect,nXRadial1,nYRadial1,nXRadial2,nYRadial2);

 SelectObject(hdc,oldpen);

 DeleteObject(pen);

 return(NULL);
}







#ifdef NEVER





/* Within each block of eight the offset from the base number has the 
   following meaning : */

#define  bbc_MoveCursorRel   0
#define  bbc_DrawRelFore     1
#define  bbc_DrawRelInverse  2
#define  bbc_DrawRelBack     3
#define  bbc_MoveCursorAbs   4
#define  bbc_DrawAbsFore     5
#define  bbc_DrawAbsInverse  6
#define  bbc_DrawAbsBack     7


/* The above applies except for bbc_Block where the codes are as follows : */

#define  bbc_BMoveRel        0
#define  bbc_BMoveRectRel    1
#define  bbc_BCopyRectRel    2
 
#define  bbc_BMoveAbs        4
#define  bbc_BMoveRectAbs    5
#define  bbc_BCopyRectAbs    6

#endif




os_error *bbc_plot(int n, int x, int y)
{
 POINT pt[5];
 int   pindex;
 int   r;
 int   xr;
 int   yr;
	int   mode;
	int   draw;


 x=GRXPIX(x);
 y=GRYPIX(y);

	mode=(n & 0x7);


	if(mode==bbc_MoveCursorRel  || mode==bbc_DrawRelFore ||
    mode==bbc_DrawRelInverse || mode==bbc_DrawRelBack)
	{
		x+=xpts[plotindex];
 	y+=ypts[plotindex];
	}


	if(mode==bbc_DrawRelFore    || mode==bbc_DrawRelInverse || 
    mode==bbc_DrawRelBack    || mode==bbc_DrawAbsFore    ||
    mode==bbc_DrawAbsInverse ||	mode==bbc_DrawAbsBack)
	{
		draw=1;
	}
	else
	{
		draw=0;
	}

	if(draw)
	{
  switch(n & ~0x7)
  {
   case         bbc_Point:
                          SetPixel(currenthdcptr->hdc,x,y,currentcolour);
                          break;
 
   case bbc_RectangleFill:      // 96
                          Rectangle(currenthdcptr->hdc,x,y,xpts[plotindex],ypts[plotindex]);
                        //  bbc_rectanglefill(x,y,xpts[plotindex]-x,ypts[plotindex]-y);
                          break;

    case bbc_ParallelFill:      // 112
                          pindex=plotindex-1;
                          if(pindex<0) pindex=MAXPLOTPTS-1;
                          pt[0].x=xpts[pindex];
                          pt[0].y=ypts[pindex];
                          pt[1].x=xpts[plotindex];
                          pt[1].y=ypts[plotindex];
                          pt[2].x=x;
                          pt[2].y=y;
                          xr=pt[0].x-pt[1].x;
                          yr=pt[0].y-pt[1].y;
                          pt[3].x=pt[2].x+xr;
                          pt[3].y=pt[2].y+yr;
                          bbc_polygon2(currenthdcptr->hdc,pt,4);
                          break;

   case  bbc_TriangleFill:    // 80
                          pindex=plotindex-1;
                          if(pindex<0) pindex=MAXPLOTPTS-1;
                          pt[0].x=xpts[pindex];
                          pt[0].y=ypts[pindex];
                          pt[1].x=xpts[plotindex];
                          pt[1].y=ypts[plotindex];
                          pt[2].x=x;
                          pt[2].y=y;
                          bbc_polygon2(currenthdcptr->hdc,pt,3);
                          break;
 
  case         bbc_Circle:      // 144
                          // previous point is centre
                          r=pythag(x-xpts[plotindex],y-ypts[plotindex]);
                          Arc(currenthdcptr->hdc,xpts[plotindex]-r,ypts[plotindex]-r,
                                         xpts[plotindex]+r,ypts[plotindex]+r,
                                         xpts[plotindex]-r,ypts[plotindex],
                                         xpts[plotindex]-r,ypts[plotindex]);

                          break; 

  case         bbc_Sector:     // 176      -1 center, pt, pt
                          pindex=plotindex-1;
                          if(pindex<0) pindex=MAXPLOTPTS-1;
                          r=pythag(x-xpts[pindex],y-ypts[pindex]);
                          bbc_pie2(currenthdcptr->hdc,xpts[pindex]-r,ypts[pindex]-r,
                                         xpts[pindex]+r,ypts[pindex]+r,
                                         xpts[plotindex],ypts[plotindex],
                                         x,y);
                          break;
 
    case    bbc_SolidExFinal:      // 8
                             LineTo(currenthdcptr->hdc,x,y);
                             break;


    case      bbc_DottedBoth:      // 16+5
                             LineTo(currenthdcptr->hdc,x,y);
                             break;


 case    bbc_SolidBoth:
  case  bbc_DottedExFinal:
  case  bbc_SolidExInit:
  case  bbc_SolidExBoth:
  case bbc_DottedExInit:
  case  bbc_DottedExBoth:
                             LineTo(currenthdcptr->hdc,x,y);
                             break;




    case         bbc_Ellipse:      // 192
                             pindex=plotindex-1;
                             if(pindex<0) pindex=MAXPLOTPTS-1;
                             xr=xpts[plotindex]-xpts[pindex];
                             yr=y-ypts[pindex];
                             Arc(currenthdcptr->hdc,xpts[pindex]-xr,ypts[pindex]+yr,
                                            xpts[pindex]+xr,ypts[pindex]-yr,
                                            xpts[pindex]-xr,ypts[pindex],
                                            xpts[pindex]-xr,ypts[pindex]);
                             break;

    case     bbc_EllipseFill:     // 200

                             break;


 

  case bbc_HorizLineFillNB:
  case bbc_HorizLineFillB:

  case bbc_HorizLineFillF:
  case  bbc_HorizLineFillNF:
  case  bbc_FloodToBack:
  case  bbc_FloodToFore:

  case  bbc_CircleFill:
  case  bbc_CircleArc:
  case   bbc_Segment:
  case bbc_Block:
  case  bbc_GraphicsChar:
  case bbc_SpritePlot:
   break;
 
  }
	}

 plotindex++;
 if(plotindex>=MAXPLOTPTS) plotindex=0;
 xpts[plotindex]=x;
 ypts[plotindex]=y;

 return(NULL);
}




/* Set up graphics window. 
 *     BottomLeftX, BottomLeftY,
 *     TopRightX, TopRightY.  */


os_error * bbc_gwindow(int x0,int y0,int x1,int y1)
{
	os_error * err;
	int        code;

/*
 err=NULL;

 bbc_startpath();

 bbc_move(x0,y0);
 bbc_draw(x0,y1);
 bbc_draw(x1,y1);
 bbc_draw(x1,y0);

 bbc_closefigure();

 bbc_endpath();


 bbc_gclip(0);
*/

// cprintf("gwin os x0 %d x1 %d",x0,x1);
// cprintf("gwin px x0 %d x1 %d",GRXPIX(x0),GRXPIX(x1));

 err=XIntersectClipRect(currenthdcptr->hdc,GRXPIX(x0),GRYPIX(y1),GRXPIX(x1),GRYPIX(y0),&code);

 return(err);
}



os_error * bbc_gwindowdr(int x0,int y0,int x1,int y1)
{
	os_error * err;
	int        code;

 err=XIntersectClipRect(currenthdcptr->hdc,GRDXPIX(x0),GRDYPIX(y1),GRDXPIX(x1),GRDYPIX(y0),&code);

 return(err);
}




os_error * bbc_gwinrectdr(int x0,int y0,int x1,int y1,int * visible)
{
 RECT currbox;
 
 currbox.left=GRDXPIX(x0);
 currbox.right=GRDXPIX(x1);
 currbox.top=GRDYPIX(y1);
 currbox.bottom=GRDYPIX(y0);

 *visible=RectVisible(currenthdcptr->hdc,&currbox);

 return(NULL);
}




os_error * bbc_clipwindow(int * x0,int * y0,int * x1,int * y1,int * area)
{
 int  code;
 RECT clipbox;

 code=GetClipBox(currenthdcptr->hdc,&clipbox);

 if(area) *area=code;
 if(x0)   *x0=GRINVXPIX(clipbox.left);
 if(x1)   *x1=GRINVXPIX(clipbox.right);
 if(y0)   *y0=GRINVYPIX(clipbox.bottom);
 if(y1)   *y1=GRINVYPIX(clipbox.top);

 return(NULL);
}




os_error * bbc_gwindowrelease(void)
{
	os_error * err;
 int        x0;
 int        x1;
 int        y0;
 int        y1;
 int        code;

	err=NULL;

 SelectClipRgn(currenthdcptr->hdc,NULL);

 if(currenthdcptr->flags & WRHDCUPDATE)
 {
  x0=currenthdcptr->x0;
  x1=currenthdcptr->x1;
  y0=currenthdcptr->y0;
  y1=currenthdcptr->y1;
//  grpix2osr(&x0,&y0);
//  grpix2osr(&x1,&y1);

  err=XIntersectClipRect(currenthdcptr->hdc,x0,y1,x1,y0,&code);
 }

 return(NULL);
}


os_error * bbc_gclip(int cmode)
{
 if(cmode==CLIP_AND)  cmode=RGN_AND;
 else
 if(cmode==CLIP_DIFF) cmode=RGN_DIFF;
 else
 if(cmode==CLIP_COPY) cmode=RGN_COPY;
 else
 if(cmode==CLIP_OR)   cmode=RGN_OR;
 else
 if(cmode==CLIP_XOR)  cmode=RGN_XOR;
 
 return(XSelectClipPath(currenthdcptr->hdc,cmode));
}




os_error * bbc_saveclippath(void ** handle)
{
 HRGN clipregn;

	clipregn=NULL;

 clipregn=CreateRectRgn(0,0,1,1);
 if(GetClipRgn(currenthdcptr->hdc,clipregn)!=1)
 {
  DeleteObject(clipregn);
  clipregn=NULL;
 }


 *handle=(void*)clipregn;

 return(NULL);
}




os_error * bbc_loadclippath(void * handle)
{
 HRGN clipregn;


 clipregn=(HRGN)handle;

 SelectClipRgn(currenthdcptr->hdc,clipregn); 

 if(clipregn)
 {
  DeleteObject(clipregn);
 }


 return(NULL);
}



os_error * bbc_beep(int freq,int duration)
{

 if(freq==-1)
 {
  MessageBeep(duration);

 }
 if(freq==0 && duration==0)
 {
  MessageBeep(MB_OK);
 }
 else
 {
  if(freq==0) freq=400;
  if(duration==0) duration=300;

  Beep(freq,duration);
 }

 return(NULL);
}


os_error * bbc_vdu(int c)
{

 if(c==7) bbc_beep(0,0);


 return(NULL);
}




os_error *bbc_gcol(int pal,int action)
{
 return(setgcolaction(pal,action));
}



/*

Dx = ((Lx - WOx) * VEx / WEx) + VOx 
The following variables are involved.

Dx     x value in device units 
Lx     x value in logical units (also known as page space units) 
WOx     window x origin 
VOx     viewport x origin 
WEx     window x-extent 
VEx     viewport x-extent 

*/



os_error * bbc_scale(int xold,int xnew,int yold,int ynew,int ox,int oy,int nx,int ny)
{
 os_error * err;

          err=XSetMapMode(currenthdcptr->hdc,MM_ANISOTROPIC,NULL);
 if(!err) err=XSetWindowExtEx(currenthdcptr->hdc,xold,yold,NULL); 
 if(!err) err=XSetViewportExtEx(currenthdcptr->hdc,xnew,ynew,NULL); 
	if(!err) err=XSetWindowOrgEx(currenthdcptr->hdc,ox,oy,NULL);
 if(!err) err=XSetViewportOrgEx(currenthdcptr->hdc,nx,ny,NULL);

 return(err);
}



