/*->c.fsx2 */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>


#include "os.h"
#include "oserr.h"

#include "deb.h"

#include "err.h"
#include "bits.h"
#include "filetype.h"

#include "fsx.h"




/* takes a filename, and a path                                  */
/* returns a new filename, which lives down the path, but is new */

os_error * makefilename(TCHAR * oldleaf,TCHAR * newpathname,TCHAR * path,int over)
{
 os_error * err;
 int        i;
 int        j;
 int        lentemp;
 TCHAR   *  p;
 TCHAR      newleaf[FSMAXLEAF];
 TCHAR      temp[16];
 int        object;

 err=NULL;

 strncpy(newleaf,oldleaf,FSMAXLEAF-1);
 newleaf[FSMAXLEAF-1]=0;

 j=0;
 for(i=0;i<(int)ustrlen(newleaf);i++)
 {

  switch(newleaf[i])
  {
    case '/':
             newleaf[j]='.';
             break;

    case ' ':
             newleaf[j]=' ';
             break;

    case '#':
             newleaf[j]='?';
             break;

    case '&':
             newleaf[j]='+';
             break;

    case '@':
             newleaf[j]='=';
             break;

    case '%':
             newleaf[j]=';';
             break;

    case '$':
             newleaf[j]='<';
             break;

    case '^':
             newleaf[j]='>';
             break;


    case '"':
    case '*':
    case ',':
    case ':':
    case'\\':
    case '|':
    case 127:
             newleaf[j]='X';
             break;

     default:
             newleaf[j]=newleaf[i];
             break;
  }
  j++;
 }

 if(strlen(newleaf)==0) ustrcpy(newleaf,TEXT("DEFAULT"));

 ustrcpy(newpathname,path);
 if(*newpathname) ustrcat(newpathname,TEXT("\\"));
 p=newpathname+strlen(newpathname);
 *temp=0;

 for(i=0;i<1000;i++)
 {
  lentemp=ustrlen(temp);
  ustrcpy(p,temp);
  ustrcpy(p+lentemp,newleaf);
  err=fs_exists(newpathname,&object);
  if(err || !object || over) break;
  xsprintf(sizeof(temp)/sizeof(TCHAR),NULL,temp,TEXT("%02d"),i);
 }

 return(err);
}




// directory controls if the last element in the path is
// to be created

static os_error * fs_validatepath2(TCHAR * to,int directory)
{
 os_error * err;
 TCHAR    * p;
 TCHAR    * q;
 int        type;
 int        lasttype=0;

 err=NULL;

 p=q=to+strlen(to);

 if(directory)
 {
  fs_exists(to,&lasttype);
 }

// cprintf("to %s dir %d last %d",to,directory,lasttype);

 if(!lasttype)
 {

  while(--p>to)
  {
   if(*p=='\\')
   {
    *p=0;
    fs_exists(to,&type);
    *p='\\';
    if(type) break;
   }
  }

  while(++p<q)
  {
   if(*p=='\\')
   {
    *p=0;
    err=fs_cdir(to);
    if(err) break;
    *p='\\';
   }
  }

  if(!err)
  {
   if(directory)
   {
//    cprintf("cdir %s",to);
    err=fs_cdir(to);
   }
  }
 }
 return(err);
}



os_error * fs_validatepath(TCHAR * name,int directory)
{
 os_error * err;
 TCHAR      xname[MAX_PATH];

          err=fs_expandpath(name,xname,sizeof(xname)/sizeof(TCHAR));
          cprintf("expand %s",xname);
 if(!err) err=fs_validatepath2(xname,directory);

 return(err);
}








os_error * fs_copyfile(TCHAR * from,TCHAR * to)
{
 return(XCopyFile(from,to,0));
}



static os_error * fs_copyobjects(TCHAR * from,TCHAR * to,int flags,TCHAR * spare1,TCHAR * spare2)
{
 os_error   * err;
 fxstat       f;
 fsscanhandle savescan;
 int          eof;
 TCHAR      * fs;
 TCHAR      * ts;

 err=NULL;

 fs_stat(from,&f.f);

 if(f.f.object==2)
 {
  fs_stat(to,&f.f);
  if(f.f.object==0) err=fs_cdir(to);
  if(!err)
  {
   fs_savescan(&savescan);
   fs_startscan();
   while(1)
   {
    err=fs_nextitem(from,&f,TEXT("*.*"),&eof);
    if(err) break;
    if(eof) break;

    fs=from+strlen(from);
    ts=to+strlen(to);
    strcpy(fs,"\\");
    strcpy(fs+1,f.name);
    strcpy(ts,"\\");
    strcpy(ts+1,f.name);

    err=fs_copyobjects(from,to,flags,spare1,spare2);
    if(err) break;

    *fs=0;
    *ts=0;
   }
   fs_endscan();
   fs_loadscan(savescan);
   if(!err)
   {
    if(flags & FS_MOVE) err=fs_delete(from);
   }
  }
 }
 else
 if(f.f.object==1)
 {
  err=XCopyFile(from,to,0);
  if(!err)
  {
   if(flags & FS_MOVE) err=fs_delete(from);
  }
 }
 else
 {
  err=geterrorf(ENOTFOUND,from);
 }

 return(err);
}



os_error * fs_copyobject(TCHAR * from,TCHAR * to,int flags,TCHAR * spare1,TCHAR * spare2)
{
 os_error * err;
 TCHAR ft[MAX_PATH];
 TCHAR tt[MAX_PATH];

 if(flags & FS_MOVE)
 {
  err=fs_rename(from,to);
  if(!err) return(err);
 }

 err=xzstrncpyu(ft,from,sizeof(ft)/sizeof(TCHAR));
 if(!err) err=xzstrncpyu(tt,to,sizeof(tt)/sizeof(TCHAR));
	if(!err) err=fs_copyobjects(ft,tt,flags,spare1,spare2);

	return(err);
}





static os_error * fs_wipes(TCHAR * name)
{
 os_error   * err;
 fxstat       f;
 fsscanhandle savescan;
 int          eof;
 TCHAR      * p;

 err=NULL;


 err=fs_stat(name,&f.f);
 if(!err)
 {
  if(f.f.object==2)
  {
   fs_savescan(&savescan);
   fs_startscan();
   while(1)
   {
    err=fs_nextitem(name,&f,TEXT("*.*"),&eof);
    if(err) break;
    if(eof) break;

    p=name+strlen(name);
    ustrcpy(p,TEXT("\\"));
    ustrcpy(p+1,f.name);

    err=fs_wipes(name);
    if(err) break;
 
    *p=0;
   }
   fs_endscan();
   fs_loadscan(savescan);
   if(!err) err=fs_delete(name);             // empty dir by now...
  }
  else
  if(f.f.object==1)
  {
   err=fs_delete(name);
  }
 }
 return(err);
}


os_error * fs_wipe(TCHAR * name)
{
 TCHAR temp[MAX_PATH];

 xzstrncpyu(temp,name,sizeof(temp)/sizeof(TCHAR));

 return(fs_wipes(temp));
}


#ifdef NEVER

you can identify a JFIF file by looking for the following sequence: X'FF', SOI, X'FF', APP0, <2 bytes to be skipped>, "JFIF", X'00'. 
if you use APP0 elsewhere, be sure not to have the strings "JFIF" or "JFXX" right after the APP0 marker. 
if you do not want to include a thumbnail, just program Xthumbnail = Ythumbnail = 0. 
be sure to check the version number in the special APP0 field. In general, if the major version number of the JFIF file matches that supported by the decoder, the file will be decodable. 
if you only want to specify a pixel aspect ratio, put 0 for the units field in the special APP0 field. Xdensity and Ydensity can then be programmed for the desired aspect ratio. Xdensity = 1, Ydensity = 1 will program a 1:1 aspect ratio. Xdensity and Ydensity should always be non-zero.

/*
 * JPEG markers consist of one or more 0xFF bytes, followed by a marker
 * code byte (which is not an FF).  Here are the marker codes of interest
 * in this program.  (See jdmarker.c for a more complete list.)
 */

#define M_SOF0  0xC0		/* Start Of Frame N */
#define M_SOF1  0xC1		/* N indicates which compression process */
#define M_SOF2  0xC2		/* Only SOF0-SOF2 are now in common use */
#define M_SOF3  0xC3
#define M_SOF5  0xC5		/* NB: codes C4 and CC are NOT SOF markers */
#define M_SOF6  0xC6
#define M_SOF7  0xC7
#define M_SOF9  0xC9
#define M_SOF10 0xCA
#define M_SOF11 0xCB
#define M_SOF13 0xCD
#define M_SOF14 0xCE
#define M_SOF15 0xCF
#define M_SOI   0xD8		/* Start Of Image (beginning of datastream) */
#define M_EOI   0xD9		/* End Of Image (end of datastream) */
#define M_SOS   0xDA		/* Start Of Scan (begins compressed data) */
#define M_APP0	0xE0		/* Application-specific marker, type N */
#define M_APP12	0xEC		/* (we don't bother to list all 16 APPn's) */
#define M_COM   0xFE		/* COMment */



#endif



os_error * fs_identify(int * filetype,TCHAR * name)
{
	os_error * err;
	fshandle   fh;
	int        word=0;
	int        word1=0;
	int        word2=0;

	*filetype=-1;

	err=fs_open(name,'r',&fh);
	if(!err)
	{
		err=fs_read(fh,&word,4);
		if(!err)
		{
			if((word & 0xFFFFFF)==('I'|('I'<<8)|('*'<<16))) *filetype=TIFFTYPE;
			if((word & 0xFFFFFF)==('M'|('M'<<8)|('*'<<16))) *filetype=TIFFTYPE;

			if((word & 0xFFFFFF)==('G'|('I'<<8)|('F'<<16))) *filetype=GIF;

			if((word & 0xFFFF)==('B'|('M'<<8))) *filetype=BMP;

			if((word & 0xFFFFFF00)==(('P'<<8)|('N'<<16)|('G'<<24))) *filetype=PNG;

			cprintf("word %x",word);


			if(word==0xE0FFD8FF || word==0xE1FFD8FF)
			{
		           err=fs_read(fh,&word1,4);
		  if(!err) err=fs_read(fh,&word2,4);

			cprintf("word1 %x",word1);
			cprintf("word2 %x",word2);

				if(!err)
				{
					if(word==0xE0FFD8FF)
					{
 					if((word1 & 0xFFFF0000)==(('J'<<16)|('F'<<24)))
 					{
 						if((word2 & 0xFFFFFF)==(('I')|('F'<<8)|(0<<16))) *filetype=JPEG;
 					}
					}
					else
					if(word==0xE1FFD8FF)
					{
 					if((word1 & 0xFFFF0000)==(('E'<<16)|('x'<<24)))
 					{
 						if((word2 & 0xFFFFFF)==(('i')|('f'<<8)|(0<<16))) *filetype=JPEG;
 					}
					}
				}
			}

		}
		err=fs_close(fh,err);
	}

	if(!err && (*filetype)==-1) err=geterror(EUNKNOWNFILETYPE);


	return(err);
}
