
#include <stdafx.h>


#include <stdio.h>
#include <stdarg.h>



#include "os.h"

#include "deb.h"
#include "etc.h"
#include "bits.h"

#include "err.h"
#include "oserr.h"




static os_error errblock;



DWORD XGetVersion(void)
{
 static DWORD getver=0;

 if(getver==0) return(getver=GetVersion());

 return(getver);
}




os_error * XFormatError2(int code,char * name,char * format,...)
{
 va_list   args;
 char      v[512];
 int       len;

 FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
 NULL,
 code,
 0,
 errblock.errmess,
 sizeof(errblock.errmess)/sizeof(TCHAR),
 NULL);

 errblock.errnum=code;

 if(format)
 {
  va_start(args, format);
  VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

  xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d) (%s)",name,code,v);

  va_end(args);
 }
 else
 {
  xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d)",name,code);
 }

//	cprintf("%s",errblock.errmess);

 return(&errblock);
}



os_error * XGetLastError2(char * name,char * format,...)
{
 va_list   args;
 char      v[512];
 int       code;
 int       len;


 code=GetLastError();
 if(code==ERROR_SUCCESS)
 {
  return(NULL);
 }
 else
 {
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
    NULL,code,0,errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR),NULL);

  errblock.errnum=code;

  if(format)
  {
   va_start(args, format);
   VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

   xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d) (%s)",name,code,v);

   va_end(args);
  }
  else
  {
   xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d)",name,code);
  }

//	 cprintf("%s",errblock.errmess);

  return(&errblock);
 }
}


// have another version that does not look for error success
// this is because on '98 at start up FindResource returns a null
// handle if a resource is not present, but getlasterror seems to
// give a success code


os_error * XGetLastError2N(char * name,char * format,...)
{
 va_list   args;
 char      v[512];
 int       code;
 int       len;

 code=GetLastError();

 {
  FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
    NULL,code,0,errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR),NULL);

  errblock.errnum=code;

  if(format)
  {
   va_start(args, format);
   VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

   xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d) (%s)",name,code,v);

   va_end(args);
  }
  else
  {
   xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d)",name,code);
  }

//	 cprintf("%s",errblock.errmess);

  return(&errblock);
 }
}




os_error * XGetLastError2NT(int code,char * name,char * format,...)
{
 va_list   args;
 char      v[512];
 int       len;


 if(GetVersion() & 0x80000000)         // Windows 98
 {
  if(code==ERROR_SUCCESS)														// for W9X that don't return usable error code
  {
   return(NULL);
  }

  errblock.errnum=code;

  if(format)
  {
   va_start(args, format);
   VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

   xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess,"(%s) (%d) (%s)",name,code,v);

   va_end(args);
  }
  else
  {
   xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess,"(%s) (%d)",name,code);
  }
 }
 else
 {
  code=GetLastError();
  if(code==ERROR_SUCCESS)
  {
   return(NULL);
  }
  else
  {
   FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
     NULL,code,0,errblock.errmess,sizeof(errblock.errmess)/sizeof(TCHAR),NULL);

   errblock.errnum=code;

   if(format)
   {
    va_start(args, format);
    VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

    xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d) (%s)",name,code,v);

    va_end(args);
   }
   else
   {
    xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess+strlen(errblock.errmess),"(%s) (%d)",name,code);
   }
  }
 }

//	cprintf("%s",errblock.errmess);

 return(&errblock);
}






os_error * XGenError(int code,char * name,char * format,...)
{
 va_list   args;
 char      v[512];
 int       len;

 errblock.errnum=code;

 if(format)
 {
  va_start(args, format);
  VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);

  xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess,"(%s) (%d) (%s)",name,code,v);

  va_end(args);
 }
 else
 {
  xsprintf(sizeof(errblock.errmess)/sizeof(TCHAR),NULL,errblock.errmess,"(%s) (%d)",name,code);
 }

//	cprintf("%s",errblock.errmess);

 return(&errblock);
}









#ifdef NEVER

os_error * XFormatError(int code)
{
 FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
 NULL,
 code,
 0,
 errblock.errmess,
 sizeof(errblock.errmess)/sizeof(TCHAR),
 NULL);

 errblock.errnum=code;
 return(&errblock);
}



os_error * XGetLastError(void)
{
 int code;

 code=GetLastError();

 return(XFormatError(code));
}


#endif


os_error * XCopyFile(LPCTSTR lpExistingFileName, // pointer to name of an existing file
                     LPCTSTR lpNewFileName,  // pointer to filename to copy to
                     BOOL bFailIfExists)      // flag for operation if file exists
{
 int code;

 code=CopyFile(lpExistingFileName,lpNewFileName,bFailIfExists);
 if(code==0) return(XGetLastError2("CopyFile","%s %s",lpExistingFileName,lpNewFileName));
 return(NULL);
}


os_error * XMoveFile(
  LPCTSTR lpExistingFileName, // pointer to the name of the existing file
  LPCTSTR lpNewFileName       // pointer to the new name for the file
)
{
 int code;

 code=MoveFile(lpExistingFileName,lpNewFileName);
 if(code==0) return(XGetLastError2("MoveFile","%s %s",lpExistingFileName,lpNewFileName));
 return(NULL);
}


os_error * XDeleteFile(
  LPCTSTR lpFileName   // pointer to name of file to delete
)
{
 int code;

 code=DeleteFile(lpFileName);
 if(code==0) return(XGetLastError2("DeleteFile","%s",lpFileName));
 return(NULL);

}


os_error * XRemoveDirectory(
LPCTSTR lpPathName   // pointer to directory to remove
)
{
 int code;

 code=RemoveDirectory(lpPathName);
 if(code==0) return(XGetLastError2("Remove Directory","%s",lpPathName));
 return(NULL);
}


os_error * XCreateDirectory(
  LPCTSTR lpPathName,                         // pointer to directory path string
  LPSECURITY_ATTRIBUTES lpSecurityAttributes  // pointer to security descriptor
)
{
 int code;

 code=CreateDirectory(lpPathName,lpSecurityAttributes);
 if(code==0) return(XGetLastError2("Create Directory","%s",lpPathName));
 return(NULL);
}


os_error * XGetFileAttributes(
  LPCTSTR lpFileName,   // pointer to the name of a file or directory
  DWORD * result
)
{
 DWORD code;

 code=GetFileAttributes(lpFileName);
 if(code==(-1)) return(XGetLastError2("GetFileAttributes","%s",lpFileName));
 *result=code;
 return(NULL);
}



#ifdef NOT95

os_error * XGetFileAttributesEx(
  LPCTSTR lpFileName,        // pointer to string that specifies a 
                             // file or directory
  GET_FILEEX_INFO_LEVELS fInfoLevelId, 
                             // value that specifies the type of 
                             // attribute information to obtain
  LPVOID lpFileInformation   // pointer to buffer to receive 
                             // attribute information
)

{
 int code;

 code=GetFileAttributesEx(lpFileName,fInfoLevelId,lpFileInformation);
 if(code==0) return(XGetLastError());
 return(NULL);
}

#endif




os_error * XCreateFile(
  LPCTSTR lpFileName,          // pointer to name of the file
  DWORD dwDesiredAccess,       // access (read-write) mode
  DWORD dwShareMode,           // share mode
  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                               // pointer to security attributes
  DWORD dwCreationDisposition,  // how to create
  DWORD dwFlagsAndAttributes,  // file attributes
  HANDLE hTemplateFile,         // handle to file with attributes to 
                               // copy
  HANDLE * filehandle
)
 
{

 *filehandle=CreateFile(lpFileName,dwDesiredAccess,dwShareMode,
                        lpSecurityAttributes,dwCreationDisposition,
                        dwFlagsAndAttributes,hTemplateFile);
 
 if(*filehandle==INVALID_HANDLE_VALUE) return(XGetLastError2("CreateFile","%s",lpFileName));
 return(NULL);
}



//#define INVALID_SET_FILE_POINTER (-1)

os_error * XSetFilePointer(
  HANDLE hFile,          // handle of file
  LONG lDistanceToMove,  // number of bytes to move file pointer
  PLONG lpDistanceToMoveHigh,
                         // pointer to high-order DWORD of 
                         // distance to move
  DWORD dwMoveMethod,    // how to move
  DWORD * result
)

{
 os_error * err;

 *result=SetFilePointer(hFile,lDistanceToMove,lpDistanceToMoveHigh,dwMoveMethod);
 if(*result==INVALID_SET_FILE_POINTER)
 {
  err=XGetLastError2("SetFilePointer","");
  if(lpDistanceToMoveHigh)
  {
   if(err->errnum==NO_ERROR) return(NULL);
  }
  return(err);
 }
 return(NULL);
}
 

os_error * XFindNextFile(
  HANDLE hFindFile,  // handle to search
  LPWIN32_FIND_DATA lpFindFileData, 
                     // pointer to structure for data on found file
  int * eof
)
{
 os_error * err;
 int        code;

 code=FindNextFile(hFindFile,lpFindFileData);
 if(code==0)
 {
  err=XGetLastError2("FindNextFile","");
  if(err->errnum==ERROR_NO_MORE_FILES)
  {
   *eof=1;
   err=NULL;
  }
  return(err);
 }

 *eof=0;
 return(NULL);
}


os_error * XFindFirstFile(
  LPCTSTR lpFileName,  // pointer to name of file to search for
  LPWIN32_FIND_DATA lpFindFileData,
                       // pointer to returned information
  HANDLE * handle
)
{

 *handle=FindFirstFile(lpFileName,lpFindFileData);

 if(*handle==INVALID_HANDLE_VALUE) return(XGetLastError2("FindFirstFile","%s",lpFileName));

 return(NULL);
}


os_error * XFindClose(
  HANDLE hFindFile   // file search handle
)
{
 int code;

 code=FindClose(hFindFile);
 if(code==0) return(XGetLastError2("FindClose",NULL));
 return(NULL);
}


os_error * XSetEndOfFile(
  HANDLE hFile   // handle of file whose EOF is to be set
)
{
 int code;

 code=SetEndOfFile(hFile);
 if(code==0) return(XGetLastError2("SetEndOfFile",NULL));
 return(NULL);

}



os_error * XWriteFile(
  HANDLE hFile,                    // handle to file to write to
  LPCVOID lpBuffer,                // pointer to data to write to file
  DWORD nNumberOfBytesToWrite,     // number of bytes to write
  LPDWORD lpNumberOfBytesWritten,  // pointer to number of bytes written
  LPOVERLAPPED lpOverlapped        // pointer to structure for overlapped I/O
)
{
 int code;

 code=WriteFile(hFile,lpBuffer,nNumberOfBytesToWrite,lpNumberOfBytesWritten,lpOverlapped);
 if(code==0) return(XGetLastError2("WriteFile",NULL));
 return(NULL);
}


os_error * XReadFile(
  HANDLE hFile,                // handle of file to read
  LPVOID lpBuffer,             // pointer to buffer that receives data
  DWORD nNumberOfBytesToRead,  // number of bytes to read
  LPDWORD lpNumberOfBytesRead, // pointer to number of bytes read
  LPOVERLAPPED lpOverlapped    // pointer to structure for data
)
{
 int code;

 code=ReadFile(hFile,lpBuffer,nNumberOfBytesToRead,lpNumberOfBytesRead,lpOverlapped);

 if(code==0) return(XGetLastError2("ReadFile",NULL));
 return(NULL);
}



os_error * XCloseHandle(
  HANDLE hObject   // handle to object to close
)
{
 int code;

 code=CloseHandle(hObject);

 if(code==0) return(XGetLastError2("CloseHandle",NULL));
 return(NULL);
}

os_error * XGetFileSize(
  HANDLE hFile,  // handle of file to get size of
  LPDWORD lpFileSizeHigh,
                 // pointer to high-order word for file size
  DWORD * result
)
{
 os_error * err;

 *result=GetFileSize(hFile,lpFileSizeHigh);

 if(*result==INVALID_FILE_SIZE)
 {
  err=XGetLastError2("GetFileSize",NULL);
  if(lpFileSizeHigh)
  {
   if(err->errnum==NO_ERROR) return(NULL);
  }
  return(err);
 }
 return(NULL);
}



os_error * XVirtualFree(
  LPVOID lpAddress,  // address of region of committed pages
  DWORD dwSize,      // size of region
  DWORD dwFreeType   // type of free operation
)
{
 int code;	

 code=VirtualFree(lpAddress,dwSize,dwFreeType);
 
 if(code==0) return(XGetLastError2("VirtualFree",NULL));
 return(NULL);
}


os_error * XVirtualAlloc(
  LPVOID lpAddress, // address of region to reserve or commit
  DWORD dwSize,     // size of region
  DWORD flAllocationType,
                    // type of allocation
  DWORD flProtect,   // type of access protection
  LPVOID * result
)
{
 
 *result=VirtualAlloc(lpAddress,dwSize,flAllocationType,flProtect);
 if(*result==NULL) return(XGetLastError2("VirtualAlloc",NULL));
 return(NULL);
}



VOID XGetSystemInfo(
  LPSYSTEM_INFO lpSystemInfo   // address of system information 
                               // structure
)
 
{
 GetSystemInfo(lpSystemInfo);
} 



os_error * XGetClientRect(
  HWND hWnd,      // handle to window
  LPRECT lpRect   // address of structure for client coordinates
)
{
 int code;

 code=GetClientRect(hWnd,lpRect);
 
 if(code==0) return(XGetLastError2("GetClientRect",NULL));
 return(NULL);
}


VOID XZeroMemory(
  PVOID Destination, 
                 // address of block to fill with zeros
  DWORD Length   // size, in bytes, of block to fill with zeros
)
{
 
 ZeroMemory(Destination,Length);
}


os_error * XGetScrollInfo(
  HWND hwnd,         // handle to window with scroll bar
  int fnBar,         // scroll bar flag
  LPSCROLLINFO lpsi  // pointer to structure for scroll parameters
)
{
 int code;

 code=GetScrollInfo(hwnd,fnBar,lpsi);

 if(code==0)
	{
		memset(lpsi,0,sizeof(SCROLLINFO));
		//return(XGetLastError2("GetScrollInfo",NULL));
	}
 return(NULL);
}


os_error * XScrollWindowEx(
  HWND hWnd,        // handle to window to scroll
  int dx,           // amount of horizontal scrolling
  int dy,           // amount of vertical scrolling
  CONST RECT *prcScroll,
                    // address of structure with scroll rectangle
  CONST RECT *prcClip,
                    // address of structure with clip rectangle
  HRGN hrgnUpdate,  // handle to update region
  LPRECT prcUpdate, // address of structure for update rectangle
  UINT flags,        // scrolling flags
  int * result
)

{
 *result=ScrollWindowEx(hWnd,dx,dy,prcScroll,prcClip,hrgnUpdate,prcUpdate,flags);
  
 if(*result==ERROR) return(XGetLastError2("ScrollWindowEx",NULL));
 return(NULL);
}




os_error * XSetScrollInfo(
  HWND hwnd,    // handle to window with scroll bar
  int fnBar,    // scroll bar flag
  LPSCROLLINFO lpsi,
                // pointer to structure with scroll parameters
  BOOL fRedraw,  // redraw flag
  int * posn
)
{

 *posn=SetScrollInfo(hwnd,fnBar,lpsi,fRedraw);

 return(NULL);
}




os_error * XRegSetValueEx(
  HKEY hKey,           // handle to key to set value for
  LPCTSTR lpValueName, // name of the value to set
  DWORD Reserved,      // reserved
  DWORD dwType,        // flag for value type
  CONST BYTE *lpData,  // address of value data
  DWORD cbData         // size of value data
)

{
 LONG code;

 code=RegSetValueEx(hKey,lpValueName,Reserved,dwType,lpData,cbData);
 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegSetValueEx","%s",lpValueName));
}


os_error * XRegCloseKey(
  HKEY hKey   // handle to key to close
)
{
 LONG code;

 code=RegCloseKey(hKey);

 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegCloseKey",NULL));
}


os_error * XRegCreateKeyEx(
  HKEY hKey,                // handle to an open key
  LPCTSTR lpSubKey,         // address of subkey name
  DWORD Reserved,           // reserved
  LPTSTR lpClass,           // address of class string
  DWORD dwOptions,          // special options flag
  REGSAM samDesired,        // desired security access
  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                            // address of key security structure
  PHKEY phkResult,          // address of buffer for opened handle
  LPDWORD lpdwDisposition   // address of disposition value buffer
)
{
 LONG code;
 
 code=RegCreateKeyEx(hKey,lpSubKey,Reserved,lpClass,dwOptions,samDesired,lpSecurityAttributes,
                     phkResult,lpdwDisposition);

 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegCreateKey","%s",lpSubKey));
}




os_error * XRegOpenKeyEx(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey,  // address of name of subkey to open
  DWORD ulOptions,   // reserved
  REGSAM samDesired, // security access mask
  PHKEY phkResult    // address of handle to open key
)

{
 LONG code;

 code=RegOpenKeyEx(hKey,lpSubKey,ulOptions,samDesired,phkResult);

 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegOpenKey","%s",lpSubKey));
}



os_error * XRegEnumKeyEx(
  HKEY hKey,          // handle to key to enumerate
  DWORD dwIndex,      // index of subkey to enumerate
  LPTSTR lpName,      // address of buffer for subkey name
  LPDWORD lpcbName,   // address for size of subkey buffer
  LPDWORD lpReserved, // reserved
  LPTSTR lpClass,     // address of buffer for class string
  LPDWORD lpcbClass,  // address for size of class buffer
  PFILETIME lpftLastWriteTime,
                      // address for time key last written to
  int * eof
)

{
 LONG code;

 *eof=0;

 code=RegEnumKeyEx(hKey,dwIndex,lpName,lpcbName,lpReserved,
                  lpClass,lpcbClass,lpftLastWriteTime);
 if(code==ERROR_SUCCESS) return(NULL);
 else
 if(code==ERROR_NO_MORE_ITEMS)
 {
  *eof=1;
  return(NULL);
 }
 return(XFormatError2(code,"RegEnumKey",NULL));
}



os_error * XRegQueryValueEx(
  HKEY hKey,           // handle to key to query
  LPTSTR lpValueName,  // address of name of value to query
  LPDWORD lpReserved,  // reserved
  LPDWORD lpType,      // address of buffer for value type
  LPBYTE lpData,       // address of data buffer
  LPDWORD lpcbData     // address of data buffer size
)
{
 LONG code;

 code=RegQueryValueEx(hKey,lpValueName,lpReserved,lpType,lpData,lpcbData);
 
 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegQueryValueEx","%s",lpValueName));
}


os_error * XRegEnumValue(
  HKEY hKey,              // handle to key to query
  DWORD dwIndex,          // index of value to query
  LPTSTR lpValueName,     // address of buffer for value string
  LPDWORD lpcbValueName,  // address for size of value buffer
  LPDWORD lpReserved,     // reserved
  LPDWORD lpType,         // address of buffer for type code
  LPBYTE lpData,          // address of buffer for value data
  LPDWORD lpcbData,        // address for size of data buffer
  int   * eof
)
{
 LONG code;

 *eof=0;

 code=RegEnumValue(hKey,dwIndex,lpValueName,lpcbValueName,
                   lpReserved,lpType,lpData,lpcbData);
 if(code==ERROR_SUCCESS) return(NULL);
 else
 if(code==ERROR_NO_MORE_ITEMS)
 {
  *eof=1;
  return(NULL);
 }
 return(XFormatError2(code,"RegEnumValue",NULL));

}






os_error *  XFindResource(
  HMODULE hModule, // module handle
  LPCTSTR lpName,  // pointer to resource name
  LPCTSTR lpType,   // pointer to resource type
  HRSRC * handle
)
{
 
 *handle=FindResource(hModule,lpName,lpType);

 if(*handle==NULL) return(XGetLastError2N("FindResource","(%s)",lpName));
 return(NULL);
}


os_error * XLoadResource(
  HMODULE hModule, // resource-module handle
  HRSRC hResInfo,   // resource handle
  HGLOBAL * handle
)
{
 
 *handle=LoadResource(hModule,hResInfo);

 if(*handle==NULL) return(XGetLastError2("LoadResource",NULL));
 return(NULL);
}



os_error * XLockResource(
  HGLOBAL hResData,
  LPVOID * handle
)
{

 *handle=LockResource(hResData );
 return(NULL);
}


os_error * XGetCursorPos(
  LPPOINT lpPoint   // address of structure for cursor position
)
{
 int code;
 
 code=GetCursorPos(lpPoint);

 if(code==0) return(XGetLastError2("GetCursorPos",NULL));
 return(NULL);
}



os_error * XCreateDialogIndirect(
  HINSTANCE hInstance,        // handle to application instance
  LPCDLGTEMPLATE lpTemplate,  // pointer to dialog box template
  HWND hWndParent,            // handle to owner window
  DLGPROC lpDialogFunc,       // pointer to dialog box procedure
  HWND * hwnd
)
{
 
 *hwnd=CreateDialogIndirect(hInstance,lpTemplate,hWndParent,lpDialogFunc);

 if(*hwnd==NULL) return(XGetLastError2("CreateDialogIndirect",NULL));
 return(NULL);
} 





os_error * XDestroyWindow(
  HWND hWnd   // handle to window to destroy
)
{
 int code;
 
 code=DestroyWindow(hWnd);

 if(code==0) return(XGetLastError2("DestroyWindow",NULL));
 return(NULL);
} 


os_error * XCloseWindow(
  HWND hWnd   // handle to window to minimize
)
{
 int code;
 
 code=CloseWindow(hWnd);
 
 if(code==0) return(XGetLastError2("CloseWindow",NULL));
 return(NULL);
} 



os_error * XGetWindowRect(
  HWND hWnd,      // handle to window
  LPRECT lpRect   // address of structure for window coordinates
)
{
 int code;
 
 code=GetWindowRect(hWnd,lpRect);

 if(code==0) return(XGetLastError2("GetWindowRect",NULL));
 return(NULL);
}



os_error * XSetWindowPos(
  HWND hWnd,             // handle to window
  HWND hWndInsertAfter,  // placement-order handle
  int X,                 // horizontal position
  int Y,                 // vertical position
  int cx,                // width
  int cy,                // height
  UINT uFlags            // window-positioning flags
)
{
 int code;

 code=SetWindowPos(hWnd,hWndInsertAfter,X,Y,cx,cy,uFlags);

 if(code==0) return(XGetLastError2("SetWindowPos",NULL));
 return(NULL);
}


os_error * XPostQuitMessage(
  int nExitCode   // exit code
)
{
 PostQuitMessage(nExitCode);
 return(NULL);
}


os_error * XDragQueryFile(
    HDROP hDrop,
    UINT iFile,
    LPTSTR lpszFile,
    UINT cch,
    UINT * count
)

{

 *count=DragQueryFile(hDrop,iFile,lpszFile,cch);

 return(NULL);
}


os_error * XDragQueryPoint(
    HDROP hDrop,
    LPPOINT lppt,
    int * result
)

{

 *result=DragQueryPoint(hDrop,lppt);

 return(NULL);
}


os_error * XDragFinish(
    HDROP hDrop
)
{

 DragFinish(hDrop);

 return(NULL);
}


os_error * XChildWindowFromPoint(
  HWND hWndParent,  // handle to parent window
  POINT Point,  // structure with point coordinates
  HWND * child
)
{
 
 *child=ChildWindowFromPoint(hWndParent,Point);

 return(NULL);
}


os_error * XMapWindowPoints(
  HWND hWndFrom, // handle of window to be mapped from
  HWND hWndTo,       // handle to window to be mapped to
  LPPOINT lpPoints,  // pointer to array with points to map
  UINT cPoints,       // number of structures in array
  int * result
)
 
{

 *result=MapWindowPoints(hWndFrom,hWndTo,lpPoints,cPoints);

 return(NULL);
}


os_error * XDefWindowProcX(
  HWND hWnd,      // handle to window
  UINT Msg,       // message identifier
  WPARAM wParam,  // first message parameter
  LPARAM lParam,  // second message parameter
  LRESULT * result
)
{
 if(IsWindowUnicode(hWnd))  *result=DefWindowProcW(hWnd,Msg,wParam,lParam);
 else                       *result=DefWindowProc(hWnd,Msg,wParam,lParam);

 return(NULL);
}



os_error * XDefWindowProc(
  HWND hWnd,      // handle to window
  UINT Msg,       // message identifier
  WPARAM wParam,  // first message parameter
  LPARAM lParam,  // second message parameter
  LRESULT * result
)
{
 *result=DefWindowProc(hWnd,Msg,wParam,lParam);
 return(NULL);
}




// supersedes GetWindowLong

os_error * XGetWindowLongPtr(
  HWND hWnd,  // handle to window
  int nIndex,  // offset of value to retrieve
  LONG_PTR * result
)
{
 if(IsWindowUnicode(hWnd)) *result=GetWindowLongPtrW(hWnd,nIndex);
 else                     	*result=GetWindowLongPtr(hWnd,nIndex);

 if(*result==0) return(XGetLastError2("GetWindowLongPtr",NULL));
 return(NULL);
}


os_error * XGetWindowLong(
  HWND hWnd,  // handle of window
  int nIndex,  // offset of value to retrieve
  LONG * result
)
{

 if(IsWindowUnicode(hWnd)) *result=GetWindowLongW(hWnd,nIndex);
 else                      *result=GetWindowLongW(hWnd,nIndex);

 if(*result==0) return(XGetLastError2("GetWindowLong",NULL));
 return(NULL);
}



os_error * XSetWindowLong(
  HWND hWnd,       // handle of window
  int nIndex,      // offset of value to set
  LONG dwNewLong,   // new value
  LONG * result
)
{
 int code;

 SetLastError(0);

 if(IsWindowUnicode(hWnd)) *result=SetWindowLongW(hWnd,nIndex,dwNewLong);
 else                      *result=SetWindowLong(hWnd,nIndex,dwNewLong);

 
 if(*result==0)
 {
  code=GetLastError();
  if(code!=ERROR_SUCCESS) return(XFormatError2(code,"SetWindowLong",NULL));
 }

 return(NULL);
}
 

// supersedes SetWindowLong

os_error * XSetWindowLongPtr(
  HWND hWnd,           // handle to window
  int nIndex,          // offset of value to set
  LONG_PTR dwNewLong,   // new value
		LONG_PTR	* result
)

{
 int code;

 SetLastError(0);

 if(IsWindowUnicode(hWnd))  *result=SetWindowLongPtrW(hWnd,nIndex,dwNewLong);
 else                       *result=SetWindowLongPtr(hWnd,nIndex,dwNewLong);

 if(*result==0)
 {
  code=GetLastError();
  if(code!=ERROR_SUCCESS) return(XFormatError2(code,"SetWindowLong",NULL));
 }

 return(NULL);
}


os_error * XGetParent(
  HWND hWnd,   // handle to child window
  HWND * parent
)
{

 *parent=GetParent(hWnd);

 if(*parent==NULL) {return(XGetLastError2("GetParent",NULL));}
 return(NULL);
}



os_error * XWinHelp(
    HWND hWndMain,
    LPCTSTR lpszHelp,
    UINT uCommand,
    DWORD dwData
)
{
 int code;

 code=WinHelp(hWndMain,lpszHelp,uCommand,dwData);

 if(code==0) return(XGetLastError2("WinHelp",NULL));
 return(NULL);
}



os_error * XRegisterClass(CONST WNDCLASS *lpWndClass,ATOM * atom)
{

 *atom=RegisterClass(lpWndClass);

 if(*atom==0) return(XGetLastError2("RegisterClass",NULL));
 return(NULL);
}



os_error * XEnumResourceNames(
  HINSTANCE hModule,           // resource-module handling
  LPCTSTR lpszType,            // pointer to resource type
  ENUMRESNAMEPROC lpEnumFunc,  // pointer to callback function
  LPARAM lParam                  // application-defined parameter
)
{
 int code;
 
 code=EnumResourceNames(hModule,lpszType,lpEnumFunc,lParam);

 if(code==0) return(XGetLastError2("EnumResourceNames",NULL));
 return(NULL);
}




os_error * XCreateWindowEx(
  DWORD dwExStyle,      // extended window style
  LPCTSTR lpClassName,  // pointer to registered class name
  LPCTSTR lpWindowName, // pointer to window name
  DWORD dwStyle,        // window style
  int x,                // horizontal position of window
  int y,                // vertical position of window
  int nWidth,           // window width
  int nHeight,          // window height
  HWND hWndParent,      // handle to parent or owner window
  HMENU hMenu,          // handle to menu, or child-window identifier
  HINSTANCE hInstance,  // handle to application instance
  LPVOID lpParam,       // pointer to window-creation data
  HWND * result
)
{
 
 *result=CreateWindowEx(dwExStyle,lpClassName,lpWindowName,dwStyle,x,y,nWidth,nHeight,hWndParent,hMenu,hInstance,lpParam);
 if(*result==NULL) return(XGetLastError2("CreateWindowEx",NULL));
 return(NULL);
}



os_error * XSendDlgItemMessage(
  HWND hDlg,      // handle of dialog box
  int nIDDlgItem, // identifier of control
  UINT Msg,       // message to send
  WPARAM wParam,  // first message parameter
  LPARAM lParam,  // second message parameter
  LRESULT * result
)
{
 *result=SendDlgItemMessage(hDlg,nIDDlgItem,Msg,wParam,lParam);
 return(NULL);
}




os_error * XSetCursorPos(
  int X,  // horizontal position
  int Y   // vertical position
)
{
 if(SetCursorPos(X,Y)==0) return(XGetLastError2("SetCursorPos",NULL));
 else                     return(NULL);
}


os_error * XGetWindowThreadProcessId(
  HWND hWnd,             // handle to window
  LPDWORD lpdwProcessId,  // address of variable for process identifier
  LPDWORD lpdwthread
)
{
 
 *lpdwthread=GetWindowThreadProcessId(hWnd,lpdwProcessId);
 return(NULL); 
}


os_error * XGetDlgItem(
  HWND hDlg,       // handle of dialog box
  int nIDDlgItem,   // identifier of control
  HWND * child
)

{
 
 *child=GetDlgItem(hDlg,nIDDlgItem);
 if(*child==NULL) return(XGetLastError2("GetDlgItem",NULL));

 return(NULL);
}




os_error * XGetDlgCtrlID(
  HWND hwndCtl,   // handle of control
  int * id
)
{
 
 *id=GetDlgCtrlID(hwndCtl);
 if(*id==0)
 {
  return(NULL);
//  return(XGetLastError2("GetDlgCtrlId",NULL)); gives an error on NT if the control really has id ==0
 }

 return(NULL);
}


os_error * XReleaseCapture(void)
{
 if(ReleaseCapture()==0) return(XGetLastError2("ReleaseCapture",NULL));
 return(NULL);
}


os_error * XSetCapture(
  HWND hWnd,   // handle of window to receive mouse capture
  HWND * hprev
)
{
 *hprev=SetCapture(hWnd);
 return(NULL);
}


os_error * XClientToScreen(
  HWND hWnd,       // window handle for source coordinates
  LPPOINT lpPoint  // pointer to structure containing screen coordinates
)
{
 if(ClientToScreen(hWnd,lpPoint)==0) return(XGetLastError2("ClientToScreen",NULL));
 return(NULL);
}


os_error * XScreenToClient(
  HWND hWnd,        // window handle for source coordinates
  LPPOINT lpPoint   // address of structure containing coordinates
)
{
 if(ScreenToClient(hWnd,lpPoint)==0) return(XGetLastError2("ScreenToClient",NULL));
 return(NULL);
}



// seemingly on W98 an icon of zero length will raise an error "The parameter is wrong"
// use GetLastError2NT to get around this
// .. and NT gives "access denied", give up.

os_error * XGetDlgItemText(
  HWND hDlg,       // handle of dialog box
  int nIDDlgItem,  // identifier of control
  LPTSTR lpString, // address of buffer for text
  int nMaxCount,    // maximum size of string
  unsigned int * read
)

{
 *read=GetDlgItemText(hDlg,nIDDlgItem,lpString,nMaxCount);
// if(*read==0) return(XGetLastError2NT(ERROR_SUCCESS,"GetDlgItemText",NULL));
 return(NULL);
}


os_error * XGetDlgItemTextW(
  HWND hDlg,       // handle of dialog box
  int nIDDlgItem,  // identifier of control
  LPWSTR lpString, // address of buffer for text
  int nMaxCount,    // maximum size of string
  unsigned int * read
)

{
 *read=GetDlgItemTextW(hDlg,nIDDlgItem,lpString,nMaxCount);
// if(*read==0) return(XGetLastError2NT(ERROR_SUCCESS,"GetDlgItemText",NULL));
 return(NULL);
}




os_error * XSetFocus(HWND hWnd,   // handle to window to receive focus
                     HWND * prev
)
{ 

 *prev=SetFocus(hWnd);
 if(*prev==NULL) return(XGetLastError2("SetFocus",NULL));
 return(NULL);
} 



os_error * XGetTextMetrics(
  HDC hdc,            // handle to device context
  LPTEXTMETRIC lptm   // pointer to text metrics structure
)
{
 int code;

 code=GetTextMetrics(hdc,lptm);
 if(code==0) return(XGenError(EGENERAL,"GetTextMetrics",NULL));    // NT only

 return(NULL);
}



os_error * XCreateMetaFile(
  LPCTSTR lpszFile,   // pointer to filename string
  HDC * hdc
)
{
 *hdc=CreateMetaFile(lpszFile);
 if(*hdc==NULL) return(XGenError(EGENERAL,"CreateMetaFile",NULL));    // no error

 return(NULL);
}
 


os_error * XCloseMetaFile(
  HDC hdc,   // handle to metafile device context
  HMETAFILE * hmf
)
 
{

 *hmf=CloseMetaFile(hdc);
 if(*hmf==NULL) return(XGenError(EGENERAL,"CloseMetaFile",NULL));    // NT only

 return(NULL);
}



os_error * XGetMetaFileBitsEx(
  HMETAFILE hmf,  // handle to metafile
  UINT nSize,     // size of metafile, in bytes
  LPVOID lpvData,  // pointer to metafile data
  UINT * length
)
{
 *length=GetMetaFileBitsEx(hmf,nSize,lpvData);
 if(*length==0) return(XGenError(EGENERAL,"GetMetaFileBitsEx",NULL));    // NT only

 return(NULL);
} 


os_error * XDeleteMetaFile(
  HMETAFILE hmf   // handle to Windows-format metafile
)
{
 if(!DeleteMetaFile(hmf)) return(XGenError(EGENERAL,"DeleteMetaFile",NULL));    // NT only
 return(NULL);
}


os_error * XCreateEnhMetaFile(
  HDC hdcRef,           // handle to a reference device context
  LPCTSTR lpFilename,   // pointer to a filename string
  CONST RECT *lpRect,   // pointer to a bounding rectangle
  LPCTSTR lpDescription, // pointer to an optional description string
  HDC * hdc
)
{
 *hdc=CreateEnhMetaFile(hdcRef,lpFilename,lpRect,lpDescription);
 if(*hdc==NULL) return(XGenError(EGENERAL,"CreateEnhMetaFile",NULL));    // NT only

 return(NULL);
}
 



os_error * XCloseEnhMetaFile(
  HDC hdc,   // handle to an enhanced-metafile device context
  HENHMETAFILE * hmf
)
{
 *hmf=CloseEnhMetaFile(hdc);
 if(*hmf==NULL) return(XGenError(EGENERAL,"CloseEnhMetaFile",NULL));    // NT only

 return(NULL);
}





os_error * XDeleteEnhMetaFile(
  HENHMETAFILE hemf   // handle to an enhanced metafile
)
{
 if(!DeleteEnhMetaFile(hemf)) return(XGenError(EGENERAL,"DeleteEnhMetaFile",NULL));    // NT only
 return(NULL);
}


os_error * XSetWindowExtEx(
  HDC hdc,       // handle of device context
  int nXExtent,  // new horizontal window extent
  int nYExtent,  // new vertical window extent
  LPSIZE lpSize  // original window extent
)
{
 if(!SetWindowExtEx(hdc,nXExtent,nYExtent,lpSize)) return(XGenError(EGENERAL,"SetWindowExtEx",NULL));    // NT only
 return(NULL);
}


os_error * XMoveToEx(
  HDC hdc,          // handle to device context
  int X,            // x-coordinate of new current position
  int Y,            // y-coordinate of new current position
  LPPOINT lpPoint   // pointer to old current position
)
{
 if(!MoveToEx(hdc,X,Y,lpPoint)) return(XGenError(EGENERAL,"MoveToEx",NULL));    // NT only
 return(NULL);
}


os_error * XSetTextAlign(
  HDC hdc,     // handle to device context
  UINT fMode,   // text-alignment flag
  UINT * prev
)
{
 *prev=SetTextAlign(hdc,fMode);
 if(*prev==GDI_ERROR) return(XGenError(EGENERAL,"SetTextAlign",NULL));    // NT only
 return(NULL);
}



os_error * XSizeofResource(
  HMODULE hModule, // resource-module handle
  HRSRC hResInfo,   // resource handle
  unsigned int * length
)
{
 *length=SizeofResource(hModule,hResInfo);
 if(*length==NULL) return(XGetLastError2("SizeofResource",NULL));
 return(NULL);
} 



os_error * XTextOut(
  HDC hdc,           // handle to device context
  int nXStart,       // x-coordinate of starting position
  int nYStart,       // y-coordinate of starting position
  LPCTSTR lpString,  // pointer to string
  int cbString       // number of characters in string
)
{
 int code;

 code=TextOut(hdc,nXStart,nYStart,lpString,cbString);
 if(code==0) return(XGenError(EGENERAL,"TextOut",NULL));    // NT only
 return(NULL);
}
 


os_error * XGetTextExtentPoint32(
  HDC hdc,           // handle to device context
  LPCTSTR lpString,  // pointer to text string
  int cbString,      // number of characters in string
  LPSIZE lpSize      // pointer to structure for string size
)
{
 int code;

 code=GetTextExtentPoint32(hdc,lpString,cbString,lpSize);
 if(code==0) return(XGenError(EGENERAL,"GetTextExtentPoint32",NULL));    // NT only
 return(NULL);
}



os_error * XGetTextExtentPoint32W(
  HDC hdc,           // handle to device context
  LPCWSTR lpString,  // pointer to text string
  int cbString,      // number of characters in string
  LPSIZE lpSize      // pointer to structure for string size
)
{
 int code;

 code=GetTextExtentPoint32W(hdc,lpString,cbString,lpSize);
 if(code==0) return(XGenError(EGENERAL,"GetTextExtentPoint32W",NULL));    // NT only
 return(NULL);
}




os_error * XSetBkMode(
  HDC hdc,      // handle of device context
  int iBkMode,   // flag specifying background mode
  int * prev
)
{
 *prev=SetBkMode(hdc,iBkMode);
 if(*prev==0) return(XGenError(EGENERAL,"SetBkMode",NULL));    // NT only
 return(NULL);
}



os_error * XSelectObject(
  HDC hdc,          // handle to device context
  HGDIOBJ hgdiobj,  // handle to object
  HGDIOBJ * prev
)
{
 *prev=SelectObject(hdc,hgdiobj);
 if(*prev==NULL) return(XGenError(EGENERAL,"SelectObject",NULL));    // apparently no error ever
 return(NULL);
}



os_error * XGetObject(
  HGDIOBJ hgdiobj,  // handle to graphics object of interest
  int cbBuffer,     // size of buffer for object information
  LPVOID lpvObject,  // pointer to buffer for object information
  int * size
)
{
 
 *size=GetObject(hgdiobj,cbBuffer,lpvObject);
 if(*size==0) return(XGenError(EGENERAL,"GetObject",NULL));    // NT only
 return(NULL);
}



os_error * XDeleteObject(
  HGDIOBJ hObject   // handle to graphic object
)
{
 int code;

 code=DeleteObject(hObject);
 if(code==0) return(XGenError(EGENERAL,"DeleteObject",NULL));    // NT only
 return(NULL);
}



os_error * XSetTextColor(
  HDC hdc,           // handle to device context
  COLORREF crColor,  // text color
  COLORREF * prev
)
{

 *prev=SetTextColor(hdc,crColor);
 if(*prev==CLR_INVALID) return(XGenError(EGENERAL,"SetTextColor",NULL));    // NT only
 return(NULL);
}



os_error * XSetBkColor(
  HDC hdc,           // handle of device context
  COLORREF crColor,  // background color value
  COLORREF * prev
)
{
 *prev=SetBkColor(hdc,crColor);
 if(*prev==CLR_INVALID) return(XGenError(EGENERAL,"SetBkColor",NULL));    // NT only
 return(NULL);
}




os_error * XCreateFontIndirect(
  CONST LOGFONT *lplf,   // pointer to logical font structure
  HFONT * fonth
)
{
 *fonth=CreateFontIndirect(lplf);
 if(*fonth==NULL) return(XGenError(EGENERAL,"CreateFontIndirect",NULL));    // NT only
 return(NULL);
}





os_error * XCreateDIBSection(
  HDC hdc,                 // handle to DC
  CONST BITMAPINFO *pbmi,  // bitmap data
  UINT iUsage,             // data type indicator
  VOID **ppvBits,          // bit values
  HANDLE hSection,         // handle to file mapping object
  DWORD dwOffset,           // offset to bitmap bit values
  HBITMAP * hbm
)
{

 *hbm=CreateDIBSection(hdc,pbmi,iUsage,ppvBits,hSection,dwOffset);
 if(*hbm==NULL) return(XGetLastError2("CreateDibSection",NULL));  // NT only

 return(NULL);
}


os_error * XRealizePalette(HDC hdc,int * n)
{

 *n=RealizePalette(hdc);
 if(*n==GDI_ERROR) return(XGetLastError2("RealizePalette",NULL));  // NT only
 return(NULL);

}


os_error * XGetUserName(
  LPTSTR lpBuffer,  // name buffer
  LPDWORD nSize     // size of name buffer
)
{
 int code;

 code=GetUserName(lpBuffer,nSize);
 if(code==0) return(XGetLastError2("GetUserName",NULL));
 return(NULL);
}



// returns 2 16 bit numbers, width in lowest 16 bits

os_error * XGetCharacterPlacement(
  HDC hdc,                  // handle to DC
  LPCTSTR lpString,         // character string
  int nCount,               // number of characters
  int nMaxExtent,           // maximum extent for string
  LPGCP_RESULTS lpResults,  // placement result
  DWORD dwFlags             // placement options
)
{
 DWORD code;

 code=GetCharacterPlacement(hdc,lpString,nCount,nMaxExtent,lpResults,dwFlags);
// cprintf("placement code %d",code);
 if(code==0) return(XGetLastError2("GetCharacterPlacement",NULL));
 return(NULL);
}


// returns 2 16 bit numbers, width in lowest 16 bits

os_error * XGetCharacterPlacementW(
  HDC hdc,                  // handle to DC
  LPCWSTR lpString,          // character string
  int nCount,               // number of characters
  int nMaxExtent,           // maximum extent for string
  LPGCP_RESULTSW lpResults,  // placement result
  DWORD dwFlags             // placement options
)
{
 DWORD code;

 code=GetCharacterPlacementW(hdc,lpString,nCount,nMaxExtent,lpResults,dwFlags);
// cprintf("placement code %d",code);
 if(code==0) return(XGetLastError2("GetCharacterPlacementW",NULL));
 return(NULL);
}





os_error * XRegDeleteKey(HKEY hKey,LPCTSTR lpSubKey)
{
 LONG code;

 code=RegDeleteKey(hKey,lpSubKey);
 
 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegQueryValueEx","%s",lpSubKey));
}



os_error * XRegDeleteValue(HKEY hKey,LPCTSTR lpValueName)
{
 LONG code;

 code=RegDeleteValue(hKey,lpValueName);

 if(code==ERROR_SUCCESS) return(NULL);
 return(XFormatError2(code,"RegQueryValueEx","%s",lpValueName));
}


os_error * XLoadLibrary(LPCTSTR lpFileName,HMODULE * handle)
{
 *handle=LoadLibrary(lpFileName);

 if(*handle==NULL) return(XGetLastError2("LoadLibrary","%s",lpFileName));
 return(NULL);
}



os_error * XSetMapMode(HDC hdc,int fnMapMode,int * oldmode)
{
 int code;
 
 code=SetMapMode(hdc,fnMapMode);
 if(code==0) return(XGetLastError2("SetMapMode",NULL)); //NT only
 if(oldmode) *oldmode=code;
 return(NULL);
}


os_error * XSetViewportExtEx(
  HDC hdc,       // handle to device context
  int nXExtent,  // new horizontal viewport extent
  int nYExtent,  // new vertical viewport extent
  LPSIZE lpSize  // original viewport extent
)
{
 int code;

 code=SetViewportExtEx(hdc,nXExtent,nYExtent,lpSize);

 if(code==0) return(XGetLastError2("SetViewportExtEx",NULL)); //NT only
 return(NULL);
}


os_error * XSetViewportOrgEx(
  HDC hdc,        // handle to device context
  int X,          // new x-coordinate of viewport origin
  int Y,          // new y-coordinate of viewport origin
  LPPOINT lpPoint // original viewport origin
)
{
 int code;

 code=SetViewportOrgEx(hdc,X,Y,lpPoint);

 if(code==0) return(XGetLastError2("SetViewportOrgEx",NULL)); //NT only
 return(NULL);
}




os_error * XSetWindowOrgEx(
  HDC hdc,        // handle to device context
  int X,          // new x-coordinate of window origin
  int Y,          // new y-coordinate of window origin
  LPPOINT lpPoint // original window origin
)
{
 int code;

 code=SetWindowOrgEx(hdc,X,Y,lpPoint);

 if(code==0) return(XGetLastError2("SetWindowOrgEx",NULL)); //NT only
 return(NULL);
}



os_error * XSelectClipPath(HDC hdc,    // handle to DC
                           int iMode   // clipping mode
)
{
 int code;

 code=SelectClipPath(hdc,iMode);
 
 if(code==0) return(XGetLastError2("SelectClipPath",NULL)); //NT only
 return(NULL);
}


os_error * XModifyMenu(
  HMENU hMnu,           // handle to menu
  UINT uPosition,       // menu item to modify
  UINT uFlags,          // options
  UINT_PTR uIDNewItem,  // identifier, menu, or submenu
  LPCTSTR lpNewItem     // menu item content
)
{
 int code;

 code=ModifyMenu(hMnu,uPosition,uFlags,uIDNewItem,lpNewItem);
 if(code==0) return(XGetLastError2("ModifyMenu",NULL));
 return(NULL);
}



os_error * XGetMessage(
  LPMSG lpMsg,         // message information
  HWND hWnd,           // handle to window
  UINT wMsgFilterMin,  // first message
  UINT wMsgFilterMax,   // last message
  int * code)
{

 *code=GetMessage(lpMsg,hWnd,wMsgFilterMin,wMsgFilterMax);
 if(*code==-1) return(XGetLastError2("GetMessage",NULL));
 return(NULL);
}


os_error * XGetMessageW(
  LPMSG lpMsg,         // message information
  HWND hWnd,           // handle to window
  UINT wMsgFilterMin,  // first message
  UINT wMsgFilterMax,   // last message
  int * code)
{

 *code=GetMessageW(lpMsg,hWnd,wMsgFilterMin,wMsgFilterMax);
 if(*code==-1) return(XGetLastError2("GetMessageW",NULL));
 return(NULL);
}




os_error * XStartDoc(HDC hdc,CONST DOCINFO *lpdi,int * jobhandle)
{
 int code;

 code=StartDoc(hdc,lpdi);

 if(jobhandle) *jobhandle=code;

 if(code<0) return(XGetLastError2NT(EGENERAL,"StartDoc",NULL));

 return(NULL);
}


os_error * XStartDocPrinter(
  HANDLE hPrinter,  // handle to printer object
  DWORD Level,      // information level
  LPBYTE pDocInfo,  // information buffer
		int * jobhandle
)
{
	int code;

	code=StartDocPrinter(hPrinter,Level,pDocInfo);

 if(jobhandle) *jobhandle=code;

	if(code==0) return(XGetLastError2("StartDocPrinter",NULL));

 return(NULL);
}



os_error * XAddFontResource(LPCTSTR lpszFilename)
{
 int code;

 code=AddFontResource(lpszFilename);

 if(code<=0) return(XGenError(EGENERAL,"AddFontResource","Can't add font %s",lpszFilename));

 return(NULL);
}



os_error * XRemoveFontResource(LPCTSTR lpszFilename)
{
 int code;

 code=RemoveFontResource(lpszFilename);

 if(code<=0) return(XGenError(EGENERAL,"RemoveFontResource","Can't remove font %s",lpszFilename));

 return(NULL);
}















os_error * XAppendMenu(
  HMENU hMenu,         // handle to menu
  UINT uFlags,         // menu-item options
  UINT_PTR uIDNewItem, // identifier, menu, or submenu
  LPCTSTR lpNewItem    // menu-item content
)
{
 int code;

 code=AppendMenu(hMenu,uFlags,uIDNewItem,lpNewItem);
 if(code==0) return(XGetLastError2("AppendMenu",NULL));
 return(NULL);
}



os_error * XCreatePopupMenu(HMENU * menu)
{

 *menu=CreatePopupMenu();

 if(*menu==NULL) return(XGetLastError2("CreatePopupMenu",NULL));
 return(NULL);
}



os_error * XCreateMenu(HMENU * menu)
{

 *menu=CreateMenu();

 if(*menu==NULL) return(XGetLastError2("CreateMenu",NULL));
 return(NULL);
}



os_error * XDestroyMenu(
  HMENU hMenu  // handle to menu to destroy
)
{
 int code;

 code=DestroyMenu(hMenu);

 if(code==0) return(XGetLastError2("DestroyMenu",NULL));
 return(NULL);
}



os_error * XDeleteMenu(
  HMENU hMenu,     // handle to menu
  UINT uPosition,  // menu item identifier or position
  UINT uFlags      // option
)
{
 int code;

 code=DeleteMenu(hMenu,uPosition,uFlags);

 if(code==0) return(XGetLastError2("DeleteMenu",NULL));
 return(NULL);
}


os_error * XSetMenu(
  HWND hWnd,  // handle to window
  HMENU hMenu // handle to menu
)
{
 int code;

 code=SetMenu(hWnd,hMenu);
 if(code==0) return(XGetLastError2("SetMenu",NULL));
 return(NULL);
}


os_error * XGetMenuItemCount(HMENU hMenu,int * nitem)
{

 *nitem=GetMenuItemCount(hMenu);
 if(*nitem==-1)  return(XGetLastError2("GetMenuItemCount",NULL));
 return(NULL);
}



os_error * XSetMenuItemInfo(
  HMENU hMenu,          
  UINT uItem,           
  BOOL fByPosition,     
  LPMENUITEMINFO lpmii  
)
{
 int code;

 code=SetMenuItemInfo(hMenu,uItem,fByPosition,lpmii);

 if(code==0) return(XGetLastError2("SetMenuItemInfo",NULL));
 return(NULL);
}


os_error * XGetMenuItemInfo(
  HMENU hMenu,          // handle to menu
  UINT uItem,           // menu item
  BOOL fByPosition,     // meaning of uItem
  LPMENUITEMINFO lpmii  // menu item information
)
{
 int code;

 code=GetMenuItemInfo(hMenu,uItem,fByPosition,lpmii);
 if(code==0) return(XGetLastError2("GetMenuItemInfo",NULL));
 return(NULL);
}



os_error * XInsertMenuItem(
  HMENU hMenu,          
  UINT uItem,           
  BOOL fByPosition,     
  LPMENUITEMINFO lpmii  
)

{
 int code;
 
 code=InsertMenuItem(hMenu,uItem,fByPosition,lpmii);

 if(code==0) return(XGetLastError2("InsertMenuItem",NULL));
 return(NULL);
}
 


os_error * XLoadMenu(
  HINSTANCE hInstance,  // handle to application instance
  LPCTSTR lpMenuName,    // menu name string or menu-resource 
                        // identifier
  HMENU * menu
)
{

 *menu=LoadMenu(hInstance,lpMenuName);
 if(*menu==NULL) return(XGetLastError2("LoadMenu",NULL));
 return(NULL);
}



os_error * XGetMenu(HWND hWnd,HMENU * menu)
{
 *menu=GetMenu(hWnd);
 return(NULL);
}


// Wine seems to not be prepared for this to ask if a zero code means error

os_error * XTrackPopupMenuEx(
  HMENU hmenu,       
  UINT fuFlags,      
  int x,             
  int y,             
  HWND hwnd,         
  LPTPMPARAMS lptpm  
)

{
 int code;

 code=TrackPopupMenuEx(hmenu,fuFlags,x,y,hwnd,lptpm);
 
 if(code==0) return(XGetLastError2("TrackPopupMenuEx",NULL));
 return(NULL);
}


os_error * XGetSubMenu(
  HMENU hMenu,  // handle to menu
  int nPos,     // menu item position
  HMENU * submenu
)

{

 *submenu=GetSubMenu(hMenu,nPos);

 return(NULL);
}



os_error * XLoadMenuIndirect(
  CONST MENUTEMPLATE *lpMenuTemplate,  // address of menu template
  HMENU * menuh
)

{
 *menuh=LoadMenuIndirect(lpMenuTemplate);
 
 if(*menuh==NULL) return(XGetLastError2("LoadMenuIndirect",NULL));

 return(NULL);
}




os_error * XDrawMenuBar(HWND hWnd)
{
	int code;

 code=DrawMenuBar(hWnd);

 if(code==0) return(XGetLastError2("DrawMenuBar",NULL));
 return(NULL);
}



// code value doesn't seem to be trustworthy i.e. for null region

os_error * XIntersectClipRect(HDC hdc,int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,int * code)
{

	*code=IntersectClipRect(hdc,nLeftRect,nTopRect,nRightRect,nBottomRect);

	if(*code==ERROR)	return(XGenError(EGENERAL,"IntersectClipRect"," - Error"));
	return(NULL);
}



os_error * XCreateProcess(
  LPCTSTR lpApplicationName,                 // name of executable module
  LPTSTR lpCommandLine,                      // command line string
  LPSECURITY_ATTRIBUTES lpProcessAttributes, // SD
  LPSECURITY_ATTRIBUTES lpThreadAttributes,  // SD
  BOOL bInheritHandles,                      // handle inheritance option
  DWORD dwCreationFlags,                     // creation flags
  LPVOID lpEnvironment,                      // new environment block
  LPCTSTR lpCurrentDirectory,                // current directory name
  LPSTARTUPINFO lpStartupInfo,               // startup information
  LPPROCESS_INFORMATION lpProcessInformation // process information
)
{
 int code;

 code=CreateProcess(
  lpApplicationName,                 // name of executable module
  lpCommandLine,                      // command line string
  lpProcessAttributes, // SD
  lpThreadAttributes,  // SD
  bInheritHandles,                      // handle inheritance option
  dwCreationFlags,                     // creation flags
  lpEnvironment,                      // new environment block
  lpCurrentDirectory,                // current directory name
  lpStartupInfo,               // startup information
  lpProcessInformation // process information
);


 if(code==0) return(XGetLastError2("CreateProcess",NULL));
 return(NULL);
}





os_error * XRegisterHotKey(
  HWND hWnd,         // handle to window
  int id,            // hot key identifier
  UINT fsModifiers,  // key-modifier options
  UINT vk            // virtual-key code
)
{
	int code;

	code=RegisterHotKey(hWnd,id,fsModifiers,vk);

	if(code==0)	return(XGetLastError2("RegisterHotKey",NULL));

	return(NULL);
}


os_error * XUnregisterHotKey(
  HWND hWnd,  // handle to window
  int id      // hot key identifier
)
{
	int code;

	code=UnregisterHotKey(hWnd,id);

	if(code==0)	return(XGetLastError2("UnregisterHotKey",NULL));

	return(NULL);
}




os_error * XOpenPrinter(
  LPTSTR pPrinterName,         // printer or server name
  LPHANDLE phPrinter,          // printer or server handle
  LPPRINTER_DEFAULTS pDefault  // printer defaults
)
{
	int code;

	code=OpenPrinter(pPrinterName,phPrinter,pDefault);

	if(code==0)		return(XGetLastError2("OpenPrinter",NULL));

	return(NULL);
}


os_error * XClosePrinter(
  HANDLE hPrinter,   // handle to printer object
		os_error * err
)
{
	int code;

 code=ClosePrinter(hPrinter);

	if(code==0 && err==NULL)		return(XGetLastError2("ClosePrinter",NULL));

	return(err);
}


os_error * XGetPrinter(
  HANDLE hPrinter,    // handle to printer
  DWORD Level,        // information level
  LPBYTE pPrinter,    // printer information buffer
  DWORD cbBuf,        // size of buffer
  LPDWORD pcbNeeded   // bytes received or required
)
{
 int        code;
	os_error * err;

 code=GetPrinter(hPrinter,Level,pPrinter,cbBuf,pcbNeeded);

	if(code==0)
	{
		err=XGetLastError2("GetPrinter",NULL);
		if(err->errnum==ERROR_INSUFFICIENT_BUFFER && pPrinter==NULL) err=NULL;		// buffer not big enough when finding size...
		return(err);
	}


	return(NULL);
}



os_error * XGetPrinterDriver(
  HANDLE hPrinter,     // printer object
  LPTSTR pEnvironment, // environment name
  DWORD Level,         // information level
  LPBYTE pDriverInfo,  // driver data buffer
  DWORD cbBuf,         // size of buffer
  LPDWORD pcbNeeded    // bytes received or required
)
{
 int        code;
	os_error * err;

	code=GetPrinterDriver(hPrinter,pEnvironment,Level,pDriverInfo,cbBuf,pcbNeeded);

	if(code==0)
	{
 	err=XGetLastError2("GetPrinterDriver",NULL);
		if(err->errnum==ERROR_INSUFFICIENT_BUFFER && pDriverInfo==NULL) err=NULL;		// buffer not big enough when finding size...
		return(err);
	}

	return(NULL);
}



os_error * XGetPrinterData(
  HANDLE hPrinter,    // handle to printer or print server
  LPTSTR pValueName,  // value name
  LPDWORD pType,      // data type
  LPBYTE pData,       // configuration data buffer
  DWORD nSize,        // size of configuration data buffer
  LPDWORD pcbNeeded   // bytes received or required 
)
{
 int code;

 code=GetPrinterData(hPrinter,pValueName,pType,pData,nSize,pcbNeeded);
 cprintf("print data code %d",code);
 if(code==ERROR_SUCCESS) return(NULL);
	if(code==ERROR_INSUFFICIENT_BUFFER && pData==NULL) return(NULL);		// buffer not big enough when finding size...
	if(code==ERROR_MORE_DATA && pData==NULL) return(NULL);		// buffer not big enough when finding size...
 return(XFormatError2(code,"GetPrinterData",NULL));
}




os_error * XCreateDC(
  LPCTSTR lpszDriver,        // driver name
  LPCTSTR lpszDevice,        // device name
  LPCTSTR lpszOutput,        // not used; should be NULL
  CONST DEVMODE *lpInitData, // optional printer data
		HDC * hdc
)
{

 *hdc=CreateDC(lpszDriver,lpszDevice,lpszOutput,lpInitData);
	if(*hdc==NULL)	return(XGetLastError2NT(EGENERAL,"CreateDC",NULL));

	return(NULL);
}


os_error * XCreateIC(
  LPCTSTR lpszDriver,       // driver name
  LPCTSTR lpszDevice,       // device name
  LPCTSTR lpszOutput,       // port or file name
  CONST DEVMODE *lpdvmInit,  // optional initialization data
		HDC * hdc
)
{

	*hdc=CreateIC(lpszDriver,lpszDevice,lpszOutput,lpdvmInit);
	if(*hdc==NULL)	return(XGetLastError2NT(EGENERAL,"CreateIC",NULL));

	return(NULL);
}



os_error * XDeleteDC(
  HDC hdc,   // handle to DC
		os_error * err
)
{
	int code;

 code=DeleteDC(hdc);
	if(code==0 && err==NULL) return(XGetLastError2NT(EGENERAL,"DeleteDC",NULL));

	return(err);
}



os_error * XSendMessage(
  HWND hWnd,      // handle to destination window
  UINT Msg,       // message
  WPARAM wParam,  // first message parameter
  LPARAM lParam,   // second message parameter
  LRESULT * result
)
{
	if(result) *result=SendMessage(hWnd,Msg,wParam,lParam);
	else															SendMessage(hWnd,Msg,wParam,lParam);
	return(NULL);
}




os_error * XGetModuleHandle(LPCTSTR lpModuleName,HMODULE * result)
{
	*result=GetModuleHandle(lpModuleName);
	if(!*result)	return(XGetLastError2("GetModuleHandle",NULL));
	return(NULL);
}


os_error * XGetProcAddress(HMODULE hModule,LPCSTR lpProcName,FARPROC * result)
{
	*result=GetProcAddress(hModule,lpProcName);
	if(!*result)	return(XGetLastError2("GetProcAddress",NULL));
	return(NULL);
}










#include "icm.h"

#include "oscms.h"

typedef BOOL (WINAPI * ccpfn)(HPROFILE hProfile);
typedef HPROFILE (WINAPI * ocpfn)(PPROFILE pProfile,DWORD dwDesiredAccess,DWORD dwShareMode,DWORD dwCreationMode);
typedef HTRANSFORM (WINAPI * cmptfn)(PHPROFILE pahProfiles,DWORD nProfiles,PDWORD padwIntent,DWORD nIntents,DWORD dwFlags,DWORD indexPreferredCMM);
typedef BOOL (WINAPI * dctfn)(HTRANSFORM hColorTransform);
typedef BOOL (WINAPI * icptpfn)(HPROFILE hProfile,TAGTYPE tag,PBOOL pbPresent);
typedef BOOL (WINAPI * gcpefn)(HPROFILE hProfile,TAGTYPE tag,DWORD dwOffset,PDWORD pcbSize,PVOID pBuffer,PBOOL pbReference);
typedef BOOL (WINAPI * tbbfn)(HTRANSFORM hColorTransform,PVOID pSrcBits,BMFORMAT bmInput,DWORD dwWidth,DWORD dwHeight,DWORD dwInputStride,PVOID pDestBits, BMFORMAT bmOutput,DWORD dwOutputStride,PBMCALLBACKFN pfnCallback,ULONG ulCallbackData);
typedef	BOOL (WINAPI * gcphfn)(HPROFILE hProfile,PPROFILEHEADER pHeader);
typedef BOOL (WINAPI * gcdfn)(PTSTR pMachineName,PTSTR pBuffer,PDWORD pdwSize);

typedef BOOL (WINAPI * sipfn)(HDC hDC,LPTSTR lpFileName);

typedef int (WINAPI * simfn)(HDC hDC,int iEnableICM);

typedef BOOL (WINAPI * gipfn)(HDC hDC,LPDWORD lpcbName,LPTSTR lpszFilename);

typedef BOOL (WINAPI * cmmfn)(DWORD cmmID);

typedef BOOL (WINAPI * rcmmfn)(PCTSTR pMachineName,DWORD cmmID,PCTSTR pCMMdll);





static ccpfn	  icmccpfn;
static ocpfn   icmocpfn;
static cmptfn  icmcmptfn;
static dctfn   icmdctfn;
static icptpfn icmicptpfn;
static gcpefn  icmgcpefn;
static tbbfn   icmtbbfn;
static gcphfn  icmgcphfn;
static gcdfn   icmgcdfn;
static sipfn   icmsipfn;
static gipfn   icmgipfn;
static simfn   icmsimfn;
static cmmfn   icmcmmfn;
static rcmmfn  icmrcmmfn;


os_error * XCloseColorProfile(HPROFILE hProfile)
{
	int code;

	code=icmccpfn(hProfile);
	if(!code)	return(XGetLastError2("CloseColorProfile",NULL));
	return(NULL);
}


os_error * XOpenColorProfile(PPROFILE pProfile,DWORD dwDesiredAccess,DWORD dwShareMode,DWORD dwCreationMode,HPROFILE * hprofile)
{
	*hprofile=icmocpfn(pProfile,dwDesiredAccess,dwShareMode,dwCreationMode);
	if(!*hprofile)	return(XGetLastError2("OpenColorProfile",NULL));
	return(NULL);
}


os_error * XCreateMultiProfileTransform(PHPROFILE pahProfiles,DWORD nProfiles,PDWORD padwIntent,DWORD nIntents,DWORD dwFlags,DWORD indexPreferredCMM,HTRANSFORM * htransform)
{
 *htransform=icmcmptfn(pahProfiles,nProfiles,padwIntent,nIntents,dwFlags,indexPreferredCMM);
	if(!*htransform) return(XGetLastError2("CreateMultiProfileTransform",NULL));
	return(NULL);
}


os_error * XDeleteColorTransform(HTRANSFORM hColorTransform)
{
	int code;

	code=icmdctfn(hColorTransform);
	if(!code)	return(XGetLastError2("DeleteColorTransform",NULL));
	return(NULL);
}


os_error * XIsColorProfileTagPresent(HPROFILE hProfile,TAGTYPE tag,PBOOL pbPresent)
{
	int code;

	code=icmicptpfn(hProfile,tag,pbPresent);
	if(!code)	return(XGetLastError2("IsColorProfileTagPresent",NULL));
	return(NULL);
}


os_error * XGetColorProfileElement(HPROFILE hProfile,TAGTYPE tag,DWORD dwOffset,PDWORD pcbSize,PVOID pBuffer,PBOOL pbReference)
{
	int code;

	code=icmgcpefn(hProfile,tag,dwOffset,pcbSize,pBuffer,pbReference);
	if(!code)	return(XGetLastError2("GetColorProfileElement",NULL));
	return(NULL);
}


os_error * XTranslateBitmapBits(HTRANSFORM hColorTransform,PVOID pSrcBits,BMFORMAT bmInput,DWORD dwWidth,DWORD dwHeight,DWORD dwInputStride,PVOID pDestBits,BMFORMAT bmOutput,DWORD dwOutputStride,PBMCALLBACKFN pfnCallback,ULONG ulCallbackData)
{
	int code;

	code=icmtbbfn(hColorTransform,pSrcBits,bmInput,dwWidth,dwHeight,dwInputStride,pDestBits,bmOutput,dwOutputStride,pfnCallback,ulCallbackData);
	if(!code)	return(XGetLastError2("TranslateBitmapBits",NULL));
	return(NULL);
}


os_error * XGetColorProfileHeader(HPROFILE hProfile,PPROFILEHEADER pHeader)
{
	int code;

	code=icmgcphfn(hProfile,pHeader);
	if(!code)	return(XGetLastError2("GetColorProfileHeader",NULL));
	return(NULL);
}


os_error * XGetColorDirectory(PTSTR pMachineName,PTSTR pBuffer,PDWORD pdwSize)
{
	int code;

 code=icmgcdfn(pMachineName,pBuffer,pdwSize);
	if(!code)	return(XGetLastError2("GetColorDirectory",NULL));
	return(NULL);
}


os_error * XSelectCMM(DWORD cmmid)
{
 int code;

 code=icmcmmfn(cmmid);

// cprintf("XsetCMM %x returns %x",cmmid,code);

 if(!code)	return(XGetLastError2("SelectCMM",NULL));

 return(NULL);
}


os_error * XRegisterCMM(PCTSTR pMachineName,DWORD cmmID,PCTSTR pCMMdll)
{
 int code;

// code=icmrcmmfn(pMachineName,cmmID,pCMMdll);

 code=1;

 cprintf("register %x %s ptr %x",cmmID,pCMMdll,icmrcmmfn);

 if(!code)	return(XGetLastError2("RegisterCMM",NULL));

 return(NULL);
}



// GDI32.LIB

os_error * XGetICMProfile(HDC hDC,LPDWORD lpcbName,LPTSTR lpszFilename)
{
	int code;

 code=icmgipfn(hDC,lpcbName,lpszFilename);

	if(!code)	return(XGetLastError2("GetICMProfile",NULL));
	return(NULL);
}


// GDI32.LIB

os_error * XSetICMProfile(HDC hDC,LPTSTR lpFileName)
{
	int code;

 code=icmsipfn(hDC,lpFileName);

	if(!code)	return(XGetLastError2("SetICMProfile",NULL));
	return(NULL);
}


// GDI32.LIB

os_error * XSetICMMode(HDC hDC,int iEnableICM)
{
	int code;

	code=icmsimfn(hDC,iEnableICM);

	if(!code) return(XGetLastError2("SetICMMode",NULL));
	return(NULL);
}


os_error * XGetDisplayProfile(LPTSTR buffer,PDWORD size)
{
	os_error * err;
	HDC        hdc;

	err=XCreateIC(TEXT("DISPLAY"),NULL,NULL,NULL,&hdc);
	if(!err)
	{
		err=XGetICMProfile(hdc,size,buffer);

		XDeleteDC(hdc,err);
	}

	return(err);
}





os_error * icminit(int * icmpresent)
{
	os_error * err;
	HMODULE    handle;

	*icmpresent=0;

 err=XLoadLibrary(TEXT("mscms"),&handle);

	if(!err && handle)
	{
  icmccpfn=(ccpfn)GetProcAddress(handle,TEXT("CloseColorProfile"));

#ifdef UNICODE
  icmocpfn=(ocpfn)GetProcAddress(handle,TEXT("OpenColorProfileW"));
  icmgcdfn=(gcdfn)GetProcAddress(handle,TEXT("GetColorDirectoryW"));
  icmgcdfn=(gcdfn)GetProcAddress(handle,TEXT("GetColorDirectoryW"));
  icmrcmmfn=(rcmmfn)GetProcAddress(handle,TEXT("RegisterCMMW"));
#else
  icmocpfn=(ocpfn)GetProcAddress(handle,TEXT("OpenColorProfileA"));
  icmgcdfn=(gcdfn)GetProcAddress(handle,TEXT("GetColorDirectoryA"));
  icmgcdfn=(gcdfn)GetProcAddress(handle,TEXT("GetColorDirectoryA"));
  icmrcmmfn=(rcmmfn)GetProcAddress(handle,TEXT("RegisterCMMA"));
#endif

  icmcmptfn=(cmptfn)GetProcAddress(handle,TEXT("CreateMultiProfileTransform"));
  icmdctfn=(dctfn)GetProcAddress(handle,TEXT("DeleteColorTransform"));
  icmicptpfn=(icptpfn)GetProcAddress(handle,TEXT("IsColorProfileTagPresent"));
  icmgcpefn=(gcpefn)GetProcAddress(handle,TEXT("GetColorProfileElement"));
  icmtbbfn=(tbbfn)GetProcAddress(handle,TEXT("TranslateBitmapBits"));
  icmgcphfn=(gcphfn)GetProcAddress(handle,TEXT("GetColorProfileHeader"));
  icmcmmfn=(cmmfn)GetProcAddress(handle,TEXT("SelectCMM"));


		if(icmccpfn && icmocpfn && icmcmptfn && icmdctfn && icmicptpfn && icmgcpefn && icmtbbfn	&&icmgcphfn &&icmgcdfn &&icmcmmfn &&icmrcmmfn)	*icmpresent=1;

  cprintf("rcptr %x present %d",icmrcmmfn,*icmpresent);

	}

	if(*icmpresent)
	{
  err=XLoadLibrary(TEXT("gdi32"),&handle);
 	if(!err && handle)
 	{

#ifdef UNICODE
   icmgipfn=(gipfn)GetProcAddress(handle,TEXT("GetICMProfileW"));
   icmsipfn=(sipfn)GetProcAddress(handle,TEXT("SetICMProfileW"));
#else
   icmgipfn=(gipfn)GetProcAddress(handle,TEXT("GetICMProfileA"));
   icmsipfn=(sipfn)GetProcAddress(handle,TEXT("SetICMProfileA"));
#endif

   icmsimfn=(simfn)GetProcAddress(handle,TEXT("SetICMMode"));

	cprintf("icmpreent %d gip %x sip %x sim %x",(*icmpresent),icmgipfn,icmsipfn,icmsimfn);

 		*icmpresent=(*icmpresent) && icmgipfn	&& icmsipfn && icmsimfn;
 	}
	}

	return(NULL);
}

