
extern DWORD XGetVersion(void);

extern os_error * XGetLastError(void);

extern os_error * XCopyFile(LPCTSTR lpExistingFileName,LPCTSTR lpNewFileName,BOOL bFailIfExists);
extern os_error * XMoveFile(LPCTSTR lpExistingFileName,LPCTSTR lpNewFileName);
extern os_error * XDeleteFile(LPCTSTR lpFileName);
extern os_error * XRemoveDirectory(LPCTSTR lpPathName);
extern os_error * XCreateDirectory(LPCTSTR lpPathName,LPSECURITY_ATTRIBUTES lpSecurityAttributes);
extern os_error * XGetFileAttributes(LPCTSTR lpFileName,DWORD * result);

extern os_error * XGetFileAttributesEx(LPCTSTR lpFileName,GET_FILEEX_INFO_LEVELS fInfoLevelId,LPVOID lpFileInformation);

extern os_error * XCreateFile(
  LPCTSTR lpFileName,
  DWORD dwDesiredAccess,
  DWORD dwShareMode,
  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
  DWORD dwCreationDisposition,
  DWORD dwFlagsAndAttributes,
  HANDLE hTemplateFile,
  HANDLE * filehandle
);
 
extern os_error * XSetFilePointer(
  HANDLE hFile,
  LONG lDistanceToMove,  // number of bytes to move file pointer
  PLONG lpDistanceToMoveHigh,
                         // pointer to high-order DWORD of 
                         // distance to move
  DWORD dwMoveMethod,    // how to move
  DWORD * result
);


extern os_error * XFindNextFile(
  HANDLE hFindFile,  // handle to search
  LPWIN32_FIND_DATA lpFindFileData, 
                     // pointer to structure for data on found file
  int * eof
);


extern os_error * XFindFirstFile(
  LPCTSTR lpFileName,  // pointer to name of file to search for
  LPWIN32_FIND_DATA lpFindFileData,
                       // pointer to returned information
  HANDLE * handle
);

extern os_error * XFindClose(
  HANDLE hFindFile   // file search handle
);


extern os_error * XSetEndOfFile(
  HANDLE hFile   // handle of file whose EOF is to be set
);


extern os_error * XWriteFile(
  HANDLE hFile,                    // handle to file to write to
  LPCVOID lpBuffer,                // pointer to data to write to file
  DWORD nNumberOfBytesToWrite,     // number of bytes to write
  LPDWORD lpNumberOfBytesWritten,  // pointer to number of bytes written
  LPOVERLAPPED lpOverlapped        // pointer to structure for overlapped I/O
);

extern os_error * XReadFile(
  HANDLE hFile,                // handle of file to read
  LPVOID lpBuffer,             // pointer to buffer that receives data
  DWORD nNumberOfBytesToRead,  // number of bytes to read
  LPDWORD lpNumberOfBytesRead, // pointer to number of bytes read
  LPOVERLAPPED lpOverlapped    // pointer to structure for data
);

extern os_error * XCloseHandle(
  HANDLE hObject   // handle to object to close
);

extern os_error * XGetFileSize(
  HANDLE hFile,  // handle of file to get size of
  LPDWORD lpFileSizeHigh,
                 // pointer to high-order word for file size
  DWORD * result
);

extern os_error * XVirtualFree(
  LPVOID lpAddress,  // address of region of committed pages
  DWORD dwSize,      // size of region
  DWORD dwFreeType   // type of free operation
);

extern os_error * XVirtualAlloc(
  LPVOID lpAddress, // address of region to reserve or commit
  DWORD dwSize,     // size of region
  DWORD flAllocationType,
                    // type of allocation
  DWORD flProtect,   // type of access protection
  LPVOID * result
);


extern VOID XGetSystemInfo(
  LPSYSTEM_INFO lpSystemInfo   // address of system information 
                               // structure
);


extern os_error * XGetClientRect(
  HWND hWnd,      // handle to window
  LPRECT lpRect   // address of structure for client coordinates
);


extern VOID XZeroMemory(
  PVOID Destination, 
                 // address of block to fill with zeros
  DWORD Length   // size, in bytes, of block to fill with zeros
);

extern os_error * XGetScrollInfo(
  HWND hwnd,         // handle to window with scroll bar
  int fnBar,         // scroll bar flag
  LPSCROLLINFO lpsi  // pointer to structure for scroll parameters
);

extern os_error * XScrollWindowEx(
  HWND hWnd,        // handle to window to scroll
  int dx,           // amount of horizontal scrolling
  int dy,           // amount of vertical scrolling
  CONST RECT *prcScroll,
                    // address of structure with scroll rectangle
  CONST RECT *prcClip,
                    // address of structure with clip rectangle
  HRGN hrgnUpdate,  // handle to update region
  LPRECT prcUpdate, // address of structure for update rectangle
  UINT flags,        // scrolling flags
  int * result
);

extern os_error * XSetScrollInfo(
  HWND hwnd,    // handle to window with scroll bar
  int fnBar,    // scroll bar flag
  LPSCROLLINFO lpsi,
                // pointer to structure with scroll parameters
  BOOL fRedraw,  // redraw flag
  int * posn
);


extern os_error * XRegSetValueEx(
  HKEY hKey,           // handle to key to set value for
  LPCTSTR lpValueName, // name of the value to set
  DWORD Reserved,      // reserved
  DWORD dwType,        // flag for value type
  CONST BYTE *lpData,  // address of value data
  DWORD cbData         // size of value data
);

extern os_error * XRegCloseKey(
  HKEY hKey   // handle to key to close
);

extern os_error * XRegCreateKeyEx(
  HKEY hKey,                // handle to an open key
  LPCTSTR lpSubKey,         // address of subkey name
  DWORD Reserved,           // reserved
  LPTSTR lpClass,           // address of class string
  DWORD dwOptions,          // special options flag
  REGSAM samDesired,        // desired security access
  LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                            // address of key security structure
  PHKEY phkResult,          // address of buffer for opened handle
  LPDWORD lpdwDisposition   // address of disposition value buffer
);



extern os_error * XRegOpenKeyEx(
  HKEY hKey,         // handle to open key
  LPCTSTR lpSubKey,  // address of name of subkey to open
  DWORD ulOptions,   // reserved
  REGSAM samDesired, // security access mask
  PHKEY phkResult    // address of handle to open key
);


extern os_error * XRegEnumKeyEx(
  HKEY hKey,          // handle to key to enumerate
  DWORD dwIndex,      // index of subkey to enumerate
  LPTSTR lpName,      // address of buffer for subkey name
  LPDWORD lpcbName,   // address for size of subkey buffer
  LPDWORD lpReserved, // reserved
  LPTSTR lpClass,     // address of buffer for class string
  LPDWORD lpcbClass,  // address for size of class buffer
  PFILETIME lpftLastWriteTime,
                      // address for time key last written to
  int * eof
);


extern os_error * XRegQueryValueEx(
  HKEY hKey,           // handle to key to query
  LPTSTR lpValueName,  // address of name of value to query
  LPDWORD lpReserved,  // reserved
  LPDWORD lpType,      // address of buffer for value type
  LPBYTE lpData,       // address of data buffer
  LPDWORD lpcbData     // address of data buffer size
);


extern os_error * XRegEnumValue(
  HKEY hKey,              // handle to key to query
  DWORD dwIndex,          // index of value to query
  LPTSTR lpValueName,     // address of buffer for value string
  LPDWORD lpcbValueName,  // address for size of value buffer
  LPDWORD lpReserved,     // reserved
  LPDWORD lpType,         // address of buffer for type code
  LPBYTE lpData,          // address of buffer for value data
  LPDWORD lpcbData,        // address for size of data buffer
  int   * eof
);






extern os_error *  XFindResource(
  HMODULE hModule, // module handle
  LPCTSTR lpName,  // pointer to resource name
  LPCTSTR lpType,   // pointer to resource type
  HRSRC * handle
);


extern os_error * XLoadResource(
  HMODULE hModule, // resource-module handle
  HRSRC hResInfo,   // resource handle
  HGLOBAL * handle
);

extern os_error * XLockResource(
  HGLOBAL hResData,
  LPVOID * handle
);



extern os_error * XGetCursorPos(
  LPPOINT lpPoint   // address of structure for cursor position
);



extern os_error * XCreateDialogIndirect(
  HINSTANCE hInstance,        // handle to application instance
  LPCDLGTEMPLATE lpTemplate,  // pointer to dialog box template
  HWND hWndParent,            // handle to owner window
  DLGPROC lpDialogFunc,       // pointer to dialog box procedure
  HWND * hwnd
);





extern os_error * XDestroyWindow(
  HWND hWnd   // handle to window to destroy
);


extern os_error * XCloseWindow(
  HWND hWnd   // handle to window to minimize
);


extern os_error * XGetWindowRect(
  HWND hWnd,      // handle to window
  LPRECT lpRect   // address of structure for window coordinates
);

extern os_error * XSetWindowPos(
  HWND hWnd,             // handle to window
  HWND hWndInsertAfter,  // placement-order handle
  int X,                 // horizontal position
  int Y,                 // vertical position
  int cx,                // width
  int cy,                // height
  UINT uFlags            // window-positioning flags
);

extern os_error * XPostQuitMessage(
  int nExitCode   // exit code
);


extern os_error * XDragQueryFile(
    HDROP hDrop,
    UINT iFile,
    LPTSTR lpszFile,
    UINT cch,
    UINT * count
);


extern os_error * XDragQueryPoint(
    HDROP hDrop,
    LPPOINT lppt,
    int * result
);


extern os_error * XDragFinish(
    HDROP hDrop
);


extern os_error * XChildWindowFromPoint(
  HWND hWndParent,  // handle to parent window
  POINT Point,  // structure with point coordinates
  HWND * child
);


extern os_error * XMapWindowPoints(
  HWND hWndFrom, // handle of window to be mapped from
  HWND hWndTo,       // handle to window to be mapped to
  LPPOINT lpPoints,  // pointer to array with points to map
  UINT cPoints,       // number of structures in array
  int * result
);
 


extern os_error * XDefWindowProc(
  HWND hWnd,      // handle to window
  UINT Msg,       // message identifier
  WPARAM wParam,  // first message parameter
  LPARAM lParam,  // second message parameter
  LRESULT * result
);


extern os_error * XDefWindowProcX(
  HWND hWnd,      // handle to window
  UINT Msg,       // message identifier
  WPARAM wParam,  // first message parameter
  LPARAM lParam,  // second message parameter
  LRESULT * result
);



extern os_error * XGetWindowLong(
  HWND hWnd,  // handle of window
  int nIndex,  // offset of value to retrieve
  LONG * result
);


extern os_error * XGetWindowLongPtr(
  HWND hWnd,  // handle to window
  int nIndex,  // offset of value to retrieve
  LONG_PTR * result
);


extern os_error * XGetParent(
  HWND hWnd,   // handle to child window
  HWND * parent
);


extern os_error * XWinHelp(
    HWND hWndMain,
    LPCTSTR lpszHelp,
    UINT uCommand,
    DWORD dwData
);

extern os_error * XRegisterClass(CONST WNDCLASS *lpWndClass,ATOM * atom);



extern os_error * XEnumResourceNames(
  HINSTANCE hModule,           // resource-module handling
  LPCTSTR lpszType,            // pointer to resource type
  ENUMRESNAMEPROC lpEnumFunc,  // pointer to callback function
  LPARAM lParam                  // application-defined parameter
);


extern os_error * XSetWindowLong(
  HWND hWnd,       // handle of window
  int nIndex,      // offset of value to set
  LONG dwNewLong,   // new value
  LONG * result
);


extern os_error * XSetWindowLongPtr(
  HWND hWnd,           // handle to window
  int nIndex,          // offset of value to set
  LONG_PTR dwNewLong,   // new value
		LONG_PTR	* result
);


extern os_error * XCreateWindowEx(
  DWORD dwExStyle,      // extended window style
  LPCTSTR lpClassName,  // pointer to registered class name
  LPCTSTR lpWindowName, // pointer to window name
  DWORD dwStyle,        // window style
  int x,                // horizontal position of window
  int y,                // vertical position of window
  int nWidth,           // window width
  int nHeight,          // window height
  HWND hWndParent,      // handle to parent or owner window
  HMENU hMenu,          // handle to menu, or child-window identifier
  HINSTANCE hInstance,  // handle to application instance
  LPVOID lpParam,       // pointer to window-creation data
  HWND * result
);

extern os_error * XSendDlgItemMessage(
  HWND hDlg,      // handle of dialog box
  int nIDDlgItem, // identifier of control
  UINT Msg,       // message to send
  WPARAM wParam,  // first message parameter
  LPARAM lParam,  // second message parameter
  LRESULT * result
);

extern os_error * XSetCursorPos(
  int X,  // horizontal position
  int Y   // vertical position
);


extern os_error * XGetWindowThreadProcessId(
  HWND hWnd,             // handle to window
  LPDWORD lpdwProcessId,  // address of variable for process identifier
  LPDWORD lpdwthread
);


extern os_error * XGetDlgItem(
  HWND hDlg,       // handle of dialog box
  int nIDDlgItem,   // identifier of control
  HWND * child
);


extern os_error * XGetDlgCtrlID(
  HWND hwndCtl,   // handle of control
  int * id
);


extern os_error * XReleaseCapture(void);


extern os_error * XSetCapture(
  HWND hWnd,   // handle of window to receive mouse capture
  HWND * hprev
);



extern os_error * XClientToScreen(
  HWND hWnd,       // window handle for source coordinates
  LPPOINT lpPoint  // pointer to structure containing screen coordinates
);


extern os_error * XScreenToClient(
  HWND hWnd,        // window handle for source coordinates
  LPPOINT lpPoint   // address of structure containing coordinates
);


extern os_error * XGetDlgItemText(
  HWND hDlg,       // handle of dialog box
  int nIDDlgItem,  // identifier of control
  LPTSTR lpString, // address of buffer for text
  int nMaxCount,    // maximum size of string
  unsigned int * read
);


extern os_error * XGetDlgItemTextW(
  HWND hDlg,       // handle of dialog box
  int nIDDlgItem,  // identifier of control
  LPWSTR lpString, // address of buffer for text
  int nMaxCount,    // maximum size of string
  unsigned int * read
);



extern os_error * XSetFocus(HWND hWnd,   // handle to window to receive focus
                     HWND * prev
);

extern os_error * XGetTextMetrics(
  HDC hdc,            // handle to device context
  LPTEXTMETRIC lptm   // pointer to text metrics structure
);


extern os_error * XCreateMetaFile(
  LPCTSTR lpszFile,   // pointer to filename string
  HDC * hdc
);


extern os_error * XCloseMetaFile(
  HDC hdc,   // handle to metafile device context
  HMETAFILE * hmf
);

extern os_error * XGetMetaFileBitsEx(
  HMETAFILE hmf,  // handle to metafile
  UINT nSize,     // size of metafile, in bytes
  LPVOID lpvData,  // pointer to metafile data
  UINT * length
);


extern os_error * XDeleteMetaFile(
  HMETAFILE hmf   // handle to Windows-format metafile
);


extern os_error * XCreateEnhMetaFile(
  HDC hdcRef,           // handle to a reference device context
  LPCTSTR lpFilename,   // pointer to a filename string
  CONST RECT *lpRect,   // pointer to a bounding rectangle
  LPCTSTR lpDescription, // pointer to an optional description string
  HDC * hdc
);


extern os_error * XCloseEnhMetaFile(
  HDC hdc,   // handle to an enhanced-metafile device context
  HENHMETAFILE * hmf
);

 

extern os_error * XDeleteEnhMetaFile(
  HENHMETAFILE hemf   // handle to an enhanced metafile
);


extern os_error * XSetWindowExtEx(
  HDC hdc,       // handle of device context
  int nXExtent,  // new horizontal window extent
  int nYExtent,  // new vertical window extent
  LPSIZE lpSize  // original window extent
);


extern os_error * XMoveToEx(
  HDC hdc,          // handle to device context
  int X,            // x-coordinate of new current position
  int Y,            // y-coordinate of new current position
  LPPOINT lpPoint   // pointer to old current position
);


extern os_error * XSetTextAlign(
  HDC hdc,     // handle to device context
  UINT fMode,   // text-alignment flag
  UINT * prev
);

extern os_error * XSizeofResource(
  HMODULE hModule, // resource-module handle
  HRSRC hResInfo,   // resource handle
  unsigned int * length
);

extern os_error * XTextOut(
  HDC hdc,           // handle to device context
  int nXStart,       // x-coordinate of starting position
  int nYStart,       // y-coordinate of starting position
  LPCTSTR lpString,  // pointer to string
  int cbString       // number of characters in string
);


extern os_error * XGetTextExtentPoint32(
  HDC hdc,           // handle to device context
  LPCTSTR lpString,  // pointer to text string
  int cbString,      // number of characters in string
  LPSIZE lpSize      // pointer to structure for string size
);


extern os_error * XGetTextExtentPoint32W(
  HDC hdc,           // handle to device context
  LPCWSTR lpString,  // pointer to text string
  int cbString,      // number of characters in string
  LPSIZE lpSize      // pointer to structure for string size
);




extern os_error * XSetBkMode(
  HDC hdc,      // handle of device context
  int iBkMode,   // flag specifying background mode
  int * prev
);



extern os_error * XSelectObject(
  HDC hdc,          // handle to device context
  HGDIOBJ hgdiobj,  // handle to object
  HGDIOBJ * prev
);




extern os_error * XGetObject(
  HGDIOBJ hgdiobj,  // handle to graphics object of interest
  int cbBuffer,     // size of buffer for object information
  LPVOID lpvObject,  // pointer to buffer for object information
  int * size
);




extern os_error * XDeleteObject(
  HGDIOBJ hObject   // handle to graphic object
);




extern os_error * XSetTextColor(
  HDC hdc,           // handle to device context
  COLORREF crColor,  // text color
  COLORREF * prev
);


extern os_error * XSetBkColor(
  HDC hdc,           // handle of device context
  COLORREF crColor,  // background color value
  COLORREF * prev
);



extern os_error * XCreateFontIndirect(
  CONST LOGFONT *lplf,   // pointer to logical font structure
  HFONT * fonth
);


extern os_error * XGetMenu(HWND hWnd,HMENU * menu);

extern os_error * XCreateDIBSection(
  HDC hdc,                 // handle to DC
  CONST BITMAPINFO *pbmi,  // bitmap data
  UINT iUsage,             // data type indicator
  VOID **ppvBits,          // bit values
  HANDLE hSection,         // handle to file mapping object
  DWORD dwOffset,           // offset to bitmap bit values
  HBITMAP * hbm
);

extern os_error * XRealizePalette(HDC hdc,int * n);

extern os_error * XGetUserName(
  LPTSTR lpBuffer,  // name buffer
  LPDWORD nSize     // size of name buffer
);

extern os_error * XGetCharacterPlacement(
  HDC hdc,                  // handle to DC
  LPCTSTR lpString,         // character string
  int nCount,               // number of characters
  int nMaxExtent,           // maximum extent for string
  LPGCP_RESULTS lpResults,  // placement result
  DWORD dwFlags             // placement options
);


os_error * XGetCharacterPlacementW(
  HDC hdc,                  // handle to DC
  LPCWSTR lpString,          // character string
  int nCount,               // number of characters
  int nMaxExtent,           // maximum extent for string
  LPGCP_RESULTSW lpResults,  // placement result
  DWORD dwFlags             // placement options
);



extern os_error * XRegDeleteKey(HKEY hKey,LPCTSTR lpSubKey);



extern os_error * XRegDeleteValue(HKEY hKey,LPCTSTR lpValueName);

extern os_error * XLoadLibrary(LPCTSTR lpFileName,HMODULE * handle);



extern os_error * XSetMapMode(HDC hdc,int fnMapMode,int * oldmode);


extern os_error * XSetViewportExtEx(
  HDC hdc,       // handle to device context
  int nXExtent,  // new horizontal viewport extent
  int nYExtent,  // new vertical viewport extent
  LPSIZE lpSize  // original viewport extent
);


extern os_error * XSetViewportOrgEx(
  HDC hdc,        // handle to device context
  int X,          // new x-coordinate of viewport origin
  int Y,          // new y-coordinate of viewport origin
  LPPOINT lpPoint // original viewport origin
);


extern os_error * XSetWindowOrgEx(
  HDC hdc,        // handle to device context
  int X,          // new x-coordinate of window origin
  int Y,          // new y-coordinate of window origin
  LPPOINT lpPoint // original window origin
);


extern os_error * XSelectClipPath(HDC hdc,    // handle to DC
                           int iMode   // clipping mode
);


extern os_error * XGetMessage(
  LPMSG lpMsg,         // message information
  HWND hWnd,           // handle to window
  UINT wMsgFilterMin,  // first message
  UINT wMsgFilterMax,   // last message
  int * code);
;


extern os_error * XGetMessageW(
  LPMSG lpMsg,         // message information
  HWND hWnd,           // handle to window
  UINT wMsgFilterMin,  // first message
  UINT wMsgFilterMax,   // last message
  int * code);
;



extern os_error * XStartDoc(HDC hdc,CONST DOCINFO *lpdi,int * jobhandle);
extern os_error * XStartDocPrinter(HANDLE hPrinter,DWORD Level,LPBYTE pDocInfo,int * jobhandle);




extern os_error * XAddFontResource(LPCTSTR lpszFilename);

extern os_error * XRemoveFontResource(LPCTSTR lpFileName);


extern os_error * XAppendMenu(
  HMENU hMenu,         // handle to menu
  UINT uFlags,         // menu-item options
  UINT_PTR uIDNewItem, // identifier, menu, or submenu
  LPCTSTR lpNewItem    // menu-item content
);



extern os_error * XSetMenuItemInfo(
  HMENU hMenu,          // handle to menu
  UINT uItem,           // identifier or position
  BOOL fByPosition,     // meaning of uItem
  LPMENUITEMINFO lpmii  // menu item information
);





extern os_error * XModifyMenu(
  HMENU hMnu,           // handle to menu
  UINT uPosition,       // menu item to modify
  UINT uFlags,          // options
  UINT_PTR uIDNewItem,  // identifier, menu, or submenu
  LPCTSTR lpNewItem     // menu item content
);


extern os_error * XTrackPopupMenuEx(
  HMENU hmenu,       
  UINT fuFlags,      
  int x,             
  int y,             
  HWND hwnd,         
  LPTPMPARAMS lptpm  
);


extern os_error * XGetSubMenu(
  HMENU hMenu,  // handle to menu
  int nPos,     // menu item position
  HMENU * submenu
);


extern os_error * XLoadMenuIndirect(
  CONST MENUTEMPLATE *lpMenuTemplate,  // address of menu template
  HMENU * menuh
);



extern os_error * XCreatePopupMenu(HMENU * menu);

extern os_error * XCreateMenu(HMENU * menu);


extern os_error * XDestroyMenu(
  HMENU hMenu  // handle to menu to destroy
);



extern os_error * XDeleteMenu(
  HMENU hMenu,     // handle to menu
  UINT uPosition,  // menu item identifier or position
  UINT uFlags      // option
);


extern os_error * XSetMenu(
  HWND hWnd,  // handle to window
  HMENU hMenu // handle to menu
);


extern os_error * XGetMenuItemCount(HMENU hMenu,int * nitem);




extern os_error * XSetMenuItemInfo(
  HMENU hMenu,          
  UINT uItem,           
  BOOL fByPosition,     
  LPMENUITEMINFO lpmii  
);


extern os_error * XGetMenuItemInfo(
  HMENU hMenu,          // handle to menu
  UINT uItem,           // menu item
  BOOL fByPosition,     // meaning of uItem
  LPMENUITEMINFO lpmii  // menu item information
);



extern os_error * XInsertMenuItem(
  HMENU hMenu,          
  UINT uItem,           
  BOOL fByPosition,     
  LPMENUITEMINFO lpmii  
);

extern os_error * XLoadMenu(
  HINSTANCE hInstance,  // handle to application instance
  LPCTSTR lpMenuName,    // menu name string or menu-resource 
                        // identifier
  HMENU * menu
);


extern os_error * XDrawMenuBar(HWND hWnd);


extern os_error * XIntersectClipRect(HDC hdc,int nLeftRect,int nTopRect,int nRightRect,int nBottomRect,int * code);


extern os_error * XCreateProcess(
  LPCTSTR lpApplicationName,                 // name of executable module
  LPTSTR lpCommandLine,                      // command line string
  LPSECURITY_ATTRIBUTES lpProcessAttributes, // SD
  LPSECURITY_ATTRIBUTES lpThreadAttributes,  // SD
  BOOL bInheritHandles,                      // handle inheritance option
  DWORD dwCreationFlags,                     // creation flags
  LPVOID lpEnvironment,                      // new environment block
  LPCTSTR lpCurrentDirectory,                // current directory name
  LPSTARTUPINFO lpStartupInfo,               // startup information
  LPPROCESS_INFORMATION lpProcessInformation // process information
);



extern os_error * XRegisterHotKey(
  HWND hWnd,         // handle to window
  int id,            // hot key identifier
  UINT fsModifiers,  // key-modifier options
  UINT vk            // virtual-key code
);


extern os_error * XUnregisterHotKey(  HWND hWnd,  // handle to window
  int id      // hot key identifier
);


extern os_error * XOpenPrinter(
  LPTSTR pPrinterName,         // printer or server name
  LPHANDLE phPrinter,          // printer or server handle
  LPPRINTER_DEFAULTS pDefault  // printer defaults
);


extern os_error * XClosePrinter(
  HANDLE hPrinter,   // handle to printer object
		os_error * err
);


extern os_error * XGetPrinter(
  HANDLE hPrinter,    // handle to printer
  DWORD Level,        // information level
  LPBYTE pPrinter,    // printer information buffer
  DWORD cbBuf,        // size of buffer
  LPDWORD pcbNeeded   // bytes received or required
);


extern os_error * XGetPrinterDriver(
  HANDLE hPrinter,     // printer object
  LPTSTR pEnvironment, // environment name
  DWORD Level,         // information level
  LPBYTE pDriverInfo,  // driver data buffer
  DWORD cbBuf,         // size of buffer
  LPDWORD pcbNeeded    // bytes received or required
);


extern os_error * XGetPrinterData(
  HANDLE hPrinter,    // handle to printer or print server
  LPTSTR pValueName,  // value name
  LPDWORD pType,      // data type
  LPBYTE pData,       // configuration data buffer
  DWORD nSize,        // size of configuration data buffer
  LPDWORD pcbNeeded   // bytes received or required 
);



extern os_error * XCreateDC(
  LPCTSTR lpszDriver,        // driver name
  LPCTSTR lpszDevice,        // device name
  LPCTSTR lpszOutput,        // not used; should be NULL
  CONST DEVMODE *lpInitData, // optional printer data
		HDC * hdc
);


extern os_error * XCreateIC(
  LPCTSTR lpszDriver,       // driver name
  LPCTSTR lpszDevice,       // device name
  LPCTSTR lpszOutput,       // port or file name
  CONST DEVMODE *lpdvmInit,  // optional initialization data
		HDC * hdc
);


extern os_error * XDeleteDC(
  HDC hdc,   // handle to DC
		os_error * err
);



extern os_error * XSendMessage(
  HWND hWnd,      // handle to destination window
  UINT Msg,       // message
  WPARAM wParam,  // first message parameter
  LPARAM lParam,   // second message parameter
 LRESULT * result
);


extern os_error * XGetModuleHandle(LPCTSTR lpModuleName,HMODULE * result);


extern os_error * XGetProcAddress(HMODULE hModule,LPCSTR lpProcName,FARPROC * result);

