

#include <stdafx.h>


#include "os.h"
#include "flex.h"
#include "alloc.h"


#include "bits.h"

#include "deb.h"

#include "oserr.h"


#include "osreg.h"




static int xstrnicmp(const char *string1,size_t count1,const char *string2,const char *string3)
{
 size_t count2;
 int    code;

 code=1;

 count2=strlen(string2);
 if(count1==count2)
 {
  code=_strnicmp(string1,string2,count1);
  if(code==0) return(code);
 }

 count2=strlen(string3);
 if(count1==count2)
 {
  code=_strnicmp(string1,string3,count1);
 }

 return(code);
}




static HKEY getrootkey(char * name,int len)
{
 HKEY mkey;

 mkey=NULL;

 if(!xstrnicmp(name,len,"HKEY_CLASSES_ROOT","HKCR")) mkey=HKEY_CLASSES_ROOT;
 else
 if(!xstrnicmp(name,len,"HKEY_CURRENT_USER","HKCU")) mkey=HKEY_CURRENT_USER;
 else
 if(!xstrnicmp(name,len,"HKEY_LOCAL_MACHINE","HKLM")) mkey=HKEY_LOCAL_MACHINE;
 else
 if(!xstrnicmp(name,len,"HKEY_USERS","HKU")) mkey=HKEY_USERS;
 else
 if(!xstrnicmp(name,len,"HKEY_CURRENT_CONFIG","HKCC")) mkey=HKEY_CURRENT_CONFIG;

 return(mkey);
}



/*
static HKEY getrootkey(char * name,int len)
{
 HKEY mkey;

 mkey=NULL;

 if(!cstrncmp(name,"HKEY_CLASSES_ROOT",len)) mkey=HKEY_CLASSES_ROOT;
 else
 if(!cstrncmp(name,"HKEY_CURRENT_USER",len)) mkey=HKEY_CURRENT_USER;
 else
 if(!cstrncmp(name,"HKEY_LOCAL_MACHINE",len)) mkey=HKEY_LOCAL_MACHINE;
 else
 if(!cstrncmp(name,"HKEY_USERS",len)) mkey=HKEY_USERS;
 else
 if(!cstrncmp(name,"HKEY_CURRENT_CONFIG",len)) mkey=HKEY_CURRENT_CONFIG;

 return(mkey);
}

*/


// given a path, validate it, creating entries, pass back key 

os_error * regcreatepath(char * name,oskeyh * key)
{
 os_error * err;
 DWORD      disp;
 char     * p;
 HKEY       mkey;
 int        len;

 err=NULL;

 p=strchr(name,'\\');
 if(p)
 {
  len=p-name;
  mkey=getrootkey(name,len);
  p++;

  err=XRegCreateKeyEx((HKEY)mkey,(LPCTSTR)p,0,"",REG_OPTION_NON_VOLATILE,
                     KEY_ALL_ACCESS,NULL,(PHKEY)key,&disp);
 }

 return(err);
}

// create a new sub key and open it

os_error * regcreatedir(oskeyh key,char * name,oskeyh * skey)
{
 os_error * err;
 DWORD      disp;

 err=XRegCreateKeyEx((HKEY)key,(LPCTSTR)name,0,"",REG_OPTION_NON_VOLATILE,
                     KEY_ALL_ACCESS,NULL,(PHKEY)skey,&disp);

 return(err);
}


os_error * regsetstr(oskeyh key,char * name,char * value)
{
 return(XRegSetValueEx((HKEY)key,name,0,REG_SZ,(const unsigned char*)value,strlen(value)+1));
}





os_error * regclosekey(oskeyh * key,os_error * err)
{
 if(*key)
 {
  if(err) XRegCloseKey((HKEY)*key);
  else    err=XRegCloseKey((HKEY)*key);
  *key=0;
 }

 return(err);
}



os_error * regopenkey(char * name,oskeyh * key,int mode)
{
 os_error * err;
 HKEY       mkey;
 int        len;
 char     * p;

 err=NULL;
 *key=0;

 p=strchr(name,'\\');
 if(p)
 {
  len=p-name;
  mkey=getrootkey(name,len);
  p++;

		if(mode=='r') mode=KEY_READ;
		else
		if(mode=='w') mode=KEY_WRITE;
		else
		/* if(mode=='u')*/	mode=KEY_ALL_ACCESS;

  err=XRegOpenKeyEx((HKEY)mkey,(LPCTSTR)p,0,mode,(PHKEY)key);
 }

 return(err);
}





os_error * regopensubkey(oskeyh key,char * name,oskeyh * skey)
{
 os_error * err;

 err=XRegOpenKeyEx((HKEY)key,name,0,KEY_ALL_ACCESS,(PHKEY)skey);

 return(err);
}



os_error * regenumkey(oskeyh key,char * string,int * size,int * eof,int * index)
{
 os_error * err;
 FILETIME   ftime;

 err=XRegEnumKeyEx((HKEY)key,(DWORD)*index,string,(DWORD*)size,0,NULL,0,&ftime,eof);
 *index=(*index)+1;

// cprintf("index=%d eof=%d string %s",*index,*eof,string);

 return(err);
}



os_error * reggetstr(oskeyh key,char * name,char * string,int * size)
{
 os_error * err;
 DWORD      ktype;

 err=XRegQueryValueEx((HKEY)key,name,NULL,&ktype,(BYTE*)string,(DWORD*)size);

 return(err);
}



os_error * regenumvalue(oskeyh key,char * string,int * size,int * type,
                        char * data,int * dsize,int * eof,int * index)
{
 os_error * err;

 err=XRegEnumValue((HKEY)key,*index,(LPTSTR)string,(LPDWORD)size,0,(LPDWORD)type,
                   (LPBYTE)data,(LPDWORD)dsize,eof);
 *index=(*index)+1;

 return(err);
}


// here using idea that what comes after last slash is value name

os_error * regreadstr(char * keypathp,char * string,int * size)
{
 os_error * err;
 oskeyh     key;
 char     * p;
	char       keypath[MAX_PATH];


// cprintf("regred %s",keypath);


	strcpy(keypath,keypathp);

 p=strrchr(keypath,'\\');
 if(p) *p=0;

 
// cprintf("regred %s",keypath);

 err=regopenkey(keypath,&key,'r');
 if(!err && key)
 {
  if(p)
  {
   err=reggetstr(key,p+1,string,size);
  }
  else
  {
   err=reggetstr(key,NULL,string,size);
  }

  if(err)
  {
   *size=0;
   *string=0;
  }

  err=regclosekey(&key,err);
 }
 else
 {
  *size=0;
  *string=0;
 }

 if(p) *p='\\';

//  cprintf("string %s len %d",keypath,*size);

 return(err);
}




os_error * regallocstr(char * keypathp,char ** string,int * size)
{
 os_error * err;
 oskeyh     key;
 char     * p;
	char       keypath[MAX_PATH];


// cprintf("regred %s",keypath);


 *size=0;
 *string=NULL;

	strcpy(keypath,keypathp);

 p=strrchr(keypath,'\\');
 if(p) *p=0;

 
// cprintf("regred %s",keypath);

 err=regopenkey(keypath,&key,'r');
 if(!err && key)
 {
  if(p)
  {
   err=reggetstr(key,p+1,NULL,size);
  }
  else
  {
   err=reggetstr(key,NULL,NULL,size);
  }

  if(!err)
  {
   err=salloc((flex_ptr)string,*size);
   if(!err)
   {
    if(p)
    {
     err=reggetstr(key,p+1,*string,size);
    }
    else
    {
     err=reggetstr(key,NULL,*string,size);
    }
   }
  }

  err=regclosekey(&key,err);
 }
 else
 {
  *size=0;
  *string=0;
 }

 if(p) *p='\\';

//  cprintf("string %s len %d",keypath,*size);

 return(err);
}








os_error * regwritestr(char * keypath,char * value)
{
 os_error * err;
 HKEY       mkey;
 HKEY       skey;
 int        len;
 char     * p;
 char     * q;
 DWORD      disp;
 char       temp[MAX_PATH];

 err=NULL;

 p=strchr(keypath,'\\');
 if(p)
 {
  len=p-keypath;
  mkey=getrootkey(keypath,len);
  if(mkey)
  {
   p++;

   q=strrchr(keypath,'\\');
   if(q)
   {
    strcpy(temp,p);
    temp[q-p]=0;
    p=temp;
   }

   err=XRegCreateKeyEx(mkey,(LPCTSTR)p,0,"",REG_OPTION_NON_VOLATILE,
                      KEY_ALL_ACCESS,NULL,(PHKEY)&skey,&disp);

   if(!err)
   {
    if(q && value) err=regsetstr((oskeyh)skey,q+1,value);
    err=regclosekey((oskeyh*)&skey,err);
   }
  }
  else
  {
   // bad key
  }
 }

 return(err);
}



os_error * regdeletekey(char * name)
{
 os_error * err;
 HKEY       mkey;
 HKEY       skey;
 int        len;
 char     * p;
 char     * q;

 err=NULL;

 p=strchr(name,'\\');
 if(p)
 {
  len=p-name;
  mkey=getrootkey(name,len);
  p++;

  q=strrchr(p,'\\');
  if(q)
  {
   *q=0;

   if(*(q+1))
   {
    err=XRegOpenKeyEx((HKEY)mkey,(LPCTSTR)p,0,KEY_ALL_ACCESS,(PHKEY)&skey);
    if(!err)
    {
     err=XRegDeleteValue(skey,q+1);
     err=regclosekey((oskeyh*)&skey,err);
    }
   }
   else
   {
    err=XRegDeleteKey(mkey,p);
   }

   *q='\\';
  }
 }

 return(err);
}
