/*->c.save */

#include <stdafx.h>

#include "commdlg.h"
#include "commctrl.h"
#include "dlgs.h"



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "werr.h"


#include "wos.h"
#include "poll.h"
#include "fsx.h"
#include "err.h"
#include "etc.h"
#include "bits.h"
#include "filetype.h"
#include "trans.h"


#include "deb.h"


#include "save.h"









/****************************************************************************/
                       /* code for dragging save icons */





static int             saveftype;  /* file type for the above                */
static wimp_w          savehandle;
static savefn          save;
static intsavefn       intsave;
static saveinfofn      saveinfo;
static int             sopts;       /* number of save options         */
static saveoptionstr * saveoption;  /* fns called on selection option */
static int           * sopt;        /* address of current option      */
static int             setoptions;
static int             savebuttons;






/*****************************************************************************/


static void setupsavetype(int ftype)
{
 saveftype=ftype;
}




static UINT_PTR CALLBACK OFNHookProc(HWND hdlg,UINT uiMsg,WPARAM wParam,LPARAM lParam)
{
 os_error * err;
 OFNOTIFY * lpon;
 int        index;
 int        type;
 TCHAR      name[MAX_PATH];

 if(uiMsg==WM_NOTIFY)
 {
  lpon=(LPOFNOTIFY)lParam; 
  if(lpon->hdr.code==CDN_TYPECHANGE)
  {
   index=lpon->lpOFN->nFilterIndex-1;
   type=saveftype;
   CommDlg_OpenSave_GetSpec(GetParent(hdlg),name,sizeof(name)/sizeof(TCHAR)); 

   // the original idea was that this function would set the option
   // then we would look at *sopt to see exactly what had been set
   // in this version we're assuming we get our way over the new type

   if(saveoption[index].fn) err=saveoption[index].fn(savehandle,index,&type,name,NITEM(name));
   setupsavetype(type);

   CommDlg_OpenSave_SetControlText(GetParent(hdlg),edt1,fs_leaf(name));
  }
 }

 return(0);

 USE(wParam);
}




#define SAVEFILTERLEN 512



static TCHAR savefilterbuffer[SAVEFILTERLEN];



static os_error * addsavetype(int i,int filetype,TCHAR * description)
{
 TCHAR          extension[FSMAXEXTLEN];
 TCHAR        * p;
 static TCHAR * lastp;



 if(i==0) p=savefilterbuffer;
 else
 {
  p=lastp;
 }


 getextension(filetype,extension);
 xzstrncpyu(p,description,SAVEFILTERLEN-(p-savefilterbuffer));
 trans(p,SAVEFILTERLEN-(p-savefilterbuffer));
 p+=ustrlen(p)+1;
	if(p<(savefilterbuffer+SAVEFILTERLEN-2))
	{
  *p++='*';
  *p++='.';
	}
 xzstrncpyu(p,extension,SAVEFILTERLEN-(p-savefilterbuffer));

 p+=ustrlen(p)+1;
 lastp=p;
	if(p<(savefilterbuffer+SAVEFILTERLEN-2))
	{
  *p++=0;
  *p++=0;
	}

#ifdef _DEBUG

 if(p>(savefilterbuffer+SAVEFILTERLEN)) cprintf("savefilterbuffer overrun");

#endif

 return(NULL);
}



static os_error * getsavefilename(TCHAR * name,int maxsize,wimp_w parent)
{
 OPENFILENAME ofn;
 TCHAR        extension[FSMAXEXTLEN];
 TCHAR        dir[MAX_PATH];
 TCHAR        filename[MAX_PATH];


 memset(&ofn,0,sizeof(OPENFILENAME));

 ofn.hwndOwner=(HWND)parent;
 ofn.lStructSize=((char*)&ofn.pvReserved)-((char*)&ofn.lStructSize);

 ofn.lpstrFilter=savefilterbuffer;

// cprintf("savefilterbuffer %s",savefilterbuffer);


 ofn.lpstrCustomFilter=NULL;
 ofn.nMaxCustFilter=0;

 if(sopts) ofn.nFilterIndex=(*sopt)+1;
 else      ofn.nFilterIndex=1;  // this is the first entry

 ofn.lpstrFile=fs_leaf(name);
 ofn.lpstrInitialDir=dir;

 xzstrncpyu(dir,name,MIN(ofn.lpstrFile-name,NITEM(dir)));
 xzstrncpyu(filename,ofn.lpstrFile,NITEM(filename));	// copy leaf

 ofn.lpstrFile=filename;

 ofn.nMaxFile=MAX_PATH;

 ofn.lpfnHook=OFNHookProc;

 ofn.Flags=OFN_HIDEREADONLY | OFN_EXPLORER | OFN_ENABLEHOOK;

//	cprintf("getsavefilename %s %s",ofn.lpstrFile,dir);

 if(GetSaveFileName(&ofn))
 {
  xzstrncpyu(name,filename,maxsize);
  getextension(saveftype,extension);
  fs_checkextension(name,extension);
  return(NULL);
 }
 else
 {
//	cprintf("commdlg err %d",CommDlgExtendedError());

  return(geterror(ESAVECANCELLED));
 }



}





/* try to save file */

os_error * savefile(TCHAR * filename,int type)
{
 os_error * err;
 TCHAR      name[MAX_PATH];

 err=NULL;

 if(!filename)
 {
  type=saveftype;
 }
 else
 {
  xzstrncpyu(name,filename,NITEM(name));
  filename=name;
 }



 if(!err && save) err=save(filename,type);

 return(err);
}









/* start save */

static os_error * setsave(TCHAR * name,int type,savefn xsave,wimp_w * handle)
{
 os_error * err;
 int        xtype;
 TCHAR      xname[MAX_PATH];
 TCHAR      description[128];
 int        i;
 int        fopt;


 err=NULL;

 save=xsave;
 intsave=NULL;
 saveinfo=NULL;

 
 if(!setoptions) sopts=0;
 else            setoptions=0;

 if(sopts)
 {
  fopt=*sopt;
  if(fopt<0 || fopt>=sopts) fopt=0;

  for(i=0;i<sopts;i++)
  {
//    cprintf("options %d saveoptions %x",sopts,saveoption);

   xname[0]=0;
   err=saveoption[i].fn(savehandle,i,&xtype,xname,NITEM(xname));
   if(err) break;
   if(i==fopt) setupsavetype(xtype);
   addsavetype(i,xtype,saveoption[i].name);
  }

  if(!err)
  {
   xname[0]=0;
   err=saveoption[fopt].fn(savehandle,fopt,&xtype,xname,NITEM(xname));
  }
 }
 else
 {
  setupsavetype(type);
  getdescription(type,description);
  addsavetype(0,type,description);
 }

 return(err);

 USE(handle);
 USE(name);
}






os_error * setsaveoptions(int options,saveoptionstr * optionstr,int * opt)
{
 sopts=options;
 saveoption=optionstr;
 sopt=opt;
 setoptions=(sopts!=0);

// cprintf("options %d saveoptions %x",sopts,saveoption);

 return(NULL);
}



// warning name has to be MAX_PATH size

os_error * opensave(TCHAR * name,int maxsize,int type,savefn save)
{
 os_error * err;
 wimp_w     handle;

          err=setsave(name,type,save,&handle);

 if(!err) err=getsavefilename(name,maxsize,NULL);
 if(!err) err=savefile(name,saveftype);
 else
 {
  if(err->errnum==ESAVECANCELLED) err=NULL;
 }

 return(err);
}


// warning name has to be MAX_PATH size

os_error * opensaveparent(TCHAR * name,int maxsize,int type,savefn save,wimp_w parent)
{
 os_error * err;
 wimp_w     handle;

          err=setsave(name,type,save,&handle);
 if(!err) err=getsavefilename(name,maxsize,parent);
 if(!err) err=savefile(name,saveftype);
 else
 {
  if(err->errnum==ESAVECANCELLED) err=NULL;
 }


 return(err);
}


// warning name has to be MAX_PATH size
// returns ESAVECANCELLED error

os_error * opensaveparent2(TCHAR * name,int maxsize,int type,savefn save,wimp_w parent)
{
 os_error * err;
 wimp_w     handle;

          err=setsave(name,type,save,&handle);
 if(!err) err=getsavefilename(name,maxsize,parent);
 if(!err) err=savefile(name,saveftype);

 return(err);
}


