/*->c.xhelp     */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"

#include "flex.h"

#include "etc.h"
#include "err.h"
#include "trans.h"
#include "temp.h"
#include "sp.h"
#include "wos.h"
#include "poll.h"
#include "alloc.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "oserr.h"
#include "osglue.h"
#include "deb.h"

#include "xhelp.h"



/* 

   Help file format

   Name,icon,icon,icon,string

 */




typedef struct ticonstr
{
 unsigned int   icon:28;
 unsigned int   bits:4;
 unsigned int   offset;

} ticonstr;



typedef struct tagstr
{
 int tag;
 int icon;
} tagstr;




#define ICONCHUNK   (sizeof(ticonstr)*32)
#define STRINGCHUNK (512)
#define TAGCHUNK    (sizeof(tagstr)*32)


static int       tags;
static tagstr  * tagptr;              /* pointers into icon structure */

static int       icons;
static ticonstr * iconptr;             /* pointers into strings */

static int       hstrings;
static char    * hstringptr;



static int findtagname(char * name)
{
 int tag;

// if(!cstrcmp(name,"IconBar")) return(ICONBARTAG);

 findtempname(&tag,name);

// cprintf("tag %x name %s",tag,name);

 return(tag);
}


static int cmptag(const void * t1,const void * t2)
{
 return((((tagstr*)t1)->tag)-(((tagstr*)t2)->tag));
}


os_error * addhelp2a(char * path,char * leaf,ascaninstance instance)
{
 os_error * err;
 char     * p;
 char     * q;
 char       temp[1024];
 int        tag;
 int        n;
 int        ch=0;
 fstat      f;
 buffer     bf;
 int        eof;
 char       lastname[256];
 int        lasttag;
 int        index;
 tagstr   * indexp;
 tagstr     target;
 int        iconi;
 int        toptag;
 int        i;
 unsigned int length=0;
 char     * rstart=NULL;
 char     * rend=NULL;
 char     * r=NULL;
 HANDLE     hDialog=NULL; 
 HRSRC      hRsrc;
 int        len;

 err=NULL;

// if(path) xcprintf("addhelp2 path %s %d",path,instance);
// if(leaf) xcprintf("addhelp2 leaf %s %d",leaf,instance);


 if(!iconptr)     err=flex_alloc((flex_ptr)&iconptr,ICONCHUNK);
 if(!err)
 {
  if(!hstringptr) err=flex_alloc((flex_ptr)&hstringptr,STRINGCHUNK);
  if(!err)
  {
   if(!tagptr)    err=flex_alloc((flex_ptr)&tagptr,TAGCHUNK);
  }
 }



 lastname[0]=0;
 lasttag=0;
 toptag=0;
 index=0;   /* compiler */

 if(path)
 {
  strcpy(temp,path);
  strcat(temp,"\\");
  strcat(temp,leaf);

//  cprintf("add help %s",temp);

  if(!err) err=fs_stat(temp,&f);
  if(!err)
  {
   if(f.object)
   {
    err=bf_open(temp,'r',DEFBUFFSIZE,&bf);
   }
   else
   {
    err=geterrorf(ENOTFOUND,temp);
   }
  }
 }
 else
 {
           err=XFindResource((HINSTANCE)instance,leaf,"INTHELP",&hRsrc);
  if(!err) err=XLoadResource((HINSTANCE)instance,hRsrc,(HGLOBAL*)&hDialog);
  if(!err) err=XLockResource(hDialog,(LPVOID*)&rstart);
  if(!err) err=XSizeofResource((HINSTANCE)instance,hRsrc,&length);
  if(!err)
  {
   rend=rstart+length;
   r=rstart;
  }
 }


 if(!err)
 {
//  cprintf("add help starting");

  while(1)
  {
   if(path)
   {
    err=bf_getstring(&bf,temp,sizeof(temp),&eof);
    if(err) break;
    if(eof) break;
   }
   else
   {
    p=r;
    while(r<rend && (*r>=' ' || *r=='\t')) r++;

    if((r-p)==0)
    {
     break;
    }
    else
    {
     len=r-p;
     len=MIN(len,sizeof(temp));
     XMEMCPYX(temp,p,len);
     *(temp+(len))=0;
     while(r<rend && *r<' ') r++;
    }
   }

//   cprintf("temp %s",temp);

   p=temp;
   while(*p)
   {
    if(*p=='\t') *p=' ';
    p++;
   }

   p=temp;
   while(*p==' ') p++;
   if((*p)=='/' || (*p)<' ') continue;               /* !!!!!!! */

   q=p;

   while(*p>=' ' && *p++!=',');
   *(p-1)=0;

//   cprintf("q %s",q);

   /* map string to tag */

   if(!cstrcmp(q,lastname)) tag=lasttag;
   else                    
   {
    tag=findtagname(q);
    xstrncpy(lastname,q,sizeof(lastname));
    lasttag=tag;
   }


   if(tag>0)
   {
    if(tag==toptag)
    {
     iconi=icons;
     iconptr[iconi-1].bits&=~0x1;
    }
    else
    {
     target.tag=tag;
     indexp=(tagstr*)bnearest(&target,tagptr,tags,sizeof(tagstr),cmptag);
     index=indexp-tagptr;

     if(index<tags && indexp->tag==tag)
     {
      iconi=tagptr[index].icon;
      while(!(iconptr[iconi].bits&0x1)) iconi++;
      iconptr[iconi++].bits&=~0x1;
     }
     else
     {
      err=flex_chunk((flex_ptr)&tagptr,(tags+1)*sizeof(tagstr),TAGCHUNK);
      memmove(tagptr+index+1,tagptr+index,sizeof(tagstr)*(tags-index));
      tagptr[index].icon=iconi=icons;
      tagptr[index].tag=tag;
      toptag=tag;
      tags++;
     }
    }


    while(1)
    {
     n=0;
     while((ch=*p++)!=0)
     {
      if(ch==',' || ch==':') break;
      else 
      if(isdigit(ch)) n=n*10+(ch-'0');
     }

     err=flex_chunk((flex_ptr)&iconptr,(icons+1)*sizeof(ticonstr),ICONCHUNK);
     if(err) break;

     if(iconi!=icons)
     {
      memmove(iconptr+iconi+1,iconptr+iconi,(icons-iconi)*sizeof(ticonstr));
    /*  for(i=index+1;i<tags;i++) tagptr[i].icon++;  */
      for(i=0;i<tags;i++) 
      {
       if(tagptr[i].icon>=iconi) tagptr[i].icon++;
      }
     }

     iconptr[iconi].icon=n;
     iconptr[iconi].offset=hstrings;
     iconptr[iconi].bits=0;

     icons++;

     if(ch!=',')
     {
      iconptr[iconi].bits|=0x1;
      break;
     }

     iconi++;
    }

    if(err) break;
    if(ch!=':') break;

    q=p;
    while(*p++>=' ');
    *(p-1)=0;

    err=flex_chunk((flex_ptr)&hstringptr,(hstrings+p-q),STRINGCHUNK);
    if(err) break;

    gstrans(hstringptr+hstrings,p-q,q,&len);
    hstrings+=len;
   }
  }

  if(path) err=bf_close(&bf,err);

  if(!err)
  {
   if(tagptr)     flex_extend((flex_ptr)&tagptr,tags*sizeof(tagstr));
   if(iconptr)    flex_extend((flex_ptr)&iconptr,icons*sizeof(ticonstr));
   if(hstringptr) flex_extend((flex_ptr)&hstringptr,hstrings);
  }
 }

// cprintf("tags %d icons %d lasttag %d",tags,icons,lasttag);

 return(err);
}


os_error * addhelp(char * path,char * leaf)
{
 return(addhelp2a(path,leaf,(ascaninstance)AppInstance));
}



char * helpfindtagstring(int tag,int icon)
{
 ticonstr * iconp;
 tagstr   * indexp;
 tagstr     target;

 target.tag=tag;

// cprintf("tag %x icon %d",tag,icon);

 indexp=(tagstr*)bsearch(&target,tagptr,tags,sizeof(tagstr),cmptag);

 if(indexp)
 {
//  xcprintf("help found tag");

  iconp=iconptr+indexp->icon;

  while(1)
  {
   if((int)iconp->icon==icon || (iconp->icon==255 && icon==-1) || iconp->icon==254)
   {
    return(hstringptr+iconp->offset);
   }
  
   if(iconp->bits & 0x1) break;
   iconp++;
  }
 }
 
 return(NULL);
}



