/*->h.process */


#ifndef __xprocess

#define __xprocess

#define PROCESSNONE  0x0
#define PROCESSFN    0x2
#define PROCESSBLACK 0x3
#define PROCESSWHITE 0x4
#define PROCESSNULL  0x5



typedef int (*processfn)(int pal);



// #define PROCESST_RGB    0x1

#define PROCESST_CMYK   0x2
#define PROCESST_PAL    0x3
#define PROCESST_RGB32  0x4
#define PROCESST_RGB16  0x5
#define PROCESST_BGR32  0x6
#define PROCESST_BGR16  0x7
#define PROCESST_BGR24  0x8



typedef struct	cmsdatastr
{
	int type;

	int intent;

	unsigned int    len;
         	char * data;


} cmsdatastr;



typedef os_error * (*processfn3)(int    handle,
                                 void * d,
                                 void * s,
                                 int    size,
                                 int    dtype,
                                 int    stype,
                                 cmsdatastr * scms,
                                 cmsdatastr * dcms);


typedef os_error * (*processcmyk2rgbfn)(void * handle,int * s,int * d,int size,cmsdatastr * scms,cmsdatastr * dcms);


#define ISPSPRINTER   2
#define ISPRINTERNORM 1

typedef struct processstr
{
 int               mode;
 int               isprinter;
 int               xdpi;
 int               ydpi;
 int               ln2bpp;
 int               tosprite;
 int               background;
 int               fontbits;
 int               jpegbits;
 processfn3        process;
 int               handle;
 int               spritebits;

 unsigned int      usespots:1;
 unsigned int      spotplate:1;
 unsigned int      knockoutgraphics:1;
 unsigned int      useproxies:1;
 int               separation;

 coordstr          scale;

 void            * handle2;

 processcmyk2rgbfn cmyk2rgb;
 processcmyk2rgbfn cmyk2bgr;

	void            * prjob;

 int               spare[8];

} processstr;



extern int processcolour(int pal,processstr * p);



/*
typedef os_error * (*cmyk2rgb3232prfn)(int * s,int * d,int size);


extern os_error * processsetfn(cmyk2rgb3232prfn * cmykfn,void * sp1,void * sp2,void * sp3);

extern os_error * processcmyk2bgr(int * s,int * d,int size);
*/




#endif